designer htmlhelp v06 internal version comments

Page#: 0_readmefirst.htm

v13 000609TTA: last edit.

designer htmlhelp version 13 readme

This is a micado internal version of the help file. This help file was written by terry taylor, terrytaylor@mynd.com, 49 (0) 221 8029 159 (office), 49 (0) 173 2845 784 (mobile).

This page and the "e-g term reference" pages will not appear in the release version of the help.

Include the "Page#" when sending comments to tta about the help.

Changes

v13

  • went thru entire help... corrected formatting errors, pic errors, etc.
  • entire tutorial updated. page numbers are correct, the text corrected, and the example layouts and models corrected.
  • "T37 Conversion list" and "T38 Dynamic Combobox" added to the tutorial.
  • examples section: text updated, models and layouts modified. links to the files and dirs added. however, the examples are still pretty bad. i need to analyze complex layouts for things to add to this section.
  • non-compiled htmlhelp version with toc and index created.
  • dir structure of help redone... this was necessary for the java applets for the toc/index for the uncompiled htmlhelp version.
  • the spaces (leerzeichen) in all html filenames replaced with underline (_) characters. this was necessary since the java applets would not work with html files with spaces in the names.
  • "using this help" added.
  • mynd contact info updated.

v12

  • dll example added to "11 tutorial".
  • bottom nav bar added.
  • release version has new icons for nav bars.

v11

  • "11 tutorial" content added.

v10

  • "11 tutorial" rewritten. NOT COMPLETE. however, the basic strucure gives an idea of the eventual goal.
  • "0_2_1 e-g properties" is more detailed and more error-free.
  • completed the properties sections (with a few exceptions).

v09

  • "concepts/arrays" rewritten. much more detailed about tables, iterations and multiple inclusion.
  • header/footer descriptions added thruout.
  • description of concept levels moved to visibility.
  • new print dialog described. print concept much more detailed.

v08

  • text on almost every page changed.
  • tutorial added.
  • common tasks added.
  • examples section added. the examples are not from tta... they need to be cleaned up a bit, but they are really helpful.
  • troubleshooting section added.
  • faq added.
  • e-g term reference added (this is internal only... should help when doing the translations).
  • index NOT updated

v06

  • Format, layout, and fonts changed. FrontPage2000 used as the editor (previously FrontPage98).
  • Error with navigation bar pics fixed.
  • Commentary text (red) added on each page (will not appear in the final version).
  • Examples and explanatory text added for almost all Properties.

v05

  • Major changes to section "Concepts". Many examples added.

How to find pages modified in a version

  • Select tab "Search".
  • Enter letter "v" + 2-digit version number. For example "v07".
  • Click "List Topics". A list of all topics modified in the version is displayed.

022.gif (13742 Byte)

Finding incomplete pages

Search for text "XX" (any page that tta considers not ready for release is marked with "XX").


e-g term reference

Page#: 0_2_e-g_term_reference.htm

v09 000224TTA: last update.

English-German term reference

This reference only appears in the internal help version.

  • properties. a list of all english and german properties (in alphabetical order for the english properties)
  • menus. all menus in designer.
  • toolbars. all toolbars (toolbar tooltip text) in designer.
  • dialogs. all dialogs.


e-g properties

Page#: 0_2_1_e-g_properties.htm

v10 000331TTA: last edit.

Properties List

The following 2 tables list the english and german properties.

Properties marked with "*" are not covered in this help version.

Any value that are available for selection for the property are shown in the table in blue text.

Property naming errors in Designer

There are several discrepancies between the English and German versions:

  • "Farbe wenn aktiv" (G): The property and subproperty have the same name. The E names are different.
  • "Font" / "Default font" (E): Different names for the same thing (G names are both "Schrift").
  • "Property" / "Value" (E): In the G version "Property" is "Wert". I think this is an error (should be "Property"?).
  • "Bounds" (E) = "Position" (G). This is confusing, because both E and G use "Position" for the location of the header/footer. "Position" (G) should probably be a more accurate translation of "Bounds" (E).

Check the red text in the tables below for the above-mentioned problems and for various spelling errors (in the property names).

E-G properties (E alphabetical)

File # | E | G
 | *DSN Name | *DSN-Name
 | *External DB | *Externe DB
 | *ODBC Timeout | *ODBC Wartezeit
 | *Password | *Passwort
 | *SQL-Statements Close | *SQL-Statements Close
 | *SQL-Statements StartUp | *SQL-Statements StartUp
 | *User Name | *Benutzername
7_01 | Action Compute DLL-Call Dialog-Call Dailog Accept Dialog Cancel | Aktion Berechnen DLL-Aufruf Dialog-Aufruf Dialog Annehmen Dialog Abbrechen
7_02 | ActivColor AppDef UserDef | Farbe wenn aktiv (property) (property and subproperty are identical in german) Anwendung Individuell
7_03 | Alignment Left Right | Ausrichtung Links Rechts
7_04 | AppActiveColor | Farbe akt. Element
7_05 | Attribute | Attribut
7_06 | AVAILABLE-Property | AVAILABLE-Property
7_07 | Background | Hintergrundfarbe
7_08 | Background color(R,G,B) | Hintergrundfarbe(R,G,B)
7_09 | Bounds | Position (boundaries)
7_10 | Calculation Automatic Manual | Berechnung
7_11 | Caption Delete | Caption Löschen
7_12 | Caption New | Caption Neu
7_121 | ChkDynamic Yes/No | CheckDynamic Ja/Nein
7_122 | ChkOtherAvailibility (spelling error) Yes/No | ChkAndereAvailable Ja/Nein
7_123 | ChkOtherVisibility Yes/No | ChkAndereVisibile (spelling error) Ja/Nein
7_124 | ChkOwnAvailibility (spelling error) None All List Page | ChkSelbstAvailable Kein Alle Liste Seite
7_125 | ChkValidation Yes/No | ChkPlausibilität Ja/Nein
7_13 | Color | Farbe
7_14 | Column | Spalten
7_15 | Columns moveable Yes/No | Spalten veränderbar Ja/Nein
7_151 | Compute OnExit OnChange | Berechnen Beim Ändern Nach Verlassen
7_152 | ComputeResult Yes/No | BerechnenErgebnis Ja/Nein
7_16 | Conversion List | Umwandlungsliste
7_17 | ConvertAttr | Umwandlungs-Attribut
7_18 | Count attribute | Zähler-Attribut
7_19 | Currency symbol On/Off | Währungs-Symbol Ein/Aus
7_20 | Data column | Datenspalte
7_21 | Data elements Selected Not selected | Datenelemente ausgewählt nicht ausgewählt
7_22 | DataIndicator On/Off | Datenzustand Ein/Aus
7_23 | Decimal position | Dezimalposition
7_24 | Default font ("Default font" and "Font" are both "Schrift" in G) | Schrift
7_25 | Defolding Automatic Manual | Expandieren Automatisch Manuell
7_26 | Devisualize Selected Not selected | Verbergen ausgewählt nicht ausgewählt
7_27 | DI Rule | Zustandsregel
7_28 | Dialog-Description | Dialog-Beschreibung
7_29 | Dll-Description | Dll-Beschreibung
7_30 | ElemActiveColor | Farbe wenn aktiv (subproperty) (property and subproperty are identical in german)
7_31 | Element3D Yes/No | 3D-Effekte Ja/Nein
7_32 | Font ("Default font" and "Font" are both "Schrift" in G) | Schrift (this file NOT in German help)
7_325 | Footer Yes/No | Fusszeile Ja/Nein
7_331 | Format (application) Individual 640*480 800*600 1024*768 | Format (Anwendung) Individuell 640*480 800*600 1024*768
7_33 | Format (element) dd/mm/yy dd/mm/yyyy mm/dd/yy yy/mm/dd dd.mm.yyyy dd-mm-yyyy MMM dd,yyyy dd-MMM-yyy | Format (Element) dd/mm/yy dd/mm/yyyy mm/dd/yy yy/mm/dd dd.mm.yyyy dd-mm-yyyy MMM dd,yyyy dd-MMM-yyy
7_34 | Frame font | Rahmenschrift
7_35 | Frame width | Rahmenbreite
7_36 | FrameMoveable Yes/No | Frame veränderbar Ja/Nein
7_37 | Graphics type Line Vertical Bar Horizontal Bar Vertical 3D bar Vertical Gantt Horizontal Gantt Pie 3D Pie | Darstellungstyp Linie Vertical Bar Horizontal Bar Vertical 3D bar Vertical Gantt Horizontal Gantt Pie 3D Pie
7_38 | Group | Zuordnung
7_385 | Header Yes/No | Kopfzeile Ja/Nein
7_39 | Header font | Header Schrift
7_40 | Height (application) | Höhe (Anwendung)
7_405 | Height (header/footer) | Höhe (Kopfzeile/Fusszeile)
7_41 | HelpID | HelpID
7_42 | Identification | Identifizierung
7_43 | Identification Grid | Identifizierungs-Grid
7_435 | Indexed | Zeilen-Indizierung Ja/Nein
7_44 | Iteration count | Durchlauf-Zähler
7_45 | Iteration property | Durchlauf-Wert
7_46 | Iteration type Attribute Property Counter | Anzahl der Durchläufe Attribut Wert Zähler
7_47 | Key column | Schlüsselspalte
7_48 | Left | Links
7_49 | Legend placement Right Bottom | Plazierung der Legende Rechts Unten
7_50 | Level Level0 ... Level7 | Ebene Ebene0...Ebene7
7_501 | List (...;...) | Liste (...;...)
7_51 | Mask | Maskierung
7_52 | MaxFrameWidth | Maximalbreite
7_53 | Maximum | Maximum
7_54 | Media file | Bild-Datei
7_55 | MinFrameWidth | Mindestbreite
7_56 | Minimum | Minimum
7_57 | Multiline Yes/No | Mehrzeilig Ja/Nein
7_58 | Multiple Yes/No | Mehrfach Ja/Nein
7_59 | Name (application) | Name (Anwendung)
7_595 | Name (workarea/page) | Name (Bereich/Seite)
7_60 | New Session Yes/No | Neue Sitzung Ja/Nein
7_61 | Next line | Nächste Zeile
7_62 | Number of columns | Anzahl Spalten
7_63 | Off conversion list | AUS-Umwandlungsliste
7_64 | Off symbol | AUS-Symbol
7_641 | On symbol | AN-Symbol
7_65 | Order Individual Standard | Reihenfolge Individuell Standard
7_653 | Position (footer) Right Bottom | Position (Kopfzeile) Rechts Oben
7_655 | Position (header) Right Top | Position (Fusszeile) Rechts Unten
7_66 | ProductModel | Produktmodell
7_67 | Property | Wert (Property)
7_68 | Property for | Werte für
7_69 | Series | Serien
7_70 | Source | Quelle
7_71 | StartAttr No Constant Dynamic | StartAttr Nein Konstante Dynamisch
7_72 | Strict check Yes/No | Obligatorisch Ja/Nein
7_73 | Style (application) Notebook/Simple | Stil (Anwendung) Einfach Notebook
7_731 | Style (workarea) Simple/Frame | Stil (Bereich) Einfach Frame
7_75 | Tab color | Tab Farbe
7_74 | Tab font | Seitenschrift
7_76 | Title | Titel
7_771 | Tooltip (static) Yes/No | Tooltip (Statisch) Ja/Nein
7_77 | Tooltip (static/dynamic) No Static Dynamic | Tooltip (Statisch/Dynamisch) Nein Statisch Dynamisch
7_78 | Tooltip text | Text
7_79 | Top | Oben
7_80 | Type (entry elements) Text Date Currency Number ComboBox RadioButton CheckBox RadioGroup Mask | Typ (Eingabeelement) Text Datum Währung Numerisch ComboBox RadioButton CheckBox RadioGroup Maske
7_807 | Type (ExtendedGrid column) Text Number Currency Date Mask ComboBox | Typ (Spalte ExtendedGrid) Text Numerisch Währung Datum Maske ComboBox
7_805 | Type (ExtendedGrid) ExtendedGrid | Typ (ExtendedGrid) ExtendedGrid
7_803 | Type (Graphic) Graphics | Typ (Grafisches Element) Graphische Darstellung
7_806 | Type (Grid column) Text Number Currency | Typ (Spalte Grid) Text Numerisch Währung Datum Maske-Ergebnis
7_804 | Type (Grid) Grid | Typ (Grid) Grid
7_801 | Type (Result elements) Result Number result Currency result Date result Mask | Typ (Ergebniselement) Ergebnis Numerisches Ergebnis Währungs-Ergebnis Datums-Ergebnis Maske-Ergebnis
7_802 | Type (visual elements) 3D-Area Border Label Line Media | Typ (Anzeigeelement) Label Rahmen 3D-Fläche Linie Bild
7_81 | Usage Input Output | Herkunft Input Output
7_82 | Value | Wert
7_821 | Version | Version
7_83 | Version info Yes/No | Versions-Info Ja/Nein
7_84 | Visible (element) Yes No Check Value | Visible (element) Ja Nein Wert
7_845 | Visible (workarea/page) Yes No Property | Visible (bereich/seite) Ja Nein Wert
7_85 | Visualize Selected Not selected | Einblenden Selected Note selected
7_851 | Width (application) | Breite (Anwendung)
7_86 | Width (Grid/ExtendedGrid column) | Breite (Grid/ExtendedGrid Spalte)
7_87 | X-axe name | Name der X-Achse
7_88 | Y-axe name | Name der Y-Achse

G-E properties (G alphabetical)

File # | G | E
 | *Benutzername | *User Name
 | *DSN-Name | *DSN Name
 | *Externe DB | *External DB
 | *ODBC Wartezeit | *ODBC Timeout
 | *Passwort | *Password
 | *SQL-Statements Close | *SQL-Statements Close
 | *SQL-Statements StartUp | *SQL-Statements StartUp
7_31 | 3D-Effekte Ja/Nein | Element3D Yes/No
7_01 | Aktion Berechnen DLL-Aufruf Dialog-Aufruf Dialog Annehmen Dialog Abbrechen | Action Compute DLL-Call Dialog-Call Dailog Accept Dialog Cancel
7_641 | AN-Symbol | On symbol
7_46 | Anzahl der Durchläufe Attribut Wert Zähler | Iteration type Attribute Property Counter
7_62 | Anzahl Spalten | Number of columns
7_05 | Attribut | Attribute
7_03 | Ausrichtung Links Rechts | Alignment Left Right
7_64 | AUS-Symbol | Off symbol
7_63 | AUS-Umwandlungsliste | Off conversion list
7_06 | AVAILABLE-Property | AVAILABLE-Property
7_151 | Berechnen Beim Ändern Nach Verlassen | Compute OnExit OnChange
7_152 | BerechnenErgebnis Ja/Nein | ComputeResult Yes/No
7_10 | Berechnung | Calculation Automatic Manual
7_54 | Bild-Datei | Media file
7_851 | Breite (Anwendung) | Width (application)
7_86 | Breite (Grid/ExtendedGrid Spalte) | Width (Grid/ExtendedGrid column)
7_11 | Caption Löschen | Caption Delete
7_12 | Caption Neu | Caption New
7_121 | CheckDynamic Ja/Nein | ChkDynamic Yes/No
7_122 | ChkAndereAvailable Ja/Nein | ChkOtherAvailibility (spelling error) Yes/No
7_123 | ChkAndereVisibile (spelling error) Ja/Nein | ChkOtherVisibility Yes/No
7_125 | ChkPlausibilität Ja/Nein | ChkValidation Yes/No
7_124 | ChkSelbstAvailable Kein Alle Liste Seite | ChkOwnAvailibility (spelling error) None All List Page
7_37 | Darstellungstyp Linie Vertical Bar Horizontal Bar Vertical 3D bar Vertical Gantt Horizontal Gantt Pie 3D Pie | Graphics type Line Vertical Bar Horizontal Bar Vertical 3D bar Vertical Gantt Horizontal Gantt Pie 3D Pie
7_21 | Datenelemente ausgewählt nicht ausgewählt | Data elements Selected Not selected
7_20 | Datenspalte | Data column
7_22 | Datenzustand Ein/Aus | DataIndicator On/Off
7_23 | Dezimalposition | Decimal position
7_28 | Dialog-Beschreibung | Dialog-Description
7_29 | Dll-Beschreibung | Dll-Description
7_45 | Durchlauf-Wert | Iteration property
7_44 | Durchlauf-Zähler | Iteration count
7_50 | Ebene Ebene0...Ebene7 | Level Level0 ... Level7
7_85 | Einblenden Selected Note selected | Visualize Selected Not selected
7_25 | Expandieren Automatisch Manuell | Defolding Automatic Manual
7_13 | Farbe | Color
7_04 | Farbe akt. Element | AppActiveColor
7_02 | Farbe wenn aktiv (property) (property and subproperty are identical in german) Anwendung Individuell | ActivColor AppDef UserDef
7_30 | Farbe wenn aktiv (subproperty) (property and subproperty are identical in german) | ElemActiveColor
7_331 | Format (Anwendung) Individuell 640*480 800*600 1024*768 | Format (application) Individual 640*480 800*600 1024*768
7_33 | Format (Element) dd/mm/yy dd/mm/yyyy mm/dd/yy yy/mm/dd dd.mm.yyyy dd-mm-yyyy MMM dd,yyyy dd-MMM-yyy | Format (element) dd/mm/yy dd/mm/yyyy mm/dd/yy yy/mm/dd dd.mm.yyyy dd-mm-yyyy MMM dd,yyyy dd-MMM-yyy
7_36 | Frame veränderbar Ja/Nein | FrameMoveable Yes/No
7_325 | Fusszeile Ja/Nein | Footer Yes/No
7_39 | Header Schrift | Header font
7_41 | HelpID | HelpID
7_81 | Herkunft Input Output | Usage Input Output
7_07 | Hintergrundfarbe | Background
7_08 | Hintergrundfarbe(R,G,B) | Background color(R,G,B)
7_40 | Höhe (Anwendung) | Height (application)
7_405 | Höhe (Kopfzeile/Fusszeile) | Height (header/footer)
7_42 | Identifizierung | Identification
7_43 | Identifizierungs-Grid | Identification Grid
7_385 | Kopfzeile Ja/Nein | Header Yes/No
7_48 | Links | Left
7_501 | Liste (...;...) | List (...;...)
7_51 | Maskierung | Mask
7_52 | Maximalbreite | MaxFrameWidth
7_53 | Maximum | Maximum
7_58 | Mehrfach Ja/Nein | Multiple Yes/No
7_57 | Mehrzeilig Ja/Nein | Multiline Yes/No
7_55 | Mindestbreite | MinFrameWidth
7_56 | Minimum | Minimum
7_61 | Nächste Zeile | Next line
7_59 | Name (Anwendung) | Name (application)
7_595 | Name (Bereich/Seite) | Name (workarea/page)
7_87 | Name der X-Achse | X-axe name
7_88 | Name der Y-Achse | Y-axe name
7_60 | Neue Sitzung Ja/Nein | New Session Yes/No
7_79 | Oben | Top
7_72 | Obligatorisch Ja/Nein | Strict check Yes/No
7_49 | Plazierung der Legende Rechts Unten | Legend placement Right Bottom
7_09 | Position (boundaries) | Bounds
7_655 | Position (Fusszeile) Rechts Unten | Position (header) Right Top
7_653 | Position (Kopfzeile) Rechts Oben | Position (footer) Right Bottom
7_66 | Produktmodell | ProductModel
7_70 | Quelle | Source
7_35 | Rahmenbreite | Frame width
7_34 | Rahmenschrift | Frame font
7_65 | Reihenfolge Individuell Standard | Order Individual Standard
7_47 | Schlüsselspalte | Key column
7_24 | Schrift | Default font ("Default font" and "Font" are both "Schrift" in G)
7_32 | Schrift (this file NOT in German help) | Font ("Default font" and "Font" are both "Schrift" in G)
7_74 | Seitenschrift | Tab font
7_69 | Serien | Series
7_14 | Spalten | Column
7_15 | Spalten veränderbar Ja/Nein | Columns moveable Yes/No
7_71 | StartAttr Nein Konstante Dynamisch | StartAttr No Constant Dynamic
7_73 | Stil (Anwendung) Einfach Notebook | Style (application) Notebook/Simple
7_731 | Stil (Bereich) Einfach Frame | Style (workarea) Simple/Frame
7_75 | Tab Farbe | Tab color
7_78 | Text | Tooltip text
7_76 | Titel | Title
7_771 | Tooltip (Statisch) Ja/Nein | Tooltip (static) Yes/No
7_77 | Tooltip (Statisch/Dynamisch) Nein Statisch Dynamisch | Tooltip (static/dynamic) No Static Dynamic
7_802 | Typ (Anzeigeelement) Label Rahmen 3D-Fläche Linie Bild | Type (visual elements) 3D-Area Border Label Line Media
7_80 | Typ (Eingabeelement) Text Datum Währung Numerisch ComboBox RadioButton CheckBox RadioGroup Maske | Type (entry elements) Text Date Currency Number ComboBox RadioButton CheckBox RadioGroup Mask
7_801 | Typ (Ergebniselement) Ergebnis Numerisches Ergebnis Währungs-Ergebnis Datums-Ergebnis Maske-Ergebnis | Type (Result elements) Result Number result Currency result Date result Mask
7_805 | Typ (ExtendedGrid) ExtendedGrid | Type (ExtendedGrid) ExtendedGrid
7_803 | Typ (Grafisches Element) Graphische Darstellung | Type (Graphic) Graphics
7_804 | Typ (Grid) Grid | Type (Grid) Grid
7_807 | Typ (Spalte ExtendedGrid) Text Numerisch Währung Datum Maske ComboBox | Type (ExtendedGrid column) Text Number Currency Date Mask ComboBox
7_806 | Typ (Spalte Grid) Text Numerisch Währung Datum Maske-Ergebnis | Type (Grid column) Text Number Currency
7_17 | Umwandlungs-Attribut | ConvertAttr
7_16 | Umwandlungsliste | Conversion List
7_26 | Verbergen ausgewählt nicht ausgewählt | Devisualize Selected Not selected
7_821 | Version | Version
7_83 | Versions-Info Ja/Nein | Version info Yes/No
7_845 | Visible (bereich/seite) Ja Nein Wert | Visible (workarea/page) Yes No Property
7_84 | Visible (element) Ja Nein Wert | Visible (element) Yes No Check Value
7_19 | Währungs-Symbol Ein/Aus | Currency symbol On/Off
7_82 | Wert | Value
7_67 | Wert (Property) | Property
7_68 | Werte für | Property for
7_18 | Zähler-Attribut | Count attribute
7_435 | Zeilen-Indizierung Ja/Nein | Indexed
7_38 | Zuordnung | Group
7_27 | Zustandsregel | DI Rule


e-g menus

Page#: 0_2_2_e-g_menus.htm

v08 000224TTA: lastedit.

E-G menus

File

Datei

Open...

Öffnen...

New

Neu

Close

Schließen

Save

Speichern

Save as...

Speichern unter...

Print

Drucken

Export screen shot

Bildschirmanzeige exportiern

Test

Test

Information

Information

Exit

Ende

Edit

Bearbeiten

Undo

Ruckgängig machen

Find

Suchen...

Find Next

Weiter suchen

Copy

Kopieren

Paste

Einfügen

Cut

Aussschneiden

Delete

Löschen

Select All

Alle markieren

Group

Markierte

Alignment

Ausrichtung

Align Left

Links ausrichten

Align Right

Rechts ausrichten

Align Up

Oben ausrichten

Align Down

Unten ausrichten

Make same size

Größe angleichen

Align Height

Höhe angleichen

Align Width

Breite angleichen

Space evenly

Gleichmäßig aufteilen

Align Vertical

Vertikal ausrichten

Align Horizontal

Horizontal ausrichten

Disk operations

Operationen

Write group to disk

Auslagern

Read group from disk to clipboard

In das Clipboard einlesen

Elements reordering

Elemente neu anordnen

Options

Optionen

Inspector

Inspektor

Warnings

Hinweis

Limit Line

Anwendungsrahmen

Grid

Grid

Display order

Tabulator-Reihenfolge

Levels

Ebene

All levels

Alle Ebenen

Level1 (...Level7)

Ebene1 (...Ebene7)

Options...

Optionen...

Move inspector upleft

Inspektor links oben

Workbench synchronization

Workbench-Synchronisierung

Tools

Tools

Autosize...

Autosize...

Synchronize...

Synchronisieren...

Window

Fenster

Arrange

Anordnen

Cascade

Kaskadieren

Tile horizontal

Horizontal teilen

Tile vertical

Vertikal teilen

View palette

Funktionen

View tools

Elemente

View alignments

Ausrichtung anzeigen

View header/footer tools

Kopfzeile/Fusszeile tools

Options...

Optionen...

Help

Hilfe

Contents

Inhalt...

Info

Info

(end of file)


e-g toolbars

Page#: 0_2_25_e-g_toolbars.htm

v08 000224TTA: lastedit.

E-G toolbars

Common

Allgemein

New layout file

Neue Layout-Datei

Open layout file

Layout-Datei öffnen

Save layout

Layout speichern

Cut element and copy it to clipboard

Element ausscheiden

Copy element to clipboard

Element in die Zwischenablage kopieren

Paste element from clipboard

Element einfügen

Print

Element drucken

Visual palette

Komponentenpalette

Pointer operation

Mauszeiger einschalten

New edit field

Neues Eingabefeld definieren

New combobox

Neue Combobox definieren

New checkbox

Neue Checkbox definieren

New radiobutton

Neuen Radiobutton definieren

New pushbutton

Neuen Pushbutton definieren

New label

Neues Label definieren

New border

Neuen Rahmen definieren

New grid list

Neues Grid definieren

Extended grid list

Extended Grid definieren

New 3D border

Neue 3D-Fläche definieren

New line

Neue Linie definieren

New multimedia element

Neues Bildelement definieren

New VP/MS result field

Neues VP/MS-Ergebnisfeld definieren

New radiogroup

Neue Radiogroup definieren

New graphics element

New graphics element

Close layout file

(no tooltip)

Test application

Anwendung testen

Groups

Markierte

Align group to the left

Markierte Elemente links ausrichten

Align group to the right

Markierte Elemente rechts ausrichten

Align group to the upper border

Markierte Elemente am oberen Rand ausrichten

Align group to the lower border

Markierte Elemente am unteren Rand ausrichten

Make all elements the same height

Allen markierten Elementen dieselbe Höhe zuweisen

Make all elements the same width

Allen markierten Elementen dieselbe Breite zuweisen

Spread vertical evenly

Vertikal gleichmäßige Abstände

Spread horizontal evenly

Horizontal gleichmäßige Abstände

Group all objects on the page

Alle Objekte auf dieser Seite markieren

Save marked group to disk

Alle markierten Elemente auf die Platte schreiben

Read group from disk and copy it to clipboard

Elemente von der Platte lesen und in das Clipboard schreiben

Show Header / Footer

(none)

App header

Kopfzeile der Anwendung

App footer

Fusszeile der Anwendung

WArea header

Kopfzeile des Bereichs

WArea footer

Fusszeile des Bereichs

(end of file)


e-g dialogs

Page#: 0_2_3_e-g_dialogs.htm

v08 000222TTA: created.

E-G dialogs

optionsdialog.gif (6932 Byte)

2__2_options.gif (5207 Byte)

2__2_1 options application.gif (8077 Byte)

2__2_1_options_application.gif (7230 Byte)

2__2_2 options workarea.gif (6904 Byte)

2__2_2_options_workarea.gif (5105 Byte)

2__2_3 options page.gif (6411 Byte)

2__2_3_options_page.gif (4938 Byte)

2__2_4 options element.gif (7641 Byte)

G2__2_4_options_element.gif (7013 Byte)

2__2_5 options usability.gif (6890 Byte)

2__2_5_options_usability.gif (4593 Byte)

2__2_6 options designer.gif (6580 Byte)

2__2_6_options_designer.gif (5451 Byte)

2__2_7 options ifos.gif (7180 Byte)

2__2_7_options_ifos.gif (6496 Byte)

E2__3_inspector.gif (3672 Byte)

G2__3_inspector.gif (2684 Byte)

E2__4_test.gif (2663 Byte)

G2__4_test.gif (2761 Byte)

E2__5_find.gif (1940 Byte)

G2__5_find.gif (2083 Byte)

E2__6_elementsreordering.gif (4460 Byte)

000222TTA: i couldnt open the elements reordering dialog in the latest german version of designer i had... so no pic.

E2__7_autosize.gif (5641 Byte)

G2__7_autosize.gif (6331 Byte)

E2__8_crfpreparation.gif (5069 Byte)

G2__8_crfpreparation.gif (5403 Byte)

E2__9_screenshot.gif (4048 Byte)

G2__9_screenshot.gif (4096 Byte)

(end of file)


Contact

Page#: 0_5_contact.htm

v13 000523TTA: last edit.

Contact

Mynd SoftwareConsult GmbH

Taubenholzweg 1

D-51105 Köln

Germany

Tel : (+49) (0) 221 - 8029 - 0

FAX : (+49) (0) 221 - 8029 - 999

Email: info@mynd.de

Web: www.mynd.de


Copyright and trademarks

Page#: 0_7_copyright.htm

v13 000609TTA: last edit.

Copyright and trademarks

Copyright

Copyright 2000 PMS MICADO. All rights reserved.

VP/MS Designer Help. 9 June 2000.

Trademarks

Windows and Windows/NT are registered trademarks of the Microsoft Corp.


Using this help

Page#: 0_70_using_this_help.htm

v13 000525TTA: created.

v13 000531TTA: stuff for html uncompiled added.

Using this help

Text conventions

The Designer is always used with the Workbench. Workbench attributes can sometime have string values that include double quotations marks (") (the quotation mark is not a string delimiter, but actually part of the string). This is very important, because leaving out the quotation marks in the Workbench value will generate no errors. Therefore, this help often delimits string values with less-than (<) and greater-than (>) signs.

Compiled vs. non-compiled HTML Help

Compiled HTML help is a single .chm file. This file can be displayed outside the browser (it is also displayed when opening help from within the Designer application).

Non-compiled HTML help consists of:

  • Multiple .htm (or .html) files (1 file for each page).
  • Multiple .gif files.
  • Java class files for the TOC and index.

Finding the topic you need

Html help provides the following tabs:

  • Contents. TOC presentation of all topics.
  • Index. All topics organized alphabetically.
  • Search (compiled HTML Help only). Provides a result list of topics for a keyword search.
  • Locate (non-compiled HTML Help only). Displays the location of the currently displayed page in the TOC.

If a topic has been selected in the Index or Search tab, then the TOC entry for that topic in the Contents tab will be highlighted if the Contents tab is selected.

Navigating between topics

There are 6 types of navigation buttons:

  • 00_home.gif (78 Byte) Home (on the help page) or 00_startpage.gif (263 Byte) (in the compile HTML Help toolbar). Click on this button to display the help main (home) topic. Note: Clicking on the <Home> icon in the browser toolbar (when viewing non-compiled help) will display the browser's homepage, not the homepage for the help.
  • 00_up.gif (90 Byte) Up. Displays the parent topic in the table of contents.
  • 00_next.gif (90 Byte) Next. Displays the next topic on the same level under the same TOC parent topic (this is not the same as the toolbar Forward button).
  • 00_previous.gif (91 Byte) Previous. Displays the previous topic on the same level under the same TOC parent topic (this is not the same as the toolbar Previous button).
  • 00_reverse.gif (163 Byte) Back. Displays the earlier topic in the topic history (no relationship to the TOC). Clicking on this button does not change the topic history, only the position in the topic history.
  • 00_forward.gif (180 Byte) Forward. Displays the later topic in the topic history (no relationship to the TOC). Clicking on this button does not change the topic history, only the position in the topic history.


Other sources of information

Page#: 0_71_docs.htm

v10 000410TTA: last edit.

v13 000531TTA: stuff for non-compiled html help added.

Other sources of information

Help

Online help is available for:

  • Designer (also on the CD ROM as \docs\english\designer\designer.chm (HTML compiled format)).
  • Workbench (also on the CD ROM as \docs\english\workench\workbench.hlp (Windows 95 help format)).
  • IFOS Report Editor (also on the CD ROM as \docs\english\ifos\reporteditor.hlp (Windows 95 help format)).

000410TTA: XX: this exists in german only... are we going to have an english version?

IFOS Report Viewer (also on the CD ROM as \docs\english\ifos\reportviewer.hlp)

Designer help is also available in non-compiled HTML help format (for viewing in a browser) on the CD ROM as \docs\english\designer\designer.htm.

Manuals

The following manuals are available on the CD ROM:

  • \docs\english\vpms\vpms_getting_started.pdf: VP/MS Getting Started manual. Includes a step-by-step tutorial for quickly gaining experience with VPMS.
  • \docs\english\workbench\workbench.doc: Workench User’s Guide.

000410TTA: these docs are not ready:

\docs\english\ifos\designer.pdf: Designer User's Guide. TTA XX: i need to create this doc from the help.

\docs\english\ifos\reporteditor.doc: IFOS Report Editor User’s Guide. TTA XX: currently available only in german.

\docs\english\ifos\reportviewer.doc: IFOS Report Viewer User’s Guide. TTA XX: will there ever be such a doc (nothing in the database for G or E).


Release notes

Page#: 0_8_releasenotes_all.htm

Release notes

  • Version 3.30
  • Version 3.25

See also:

  • Designer version information in the Status bar
  • Designer version information in the Info dialog


Release notes v3.30

Page#: 0_82_releasenotes_v3.30.htm

v09 000302TTA: reference to report changed. some stuff deleted (not within scope of this help file).

Release notes v3.30

HTML Help

Help for Designer is now in Microsoft HTML Help format.

Application/Workarea header/footer

Layout componentsnow include application header/footer and workarea header/footer.

For details see Adding/Deleting layout components subsections:

  • Application header/footer
  • Workarea header/footer.
  • Header/footer toolbar.

Workarea/Page visibility with property <Visible>

Workareas and pages visibility can be controlled using property Visible(previously visibility of workareas and pages could only be controlled using Visualize/Devisualize).

Any row can be deleted in ExtendedGrid

The ExtendedGrid now supports inserting or deleting of a row at any location in the ExtendedGrid (previously only the last row could be inserted or deleted).

Saving page views to .bmp file ("export screen shot")

Layout pages can now be saved to .bmp files by selecting menu option File / Export screen shot to open the Select page for screen shot dialog. Concept details.

Option dialog available from menu item "Window / Options..."

If no layout is open in the Designer: The Options dialog can be opened by selecting from the main menu "Window / Options...".

Extended layout report functionality

The functionality of the layout reports has been extended.

The CRF preparation dialog and the IFOS options dialog have been updated accordingly.

v09 000302TTA: old text:

The Options dialog for IFOS includes a selection for the Full version report control group. This group defines the path/filename of the IFOS report template that specifies the following data for elements (pages, areas):

Name

Title

Version

Description

Created by

Creation date

Updated by

Update date

Update description

The Options dialog for IFOS includes a selection for the Reduced version report Sorter control group. This group defines the path/filename of the IFOS report template that specifies the following data for elements (pages, areas):

Name

Title

Version

Update date

Print dialog

The Print dialog (menu File/Print) now includes the following:

Report type radiobutton group. Includes 2 radiobuttons: Standard (standard report) and Version (report with additional version information).

Version information radiobutton group. Includes 2 radiobuttons that determine the content of the printed report: Reduced (reduced report) or Full (full report).

License support

Software license functionality has been added.

The license is implemented using registry entry HKEY_LOCAL_MACHINE/SOFTWARE/CAFGmbh/vpms Designer/VPMS/. If the required information is not enterd in fields LicenceName and LicenceNR, then only demo-version functionality of Designer will be available.

License support requires service.dll.

Note: Select menu item Help/Info for information about what version (full or demo) of Designer is being used.

v09 000302TTA: i dont think this stuff is within the help scope currently.

New default for PRELOAD_ACTION_ELEM_ONLY

The default value is now ON.

New API function XPLSetVar (build 004)

Syntax

long XPLSetVar(XPLCOMM *block)

Remarks

XPLSetVar assumes to attribute or element defined in block->psz


Release notes v3.25

Page#: 0_81_releasenotes_v3.25.htm

Release notes v3.25

New runtime model initialization file: vds_rt.ini

vds_rt.ini is new.

Section MAIN

DYNAMIC_LIST_BUFFER_SIZE (default = 255). Default buffer size for dynamics.

Section PERFORMANCE

INITIALIZE_ATTRIBUTES (default = ON).

  • ON: Non-initialized attributes are initialized before saving data (XPLGetData).
  • OFF: Non-initialized attributes are NOT initialized before saving data (XPLGetData).

RECALCULATE_VISIBLE_PAGES_ONLY (default = OFF).

  • ON: Invisible pages are reinitialized and recalculated when saving data (XPLGetData).
  • OFF: Invisible pages are NOT reinitialized and recalculated when saving data (XPLGetData).

LOADDATA_COUNTATTR_RECALCDYNAMIC (default = ON).

When creating a new page for a multiple node, the checking of dynamics can now be disabled. Checking the dynamics can significantly reduce performance for large dynamic lists.

  • ON: All dynamics are recalculated.
  • OFF: Dynamics are NOT recalculated.

PRELOAD_ACTION_ELEM_ONLY (default OFF).

The model attributes for elements with properties Visualize/Devisualize (CheckBox's and RadioButtons) can be optionally initialized at startup. Optional initialization means that the model attribute is only initialized if a page or workarea has been specified in the corresponding element property's Visualize or Devisualize list.

  • ON: Attributes are initialized only for CheckBox's and RadioButtons with page/workarea selected in the Visualize or Devisualize list.
  • OFF: Attributes are initialized for all CheckBox's and RadioButtons.

New warning messages

  • "Missing identification grid." Graphics identification grid has not been defined.
  • "Automatically generated name has not been changed." Automatically generated name for page or element was not redefined.
  • "No elements are defined on page."
  • "No identification element is defined for multiple page." Property Identification for multiple page is not defined.


Installation of Designer

Page#: 1_installation.htm

v09 000224TTA: changed.

Installation

  • System requirements
  • System limitations
  • Step-by-step


Minimum system requirements

Page#: 1_1_system_reqs.htm

v10 000410TTA XX: is this correct??

Designer minimum system requirements

Design-time:

  • IBM PC 486
  • Windows 95 or Microsoft Windows NT 4
  • 32MB RAM
  • 20MB available hard disk space

Run-time:

Windows 3.1

  • 486/50 Mhz
  • 8 MB memory

Windows 95

  • Pentium/90 Mhz
  • 20 MB memory

Windows/NT

  • Pentium/133 Mhz
  • 32 MB memory


System limitations

Page#: 1_5

v10 000410TTA XX: is this correct?

System limitations

Technical limitations (16-bit version):

  • Maximum name length: 60 Characters
  • Maximum number of results per page: 54
  • Maximum number of EditFields per page: 200


Step-by-step

Page#: 1_2_installation.htm

000410TTA: last edit.

Installation step-by-step

The installation procedure differs slightly, depending on whether Designer has already been installed.

  • Installing from CD ROM (Designer not already installed)
  • Installing from CD ROM (Designer already installed)

Note: It is always recommended to install VPMS components in the following order:

  • VFrame
  • Workbench
  • Designer


Installing on computer without Designer

Page#: 1_2_1_install_from_cdrom_NO.htm

v13 000524TTA: updated... however, i installed the version from 24.3.2000, which was the latest version i found on the server.

Installing Designer (Designer not already installed)

  1. Double click on E:\Designer\Setup.exe ("E" = CD ROM drive letter). The <Welcome> dialog appears.
  2. Click Next. The <Get Registration Information> dialog appears.
  3. In the <Licensename> field: Enter your name.
  4. In the <Licensenumber> field: Enter your license number. Note: If no license is entered, a trial version will be installed.
  5. Click Next. The <Registration Information> dialog appears.
  6. Click Next. The dialog <Select destination drive> (for Designer) appears. <C> is the default drive/directory. NOTE: It is highly recommended to use the default setting.
  7. Click Next. The Backup replaced files? dialog appears. Yes is selected.
  8. Click Next. The files for Designer are copied to your harddisk. The dialog Select Destination Directory (for IFOS) appears. C:\Programs\CAF\IFOS is the default drive/directory.
  9. Click Next. The files for IFOS are copied to your harddisk. The dialog Installation Completed! appears.
  10. Click Finish.

Designer is now installed on your computer and available from:

  • Start Menu entry Programs / CAF VPMS / VPMS Designer.
  • Desktop icon VPMS Designer.


Installing on a computer with Designer

Page#: 1_2_2_install_from_cdrom_YES.htm

v13 000524TTA: updated... however, i installed the version from 24.3.2000, which was the latest version i found on the server. this is the same as for designer not installed, except that the destination drive is displayed different and IFOS is not installted (why?).

Installing Designer (Designer already installed)

  1. Double click on E:\Designer\Setup.exe ("E" = CD ROM drive letter). The <Welcome> dialog appears.
  2. Click Next. The <Get Registration Information> dialog appears.
  3. In the <Licensename> field: Enter your name.
  4. In the <Licensenumber> field: Enter your license number. Note: If no license is entered, a trial version will be installed.
  5. Click Next. The <Registration Information> dialog appears.
  6. Click Next. The dialog <Select destination drive> (for Designer) appears. <C:\VPMS\Designer> is the default drive/directory. NOTE: It is highly recommended to use the default setting.
  7. Click Next. The Backup replaced files? dialog appears. Yes is selected.
  8. Click Next. The files for Designer are copied to your harddisk.
  9. Click Finish.

Designer is now installed on your computer and available from:

  • Start Menu entry Programs / CAF VPMS / VPMS Designer.
  • Desktop icon VPMS Designer.


Tutorial

Page#: 11_tutorial.htm

v10 000406TTA: last edit. please note that a lot of the sections are still empty.

v11 000411TTA: enter / select data deleted. display data deleted. calculation section reordered.

v11 000413TTA: topics added.

v13 000605TTA: editted. numbers changed, T37,38 added.

Tutorial

This section presents a tutorial that introduces the basic functionality of the Designer.

All example layouts and models in this tutorial are available on the CD-ROM in directory /docs/english/designer/tutorial.

Workbench models are required for working with Designer. However, if you have no working knowledge of the Workbench, you can still complete this tutorial with the supplied pre-compiled Workbench models.

For a complete step-by-step tutorial of the complete VP/MS toolset (including Designer, Workbench, VFrame and the Report Editor), consult the VP/MS Getting Started manual.

Overview

Basics

  • T01. Example models and layouts.
  • T02. Specify extension defaults.
  • T03. Create a layout
  • T04. Add an element (label) to the layout.
  • T05. Test the layout (using the Designer Test application).

Workbench model

  • T06. Assign a model to the layout.
  • T07. Open the model in the Workbench.

Model attributes/properties in the layout

  • T08. Add model attributes to the layout.
  • T09. Add a model property to the layout.
  • T10. Test the layout.

Workareas, pages, header/footers

  • T11. Add a second workarea to the layout.
  • T12. Add application header/footer to the layout.
  • T13. Add a second page to a workarea.
  • T14. Add workarea header/footer to the layout.

Edit tools

  • T15. Find
  • T16. Cut / Copy / Paste
  • T17. Groups
  • T18. Autosize

Multiple layouts/models

  • T19. Multiple layouts
  • T20. Multiple models

External DLL

  • T21. Calling a DLL from the layout

Layout documentation

  • T22. Component comments
  • T23. Layout report
  • T24. Page screenshot
  • T25. Layout comparison (synchronize)

Tooltips

  • T26. Tooltips

Data types

  • T27. Single-line text
  • T28. Multi-line text
  • T29. Boolean
  • T30. Number
  • T31. Currency
  • T32. Date
  • T33. Mask
  • T34. Table arrays
  • T35. Iteration arrays
  • T36. Multiple-page arrays

Data entry

  • T37. Conversion list
  • T38. Dynamic combobox
  • T39. Element order
  • T40. Start attribute
  • T41. Parameter search
  • T42. Data indicator

Result calculation

  • T43. Page change
  • T44. Focus change
  • T45. Data entry
  • T46. Pushbutton click

Component visibility

  • T47. Design-time
  • T48. Run-time static
  • T49. Run-time dynamic

Component availability

  • T50. Static
  • T51. Dynamic

Where to go from here


Basics

Page#: 11_01_ov_basics.htm

v13 000524TTA: last edit.

Basics

The first part of this tutorial introduces information to help you get the most from the tutorial. You will also create and test your first simple layout.


T01. Using example layouts and models

Page#: 11_02_using_example_files.htm

v13 000605TTA: last edit.

T01. Example layouts and models

The completed layout and any required files for the layout (such as the model) are provided in directory docs\english\designer\tutorial. The name of the completed layout and required files match the page number at the top of the help page. For example, completed layout for T08 is 08.vpl and the completed model is 08.pms.

It is recommended to backup the \tutorial directory and then work through the tutorial, overwriting any files that you edit or create.

Example

Note: If you are totally new to Designer and are planning to do each section starting from the beginning, then go now to the next page now (the text below includes terminology and concepts that you would not require for completing the tutorial).

Assume that you want to start the tutorial at page T08 and that the following files exist:

  1. 08.vpl: Completed design-time layout for page T08.
  2. 08.vpc: Completed runtime layout for page T08.
  3. 08.pms: Completed design-time model for page T08.
  4. 08.vpm: Run-time model for T08.
  5. 07.vpl: Completed design-time layout for page T07.
  6. 06.pms: Completed design-time model for page T06 (assume that changes to the model were not required on page T07 (and thus 07.pms does not exist)).

You would have the following options:

  • Simply open the T08 runtime layout 08.vpc in Designer Test.
  • Open the T08 design-time layout 08.vpl and then click the test button to regenerate and open the T08 runtime layout 08.vpc in Designer Test.
  • Open the T07 design-time layout 07.vpl and follow the step-by-step instructions in T08.
  • (Workbench experience required) Add the required model changes described in T08 to design-time model 06.pms, save the model as 08.pms, compile the model as 08.vpm, and then test the layout with the model (instructions for using the Workbench is outside the scope of this Designer tutorial).


T02. Specify extension defaults

Page#: 11_03_specifying_extension_defaults.htm

v13 000525TTA: english pics added, text editted.

T02. Specify extension defaults

You will now specify the default applications for extension defaults for Designer and (if installed) Workbench. This will allow you to open, for example, a .vpl file in the Designer by simply double-clicking on the .vpl file. This will make completion of the tutorial much faster.

Design-time layout (.vpl)

Do the following:

  1. Open directory \docs\english\designer\tutorial.
  2. Press and hold the Shift key.
  3. Right click on any .vpl file. A pop-up menu appears.
  4. Select "Open With...". The "Open with" dialog appears.
  5. In the list <Choose the program you want to use:>: Select <VDS>. NOTE: VDS should be in the list. If it is not, then click on the <Other...> button and select C:\VPMS\Designer\vds.exe.
  6. Check the checkbox <Always use this program to open this file>.
    11_03_specifying_extension_defaults.gif (5510 Byte)
  7. Click "OK". The file is opened in the Designer.
  8. Close the Designer.

Run-time layout (.vpc)

A run-time layout (.vpc) will be created from the design-time layout (.vpl) and displayed in the Designer Test application by clicking on the <Test> icon in the Designer.

However, by assigning extension ".vpc" to application C:\VPMS\Designer\vds_tx32.exe, you can simply double-click on a .vpc file to open the run-time layout in the Designer Test application .

Do the following:

  1. Open directory \docs\english\designer\tutorial.
  2. Press and hold the Shift key.
  3. Right click on any .vpc file. A pop-up menu appears.
  4. Select "Open With...". The "Open with" dialog appears. Note: An icon for vds_tx32.exe does not exist in the list.
  5. Click <Other...>. The <Open With...> dialog appears.
  6. Double-click on C:\Vpms\Designer\vds_tx32.exe. Note that an icon for vds_tx32 appears in the <Open with> dialog:
    11_03_specifying_extension_defaults1.gif (1024 Byte)
  7. Check the checkbox <Always use this program to open this file>.
  8. Click "OK". The file is opened in the Designer Test.
  9. Close the Designer Test.

Design-time model (.pms)

Assign design-time models (.pms) to C:\VPMS\WBench\Vpms32.exe. Note: This is only necessary if during the tutorial you want to open the design-time models (not necessary to complete the tutorial).


T03. Create new layout

Page#: 11_05_create_new_layout.htm

v13 000525TTA: last edit.

T03. Create new layout

To create a new layout:

  1. Select from the Start menu: <Programs / CAF VPMS / VPMS Designer>. The Designer opens. Note: If the Start menu item is not available: Start vds.exe.
  2. Click on the <Create new layout> icon 2__1_4_1_filenew.gif (105 Byte). A new layout is opened. Note: If the layout is not fully visible: From the Designer menu bar: Select <Window / Cascade>.
    11_05 createnewlayout2.gif (986 Byte)
  3. If the Inspector is not visible: From the menu bar: Select <Options / Inspector>. The Inspector displays all layout properties.
    11_05 createnewlayout3.gif (2272 Byte)
  4. In Inspector tab Application: Set <Width>=<100>.
  5. Set <Height>=<50>. Note the appearance of a dotted red line indicating the boundaries of the layout.
    11_05_createnewlayout7.gif (1336 Byte)
    Note: If the line is not visible: From the main menu select <Options / Limit line>.
  6. Move the cursor to the lower right corner of the box marked by the red dotted line. Note that the cursor becomes an arrow:
    11_05_createnewlayout8.gif (1254 Byte)
  7. Press and hold the left mouse button.
  8. Move the cursor to resize the layout.
    11_05_createnewlayout9.gif (1473 Byte)
  9. Select the Inspector tab <Workarea>.
  10. Change the workarea name to "Area1":
    11_05_createnewlayout4.gif (553 Byte)
    Note: Retype the name even if the name is already <Area1>. Otherwise a warning will be generated that the default name has not been changed.
  11. Select the Inspector tab <Page>.
  12. Change the page name to <A1Page1>.
    11_05_createnewlayout5.gif (689 Byte)
  13. Select <File / Save as> and save the file as 03.vpl. Note the warning message that is generated:
    11_05_createnewlayout6.gif (1406 Byte)

Note: Saving the file as 03.vpl also creates the following files:

  • 03.vpc: Runtime layout.
  • 03.vpd: Interface file.
  • 03.bak: Layout backup.


T04. Add element to layout

Page#: 11_06_add_element.htm

v10 000325TTA: last edit.

v11 000413TTA: info about changing size added.

v13 000605TTA: last edit.

T04. Add element to layout

You will now add a Label element to the layout.

Do the following:

  1. If the layout created in T03 is not open in the Designer: Open 03.vpl.
  2. Click on the icon <New label> 11_06_add_elements.gif (153 Byte).
  3. Click in the layout inside the red dotted line. A Label is added to the layout. Note the default name of the element (the name will be different for your layout).
    11_06_add_elements1.gif (389 Byte)
    Whenever an element is added to the layout, the element is assigned a default name. This name should always be changed (if the name is not changed, a warning message will be generated).
  4. Change the label name to <L_a_1>.
  5. Change label property <Title> to <Attribute 1>.
    11_06_add_elements2.gif (2120 Byte)
  6. Click on the Label to select it.
  7. Position the cursor over any of the solid squares on the Label boundary. Note that the cursor becomes an arrow:
    11_06_addelements9.gif (1230 Byte)
  8. Press and hold the left mouse button.
  9. Move the cursor to resize the Label.
  10. Save the layout as 04.vpl.


T05. Test layout

Page#: 11_07_test_layout.htm

v11 000413TTA: new stuff.

v13 000605 XX: english pics, text added. 1 german pic remains.

T05. Test layout

A run-time layout (.vpc) must have a run-time model (.vpm) in order to be tested (with the Designer Test tool). The run-time model normally includes the definitions of model properties and attributes that are referenced in the layout.

Your simple layout doesn't yet reference any model properties or attributes; however, it still requires a run-time model. Our layout doesnt define a required model (this will be demonstrated later in this tutorial). However, by default a layout without a defined run-time model uses the model empty.vpm in directory \vpms\designer (where vds.exe is located). empty.vpm is an empty run-time model included with Designer, and as the name suggest, doesnt define any properties or attributes.

Do the following:

  1. Open layout 04.vpl if it is not already open in Designer.
  2. Click on Toolbar icon "Test application" 2__1_3_18_test.gif (123 Byte). This automatically generates the .vpc (run-time layout) file.
    A minimized Designer Test dialog appears:
    11_07_testlayout2.gif (795 Byte)
    Note: If the following error message appears:
    11_07_testlayout3.gif (1236 Byte)
    then the default runtime model (empty.vpm) was not found. empty.vpm should have been copied to the required directory during installation. To solve this problem, copy \docs\english\designer\tutorial\empty.vpm to the Designer main directory (\VPMS\Designer).
  3. Close Designer Test.

Note: If the Label was not fully within the boundaries marked by the red dotted line (limit line), then the layout would appear with scroll bars (the scroll bars would also take up space in the layout). For example, for the following design-time layout
11_07_testlayout4.gif (612 Byte)
the resulting runtime layout would be
11_07_testlayout5.gif (814 Byte)


Workbench model

Page#: 11_08_ov_workbench_model.htm

v13 000605TTA: last edit.

Workbench model

A layout with any computational functionality (business logic) requires a run-time model. The runtime model defines the business logic. This part of the tutorial introduces the basics for working with models.


T06. Assign a model to the layout

Page#: 11_10_model_connect.htm

v13 000605TTA: last edit. XX ? must the .vpm be in the same dir as .vpc??

T06. Assign a model to the layout

The layout must have a runtime (.vpm) model (if no model is specified, then the default model empty.vpm is used). Whereas empty.vpm must be located in directory \VPMS\Designer, any other model must be located in the same directory as the layout. The model is specified with the application property <Product model>.

See also: Detailed information about the layout/model connection.

Do the following:

  1. If the layout created in T04 is not open in the Designer: Open 04.vpl.
  2. In Inspector tab <Layout>: Click in the cell to the right of <Product model>. Note that a directory button appears.
    11_06_addelements1.gif (1190 Byte)
  3. Click on the directory button. Select the model /docs/english/designtutorial/06.vpm.
    11_06_addelements2.gif (1167 Byte)
  4. Save the layout as 06.vpl.


T07. Open the model in the Workbench

Page#: 11_105_model_open_in_workbench.htm

v13 000605TTA: last edit.

T07. Open the model in the Workbench

Throughout this tutorial you can used the supplied runtime (.vpm) workbbench models. However, in order to select model attributes from a drop-down list within the Designer, the design-time model (.pms) must be the current model open in the Workbench.

Note: You do not have to select from the drop-down list; you can simply type in the attribute names manually. In this case you do not need to open the design-time model in the workbench.

The following assume that the workbench is set as the default application for opening .pms files (see T02).

Do the following:

  1. If the layout created in T06 is not open in the Designer: Open 06.vpl.
  2. Select the Label <Attribute 1>.
  3. Click on the value for property <Attribute>. Note that no attributes are available.
    11_105_model_open_in_workbench1.gif (2895 Byte)
  4. Double-click on 06.pms. The workbench opens for 06.pms:
    11_105_model_open_in_workbench.gif (7222 Byte)
    Note the 2 attributes <a_1> and <a_2>.
  5. Click on the value for property <Attribute> in the Designer. Note that still no attributes are available.
  6. From the Designer menu: Select <Options> / <Workbench synchronisation>.
  7. Click on the value for property <Attribute> in the Designer. Note that the attributes are now available.
    11_105_model_open_in_workbench2.gif (2830 Byte)
    Note: Do not actually select a new value.
    Do not close the Workbench.


Calculation

Page#: 11_107_ov_calculation.htm

v10 000605TTA: last edit.

Calculation

The layout created in the previous sections contained only a label. In this part you will add layout components that will allow you to input data to the model and display result output from the model.


T08. Add model attribute to layout

Page#: 11_11_add_model_attribute.htm

v13 000605TTA: last edit.

T08. Add model attribute to layout

You will now add 2 EditField's to the layout for entering data to the model.

Do the following:

  1. If the layout created in T06 is not open in the Designer: Open 06.vpl.
  2. Click on Toolbar icon "EditField" 2__1_3_02_entryfield.gif (139 Byte).
  3. Click in the layout. An EditField is added to the layout (note that the EditField is the element with the focus).
    11_05_createnewlayout.gif (1128 Byte)
  4. In the Inspector: Define a name for the element by entering <EF_a_1> in the drop-down list at the top of Inspector tab "Element" (make sure that the EditField is selected).
    11_06_addelements6.gif (1058 Byte)
  5. In the Inspector tab "Element": Select from the drop-down list for property <Source> model attribute <a_1>.
    11_06_addelements4.gif (1942 Byte)
    Note that the model attribute name is displayed in the EditField:
    11_06_addelements5.gif (328 Byte)
    NOTE: If no model attributes are available
    11_06_addelements3.gif (1588 Byte)
    then the model is probably not open in the Workbench. Open 06.pms and synchronize with the layout as described in T07.
  6. Add a second Label with <Name> = <L_a_2> and <Title> = <Attribute 2>.
  7. Add a second EditField with <Name> = <EF_a_2> and with <Source> = <a_2>.
    11_06_addelements8.gif (813 Byte)
  8. Save the layout as 08.vpl.


T09. Add model property to layout

Page#: 11_14_add_model_property.htm

v13 000605TTA: last edit.

T09. Add model property to layout

You will now add a ResultField to the layout for displaying result data from the model.

Do the following:

  1. If the layout created in T08 is not open in the Designer: Open 08.vpl.
  2. All a Label with <Name> = <L_p_1> and <Title> = <Result>.
  3. Add a ResultField ( 2__1_3_14_resultfield.gif (156 Byte)) with <Name> = <RF_p_1> with <Source> = <p_1>. Note: <p_1> will not be available in the <Source> drop-down list, because <p_1> is a model "property". You must type in "p_1".
    The layout should look like the following:
    11_14_add_model_property.gif (2171 Byte)
  4. Save the layout as 09.vpl.


T10. Test result calculation

Page#: 11_15_test_result_calculation.htm

v13 000605TTA: last edit.

T10. Test result calculation

You will now do your first test of basic calcuation with Designer. Data you enter in the EditField's will be input to the runtime model. The result from the runtime model will be displayed in the layout ResultField.

Note: Data input to the model and display of data output from the model can be controlled with layout properties. This will be demonstrated later in this tutorial.

Do the following:

  1. If the layout created in T09 is not open in the Designer: Open 09.vpl.
  2. Click on the test icon. The following runtime layout appears:
    11_14_add_model_property1.gif (1598 Byte)
    Note: If there are any unsaved changes in the design-time layout, you will be prompted to save the changes.
  3. Enter 2 for Attribute 1.
  4. Enter 3 for Attribute 2. Note that no result is displayed:
    11_14_add_model_property2.gif (743 Byte)
    The reasons for this will be explained later in this tutorial.
  5. Click in the upper EditField to change the focus. Note that the result is now displayed.
    11_14_add_model_property3.gif (732 Byte)
  6. Close the test dialog.


Workareas, pages, header/footers

Page#: 11_16_ov_workarea_page_headfoot.htm

v13 000605TTA: last edit.

Workareas, pages, header/footers

Most layouts contain too much information for a single page. A layout can contain multiple workareas, each of which can contain multiple pages. In addition there can be a header and/or footer for the entire layout and/or for each workarea.


T11. Add 2nd workarea to layout

Page#: 11_17_add_2nd_workarea.htm

v13 000605TTA: last edit.

T11. Add 2nd workarea to layout

The current layout consists of a single workarea that contains a single page. In this section you will add a second workarea to the layout.

Do the following:

  1. If the layout created in T09 is not open in the Designer: Open 09.vpl.
  2. In the Inspector: In tab <Application>: Set property <Style> = <Notebook>. Note that 2 tabs appear in the layout:
    11_17_add_2nd_workarea.gif (2031 Byte)
    Note: The tab text initial values for your layout will probably be different from those shown above.
  3. For the first (leftmost) workarea: Set <Name> = <WA1>.
  4. Set <Title> = <Workarea1>.
    11_17_add_2nd_workarea1.gif (1531 Byte)
  5. For the second workarea: Set <Name> = <WA2>.
  6. Set <Title> = <Workarea2>.
  7. Save the layout as 11.vpl.
  8. Test the layout.
  9. Click on the tabs to change the displayed workarea.
    11_17_add_2nd_workarea2.gif (1576 Byte)


T12. Add application header/footer

Page#: 11_18_add_appl_headfoot.htm

v11 000413TTA: last edit. XX bug? if you dont add something to the header/footer and test the layout, then the header/footer doesnt appear.

v13 000605TTA: last edit.

T12. Add application header/footer

A layout can have a header and/or footer that is/are always visible. The header/footer can contain any elements.

Important: If the header or footer contains no elements and the layout is closed, then the empty header and/or empty footer is deleted from the layout (even if the .vpl file is saved during the close).

You will now add an application header and footer. Do the following:

  1. If the layout created in T11 is not open in the Designer: Open 11.vpl.
  2. Set application property <Header> = <Yes>. A header appears in the layout.
  3. Set Header subproperty <Height> = <30>.
  4. Set Header subproperty <Background color(R,G,B)> = Yellow.
    11_18_add_appl_headfoot.gif (2568 Byte)
  5. Set application property <Footer> = <Yes>. A footer appears in the layout.
  6. Set footer subproperty <Height> = <30>.
  7. Set footer subproperty <Background color(R,G,B)> = Green.
    11_18_add_appl_headfoot1.gif (2720 Byte)
  8. Add a label to the header with <Name> = <L_AH> and <Title> = <Appl Header>.
    11_18_add_appl_headfoot2.gif (1302 Byte)
  9. Add a label to the footer with <Name> = <L_AF> and <Title> = <Appl Footer>.
    11_18_add_appl_headfoot3.gif (1511 Byte)
  10. Save the layout as 12.vpl.
  11. Test the layout. Note the header and footer:
    11_18_add_appl_headfoot4.gif (2712 Byte)


T13. Add 2nd page to workarea

Page#: 11_19_add_2nd_page.htm

v13 000605TTA: last edit.

T13. Add 2nd page to workarea

A workarea can contain any number of pages. The pages are accessible by clicking on an icon in the page frame.

Do the following:

  1. If the layout created in T12 is not open in the Designer: Open 12.vpl.
  2. Select Workarea1.
  3. In the Inspector: In tab Workarea: Select for property Style "Frame". Note that a frame appears in the workarea:
    11_19_add_2nd_page.gif (4153 Byte)
    Note: The name of the page ("Seite1" above) may be different in your layout.
  4. Set page <Name> = <W1P1> and <Title> = <W1Page1>.
    11_19_add_2nd_page1.gif (1605 Byte)
  5. Right-click on the W1Page1 icon. The following popup menu appears:
    11_19_add_2nd_page2.gif (2954 Byte)
  6. Click on <Insert node below>. A new "node" appears in the frame tree:
    11_19_add_2nd_page3.gif (873 Byte)
  7. For the second page: Set <Name> = <W1P2> and <Title> = <W1Page2>.
  8. Save the layout as 13.vpl.
  9. Test the layout.
  10. Click on the node icons to view different pages in Workarea1.
    11_19_add_2nd_page4.gif (3419 Byte)


T14. Add workarea header/footer

Page#: 11_20_add_workarea_headfoot.htm

v13 000605TTA: last edit. XX bug? if you dont add something to the header/footer and test the layout, then the header/footer doesnt appear.

T14. Add workarea header/footer

A workarea can have a header and/or footer that is/are visible when the workarea is selected. The header/footer can contain any elements.

Important: If the header or footer contains no elements and the layout is closed, then the empty header and/or empty footer is deleted from the layout (even if the .vpl file is saved during the close).

You will now add a workarea header and footer. Do the following:

  1. If the layout created in T13 is not open in the Designer: Open 13.vpl.
  2. Select workarea Workarea1.
  3. Set workarea property <Header> = <Yes>. A header appears in the workarea.
  4. Set Header subproperty <Height> = <30>.
  5. Set Header subproperty <Background color(R,G,B)> = Light blue.
    11_20_add_workarea_headfoot.gif (3892 Byte)
  6. Set workarea property <Footer> = <Yes>. A footer appears in the workarea.
  7. Set footer subproperty <Height> = <30>.
  8. Set footer subproperty <Background color(R,G,B)> = Orange.
    11_20_add_workarea_headfoot1.gif (3171 Byte)
  9. Add a Label to the Header with <Name> = <L_WH> and <Title> = <W1 Header>.
  10. Add a Label to the Footer with <Name> = <L_WF> and <Title> = <W1 Footer>.
  11. Save the layout as 14.vpl.
  12. Test the layout. Note the Workarea1 header and footer.:
    11_20_add_workarea_headfoot2.gif (4101 Byte)

    11_20_add_workarea_headfoot3.gif (1664 Byte)


Editting with Designer

Page#: 11_25_ov_editting.htm

v13 000605TTA: last edit.

Editting with Designer

The Designer provides various tools for working with elements and groups of elements in the layout.


T15. Find

Page#: 11_26_find.htm

v11 000417TTA XX: hotkeys did not work.

v13 000606TTA: last edit.

T15. Find

You can search for layout elements:

  • On a page via the element name
  • Anywhere in the layout via the value of element property <Source>

Do the following:

  1. If the layout created in T14 is not open in the Designer: Open 14.vpl.
  2. Select any page in <Workarea1>.
  3. From the main menu: Select <Edit> / <Find>. The "Find" dialog appears:
    11_26_find.gif (1867 Byte)
  4. For <Name>: Enter <l_wh> (name of the <Workarea1> header label).
  5. Check <Element name>.
  6. Check <Ignore case>.
  7. Click <OK>. The workarea header label obtains the focus.
    11_26_find1.gif (1523 Byte)
  8. Select Workarea2.
  9. From the main menu: Select <Edit> / <Find>. The "Find" dialog appears.
  10. For <Name>: Enter <a_2> (value of property <Source> for <Workarea1> page <W1Page1> <Attribute 2> EditField).
  11. Check <Attribute name>.
  12. Click <OK>. The page with the element is displayed and the element has the focus.
    11_26_find2.gif (2154 Byte).


T16. Cut / Copy / Paste

Page#: 11_27_cut_copy_paste.htm

v13 000606TTA: last edit.

T16. Cut / Copy / Paste

Designer provides standard functions for elements such as copy, cut, paste, and delete.

Do the following:

  1. If the layout created in T14 is not open in the Designer: Open 14.vpl.
  2. In <Workarea1> page <W1Page1>: Select <Attribute 1> EditField.
  3. Place the cursor over the element. Note that the cursor becomes a cross:
    11_27_cut_copy_paste.gif (1245 Byte)
  4. Right-click the mouse. A context menu appears:
    11_27_cut_copy_paste1.gif (1696 Byte)
  5. Click <Copy>.
  6. Select <Workarea2>.
  7. Right-click in the workarea. A context menu appears:
    11_27_cut_copy_paste2.gif (1407 Byte)
  8. Click <Paste> (the only available selection). A copy of the element appears.
    11_27_cut_copy_paste3.gif (1183 Byte)
    Note: The copied element has a new name. An element should be renamed after being copied.
    Do not save the layout.


T17. Groups

Page#: 11_28_groups.htm

v13 000606TTA: last edit.

T17. Groups

Designer provides extensive functionality for working with groups of elements.

Do the following:

  1. If the layout created in T14 is not open in the Designer: Open 14.vpl.
  2. In <Workarea1> page <W1Page1>: Press and hold the left mouse button to the upper left of the Label <Attribute 1> (not on the label). A small dotted square appears:
    11_28_groups.gif (980 Byte)
  3. Drag the mouse until it is over the <p_1> ResultField. Note the dotted square:
    11_28_groups1.gif (1850 Byte)
  4. Release the left mouse button. Note that all elements within or partially within the dotted square are selected. These elements constitute a group:
    11_28_groups2.gif (1175 Byte)
  5. Right-click over any element in the group. The context menu contains the options for single elements and also the special options for groups:
    11_28_groups3.gif (2842 Byte)
  6. Create 3 EditElement's in <Workarea2> as shown below:
    11_28_groups4.gif (650 Byte)
  7. Select the group. Note that the upper left element has a blue frame, indicating that this element is the selected element within the group.
    11_28_groups5.gif (913 Byte)
  8. Press and hold the Ctrl key.
  9. Click on the middle EditField. The element is no longer a member of the group:
    11_28_groups6.gif (851 Byte)
  10. Click on the middle EditField again (with the Ctrl key still held). The element is now the selected member of the group:
    11_28_groups7.gif (901 Byte)
  11. Reselect the upper EditField in the group.
  12. Click on the <Make all elements the same width> icon ( 11_28_groups8.gif (187 Byte)). Note that all of the elements now have the same width as the selected element in the group:
    11_28_groups9.gif (848 Byte)
  13. Click on the <Make all elements the same height> icon ( 11_28_groups10.gif (176 Byte)). Note that all of the elements now have the same height as the selected element in the group:
    11_28_groups11.gif (725 Byte)
  14. Click on the <Spread vertical evenly> icon ( 11_28_groups13.gif (163 Byte)). Note that the distance between the top edges of the lower pair of elements is the same as that between the upper pair of elements:
    11_28_groups14.gif (696 Byte)
  15. Click on the <Align group to left> icon ( 11_28_groups15.gif (170 Byte)). Note that the left edges of all elements are aligned vertically with the left edge of the selected element in the group:
    11_28_groups16.gif (675 Byte)
  16. Select the <Save marked group to disk> icon ( 11_28_groups17.gif (179 Byte)). The <Save as> dialog appears.
  17. Save the file as 17.vpg (.vpg file details).
  18. Delete the group.
  19. Select the <Read group from disk and copy it to clipboard> icon ( 11_28_groups18.gif (177 Byte)). The <Open> dialog appears.
  20. Open 17.vpg.
  21. Paste in <Workarea2>.
    11_28_groups16.gif (675 Byte)
  22. Delete the group.
    Do not save the layout.


T18. Autosize

Page#: 11_29_autosize.htm

v13 000606TTA: last edit.

T18. Autosize

The entire contents of the layout can be scaled to fit certain screen sizes.

Do the following:

  1. If the layout created in T14 is not open in the Designer: Open 14.vpl.
  2. Select <Tools> / <Autosize>. The Autosize-Tool dialog appears.
    11_29_autosize.gif (3760 Byte)
  3. For proportional factor: Select <Manual>.
  4. Set <Rate> = 0.5.
  5. Click <Start>. A new layout is created whose name = (application name) + "x05".
    11_29_autosize2.gif (1504 Byte)
    Note that this new layout has been resized with a proportionality factor of 0.5
    11_29_autosize1.gif (2221 Byte)
  6. Resize the layout with proportional factor 2. A new layout is created whose name = (application name) + "x05x063".
    11_29_autosize3.gif (979 Byte)
    Note that the layout is the original size.
  7. Close the 2 new layouts (do not save).
    Do not save the original layout.


Multiple layouts/models

Page#: 11_30_ov_multilayoutmodels.htm

v10 000606TTA: last edit.

Multiple layouts/models

It is possible to open a layout from another layout.

A layout can have only a single model. However, that model can include other models whose attributes and properties are available to the the model (and thus the layout).


T19. Multiple layouts

Page#: 11_31_multiple_layouts.htm

v13 000606TTA: last edit. pic changed.

T19. Multiple layouts

A sublayout can be opened from the same layout using a PushButton element.

The sublayout can define a new "session" or use the same session as the calling layout. If a new session is defined, then values entered for attributes in the sublayout have no effect on the values of the same attributes in the calling layout. Likewise if no new session is defined, then values entered for attributes in the sublayout become the values for the same attributes in the calling layout.

In this example the sublayout will be the same layout as the calling layout (normally the layouts are different).

Do the following:

  1. If the layout created in T14 is not open in the Designer: Open 14.vpl.
  2. Add a Pushbutton ( 11_31_multiple_layouts.gif (165 Byte)) to <Workarea2>.
  3. Set Pushbutton <Name> = <W2_P1>.
  4. Set property <Title> = <Same session>.
  5. Set property <Action> = <Dialog-Call>.
  6. Set property <Dialog-Description> = <19.vpc> (19.vpc will be created when you save this layout). IMPORTANT: Note that the runtime layout (not the design-time) is specified.
  7. Set property <New Session> = <No>.
    11_31_multiple_layouts1.gif (1921 Byte)
  8. Add a Pushbutton to <Workarea2>.
  9. Set <Name> = <W2_P2>.
  10. Set <Title> = <New session>.
  11. Set property <Action> = <Dialog-Call>.
  12. Set property <Dialog-Description> = <19.vpc>.
  13. Set property <New Session> to <Yes>.
    11_31_multiple_layouts2.gif (2071 Byte)
  14. Add a Pushbutton to <Workarea2>.
  15. Set <Name> = <W2_P3>.
  16. Set <Title> = <Accept>.
  17. Set <Action> = <Dialog Accept>.
    11_31_multiple_layouts3.gif (1283 Byte)
  18. Add a Pushbutton to <Workarea2>.
  19. Set <Name> = <W2_P4>.
  20. Set <Title> = <Cancel>.
  21. Set <Action> = <Dialog Cancel>.
    11_31_multiple_layouts4.gif (1221 Byte)
  22. Save the layout as 19.vpl.
  23. Test the layout.
  24. For <Attribute 1>: Enter 2.
  25. For <Attribute 2>: Enter 3.
  26. In <Workarea2>: Click <Same session>. A sublayout appears:
    11_31_multiple_layouts5.gif (5626 Byte)
    Note that the values entered in the previous "session" also appear in the new sesion.
  27. For <Attribute 1>: Enter 4.
  28. For <Attribute 2>: Enter 5.
  29. In <Workarea2>: Select <Accept>. The new session dialog disappears.
    In <Workarea1>: Note that <Attribute 1> = 4 and <Attribute 2> = 5.
  30. In <Workarea2>: Click <New session>. A sublayout appears without the values entered in the previous session:
    11_31_multiple_layouts6.gif (4175 Byte)
  31. For <Attribute 1>: Enter 6.
  32. For <Attribute 2>: Enter 7.
  33. In <Workarea2>: Select <Accept>. The new session dialog disappears.
    In <Workarea1>: Note that <Attribute 1> = 4 and <Attribute 2> = 5 (the values have not changed).
  34. Test the Accept and Cancel buttons with a Same Session.


T20. Multiple models

Page#: 11_32_multiple_models.htm

v13 000606TTA: last edit.

T20. Multiple models

Only a single model can be connected to the layout (specified with property <Product model>). However, this model can contain links to other models, effectively giving the layout access to multiple models.

Do the following:

  1. If the layout created in T19 is not open in the Designer: Open 19.vpl.
  2. Set application property <Product model> = <20a.vpm>. 20a.pms is the same as the previous model, except that it "includes" model 20b.pms.
    20a.pms:
    11_32_multiple_models.gif (2818 Byte)
    20b.pms:
    11_32_multiple_models1.gif (2597 Byte)
    Note: 20a.pms must have the link ("Product1b@20b") in order to access the properties in 20b.pms. For more information about model inclusion, consult the Workbench documentation.
  3. Copy the labels, EditFields and ResultField from <Workarea1> to <Workarea2>.
  4. Append the letter "b" to the names and title for each copied element (ie, <EF_a_1> becomes <EF_a_1b>).
  5. Open 20a.pms in the Workbench.
  6. Select tab <20b> in the Workbench.
  7. In Designer: Select <Options> / <Workbench synchronization>.
  8. Select the EditField for <a_1b>.
  9. In the Inspector tab <Element>: Set <Source> = <a_1b> (select from the drop-down list):
    11_32_multiple_models2.gif (3583 Byte)
  10. For the second EditField: Set <Source> = <a_2b>.
  11. For the ResultField: Set <Source> = <p_1b> (remember that this value must be typed in, not selected from the drop-down list).
    11_32_multiple_models3.gif (994 Byte)
  12. Save the layout as 20.vpl.
  13. Test the layout.
  14. In Workarea2: Enter 3 and 7 for the attributes.
  15. Click to change the focus. Note that the result was calculated in the included model and displayed in the layout:
    11_32_multiple_models4.gif (1184 Byte).


External DLL

Page#: 11_325_ov_external_dll_dbase.htm

v13 000606TTA: last edit.

External DLL

A layout can utilize functionality provided by an exteral DLL.


T21. Calling a DLL from the layout

Page#: 11_33_dll.htm

v12 000504TTA: dll example from jko.. modified by tta.

v13 000606TTA: last edit.

T21. Calling a DLL from the layout

A DLL can be called from the layout.

Do the following:

  1. If the layout created in T20 is not open in the Designer: Open 20.vpl.
  2. Open the file 21.ini. 21.ini contains the following code:
    ;Configuration file for DLL-call
    ;===============================================
    [common]
    ; 32-Bit DLL path (relative to layout) / filename
    DLL=21.dll
    Method=Rechnen
    ; 16-Bit DLL path (relative to layout) / filename
    DLL16=21.dll
    Method16=Rechnen
    ;===============================================
    [input]
    ; (DLL-call input)=(layout input element name)
    0=$hwnd
    1=EF_Operand1
    2=EF_Operand2
    3=EF_Operator
    ;===============================================
    [output]
    ; (DLL-call result)=(layout display element name)
    0=EF_Result
    ;===============================================
  3. Save 21.ini.
  4. In layout <Workarea1> page <W1Page2>: Add a label with <Text> = <Operand1>.
  5. Add a text EditField with <Name> = <EF_Operand1>.
  6. Add a Label with <Text> = <non-negative integer>.
    11_33_dll.gif (2658 Byte)
  7. Add a Label with <Text> = <Operator>.
  8. Add a text EditField with <Name> = <EF_Operator>.
  9. Add a Label with <Text> = <( + , - , * , / )>.
    11_33_dll1.gif (1696 Byte)
  10. Add a Label with <Text> = <Operand>.
  11. Add a text EditField with <Name> = <EF_Operand2>.
  12. Add a Label with <Text> = <non-negative integer>.
    11_33_dll2.gif (1702 Byte)
  13. Add a Label with <Text> = <Result>.
  14. Add a text EditField with <Name> = <EF_Result>.
    11_33_dll3.gif (1411 Byte)
  15. Add a Pushbutton with <Name> = <PB_Compute>.
  16. Set <Title> = <call 21.dll>.
  17. Set <Action> = <DLL-call>.
  18. Set <Dll-Description> = <21.ini>.
    11_33_dll4.gif (2606 Byte)
  19. Save the layout as 21.vpl.
  20. Test the layout.
  21. For Operand1: Enter 2.
  22. For Operator: Enter *.
  23. For Operand2: Enter 3.
  24. Click Pushbutton "call 21.dll". The following dialog appears:
    11_33_dll5.gif (1955 Byte)
  25. Click OK. The result is displayed:
    11_33_dll6.gif (824 Byte)


Documenting a layout

Page#: 11_40_ov_document_layout.htm

v13 000606TTA: last edit.

Documenting a layout

Layouts can be complicated, and therefore its important to be able to somehow document the layout. Designer supports the following documentation functions:

  • Comments can be included in the layout for each component.
  • Reports about the content can be generated.
  • Screenshots can be generated for each layout page.


T22. Commenting layout components

Page#: 11_41_comments.htm

v13 000606TTA: last edit.

T22. Commenting layout components

Comments can be included in the layout for any layout components.

Do the following:

  1. If the layout created in T21 is not open in the Designer: Open 21.vpl.
  2. Set application property <Version info> = <Yes>. Note that the subproperty <Version> appears:
    11_41_comments.gif (949 Byte)
  3. Click in to the right of <Version>. A button appears.
    11_41_comments1.gif (1542 Byte)
  4. Click on the button. The <Version information> dialog appears.
  5. Enter commentary as shown:
    11_41_comments2.gif (4643 Byte)
  6. Click <OK>. Note the text from <Version> in the Inspector:
    11_41_comments3.gif (426 Byte)
  7. Optional: Comment any other components (workareas, pages, elements).
  8. Save the layout as 22.vpl.


T23. Generating layout report

Page#: 11_42_print_report.htm

v13 000606TTA: last edit. XX german report.

T23. Generating layout report

2 report formats are available:

  • Table
  • Text

The content of the report can also be selected.

More detailed info about reports.

In this chapter you will create report in table and text format.

Do the following:

  1. If the layout created in T22 is not open in the Designer: Open 22.vpl.
  2. From the menu bar: Select <Options> / <Options...>. The <Options> dialog appears.
    11_42_print_report.gif (1958 Byte)
  3. Select category <IFOS>.
  4. Using the buttons, select the .cat files as shown:
    11_42_print_report1.gif (4598 Byte)
    Note: The location of the .cat files may be different on your computer. The full directory path and filename is required.
  5. Click <OK>.
  6. Select <File> / <Print...>. The <CRF preparation dialog> appears:
    11_42_print_report2.gif (5025 Byte)
  7. Select <Report type>, <Sorting>, and <Output> on as shown in the dialog above.
  8. Click <Print>. The IFOS ReportViewer appears with a report describing the contents of the layout in table format:
    11_42_print_report3.gif (8628 Byte)
  9. Close the ReportViewer.
  10. In Designer: Select <File> / <Print...>.
  11. In the <CRF preparation dialog>: Select <Report type> = <Detail>, check <Version information>, select <Range> = <All>, <Output on> = <Screen>.
  12. Click <Print>. The IFOS ReportViewer appears with a report (approximately 12 pages) describing the contents of the layout in text format. The first page should be similar to the following (note the version information (comments)):
    11_42_print_report4.gif (3504 Byte)
  13. Close the ReportViewer.
  14. Save the layout as 23.vpl.


T24. Creating layout page screenshot

Page#: 11_43_screenshot.htm

v13 000606TTA: last edit. XX how is the directory for the .bmp files determined?

T24. Creating layout page screenshot

Screenshots (.bmp files) can be created for any of the layout pages. A page screenshot includes the entire layout as it would appear with that page selected.

The .bmp files are normally saved to the same directory as the .cat files.

Do the following:

  1. If the layout created in T23 is not open in the Designer: Open 23.vpl.
  2. Select <File> / <Export screen shots>. The <Select page for screen shot> dialog appears:
    11_43_screenshot.gif (3495 Byte)
    All of the layout pages are listed in the left window. The currently visible page is marked with an asterisk (*).
  3. Select (move to the right window) all pages using the ">>" key.
  4. Click <OK>. A message about the created screenshots appears:
    11_43_screenshot1.gif (1177 Byte)
    The bmp files (scr_W1P1.bmp, scr_W1P2.bmp, and scr_WA2().bmp) were saved in the directory where the .cat files are located.
  5. Do not save the layout.


T25. Compare layouts

Page#: 11_435_synchronize_layouts.htm

v11 000413TTA XX: created. there seems to be a nasty little bug in synchronize layouts... ask me for more info.

v13 000605TTA: last edit.

T25. Compare layouts

A report can be generated that describes the differences between 2 layouts.

Do the following:

  1. If the layout created in T23 is not open in the Designer: Open 23.vpl.
  2. In <Workarea1> page <W1Page2>: Add a Label with <Name> = <L_new> and <Title> = <Labelnew>.
    11_435_synchronize_layouts.gif (2498 Byte)
  3. Save the layout as 25.vpl.
  4. Select <File> / <Open> and open 23.vpl (there are now 2 Designer layouts open in a single Designer application).
    11_435_synchronize_layouts1.gif (748 Byte)
  5. Select <Tools> / <Synchronize...>. The Synchronisierungs-Tool appears:
    11_435_synchronize_layouts2.gif (3013 Byte)
  6. Select 23.vpl as the Basic application and 25.vpl as the synchronized application.
  7. Click <Start>. Note that no differences between the layouts was reported, since the synchronized layout (25.vpl) contains all elements in the basic application (23.vpl)):
    11_435_synchronize_layouts3.gif (2465 Byte)
  8. Close the report.
  9. Select <Tools> / <Synchronize...>.
  10. Select 25.vpl as the Basic application and 23.vpl as the synchronized application.
  11. Click <Start>. Note that the report states that <L_new> in page <W1P2> in workarea <WA1> does not exist:
    11_435_synchronize_layouts4.gif (2801 Byte)
  12. Close the report.
  13. Close layout 25.vpl (saving is not necessary).


Tooltips

Page#: 11_45_ov_help_tooltips.htm

v13 000606TTA: last edit.

Tooltips

Tooltips can be implemented for various layout components.

Its important to provide information about the layout for the end-user. This is possible via windows help files and embedded tooltips.


T26. Tooltips

Page#: 11_47_tooltips.htm

v13 000606TTA: last edit.

T26. Tooltips

A tooltip can be defined for any layout component (workarea, page, element).

Do the following:

  1. If the layout created in T23 is not open in the Designer: Open 23.vpl.
  2. Select <Workarea1> <W1Page1>.
  3. In the Inspector: Select tab Workarea.
  4. Set <Tooltip> = <Yes>. The tooltip subproperties appear.
  5. Set <Tooltip text> = <Workarea1 tooltip>.
  6. Set <Background> = yellow.
    11_47_tooltips.gif (2552 Byte)
  7. In the Inspector: Select tab <Page>.
  8. Set <Tooltip> = <Yes>. The tooltip subproperties appear.
  9. Set <Tooltip text> = <W1Page1 tooltip>.
  10. Select <Background> = green.
    11_47_tooltips1.gif (2463 Byte)
  11. Set the model as 26.vpm. 26.pms contains the tooltip for <a_1> and <a_2>.
    11_47_tooltips2.gif (1833 Byte)
  12. Set <Tooltip> = <Dynamic> for <a_1> and <a_2> EditField's.
    11_47_tooltips3.gif (1202 Byte)
  13. Save the layout as 26.vpl.
  14. Test the layout.
  15. Place the cursor over the components to display the tooltips:
    11_47_tooltips4.gif (1846 Byte)

    11_47_tooltips5.gif (1832 Byte)

    11_47_tooltips6.gif (1843 Byte)


Datatypes

Page#: 11_50_ov_datatypes.htm

v13 000606TTA: last edit.

Datatypes

This part introduces the data types supported by Designer.


T27. Datatype: Single-line text

Page#: 11_51_datatype_text_1line.htm

v13 000605TTA: last edit. note: the pics names are wrong (for next section). workarea2 was rearranged before starting this section.

T27. Datatype: Single-line text

Single-line text is the most common data type. You have already used single-line text EditField's in the previous examples for entering <a_1> and <a_2> values.

Do the following:

  1. If the layout created in T26 is not open in the Designer: Open 26.vpl.
  2. Change the Product model to 27.vpm.
  3. In <Workarea2>: Add page <Datatypes>.
  4. Add a Label with <Title> = <Text>.
  5. Add an EditField with <Type> = <Text> and <Source> = <a_3>.
    11_52_datatype_text_2lines.gif (4023 Byte)
  6. Add an ResultField with <Type> = <Result> and <Source> = <p_3>.
    11_52_datatype_text_2lines1.gif (1860 Byte)
  7. Save the layout as 27.vpl.
  8. Test the layout.
  9. Enter any characters in the EditField. The characters are displayed in the ResultField.
    11_52_datatype_text_2lines2.gif (598 Byte)


T28. Datatype: Multiline text

Page#: 11_52_datatype_text_2lines.htm

v13 000606TTA: last edit.

T28. Datatype: Multiline text

An EditField can be used to enter (or display) multiline text.

Do the following:

  1. If the layout created in T27 is not open in the Designer: Open 27.vpl.
  2. Add a Label with <Title> = <Multiline>.
  3. Add an EditField with <Type> = <Text>, <Multiline> = <Yes>, <Compute> = <OnChange> and <Source> = <a_3>.
    11_52_datatype_text_2lines5.gif (3570 Byte)
  4. Add an ResultField with <Type> = <Result>, <Multiline> = <Yes> and <Source> = <p_3>.
    11_52_datatype_text_2lines6.gif (1837 Byte)
  5. Save the layout as 28.vpl.
  6. Test the layout.
  7. Enter multiline data in the multine EditField (press the Return key to start a new line). Note how the input is displayed in the single-line EditField and in the ResultField's.
    11_52_datatype_text_2lines7.gif (1184 Byte)


T29. Datatype: Boolean

Page#: 11_53_datatype_boolean.htm

v13 000606TTA: last edit.

T29. Datatype: Boolean

A Checkbox can be used to enter a boolean value.

Do the following:

  1. If the layout created in T28 is not open in the Designer: Open 28.vpl.
  2. Add a CheckBox with <Title> = <Boolean> and <Source> = <a_3>.
    11_53_datatype_boolean.gif (1814 Byte)
  3. Save the layout as 29.vpl.
  4. Test the layout.
  5. Check and uncheck the checkbox. Note that the boolean value appears in the ResultFields.
    11_53_datatype_boolean1.gif (986 Byte)

    11_53_datatype_boolean2.gif (964 Byte)


T30. Datatype: Number

Page#: 11_54_datatype_number.htm

v13 000606TTA: last edit.

T30. Datatype: Number

An EditField can be used to enter (or display) numerical values with a fixed number of digits after the decimal point.

Do the following:

  1. If the layout created in T29 is not open in the Designer: Open 29.vpl.
  2. Add a Label with <Title> = <Number>.
  3. Add an EditField with <Type> = <Number>, <Compute> = <OnChange>, <Decimal position> = <2>, and <Source> = <a_3>.
    11_54_datatype_number.gif (2530 Byte)
  4. Add an ResultField with <Type> = <Number result>, <Decimal position> = <3> and <Source> = <p_3>.
    11_54_datatype_number1.gif (2028 Byte)
  5. Save the layout as 30.vpl.
  6. Test the layout.
  7. Enter in the NumberField 123,3456. Note that the input is limited to 2 decimal positions after the decimal point. Note also the values shown in the other elements.
    11_54_datatype_number2.gif (1529 Byte)


T31. Datatype: Currency

Page#: 11_55_datatype_currency.htm

v13 000605TTA: last edit.

T31. Datatype: Currency

An EditField can be used to enter (or display) currency value with/without a currency unit.

Do the following:

  1. If the layout created in T30 is not open in the Designer: Open 30.vpl.
  2. Add a Label with <Title> = <Currency>.
  3. Add an EditField with <Type> = <Currency>, <Compute> = <OnChange>, <Decimal position> = <2>, and <Source> = <a_3>.
    11_55 datatype_currency.gif (2847 Byte)
  4. Add an ResultField with <Type> = <Currency result>, <Currency symbol> = <On>, <Decimal position> = <3> and <Source> = <p_3>.
    11_55 datatype_currency1.gif (2541 Byte)
  5. Save the layout as 31.vpl.
  6. Test the layout.
  7. Enter in the CurrencyField 123,3456.
  8. Click to change the focus and display the currency symbol. Note that the input is limited to 2 decimal positions after the decimal point. Note also the values shown in the other elements.
    11_55 datatype_currency2.gif (1975 Byte)


T32. Datatype: Date

Page#: 11_56_datatype_date.htm

v13 000606TTA: last edit.

T32. Datatype: Date

A DateField can be used to enter (or display) Date values of various formats.

Do the following:

  1. If the layout created in T31 is not open in the Designer: Open 31.vpl.
  2. Add a Label with <Title> = <Date>.
  3. Add an EditField with <Type> = <Date>, <Format> = <dd/mm/yy> and <Source> = <a_3>.
    11_56_datatype_date.gif (2162 Byte)
  4. Add an ResultField with <Type> = <Date result>, <Format> = <yyyy%MMM$dd> and <Source> = <p_3>.
    11_56_datatype_date1.gif (2088 Byte)
  5. Save the layout as 32.vpl.
  6. Test the layout.
  7. Enter in the DateField 010299 (Feb 01, 99).
  8. Click to change the focus. Note the values shown in the other elements.
    11_56_datatype_date2.gif (2343 Byte)


T33. Datatype: Mask

Page#: 11_57_datatype_mask.htm

v13 000608TTA: last edit.

T33. Datatype: Mask

A mask can be used to specify a special format for valid data.

Do the following:

  1. If the layout created in T32 is not open in the Designer: Open 32.vpl.
  2. Add a Label with <Title> = <Mask>.
  3. Add an EditField with <Type> = <Mask>, <Mask> = <ULLL##> and <Source> = <a_3>.
    11_57_datatype_mask.gif (1359 Byte)
  4. Add an ResultField with <Type> = <Mask result>, <Mask> = <UUUU##> and <Source> = <p_3>.
    11_57_datatype_mask1.gif (1685 Byte)
  5. Save the layout as 33.vpl.
  6. Test the layout.
  7. Enter in the MaskField abcde12345.
  8. Click to change the focus. Note the values shown in the other elements.
    11_57_datatype_mask2.gif (2655 Byte)


T34. Datatypes: Arrays: Tables

Page#: 11_58_datatype_array_table.htm

v13 000606TTA: last edit.

T34. Datatypes: Arrays: Tables

This section demonstrates how a model table can be displayed in the layout and how values from the table can be selected.

Do the following:

  1. If the layout created in T33 is not open in the Designer: Open 33.vpl.
  2. Change the Product model to 34.vpm.
    34.vpm contains attribute <a_Table1> with property <table> = <"t_Table1">:
    3_10_1_1_comp_model.gif (2138 Byte)
    and table <t_Table1> with columns <key> and <value> with 3 rows of data:
    3_10_1_1_comp_model1.gif (2974 Byte)
    Details about this model.
  3. In <Workarea2>: Add a page with <Name> = <PTable> and <Title> = <Tables>.
  4. In Page <PTable>: Add a Combobox with <Name> = <CB_Table1> and <Source> = <a_Table1>:
    11_58_datatype_array_table.gif (2654 Byte)
  5. In Page <PTable>: Add a Combobox with <Name> = <CB_Table1> and <Source> = <a_Table1>:
    11_58_datatype_array_table1.gif (1985 Byte)
  6. Save the layout as 34.vpl.
  7. Test the layout.
  8. Select a value from the ComboBox or RadioGroup. Note that the value is displayed in both elements.
    11_58_datatype_array_table2.gif (878 Byte)


T35. Datatypes: Arrays: Iteration

Page#: 11_59_datatype_array_iteration.htm

v13 000606TTA: last edit.

T35. Datatypes: Arrays: Iteration

This section demonstrates how an array of data can be generated using iteration. The array is generated with the help of and display by a Grid.

Do the following:

  1. If the layout created in T34 is not open in the Designer: Open 34.vpl.
  2. Change the Product model to 35.vpm.
    35.vpm contains attribute <a_Iteration> and <a_Start>:
    3_10_2_1_comp_model.gif (1167 Byte)
    and a next-line property and a value for each iteration:
    3_10_2_1_comp_model1.gif (2358 Byte)
    Note: <xx> and <yy> used above could be changed to any string with no effect.
    Details about this model.
  3. In <Workarea2>: Add a page with <Name> = <PGrid> and <Title> = <Grid>.
  4. In Page <PGrid>: Add an EditField with <Name> = <EF_Start> and <Source> = <a_Start>:
    11_59_datatype_array_iteration.gif (2913 Byte)
  5. In Page <PGrid>: Add an EditField with <Name> = <EF_Iteration> and <Source> = <a_Iteration>:
    11_59_datatype_array_iteration1.gif (2387 Byte)
  6. In Page <PGrid>: Add a <Grid> with name = <G_Grid> and with properties as shown in the following diagrams:
    11_59_datatype_array_iteration2.gif (4257 Byte)

    11_59_datatype_array_iteration3.gif (1166 Byte)

    11_59_datatype_array_iteration4.gif (1265 Byte)

    11_59_datatype_array_iteration5.gif (1366 Byte)
  7. Save the layout as 35.vpl.
  8. Test the layout.
  9. Set a_Start = 3.
  10. Set a_Iteration = 4. Note the resultant Grid.
    11_59_datatype_array_iteration6.gif (1380 Byte)


T36. Datatypes: Arrays: Multiple pages

Page#: 11_60_datatype_array_multipages.htm

v13 000606TTA XX: last edit. i tried to get this to work. i copied the exact element from a different model that worked.. and then used the model from that layout... and still nothing worked.

T36. Datatypes: Arrays: Multiple pages

An array of data can be generated using multiple inclusion in the model and multiple subpages in the layout.

Do the following:

  1. If the layout created in T35 is not open in the Designer: Open 35.vpl.
  2. Change the Product model to 36.vpm.
    36.vpm adds the attribute <a_Data>.
    and a model subnode with mutiple inclusion and property <p_Result>:
    11_60_datatype_array_multipages.gif (2863 Byte)
    The upper branch also adds property <p_Total>:
    11_60_datatype_array_multipages1.gif (2078 Byte)
    Details about this model.
  3. In Workarea2: Add a page with <Name> = <PMultipages> and <Title> = <Multipages>.
  4. In Workarea2: Add a subpage for page <Multipages> with <Name> = <PSub> and <Title> = <Sub>.
  5. In Page <PSub>: Add an EditField with <Name> = <EF_Data> and <Source> = <a_Data> and <Multiple> = <Yes>:
    11_60_datatype_array_multipages2.gif (3857 Byte)
  6. In Page <PSub>: Add a ResultField with <Name> = <RF_Result> and <Source> = <p_Result()>:
    11_60_datatype_array_multipages3.gif (1669 Byte)
  7. In Page <Multipages>: Add a <ResultField> with <Name> = <RF_Total> and <Source> = <p_Total>:
    11_60_datatype_array_multipages4.gif (3109 Byte)
  8. Save the layout as 36.vpl.
  9. Test the layout.
  10. In Workarea2: Click on the subnode named <new>. A new page appears:
    11_60_datatype_array_multipages5.gif (2249 Byte)
  11. Enter in the EditField 123:
    11_60_datatype_array_multipages6.gif (2293 Byte)
  12. Select page <Multipages>. Note that the result is displayed in the page:
    11_60_datatype_array_multipages7.gif (2199 Byte)


Entering/selecting data

Page#: 11_70_ov_enter_select_data.htm

v13 000606TTA: last edit.

Entering/selecting data

In the previous pages you used layout elements to enter (EditField) and select (ComboBox) data.

In this part you will learn more advanced aspects of entering/selecting data.


T37. Conversion list

Page#: 11_71_conversion_list.htm

v13 000606TTA: created.

T37. Conversion list

The values for multiple attributes in a layout can be set (converted) by simply clicking on a PushButton.

Do the following:

  1. If the layout created in T36 is not open in the Designer: Open 36.vpl.
  2. Set the model to 37.vpm. 37.pms specifies the following:
    Properties <uunconvert> and <cconvert> for attributes <a_1> and <a_2>.
    11_71_conversion_list.gif (1009 Byte)

    11_71_conversion_list1.gif (984 Byte)
    Note: The attribute property names <uunconvert> and <cconvert> could be any non-reserved word.
    11_71_conversion_list2.gif (1732 Byte)

    11_71_conversion_list3.gif (1831 Byte)

    11_71_conversion_list4.gif (1842 Byte)

    11_71_conversion_list5.gif (2008 Byte)
  3. In the layout: In <Workarea1> <W1Page1>: Add a PushButton with <Name> = <PB_Convert>, <Title> = <convert>, <Action> = <Compute> and <ConvertAttr> = <a_Convert>:
    11_71_conversion_list6.gif (3785 Byte)
  4. In <Workarea1> <W1Page1>: Add a PushButton with <Name> = <PB_Unconvert>, <Title> = <unconvert>, <Action> = <Compute> and <ConvertAttr> = <a_Unconvert>:
    11_71_conversion_list7.gif (2198 Byte)
  5. Save the layout as 37.vpl.
  6. Test the layout.
  7. Click on the <convert> pushbutton. Note that the convert values are entered for <a_1> and <a_2>:
    11_71_conversion_list8.gif (1092 Byte)
  8. Click on the <unconvert> pushbutton. Note that the unconvert values are entered for <a_1> and <a_2>:
    11_71_conversion_list9.gif (1046 Byte)


T38. Dynamic Combobox

Page#: 11_72_combobox_dynamic.htm

v13 XXX 000605TTA: created.

T38. Dynamic Combobox

The available selections in a ComboBox can be dynamic, which means that the available selections change in the runtime layout depending on some other layout attribute.

Do the following:

  1. If the layout created in T37 is not open in the Designer: Open 37.vpl.
  2. Change the product model to 38.vpm. 38.pms contains the following:
    Attribute <a_Table1> has property <dynamic> = <"a_Table2">. This means that when a change is made (in the layout) to <a_Table1> using a layout component with property <ChkDynamic> = <Yes>: The value for <a_Table2> will be recalculated.
    11_72_combobox_dynamic.gif (809 Byte)
    <t_Table1> as in previous layouts:
    11_72_combobox_dynamic1.gif (1199 Byte)
    <a_Table2> possible values are defined in <t_Table2>. The property <display> specifies which column in <t_Table2> should be displayed (<chooseable>).
    11_72_combobox_dynamic2.gif (823 Byte)
    <t_Table2> has several values in column <chooseable> for each possible value in column <value>.
    11_72_combobox_dynamic3.gif (2482 Byte)
    <a_Table2> property <filter> defines that only those rows in <t_Table2> whose value in column <value> = value in column <value> in table <t_Table1> are to be available (or "chooseable").
    11_72_combobox_dynamic4.gif (953 Byte)
    For more details, consult the Workbench User's Guide.
  3. In the layout: In <Workarea2> page <Tables>: Add a ComboBox with <Name> = <CB_Table2>, <Source> = <a_Table2>, <Compute> = <OnChange> and <ChkDynamic> = <Yes>.
    11_72_combobox_dynamic5.gif (5304 Byte)
  4. Set <a_Table1> property <ChkDynamic> = <Yes>.
    11_72_combobox_dynamic6.gif (976 Byte)
  5. Save the layout as 38.vpl.
  6. Test the layout.
  7. In <Workarea2> page <Tables>: Select <table1_value1>.
  8. Click on the lower CheckBox. Note that only the values in <a_Table2> column <chooseable> whose value in column <value> matches <table1_value1> can be selected:
    11_72_combobox_dynamic7.gif (2218 Byte)
  9. Select the RadioButton <table1_value2>.
  10. Click on the lower CheckBox. Note that the available values have not changed:
    11_72_combobox_dynamic8.gif (2199 Byte)
    The value did not change because the RadioGroup attribute property <ChkDynamic> = <No>.


T39. Element order

Page#: 11_73_element_order.htm

v13 000606TTA: last edit.

T39. Element order

An important aspect in entering data in a layout is the order in which the elements gain the focus when the tab key is pressed. This order can be specified in the Designer.

Do the following:

  1. If the layout created in T38 is not open in the Designer: Open 38.vpl.
  2. Select <Workarea1> page <W1Page1>.
  3. In Inspector tab <Page>: Set <Order> = <Individual>.
    11_73_element_order.gif (849 Byte)
  4. From the menu: Select <Options> / <Display order>. The order of the elements is displayed in the layout:
    11_73_element_order1.gif (2577 Byte)
  5. From the menu: Select <Edit> / <Elements reordering>. The <Elements reordering> dialog appears.
    11_73_element_order2.gif (2628 Byte)
    Note that the elements are listed in the order as shown by the numbers in the layout.
  6. Select <EF_a_1>.
  7. Press and hold the <Shift> key.
  8. Click the down arrow key 2 times (until <EF_a_1> is below <EF_a_2> in the dialog).
    11_73_element_order3.gif (1227 Byte)
  9. Click <OK>. Note the new order of the elements:
    11_73_element_order4.gif (981 Byte)
  10. Save the layout as 39.vpl.
  11. Test the layout.
  12. Click on the <Workarea1> tab.
  13. Click the <Tab> key. <W1Page1> obtains the focus.
  14. Click the <Tab> key. The EditField for <Attribute 2> obtains the focus.
  15. Click the <Tab> key. The EditField for <Attribute 1> obtains the focus.


T40. Start attribute

Page#: 11_74_start_attribute.htm

v13 000606TTA XX: last edit. i am not sure that i understand fully what start attribute is used for.

T40. Start attribute

The layout can have a single start attribute. The value of the start attribute can be specified in the layout or the model.

Do the following:

  1. If the layout created in T39 is not open in the Designer: Open 39.vpl.
  2. Set application property <Start attribute> = <Constant>.
  3. Set <Name> = <a_3>.
  4. Set <Value> = <abcdef123456>.
    11_74_start_attribute.gif (1287 Byte)
  5. Save the layout as 40.vpl.
  6. Test the layout.
  7. Select <Workarea2> page <Datatypes>. Note the values:
    11_74_start_attribute1.gif (4938 Byte)


T41. Parameter search

Page#: 11_75_parameter_search.htm

v13 000606TTA: last edit.

T41. Parameter search

When an attribute value is entered in the runtime layout, the focus can automatically be transferred to the layout element for a second attribute that is required along with the first attribute for a computation. Details.

Do the following:

  1. If the layout created in T40 is not open in the Designer: Open 40.vpl.
  2. Move the <Attribute 2> Label and EditField from <Workarea1> <W1Page1> to <W1Page2>.
    11_75_parameter_search.gif (2226 Byte)

    11_75_parameter_search1.gif (1835 Byte)
  3. Save the layout as 41.vpl.
  4. Test the layout.
  5. For <Attribute 1>: Enter 123.
  6. Click on the <Workarea2> tab. Note that <Workarea1> <W1Page2> is displayed (not <Workarea2>), since <Attribute 2> is required for computing Result <p_1>.
  7. Enter 456 for <Attribute 2>.
  8. Click on <Workarea2> tab. Note that <Workarea2> is displayed (the required attributes for Result have been entered).


T42. Data indicator

Page#: 11_76_data_indicator.htm

v13 000606TTA: last edit.

T42. Data indicator

A symbol can be used to indicated if all required data on a workarea or page has been entered. Details.

Do the following:

  1. If the layout created in T41 is not open in the Designer: Open 41.vpl.
  2. Change the layout Product model to 41.vpm. 41.pms contains the DI (data indicator) rules:
    11_76_data_indicator.gif (3287 Byte)
  3. For page <W1Page1>: Set <DataIndicator> = <On>. Note the design-time layout data indicator symbol for the page icon in the frame.
  4. For page <W1Page1>: Set <DI Rule> = <p_DI_W1Page1>.
    11_76_data_indicator1.gif (3083 Byte)
  5. For page <W1Page2>: Set <DataIndicator> = <On>.
  6. For page <W1Page2>: Set <DI Rule> = <p_DI_W1Page2>.
    11_76_data_indicator2.gif (3154 Byte)
  7. For <Workarea1>: Set <DataIndicator> = <On>.
  8. For <Workarea1>: Set <DI Rule> = <p_DI_Workarea1>.
    11_76_data_indicator3.gif (2465 Byte)
  9. Save the layout as 42.vpl.
  10. Test the layout. Note the "-" icon for the workarea and page tabs.
    11_76_data_indicator4.gif (837 Byte)
  11. For <Attribute 1>: Enter 123.
  12. Display <W1Page2>. Note that the symbol for <W1Page1> has changed to a <+>.
    11_76_data_indicator5.gif (859 Byte)
  13. For <Attribute 2>: Enter 456.
  14. Display <W1Page1> (to change the focus). Note that the symbol for <W1Page2> and <Workarea1> has changed to a <+>:
    11_76_data_indicator6.gif (858 Byte)


Recomputing result

Page#: 11_799_ov_recompute_result.htm

v13 000606TTA: last edit.

Recomputing result

This part demontrates how the layout can control how the data entered in the layout is processed by the model logic and the results displayed in the layout.


T43. Calculate: Page change

Page#: 11_80_recompute_change_page.htm

v13 000606TTA: last edit.

T43. Calculate: Page change

If [ application property <Calculation> = <Automatic> ]

AND [ entry element property <Compute result> = <No> ]

AND [ the value entered in the element is entered or modified ]

AND [ all other values for a result have already been entered ] :

The result is recalculated when a different page is selected.

Do the following:

  1. If the layout created in T42 is not open in the Designer: Open 42.vpl.
  2. Move <Attribute 2> Label and EditField to <Workarea1>.
  3. Set <Attrribute 2> property <ComputeResult> = <No>.
    11_80_recompute_change_page.gif (3987 Byte)
  4. Save the layout as 43.vpl.
  5. Test the layout.
  6. Enter for <Attribute 1>: 123.
  7. Enter for <Attribute 2>: 456. Note that the result is not calculated.
  8. Click in the EditField for <Attribute 1> (to change the focus). Note that the result is not computed.
  9. Display <W1Page2>.
  10. Display <W1Page1>. Note that the result has been calculated.
    11_80_recompute_change_page1.gif (2283 Byte)


T44. Calculate: Focus change

Page#: 11_81_recompute_change_focus.htm

v13 000606TTA: last edit.

T44. Calculate: Focus change

If [ application property <Calculation> = <Automatic> ]

AND [ entry element property <Compute result> = <Yes> ]

AND [ entry element property <Compute> = <OnExit> ] :

AND [ the value entered in the element is entered or modified ]

AND [ all other values for a result have already been entered ] :

The result is recalculated when the focus changes.

Do the following:

  1. If the layout created in T43 is not open in the Designer: Open 43.vpl.
  2. Set <Attribute 2> property <ComputeResult> = <Yes>.
  3. Set <Attribute 2> property <Compute> = <OnExit>.
    11_81_recompute_change_focus.gif (3813 Byte)
  4. Save the layout as 44.vpl.
  5. Test the layout.
  6. Enter for <Attribute 1>: 123.
  7. Enter for <Attribute 2>: 456. Note that the result is not calculated.
  8. Click in the EditField for <Attribute 1> (to change the focus). Note that the result is computed.
    11_81_recompute_change_focus1.gif (2307 Byte)


T45. Calculate: Data entry

Page#: 11_80_recompute_change_page.htm

v13 000606TTA: last edit.

T45. Calculate: Data entry

If [ application property <Calculation> = <Automatic> ]

AND [ entry element property <Compute result> = <Yes> ]

AND [ entry element property <Compute> = <OnChange> ]

AND [ the value entered in the element is entered or modified ]

AND [ all other values for a result have already been entered ] :

The result is recalculated immediately.

Do the following:

  1. If the layout created in T44 is not open in the Designer: Open 44.vpl.
  2. Set <Attribute 2> property <Compute> = <OnChange>.
    11_82_recompute_enter_data.gif (3974 Byte)
  3. Save the layout as 45.vpl.
  4. Test the layout.
  5. Enter for <Attribute 1>: 123.
  6. Enter for <Attribute 2>: 4. Note that the result is calculated immediately after the 4 key is pressed.
    11_82_recompute_enter_data1.gif (2301 Byte)
  7. Press the 5 key. Note that the result is again immediately calculated.
    11_82_recompute_enter_data2.gif (818 Byte)


T46. Calculate: Pushbutton click

Page#: 11_83_recompute_push_button.htm

v13 000606TTA: last edit.

T46. Calculate: Pushbutton click

If [ application property <Calculation> = <Manual>

AND [ the value entered in the element is entered or modified ]

AND [ all other values for a result have already been entered ] :

The result is recalculated only when a PushButton with <Action> = <Compute> is clicked.

Do the following:

  1. If the layout created in T45 is not open in the Designer: Open 45.vpl.
  2. Set application property <Calculation> = <Manual>.
  3. In <Workarea1> <W1Page1>: Add a PushButton with <Name> = <PB_Compute>, <Title> = <Compute> and property <Action> = <Compute>.
    11_83_recompute_push_button.gif (1697 Byte)
  4. Save the layout as 46.vpl.
  5. Test the layout.
  6. Enter for <Attribute 1>: 123.
  7. Enter for <Attribute 2>: 456. Note that the result is not calculated.
  8. Click to change the focus or page. Note that the result is not calculated.
  9. Click on the <Compute> PushButton. Note that the result is calculated.
    11_83_recompute_push_button1.gif (2551 Byte)
    Note: A different page may be displayed when clicking the <Compute> Pushbutton, since data is required for other results.


Visibility

Page#: 11_90_ov_visibility.htm

v13 000606TTA: last edit.

Visibility

The visibility of elements can be set during design-time (sometimes useful when creating the layout) and run-time (for example when certain components are visible only under certain conditions).


T47. Visibility: Design-time

Page#: 11_91_visibility_design_time.htm

v13 000606TTA: added.

T47. Visibility: Design-time

An element can be hidden in the layout during design time. You will encounter an example layout in which this is useful later in this tutorial.

Do the following.

  1. If the layout created in T46 is not open in the Designer: Open 46.vpl.
  2. In <Workarea1> page <W1Page2>: Add a MaskField with <Source> = <a_3>, <Name> = <EF_UU###> and <Mask> = <UU###> (2 upper-case letters and 3 digits).
    11_91_visibility_design_time.gif (3303 Byte)
  3. In <Workarea1> page <W1Page2>: Add a MaskField with <Source> = <a_3>, <Name> = <EF_U###L> and <Mask> = <U###L> (upper-case letter + 3 digits + lower-case letter).
    11_91_visibility_design_time1.gif (2179 Byte)
  4. For top EditField: Set property <Level> = <Level 1>.
    11_91_visibility_design_time2.gif (847 Byte)
  5. For lower EditField: Set property <Level>=<Level 2>.
    11_91_visibility_design_time3.gif (980 Byte)
  6. Save the layout as 47.vpl.
  7. From the main menu: Select <Options> / <Levels> / <Level 1> (uncheck). Note that the <Level 1> EditField is hidden:
    11_91_visibility_design_time4.gif (1905 Byte)
  8. From the main menu: Select <Options> / <Levels> / <Level 2> (uncheck). Note that the <Level 2> EditField is hidden.
  9. From the main menu: Select <Options> / <Levels> / <All levels>. Note that the EditFields are again visible.


T48. Visibility: Run-time static

Page#: 11_92_visibility_rt_static.htm

v13 000606TTA: last edit.

T48. Visibility: Run-time static

An element can be hidden in the runtime layout. In certain cases an element that should not be displayed is still required in the layout.

Do the following.

  1. If the layout created in T47 is not open in the Designer: Open 47.vpl.
  2. In <Workarea1> page <W1Page2>: For the upper EditField: Set property <Visible> = <No>.
    11_92_visibility_rt_static.gif (3139 Byte)
  3. Save the layout as 48.vpl.
  4. Test the layout. Note that the upper EditField is not visible.
    11_92_visibility_rt_static1.gif (1632 Byte)


T49. Visibility: Run-time dynamic

Page#: 11_93_visibility_rt_dynamic.htm

v13 000606TTA: last edit.

T49. Visibility: Run-time dynamic

An element in a layout can be hidden or displayed based on a run-time condition in the model or run-time input in the layout (without any processing in the model). This page demonstrates the most common and simple method for implementing run-time dynamic visibility. More run-time dynamic details.

Do the following:

  1. If the layout created in T48 is not open in the Designer: Open 48.vpl.
  2. Change the Product model to 49.vpm. 49.pms contains the following:
    11_93_visibility_rt_dynamic.gif (1973 Byte)
  3. In <Workarea1> page <W1Page2>: Add a PushButton with <Name> = <CB_MaskField> and <Title> = <Use bottom MaskField>.
    11_93_visibility_rt_dynamic1.gif (4147 Byte)
  4. For the PushButton: Set <Source> = <a_3>, <Compute> = <OnChange> and <ChkOtherVisibility> = <Yes>:
    11_93_visibility_rt_dynamic2.gif (1325 Byte)
  5. For the upper EditField: Set <Source> subproperty <Visible> = <Value> and <Property> = <p_3_0>:
    11_93_visibility_rt_dynamic3.gif (1704 Byte)
  6. For the lower EditField: Set <Source> subproperty <Visible> = <Value> and <Property> = <p_3_1>:
    11_93_visibility_rt_dynamic4.gif (1685 Byte)
  7. Save the layout as 49.vpl.
  8. Test the layout. Note the initial <W1Page2>:
    11_93_visibility_rt_dynamic5.gif (1871 Byte)
  9. Check the checkbox. The lower EditField is displayed (the upper is hidden):
    11_93_visibility_rt_dynamic6.gif (2039 Byte)
  10. Uncheck the checkbox. The upper EditField is displayed (the lower is hidden):
    11_93_visibility_rt_dynamic7.gif (1886 Byte)


Availability

Page#: 11_95_ov_availability.htm

v13 000606TTA: last edit.

Availability

Sometimes an element should not be available in the layout, but should still be visible. This part demonstrates how to implement this with the Designer.


T50. Availability: Static

Page#: 11_97_availibility_static.htm

v13 000606TTA: added.

T50. Availability: Static

The availability of an element can be specified as always being not available.

Do the following:

  1. If the layout created in T49 is not open in the Designer: Open 49.vpl.
  2. Change the product model to 50.vpm. 50.pms contains the following:
    11_97_availibility_static.gif (2487 Byte)
  3. Copy the Label's and EditField's for <Attribute 1> and <Attribute2> in <Workarea2> page <ModelB> to <Workarea1> <W1Page1>:
    11_97_availibility_static1.gif (2928 Byte)
  4. Rename the copied elements to avoid warning messages.
  5. For the <Attribute 1b> EditField: Set <ChkOwnAvailibilty> = <List> and <List (...;...)> = <p_1>.
    11_97_availibility_static2.gif (3235 Byte)
  6. For the <Attribute 2b> EditField: Set <ChkOwnAvailibilty> = <Page>.
    11_97_availibility_static3.gif (2109 Byte)
  7. For page <W1Page1>: Set property <AVAILABLE-Property> = <p_1>.
    11_97_availibility_static4.gif (2063 Byte)
  8. Save the layout as 50.vpl.
  9. Test the layout.
  10. In <Workarea2> page <ModelB>: Enter 123 for <Attribute 1b>.
  11. In <Workarea2> page <ModelB>: Enter 456 for <Attribute 2b>.
    11_97_availibility_static5.gif (1784 Byte)
  12. In <Workarea1> page <W1Page1>: Note that the <Attribute 1b> EditField is not available since the List specifies <p_1b>, which has no element on the page. Note that <Attribute 2b> EditField is not available since no element for <p_1b> exists on the page.
    11_97_availibility_static6.gif (2592 Byte)


T51. Availability: Dynamic

Page#: 11_98_availibility_dynamic.htm

v13 000606TTA: last edit.

T51. Availability: Dynamic

The availabilty of an element can be dynamic in the runtime layout.

Do the following:

  1. If the layout created in T50 is not open in the Designer: Open 50.vpl.
  2. Change the product model to 51.vpm. 51.pms contains the following:
    11_98_availibility_dynamic.gif (2445 Byte)
  3. Add a Label and EditField with <Source> = <a_E> and <ChkOwnAvailibility> = <Page> (remember <AVAILABLE-property> = <p_1>):
    11_98_availibility_dynamic1.gif (4809 Byte)
  4. For <Attribute 1> EditField: Set property <ChkOtherAvailibility> = <Yes>:
    11_98_availibility_dynamic2.gif (2552 Byte)
  5. Save the layout as 51.vpl.
  6. Test the layout. Note that the Extra EditField is not available.
  7. For <Attribute 2>: Enter 100. Note that the Extra EditField is not available.
  8. For <Attribute 1>: Enter 100. Note that the Extra EditField is not available.
  9. Click in <Attribute 2> EditField. The focus change caused other availability to be checked. Data can now be entered in the <Extra> EditField.
  10. Enter 3 in the <Extra> EditField.
  11. Click to change the focus. Note the result:
    11_98_availibility_dynamic3.gif (909 Byte)
  12. Change <Attribute 2> to 10.
  13. Click in <Extra>. Note that it is still available.
    11_98_availibility_dynamic4.gif (896 Byte)
  14. Change <Attribute 1> to 10.
  15. Click in Extra. Note that it is not available.
    11_98_availibility_dynamic5.gif (883 Byte)


Where to go from here

Page#: 11_99_where_to_go_from_here.htm

v13 000606TTA: last edit.

Where to go from here

At this point you have a basic understanding of Designer functionality.

Now it is recommended to do the following:

  1. Read in detail Designer concepts.
  2. Study the Designer properties.
  3. Review how to trouble-shoot common problems and the answers to frequently-asked questions.
  4. Analyze the example models.


Tools and dialogs

Page#: 2_tools_dialogs.htm

000215TTA: link for screenshot added.

v10 000406TTA: links for synchronization and data elements added.

Tools and dialogs

The following is a list of the tools and dialogs available within Designer.

  • Main dialog
  • Options dialog
  • Inspector
  • Test
  • Find/Find Next
  • Elements reordering dialog
  • Autosize
  • Synchonisierungs-Tool
  • Synchronisations-Report
  • Data elements
  • CRF Preparation (Print)
  • Screen shot


Main dialog

Page#: 2__1_main_dialog.htm

Main dialog

Click on a section of the main dialog for information about that section.


Title bar

Page#: 2__1_1_titlebar.htm

Title bar

The title bar contains the following information:

  • The Designer version and build.
  • The layout currently selected.

2__1_1 title bar.gif (1026 Byte)


Menu bar

Page#: 2__1_2_menubar.htm

Menu bar

The complete menu bar as shown below appears when a layout has been opened in Designer.

Click on a menu item for information about that menu item.


Menu File

Page#: 2__1_2_1_menu_file.htm

000212TTA: pic updated (for bmp export option)

000217TTA: german pic added.

Menu: File

Click on the diagram below for information about that window item.


Open

Page#: 2__1_2_1_01_menu_file_open.htm

Menu: File / Open

Brings up the Windows Open dialog for selecting a .vpl file.

Toolbar icon.


New

Page#: 2__1_2_1_02_menu_file_new.htm

Menu: File / New

Creates a new .vpl file and opens in the Designer.

Toolbar icon.


Close

Page#: 2__1_2_1_03_menu_file_close.htm

Menu: File / Close

Closes the .vpl file selected in the Designer.

A prompt for saving the file will appear if the file has unsaved changes.

Does not close the Designer.

The file can also be closed by clicking the Close button in the upper-right corner of the .vpl file dialog.

Toolbar icon.


Save

Page#: 2__1_2_1_04_menu_file_save.htm

Menu: File / Save

Saves the currently selected layout to a .vpl file.

Note: The .vpl fileis compiledto a .vpc file during the save.

Same as File / Save as... if the selected .vpl file is new and has not been saved yet.

Toolbar icon.


Save as...

Page#: 2__1_2_1_05_menu_file_saveas.htm

Menu: File / Save as...

Brings up the Windows "Save as..." dialog. The layout is saved to the specified .vpl file.

Note: The .vpl fileis compiledto a .vpc file during the save.


Print

Page#: 2__1_2_1_06_menu_file_print.htm

Menu: File / Print

Brings up the CRF preparation dialog for printing the layout.

Note: Has no effect if the layout contains no elements.

Toolbar icon.


Export screen shot

Page#: 2__1_2_1_065_menu_file_exportbmp.htm

000213TTA: created.

Menu: File / Export screen shot

Brings up the dialog Select page for screen shot.

See saving workareas/pages to .bmp files for details.


Test

Page#: 2__1_2_1_07_menu_file_test.htm

Menu: File / Test

Tests the layout file:

If the layout has not been saved: Prompt for saving the layout appears (the .vpl fileis compiled to a .vpc file during the save).

The compiled layout (.vpc)is opened in the Test tool.

Toolbar icon.


Information

Page#: 2__1_2_1_08_menu_file_info.htm

000217TTA: german pic added.

Menu: File / Information

Displays the following information about the currently selected model:

  • The application name.
  • Number of note pages.
  • Number of other pages.
  • Total number of pages.
  • Number of visual elements.

2__1_2_1_08_modelinfo.gif (2477 Byte)


(List of files)

Page#: 2__1_2_1_09_menu_file_filelist.htm

000217TTA: german pic added.

Menu: File / (list of most recent files)

A list of the most recently opened .vpl layout files is included in the File menu.

Selecting an entry will open that file in the Designer.

Example

The following File menu contains links to files.

Das nachfolgende Menü Datei beinhaltet Dateianzeiger.

2__1_2_1_09_filelist.gif (1167 Byte)


Exit

Page#: 2__1_2_1_10_menu_file_exit.htm

Menu: File / Exit

Closes Designer.

Note: If a layout in the Designer has unsaved changes: A prompt will appear to save the changes.


Menu Edit

Page#: 2__1_2_2_menu_edit.htm

Menu Edit

Click on the diagram below for information about that window item.

2__1_2_2_menu_edit.gif (2673 Byte)


Undo

Page#: 2__1_2_2_01_menu_edit_Undo.htm

Menu: Edit / Undo

Causes the last action to be undone.

The name of this menu item sometimes describes what type of action will be undone.

Example

If an element is added to a layout, then the menu selection will be named "Edit / Undo add element".


Find / Find next dialog

Page#: 2__5_find_find_next.htm

Dialog: Find / Find next

Locates text within the layout.

2__5 find.gif (1940 Byte)


Copy

Page#: 2__1_2_2_04_menu_edit_Copy.htm

Menu: Edit / Copy

Select to:

  • Copy selected text
  • Copy a selected element
  • Copy a selected group of elements to the clipboard.

    • Toolbar icon.

    Note: Pressing Ctrl-C has the same effect.


Paste

Page#: 2__1_2_2_05_menu_edit_Paste.htm

Menu: Edit / Paste

Paste the contents of the clipboard (text, element, or group of elements) from the clipboard to the layout.

Toolbar icon.

Note: Pressing Ctrl-V has the same effect.


Cut

Page#: 2__1_2_2_06_menu_edit_Cut.htm

Menu: Edit / Cut

Copies the selected text, element, or group of elements to the clipboard and then deletes the selected items.

Select to:

  • Cut selected text
  • Cut a selected element
  • Cut a selected group of elements

Toolbar icon.

Note: Pressing Ctrl-X has the same effect.


Delete

Page#: 2__1_2_2_07_menu_edit_Delete.htm

Menu: Edit / Delete

Deletes the selected text, element, or group of elements from the layout.

Note: Pressing the Del key has the same effect for only text or an element (not a group of elements).


Select all

Page#: 2__1_2_2_08_menu_edit_SelectAll.htm

Menu: Edit / Select all

Selects all elements on the displayed workarea page.

Toolbar icon (Group all).


Group

Page#: 2__1_2_2_09_menu_edit_Group.htm

Menu: Edit / Group

The Edit / Group submenu provides operations for groups of elements.

Corresponds to Alignment toolbar.

Click on the diagram below for information about that window item.

2__1_2_2_09 menu edit Group.gif (1995 Byte)


Group Align

Page#: 2__1_2_2_09_1_menu_edit_Group_Align.htm

Menu: Edit / Group / Group Align

A group of elements can be aligned.

Click on the diagram below for information about that window item.

2__1_2_2_09_1 menu edit Group align.gif (2125 Byte)


Align Left

Page#: 2__1_2_2_09_1_1_menu_edit_Group_Align_Left.htm

Menu: Edit / Group /Alignment / Align Left

Select to align the left edge of the group elements.

Same as clicking the icon Align left.


Aline Right

Page#: 2__1_2_2_09_1_2_menu_edit_Group_Align_Right.htm

Menu: Edit / Group /Alignment /Aline Right

Select to align the right edge of the group elements.

Same as clicking the icon Align right.


Aline Up

Page#: 2__1_2_2_09_1_3_menu_edit_Group_Align_Up.htm

Menu: Edit / Group /Alignment / Aline Up

Select to align the top edge of the group elements.

Same as clicking the icon Align up.


Aline Down

Page#: 2__1_2_2_09_1_4_menu_edit_Group_Align_Down.htm

Menu: Edit / Group /Alignment / Aline Down

Select to align the bottom edge of the group elements.

Same as clicking the icon Align down.


Group Same Size

Page#: 2__1_2_2_09_2_menu_edit_Group_SameSize.htm

Menu: Edit / Group / Make same size

All the elements selected in a group can be set to the same height and/or width.

Click on the diagram below for information about that window item.

2__1_2_2_09_2 menu edit Group samesize.gif (1937 Byte)


Align Height

Page#: 2__1_2_2_09_2_1_menu_edit_Group_SameSize_Height.htm

Menu: Edit / Group / Make same size/ Align Height

Changes the height of all selected elements to the height of the last element selected.

Toolbar icon.


Align Width

Page#: 2__1_2_2_09_2_2_menu_edit_Group_SameSize_Width.htm

Menu: Edit / Group / Make same size/ Align Width

Changes the width of all selected elements to the height of the last element selected.

Toolbar icon.


Group Space Evenly

Page#: 2__1_2_2_09_3_menu_edit_SpaceEvenly.htm

Edit / Group / Space Evenly

All of the elements selected in a group can be positioned so that the horizontal and/or vertical space between any 2 neighboring elements is the same.

Click on the diagram below for information about that window item.

2__1_2_2_09_3 menu edit Group spaceevenly.gif (2026 Byte)


Align Vertical

Page#: 2__1_2_2_09_3_1_menu_edit_Group_SpaceEvenly_Vertical.htm

Menu: Edit / Group / Space Evenly / Align Vertical

All elements in the group (with the exception of the 2 highest elements) are moved vertically such that:

[ The vertical space between the centers of any 2 vertically neighboring elements ] = [ The vertical space between the centers of the highest and the second highest elements ].

Toolbar icon.


Align Horizontal

Page#: 2__1_2_2_09_3_2_menu_edit_Group_SpaceEvenly_Horizontal.htm

Menu: Edit / Group / Space Evenly / Align Horizontal

All elements in the group (with the exception of the 2 leftmost elements) are moved horizontally such that:

[ The horizontal space between the centers of any 2 horizontally neighboring elements ] = [ The horizontal space between the centers of the leftmost and the second leftmost elements ].

Toolbar icon.


Group Disk Operations

Page#: 2__1_2_2_09_4_menu_edit_DiskOps.htm

Edit / Group / Disk Operations

Disk operations allow an entire group of elements to be written or read to / from the clipboard.

Click on the diagram below for information about that window item.

2__1_2_2_09_4 menu edit Group diskops.gif (2311 Byte)


Write Group to Disk

Page#: 2__1_2_2_09_4_1_menu_edit_Group_DiskOps_WriteGroup.htm

Menu: Edit / Group / Disk Operations / Write Group to Disk

Copies the elements selected in the layout to a .vpg file.

Toolbar icon.


Read group from disk to clipboard

Page#: 2__1_2_2_09_4_2_menu_edit_Group_DiskOps_ReadGroup.htm

Menu: Edit / Group / Disk Operations / Read Group from disk to clipboard

Copies the contents of a .vpg file (a group of elements) to the clipboard.

Toolbar icon.


Elements reordering

Page#: 2__1_2_2_10_menu_edit_elementsreordering.htm

Menu: Edit / Elements reordering

Displays the Elements (re)ordering dialog.


Menu Options

Page#: 2__1_2_3_menu_options.htm

v12 000504TTA: hyperlink changed (for options...).

Menu: Options

Click on the diagram below for information about that window item.

2__1_2_3_menu_options.gif (2556 Byte)


Inspector

Page#: 2__1_2_3_0_menu_options_inspector.htm

Menu: Options / Inspector

Opens the Inspector.


Warnings

Page#: 2__1_2_3_1_menu_options_warnings.htm

Menu: Options / Warnings

Opens or closes the Warning message window.

2__1_2_3_1_menu_options_warnings.gif (2484 Byte)


Options Limit Line

Page#: 2__1_2_3_2_menu_options_limitline.htm

Menu: Options / Limit Line

Displays or hides the red dotted limit line in the layout.

2__1_2_3_2_limitline.gif (977 Byte)


Options Grid

Page#: 2__1_2_3_3_menu_options_grid_.htm

Menu: Options / Grid

Displays or hides the grid in the layout.

2__1_2_3_3_grid.gif (906 Byte)


Options Display Order

Page#: 2__1_2_3_4_menu_options_displayorder.htm

000609TTA: pic corrected.

Menu: Options / Display Order

Displays or hides the order of the elements in the layout.

Concept.

Elements (re)ordering dialog.

2__1_2_3_4_order.gif (1592 Byte)


Options Levels

Page#: 2__1_2_3_5_menu_options_levels.htm

v10 000328TTA: last edit.

Menu: Options / Levels

Displays or hides all elements on the selected level.

Level property.

2__1_2_3_1_menu_options_levels.gif (2472 Byte)


Menu: Options / Options...

Page#: 2__1_2_3_55_menu_options_options.htm

v12 000504TTA: created.

Menu: Options / Options...

Opens the Options dialog.


Options Move Inspector Left

Page#: 2__1_2_3_6_menu_options_moveinspleft.htm

Menu: Options / Move Inspector Left

Moves the Inspector window to the upper left corner of the display.


Options Workbench Synchronization

Page#: 2__1_2_3_7_menu_options_wbsynchro.htm

Menu: Options / Workbench Synchronization

Synchronizes the layout with the model opened in the Workbench.


Menu Tools

Page#: 2__1_2_4_menu_tools.htm

Menu: Tools

Click on the diagram below for information about that window item.

2__1_2_4_menu_tools.gif (1408 Byte)


Autosize

Page#: 2__1_2_4_0_menu_tools_autosize.htm

Menu: Tools / Autosize

Opens the Autosize dialog.


Synchronize

Page#: 2__1_2_4_1_menu_tools_synchronize.htm

Menu: Tools / Synchronize

Opens the dialog "Synchronize".


Menu Window

Page#: 2__1_2_5_menu_window.htm

Menu: Window

Click on the diagram below for information about that window item.

Menu (1 or more layouts opened)

2__1_2_5_menu_window.gif (2174 Byte)

Menu (no layouts opened)

2__1_2_5_menu_window1.gif (2068 Byte)


Window / Arrange

Page#: 2__1_2_5_1_menu_window_arrange.htm

Menu: Window / Arrange

Arranges the windows in the Designer.


Window / Cascade

Page#: 2__1_2_5_2_menu_window_cascade.htm

Menu: Window / Cascade

Arranges the layouts in the Designer in a cascade format. All layouts are changed to a single size that will fit within the Designer layout design area.

2__1_2_5_2_cascade.gif (11854 Byte)


Window / Tile horizontal, vertical

Page#: 2__1_2_5_3_menu_window_tile.htm

Menu: Window / Tile horizontal, vertical

Arranges the layouts in the Designer in a tile format. All layouts are changed to a single size that will fit within the Designer layout design area.

Examples

Tile horizontal:

2__1_2_5_3_tilehorizontal.gif (4360 Byte)

Tile vertical:

2__1_2_5_3_tilevertical.gif (7308 Byte)


Window / View palette, tools, alignments

Page#: 2__1_2_5_4_menu_window_view.htm

Menu: Window / View palette, View tools, View alignments

Displays or hides the following toolbars:

  • Palette bar (common)
  • Tools bar (visual palette)
  • Alignment bar (groups)


Window / (layout list)

Page#: 2__1_2_5_5_menu_window_(dialoglist).htm

Menu: Window / (layout list)

A list of all layouts open in Designer.

The currently selected layout is marked with a check mark.

See also: List of open and previously opened files.

Example

2__1_2_5_5_layoutlist.gif (638 Byte)


Menu: Window / View header/footer tools

Page#: 2__1_2_5_6_menu_window_viewhftools_.htm

Menu: Window / View header/footer tools

Displays / hides the header/footer toolbar.


Menu: Window / Options

Page#: 2__1_2_5_7_menu_window_options.htm

Menu: Window / Options

Opens the Options dialog.


Menu Help

Page#: 2__1_2_6_menu_help.htm

Menu: Help

Click on the diagram below for information about that window item.

2__1_2_6_menu_help.gif (1300 Byte)


Help / Contents

Page#: 2__1_2_6_1_menu_help_contents.htm

Menu: Help / Contents

Opens the Designer help file contents page.


Help / Info

Page#: 2__1_2_6_2_menu_help_info.htm

Menu: Help / Info

Opens a window with:

  • Information about Designer.
  • Release information.
  • Contact information


Tools bar (visual palette)

Page#: 2__1_3_tools(visual_palette).htm

Toolbar: Tools (visual palette)

Menu item for displaying / hiding.

Click on the diagram below for information about that window item.


Toolbar icon: Pointer

Page#: 2__1_3_01_toolbar_pointer.htm

2__1_3_01_pointer.gif (168 Byte) Toolbar icon: Pointer

Changes the cursor to a pointer for selecting elements (removes the crosshair images from the mouse pointer).

Pointer location information in the Status bar.


Toolbar icon: EditField

Page#: 2__1_3_02_toolbar_entryfield.htm

2__1_3_02_entryfield.gif (139 Byte) Toolbar icon: EditField

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an EditField to the layout.

Changing the cursor back to a pointer.


Toolbar icon: ComboBox

Page#: 2__1_3_03_toolbar_combobox.htm

2__1_3_03_combobox.gif (155 Byte) Toolbar icon: ComboBox

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an ComboBox to the layout.

Changing the cursor back to a pointer.


Toolbar icon: CheckBox

Page#: 2__1_3_04_toolbar_checkbox.htm

2__1_3_04_checkbox.gif (108 Byte) Toolbar icon: CheckBox

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an CheckBox to the layout.

Changing the cursor back to a pointer.


Toolbar icon: Radio button

Page#: 2__1_3_05_toolbar_radiobutton.htm

2__1_3_05_radiobutton.gif (111 Byte) Toolbar icon: Radio button

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an RadioButton to the layout.

Changing the cursor back to a pointer


Toolbar icon: Push Button

Page#: 2__1_3_06_toolbar_pushbutton.htm

2__1_3_06_pushbutton.gif (127 Byte) Toolbar icon: Push Button

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an PushButton to the layout.

Changing the cursor back to a pointer


Toolbar icon: Label

Page#: 2__1_3_07_toolbar_label.htm

2__1_3_07_label.gif (92 Byte) Toolbar icon: Label

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Label to the layout.

Changing the cursor back to a pointer


Toolbar icon: Border

Page#: 2__1_3_08_toolbar_border.htm

2__1_3_08_border.gif (126 Byte) Toolbar icon: Border

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Border to the layout.

Changing the cursor back to a pointer


Toolbar icon: Grid

Page#: 2__1_3_09_toolbar_grid.htm

2__1_3_09_grid.gif (171 Byte) Toolbar icon: Grid

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Grid to the layout.

Changing the cursor back to a pointer


Toolbar icon: Extended Grid

Page#: 2__1_3_10_toolbar_extendedgrid.htm

2__1_3_10_extendedgrid.gif (191 Byte) Toolbar icon: Extended Grid

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds an ExtendedGrid to the layout.

Changing the cursor back to a pointer


Toolbar icon: 3d Border

Page#: 2__1_3_11_toolbar_3dborder.htm

2__1_3_11_3dborder.gif (115 Byte) Toolbar icon: 3d Border

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a 3D Border to the layout.

Changing the cursor back to a pointer


Toolbar icon: Line

Page#: 2__1_3_12_toolbar_line.htm

2__1_3_12_line.gif (90 Byte) Toolbar icon: Line

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Line to the layout.

Changing the cursor back to a pointer


Toolbar icon: Multimedia element

Page#: 2__1_3_13_toolbar_multimedia.htm

2__1_3_13_multimedia.gif (155 Byte) Toolbar icon: Multimedia element

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Multimedia element to the layout.

Changing the cursor back to a pointer


Toolbar icon: Result field

Page#: 2__1_3_14_toolbar_resultfield.htm

2__1_3_14_resultfield.gif (156 Byte) Toolbar icon: Result field

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a ResultField to the layout.

Changing the cursor back to a pointer


Toolbar icon: RadioGroup

Page#: 2__1_3_15_toolbar_radiogroup.htm

2__1_3_15_radiogroup.gif (140 Byte) Toolbar icon: RadioGroup

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a RadioGroup to the layout.

Changing the cursor back to a pointer


Toolbar icon: Graphics element

Page#: 2__1_3_16_toolbar_graphic.htm

2__1_3_16_graphic.gif (130 Byte) Toolbar icon: Graphics element

Click to add crosshair images to the mouse pointer.

Clicking with the mouse cursor on a layout then adds a Graphics element to the layout.

Changing the cursor back to a pointer


Toolbar icon: Close layout file

Page#: 2__1_3_17_toolbar_closelayout.htm

2__1_3_17_close.gif (128 Byte) Toolbar icon: Close layout file

Closes the .vpl file selected in the Designer.

A prompt for saving the file will appear if the file has unsaved changes.

Does not close the Designer.

The file can also be closed by clicking the Close button in the upper-right corner of the .vpl file dialog.

Menu item.


Toolbar icon: Test layout

Page#: 2__1_3_18_toolbar_testlayout.htm

2__1_3_18_test.gif (123 Byte) Toolbar icon: Test layout

Tests the layout file:

If the layout has not been saved: Prompt for saving the layout appears (the .vpl fileis compiled to a .vpc file during the save).

The compiled layout (.vpc)is opened in the Test tool.

Menu item.


Palette bar (common)

Page#: 2__1_4_palette(common).htm

Toolbar: Palette (common)

Menu item for displaying / hiding.

Click on the diagram below for information about that window item.

2__1_4 common.gif (1081 Byte)


New

Page#: 2__1_4_1_commonbar_filenew.htm

2__1_4_1_filenew.gif (105 Byte) Icon: New file

Creates a new .vpl file and opens in the Designer.

Menu item.


Open

Page#: 2__1_4_2_commonbar_fileopen.htm

2__1_4_2_fileopen.gif (118 Byte) Icon: Open file

Brings up the Windows Open dialog for selecting a .vpl file.

Menu item.


Save

Page#: 2__1_4_3__commonbar_filesave.htm

2__1_4_3_filesave.gif (130 Byte) Icon: Save file

Saves the currently selected layout to a .vpl file.

Note: The .vpl fileis compiledto a .vpc file during the save.

Same as File / Save as... if the selected .vpl file is new and has not been saved yet.

Menu item.


Cut

Page#: 2__1_4_4_commonbar_editcut.htm

2__1_4_4_editcut.gif (93 Byte) Icon: Cut

Copies the selected text, element, or group of elements to the clipboard and then deletes the selected items.

Select to:

  • Cut selected text
  • Cut a selected element
  • Cut a selected group of elements

Menu item.

Note: Pressing Ctrl-X has the same effect.


Copy

Page#: 2__1_4_5_commonbar_editcopy.htm

2__1_4_5_editcopy.gif (133 Byte) Icon: Copy

Click to:

  • Copy selected text
  • Copy a selected element
  • Copy a selected group of elements

to the clipboard.

Menu item.

Note: Pressing Ctrl-C has the same effect.


Paste

Page#: 2__1_4_6_commonbar_editpaste.htm

2__1_4_6_editpaste.gif (137 Byte) Icon: Paste

Paste the contents of the clipboard (text, element, or group of elements) from the clipboard to the layout.

Menu item.

Note: Pressing Ctrl-V has the same effect.


Print

Page#: 2__1_4_7_commonbar_fileprint.htm

2__1_4_7_fileprint.gif (118 Byte) Icon: Print file

Click to print (CRF preparation) the currently selected layout.

Menu item.


Alignment bar (groups)

Page#: 2__1_5_alignment(groups).htm

Toolbar: Alignment (groups)

Menu item for displaying / hiding.

Click on the diagram below for information about that window item.

2__1_5 groups.gif (1490 Byte)


Align Left

Page#: 2__1_5_01_alignbar_alignleft.htm

2__1_5_01_alignleft.gif (106 Byte) Icon: Align Left

Click to align the left edge of the group elements.

Same as selecting from the main menu Edit / Group / Alignment / Align left.


Align Right

Page#: 2__1_5_02_alignbar_alignright.htm

2__1_5_02_alignright.gif (111 Byte) Icon: Align Right

Click to align the left edge of the group elements.

Same as selecting from the main menu Edit / Group / Alignment / Align right.


Align Up

Page#: 2__1_5_03_alignbar_alignup.htm

2__1_5_03_alignup.gif (111 Byte) Icon: Align Up

Click to align the top edge of the group elements.

Same as selecting from the main menu Edit / Group / Alignment / Align up.


Align Down

Page#: 2__1_5_04_alignbar_aligndown.htm

2__1_5_04_aligndown.gif (112 Byte) Icon: Align Down

Click to align the left edge of the group elements.

Same as selecting from the main menu Edit / Group / Alignment / Align down.


Same height (Align height / Make same size vertical)

Page#: 2__1_5_05_alignbar_samesizevertical.htm

2__1_5_05_samesizevertical.gif (116 Byte) Icon: Same height (Align height / Make same size vertical)

Changes the height of all selected elements to the height of the last element selected.

Menu item.


Same width (Align width / Make same size horizontal)

Page#: 2__1_5_06_alignbar_samesizehorizontal.htm

2__1_5_06_samesizehorizontal.gif (121 Byte) Icon: Same width (Align width / Make same size horizontal)

Changes the width of all selected elements to the width of the last element selected.

Menu item.


Space evenly vertical (Align vertical / Spread vertical evenly)

Page#: 2__1_5_07_alignbar_spaceevenlyvertical.htm

2__1_5_07_spaceevenvertical.gif (97 Byte) Icon: Space evenly vertical (Align vertical / Spread vertical evenly)

All elements in the group (with the exception of the 2 highest elements) are moved vertically such that:

[ The vertical space between the centers of any 2 vertically neighboring elements ] = [ The vertical space between the centers of the highest and the second highest elements ].

Menu item.


Space evenly horizontal (Align horizontal / Spread horizontal evenly)

Page#: 2__1_5_08_alignbar_spaceevenlyhorizontal.htm

2__1_5_08_spaceevenhorizontal.gif (89 Byte) Icon: Space evenly horizontal (Align horizontal / Spread horizontal evenly)

All elements in the group (with the exception of the 2 leftmost elements) are moved horizontally such that:

[ The horizontal space between the centers of any 2 horiozontally neighboring elements ] = [ The horizontal space between the centers of the leftmost and the second leftmost elements ].

Menu item.


Group all

Page#: 2__1_5_09_alignbar_groupall.htm

2__1_5_09_groupall.gif (128 Byte) Icon: Group all

Selects all elements on the displayed workarea page.

Menu item (Select all).


Save group to disk

Page#: 2__1_5_10_alignbar_savetodisk.htm

2__1_5_10_writegrouptodisk.gif (124 Byte) Icon: Save group to disk

Copies the elements selected in the layout to a .vpg file.

Menu item.


Read group from disk (and copy to clipboard)

Page#: 2__1_5_11_alignbar_readfromdisk.htm

2__1_5_11_readgroupfromdisk.gif (124 Byte) Icon: Read group from disk (and copy to clipboard)

Copies the contents of a .vpg file (a group of elements) to the clipboard.

Menu item.

Concept.


Toolbar: Header/footer tools

Page#: 2__1_55_headerfooter.htm

Toolbar: Header/footer tools

Menu item for displaying / hiding.

Click on the diagram below for information about that window item.

2__1_55_headerfooter.gif (767 Byte)


Icon: App header

Page#: 2__1_55_1_applicationheader.htm

2__1_55_1_applicationheader.gif (117 Byte) Icon: App header

Click to display / hide the application header.


Icon: App footer

Page#: 2__1_55_2_applicationfooter.htm

2__1_55_2_applicationfooter.gif (113 Byte) Icon: App footer

Click to display / hide the application footer.


Icon: WArea header

Page#: 2__1_55_3_workareaheader.htm

2__1_55_3_workareaheader.gif (116 Byte) Icon: WArea header

Click to display / hide the workarea header.


Icon: WArea footer

Page#: 2__1_55_4_workareafooter.htm

2__1_55_4_workareafooter.gif (115 Byte) Icon: WArea footer

Click to display / hide the workarea footer.


Design area

Page#: 2__1_6_designarea.htm

Main dialog: Design area

Layouts are displayed in the Designer Design area.

2__1_6 design area.gif (9450 Byte)


Status bar

Page#: 2__1_7_statusbar.htm

Main dialog: Status bar

The Status bar displays the following information:

  • Pointer location.
  • Version number of Designer.
  • Capital / Numeric / Scroll lock

2__1_7_status_bar.gif (737 Byte)


Options dialog

Page#: 2__2_options_dialog.htm

Dialog: Options

Click on the diagram below for information about that window item.

optionsdialog.gif (6932 Byte)


Options dialog / Application

Page#: 2__2_1_options_application.htm

Dialog: Options / Application

Click on the diagram below for information about that window item.

2__2_1 options application.gif (8077 Byte)


Application Width/Height

Page#: 2__2_1_1_options_application_widthheight.htm

Dialog: Options / Application / Width/Height

Sets the default width / height of an application (in pixels).

Changing the application width.

Changing the application height.

Example (of application width / height)

The following example shows an application with Width/Height set to 227/166.

2__2_1_1_applwidthheight.gif (3587 Byte)

Testing the above application would result in the following dialog.

2__2_1_1_applwidthheight2.gif (3022 Byte)


Application Style

Page#: 2__2_1_2_options_application_style.htm

Dialog: Options / Application / Style

Set the default application style property.


Application/Notes fonts

Page#: 2__2_1_3_options_application_fonts.htm

Dialog: Options / Application / Application, Notes (tab) fonts

Sets the default fonts for the entire application.

  • The application font is the font for the contents of all pages, but NOT for frame text.
  • The notes font is the font for the workarea tab text. NOTE: Changing the default value will only take effect after the layout has been reopened.

Frame text font default settings.

Example of application font setting

In the following example, the font for the application has been changed to Elephant,11. Note that the application font does not apply to the frame font.

2__2_1_3_fontsappl.gif (4777 Byte)

Example of notes (tab) font setting

In the following example, the notes (tab) font was changed to Courier,12.

2__2_1_3_fontsappl2.gif (4637 Byte)


Application Version Support

Page#: 2__2_1_4_options_application_versionsupport.htm

Dialog: Options / Application / Version Support

Specifies the default value for the version info property for applications.

Versioning in Designer.


Options dialog / Workarea

Page#: 2__2_2_options_workarea.htm

Dialog: Options / Workarea

Click on the diagram below for information about that window item.

2__2_2 options workarea.gif (6904 Byte)


Workarea Frame Width

Page#: 2__2_2_1_options_workarea_framewidth.htm

Dialog: Options / Workarea / Frame Width

Sets the default width of a frame in a workarea with style set to Frame.

Changing the frame width.

Example

The following example shows a frame with width

2__2_2_1_framewidth.gif (2958 Byte)


Workarea font

Page#: 2__2_2_2_options_workarea_font.htm

Dialog: Options / Workarea / (frame) font

Sets the default font for the frame for a workarea.

Page (application) / tab (notes) text default settings.

Example of workarea (frame) font setting

In the following example, the font for the frame has been changed to MS Sans Serif,12.

2__2_2_2_fontframe.gif (2246 Byte)


Workarea version support

Page#: 2__2_2_3_options_workarea_versionsupport.htm

Dialog: Options / Workarea / Version Support

Specifies the default value for the version info property for workareas.

Versioning in Designer.


Options Page

Page#: 2__2_3_options_page.htm

Dialog: Options / Page

Click on the diagram below for information about that window item.

2__2_3 options page.gif (6411 Byte)


Page Background Color

Page#: 2__2_3_1_options_page_backgrcolor.htm

Dialog: Options / Page / Background Color

Sets the default Background color property of pages.

Notes:

  • This has no effect on the frame and tab background color settings.
  • The frame background cannot be changed.
  • The tab background settings must be set individually (no default settings).
  • Element background settings must be set individually (no default settings).

Example

The following example shows a page with background color set to green.

2__2_3_1_pagebackgroundcolor.gif (5096 Byte)


Page Sequence

Page#: 2__2_3_2_options_page_sequence.htm

Dialog: Options / Page Sequence

Sets the page sequence to individual or standard.

If page sequence = standard: The element order on a page cannot be changed (the Elements reordering option in the Edit menu is disabled).


Page version support

Page#: 2__2_3_3_options_page_versionsupport.htm

Dialog: Options / Page / Version Support

Specifies the default value for the version info property for pages.

Versioning in Designer.


Options Element

Page#: 2__2_4_options_element.htm / v07 X / 000217

000217TTA: german pic added.

Dialog: Options / Element

Click on the diagram below for information about that window item.

2__2_4 options element.gif (7641 Byte)


Element Compute Event

Page#: 2__2_4_1_options_element_computeevent.htm

Dialog: Options / Element / Compute Event

Sets the compute (event) property default for elements.

  • On change: Compute default value = OnChange.
  • On exit: Compute default value = OnExit.


Element Check Validity

Page#: 2__2_4_2_options_element_checkvalidity.htm

Dialog: Options / Element / Check Validity

Sets the ChkValidation property default for elements.


Element Visible

Page#: 2__2_4_3_options_element_visible.htm

Dialog: Options / Element / Visible

Sets the Visible property default for elements.

Note: Whereas the Visible property can be set to Check, the default cannot.

Concepts: Visibility.


Element Check Other Visibility

Page#: 2__2_4_4_options_element_checkothervisible.htm

Dialog: Options / Element / Check other visibility

Sets the ChkOtherVisibility property default for elements.

Concepts: Checking other visibility.


Element Check Own Availability

Page#: 2__2_4_5_options_element_checkownavailable.htm

Dialog: Options / Element / Check Own Availability

Sets the ChkOwnAvailibility property default for elements.

Concepts: Availibility.


Element Check Other Availability

Page#: 2__2_4_6_options_element_checkotheravailable.htm

Dialog: Options / Element / Check other availibilty

Sets the ChkOtherAvailibility property default for elements.

Concepts: Availibility.


Element Compute Results

Page#: 2__2_4_7_options_element_computeresults.htm

Dialog: Options / Element / Compute results

Sets the ComputeResult property default for elements.

Concepts: Compute result.


Element Dynamics

Page#: 2__2_4_8_options_element_dynamics.htm

Dialog: Options / Element / Dynamics

Sets the ChkDynamic property default for elements.

Concepts: Check dynamically.


Element version support

Page#: 2__2_4_9_options_element_versionsupport.htm

Dialog: Options / Element / Version Support

Specifies the default value for the version info property for elements.

Versioning in Designer.


Options Useability

Page#: 2__2_5_options_useability.htm

Dialog: Options / Useability

Click on the diagram below for information about that window item.

2__2_5 options usability.gif (6890 Byte)


Useability Play Sounds

Page#: 2__2_5_1_options_useability_playsounds.htm

Dialog: Options / Useability / Play Sounds

Determines whether or not audio for multimedia elements will be played.


Useability 2d appearance

Page#: 2__2_5_2_options_useability_2dlooks.htm

Dialog: Options / Useability / 2d appearance

Determines whether the toolbars will be displayed in 2d or 3d.

Operations ("palette", "common") bar

2d

2__2_5_2_operationsbar2d.gif (582 Byte)

3d

2__2_5_2_operationsbar3d.gif (803 Byte)


Options Designer settings

Page#: 2__2_6_options_designer.htm

Dialog: Options / Designer settings

Click on the diagram below for information about that window item.

2__2_6 options designer.gif (6580 Byte)


Designer Raster

Page#: 2__2_6_1_options_designer_raster.htm

Dialog: Options / Designer settings / Raster

Changes the raster settings.


Designer Create Backup

Page#: 2__2_6_2_options_designer_createbackup.htm

Dialog: Options / Designer settings / Create backup file

Creates a backup file of the layout.


Designer DI Path

Page#: 2__2_6_3_options_designer_dipath.htm

Dialog: Options / Designer settings / DI Path

Specifies the default directory for DI (data indicator) bitmaps.


Designer VPM Path

Page#: 2__2_6_4_options_designer_vpmpath.htm

Dialog: Options / Designer settings / VPM Path

Specifies the default path of .vpm (compiled model) files.


Options IFOS

Page#: 2__2_7_options_ifos.htm

Dialog: Options / IFOS

Click on the diagram below for information about that window item.

2__2_7 options ifos.gif (7180 Byte)


IFOS Executable

Page#: 2__2_7_1_options_ifos_executable.htm

Dialog: Options / IFOS / IFOS Executable

Specifies the directory / filename of the IFOS executable (normally C:\Programme\CAF\IFOS\ifosre.exe).


IFOS Elements Sorter

Page#: 2__2_7_2_options_ifos_elementssorter.htm

Dialog: Options / IFOS / Elements Sorter

Specifies the directory / filename of the elements sorter file.


IFOS Attribute Sorter

Page#: 2__2_7_3_options_ifos_attributessorter.htm

Dialog: Options / IFOS / Attributes Sorter

Specifies the directory / filename of the attributes sorter file.


IFOS Page Sorter

Page#: 2__2_7_4_options_ifos_pagesorter.htm

Dialog: Options / IFOS / Page Sorter

Specifies the directory / filename of the page sorter file.


Inspector

Page#: 2__3_inspector.htm

Inspector

The Inspector is used to display the available propertiesfor the currently selected application, workarea, page, element.

inspector.gif (3672 Byte)


Test dialog

Page#: 2__4_test.htm

Test dialog

The Test dialog shows how the layout would perform in a consultation.

Starting the test dialog:

  • Menu item.
  • Toolbar icon.

test2.gif (2663 Byte)


Elements reordering dialog

Page#: 2__6_elements_reordering.htm

Dialog: Elements (re)ordering

This dialog is used to reorder the elements on a page.

Menu item for opening element (re)ordering dialog.

Menu item for displaying element order in layout.

Concept.

2__6 elementsreordering.gif (4460 Byte)


Autosize-Tool dialog

Page#: 2__7_autosize.htm

v10 000406TTA: non-tta text added.

Dialog: Autosize-Tool

This dialog is used to generating a new layout from the current application layout for the target resolution using defined autosizing data.

Opening from main menu.

Click on the diagram below for information about that window item.

2__7 autosize.gif (5641 Byte)


Autosize Proportional Factor Automatic

Page#: 2__7_1_autosize_proportionalfactor_auto.htm

Dialog: Autosize / Proportional Factor Automatic

Allows the layout to be autosized by simply specifying the target screen configuration.

2__7_1 autosize proporauto.gif (1556 Byte)


Autosize Proportional Factor Manual

Page#: 2__7_2_autosize_proportionalfactor_manual.htm

Dialog: Autosize / Proportional Factor Manual

Allows the layout to be autosized by specifying the target screen size relative to the current screen size.

2__7_2_autosize_propormanual.gif (752 Byte)


Autosize font Map

Page#: 2__7_3_autosize_fontmap.htm

Dialog: Autosize / font Map

The font maps displays how the fonts will be replaced in the generated layout.

2__7_3_autosize_fontmap.gif (1046 Byte)


Autosize fontBrowser

Page#: 2__7_4_autosize_fontbrowser.htm

Autosize fontBrowser

The font browser is a standard browser for fonts.

2__7_4_autosize_fontbrowser.gif (6075 Byte)


Autosize fontList Save/Load

Page#: 2__7_5_autosize_fontlist_saveload.htm

Autosize fontList Save/Load

Click Save to save the font list to a file.

Click Load to load the font list from a file.


Dialog: Synchonisierungs-Tool

Page#: 2__75_synchronization.htm

v10 000406TTA: created. non-tta text added.

Dialog: Synchonisierungs-Tool

The dialog is aimed on getting a report as a result of comparison of two applications opened in different MDI windows (mainly used for synchronizing XPL-applications with different screen resolutions). This dialog can be activated if at least two applications are opened in the Designer.

Opening from main menu.

The dialog includes the following controls.

  • List box Basis Application. Used for defining a basic application for synchronization. Consists of the list of open applications. Default value is the current (active) open application.
  • List box Synchronized Application. Used for defining an application to be compared with the basic application. Consists of the list of open applications excluding the basic application. Default value is the first application of the list.
  • Pushbutton Synchronize. Used to generate a synchronization report of the applications defined by the lisboxes described above. The genereted report is opened in the new MDI window.
  • Checkbox Ignore position/size information. Used to avoid reporting differences on elements positioning and size. Default value is checked.
  • Pushbutton Close. Used for closing Synchronize dialog.
  • Pushbutton Help. Used for getting help information on Synchronize dialog.

2__75_synchronization.gif (3060 Byte)


Dialog: Synchronisations-Report

Page#: 2__77_synchronization_report.htm

v10 000406TTA: created. non-tta text added.

Dialog: Synchronisations-Report

Synchronization report windows appears when pushbutton ‘Synchronize’ in ‘Synchronize’ dialog is pressed. It is aimed on displaying of synchronization results and provides possibility to save report.

Window overview

2__77_synchronization_report.gif (4898 Byte)

Synchronization windows contains a Report display field. In this multi-line scrollable (vertical and horizontal) display field results of synchronization (comparison) are displayed. The report displaying format consists of the header and difference parts.

  • The header part contains general information: the names of synchronized applications, synchronization date and time.
  • The difference part contains the differences between the applications layouts. For every difference a difference object (in hierarchy area:page:element:property) and the difference character (object does not exist or different properties values) are reported. Values found in the basic application are prefixed with ‘>’ character, values from the synchronized application are prefixed with ‘<’ character. If an object does not exist in one of the applications, ‘not exist’ string is reported prefixed with correspondent character.

Example report.

Synchronization report: pkvv.vpl, pkvv_640.vpl 24.04.98 12:32:04

Haftfplicht_W:Privat_P:A_HAFT_PHVDeckungsumfang:

<Not exist

Haftfplicht_W:Privat_P:A_HAFT_PHVDeckungsumfang:A_HAFT_SonstigePerson:Typ

>Numerish

<Text

The Sychronization window also contains:

  • Pushbutton ‘Save’. Used for synchronization report saving. It activates standard ‘Save File’ dialog.
  • Pushbutton ‘Close’. For closing synchronization report window.
  • Pushbutton ‘Help’. Used for getting help information on synchronization report window.


Dialog: Data elements

Page#: 2__78_data_elements.htm

v10 000406TTA: created. non-tta (functional description) text added.

Dialog: Data elements

Data elements support is aimed to provide possibility to have in XPL-application non-visible data elements that are connected to product model attributes. These elements as well as visual elements participate in the data exchange via XPL-data block and their values can be used for computing and setting visual elements values using certain conversion rules (properties) defined in the product model. This conversion process may be activated while running XPL application by some events, such as pushbutton or radio-button pressing or check-box checking.

Window overview

Using ‘Data Elements’ secondary dialog for every data element the following properties are defined: name (unique in XPL-application among all elements, including visual ones), source (attribute name) and multiplicity (Yes/No, active for multiple pages only, for static pages always No).

2__78_data_elements.gif (2204 Byte)

‘Data Elements’ dialog consists of the following controls.

  • Grid ‘Data Elements’. The grid contains a data element list defined for the page. For static pages the grid has two columns corresponding to the data elements properties: Name, Source. For multiple pages the grid has three columns: Name, Source, Multiple. Every line of the grid describes a data element. Data elements are ordered in the grid in order of their appearance in the grid. Grid is vertical scrollable. Editing of the data element properties may be made by double-click on the grid cells. Double-click on Name cell causes appearance of an edit-filed in this cell containing data element name for editing. Double-click on Source cell causes appearance of a list-box in this cell containing product model attributes to select an attribute for the data element. Double-click on Multiple cell (for multiple pages only) causes appearance of a list-box in this cell containing two options: ‘Yes’ and ‘No’. On right click on the grid area a pop-up menu appears, consisting of two options: ‘New’ and ‘Delete’. Choosing of ‘New’ option causes addition of a new data element to the grid with automatically generated unique name, which is available to edit. ‘Delete’ option is used for deletion of the focused data element from the grid producing a warning message-box for confirmation of the action.
  • Pushbutton ‘New’. Function of this pushbutton is the same as option ‘New’ in the pop-up menu described above.
  • Pushbutton ‘Delete’. Function of this pushbutton is the same as option ‘Delete’ in the pop-up menu described above.
  • Pushbutton ‘Ok’. When this pushbutton is pressed, all the changes been made in the data elements list are committed and the secondary dialog is closed.
  • Pushbutton ‘Cancel’. When this pushbutton is pressed, all the changes been made in the data elements list are canceled (the data elements list has the state as before opening the dialog) and the secondary dialog is closed.
  • Pushbutton ‘Help’. Used for getting help information on ‘Data Elements’ secondary dialog.


CRF preparation (print) dialog

Page#: 2__8_crf_preparation.htm

000217TTA: new english pic

CRF preparation (print) dialog

Click on the diagram below for information about that window item.

2__8_crfpreparation.gif (5403 Byte)


Report type

Page#: 2__8_1_crf_preparation_sorting.htm

v09 000303TTA: rewriten.

Report type

"Report type" includes options for selecting the type of report and the content of the report.

The following options are available:

  • Sorting: Create a table report with entries order by page, element, or element property <Source> value.
  • Unsorted: Create a table report with entries in the order as they appear in the layout.
  • Detail: Create a text report.
  • Layout (available only if "Detail" selected): Include layout information in the report.
  • Version information (available only if "Detail" selected): Include component comments ("version information) in the report.
  • Cover (available only if "Detail" selected): Include cover information in the report.

2__8_1_crf_preparation_sorting.gif (1342 Byte)


Sorting

Page#: 2__8_2_crf_preparation_sortby.htm

v09 000303TTA: rewritten.

Sorting

"Sorting" includes options for selecting the order of the entries in a table report.

The following options are available:

  • Elements: Order the entries by element name.
  • Elements: Order the entries element property <Source> value.
  • Elements: Order the entries by page name.

2__8_2_crf_preparation_sortby.gif (684 Byte)


Range

Page#: 2__8_25_crf_preparation_range.htm

v09 000303TTA: rewritten.

Range

"Range" includes options for selecting the content of a text report.

The following options are available:

  • All: Properties for all layout components.
  • Workarea: Properties for:
    • Application
    • Selected workarea
    • All components in the selected workarea.
  • Page: Properties for:
    • Application
    • Workarea of selected page.
    • Selected page.
    • All components in the selected selected page.

2__8_25_crf_preparation_range.gif (1021 Byte)


Output On

Page#: 2__8_3_crf_preparation_outputon.htm

Output On

Determines the output device (printer or screen) for the printing.


CRF Printer Settings

Page#: 2__8_4_crf_preparation_printersettings.htm

v09 000303TTA: i could not open the dialog (build 013b).

Printer Settings

Open a dialog for specifying the printer settings for the print.


Select page for screen shot dialog

Page#: 2__9_screenshot.htm

000213TTA: created.

Select page for screen shot dialog

Used to select the workareas and/or pages to be saved to individual .bmp files.

Opened from the menu Fileselection Export screen shot.

See saving workareas/pages to .bmp files for details.

2__9_screenshot.gif (4048 Byte)


Concepts

Page#: 3_concepts.htm

v09 000229TTA: arrays entry updated. visibility updated.

v10 000405TTA: arrays removed from this level (now under datatypes).

Concepts

The following are the major concepts for Designer.

  • VP/MS components. Describes the VP/MS components (which include Designer).
  • Layout components. Describes the components that a layout can contain.
  • Add / delete components. Describes how to add and delete layout components.
  • Properties. Describes the central function of component properties in the layout.
  • Data connections model / layout. Describes the connection between model [attributes] / [attribute properties] / [product properties] and the layout.
  • Data types. Describes the data types supported in the layout.
  • Entering / selecting data. Describes the various methods Designer provides for entering (EntryField, etc.) and selecting (ComboBox, etc.) data. Also describes other aspects of data entry, including element order, start attribute, the parameter search algorithm and data indicators.
  • Displaying data. Describes the methods Designer provides for displaying data.
  • Computing result (model property). Describes the different ways of controlling when a result is evaluated in the model and displayed in the layout.
  • Re-computing attribute defaults and labels. Describes the different ways of controlling when the attribute properties <default> and <label> are re-computed.
  • Visibility. Describes visibility of layout components in the design-time layout (levels) and in the runtime layout (static and dynamic).
  • Availibility. Describes static and dynamic availability (spelled "availibility" in Designer) of layout components. A non-available component is grey and cannot be used for input (although output is supported).
  • Subdialogs. Describes how to open and close subdialogs.
  • Media element. Describes how to use media elements in a layout.
  • DLL calls. Describes how to call DLL's from the layout.
  • Help and tooltips. Describes how to implement Windows help and static/dynamic tooltips.
  • Layout comment / print. Describes how to comment layout components and create printed lists of layout components.
  • Layout test. Describes how to test a layout.


VPMS components

Page#: 3_01_concepts_vpmscomponents.htm

VP/MS components

The following are the major components of VP/MS:

  • Model. The model is the source for creating a runtime model.
  • Runtime model. The runtime model contains the business logic for the VP/MS application (calculations for the VP/MS application are carried out in the runtime model).
  • Layout. The layout is the source for creating a compiled layout.
  • Compiled layout. The compiled layout provides the user interface (the layout) for the VP/MS application.
  • VFrame consultation. The VFrame consultation integrates the runtime model and compiled layout.
  • Report. Describes how a report is used to create a report of the information entered into the layout.


Model

Page#: 3_01_01_concepts_model.htm

Model

The model is the source that describes the business logic of the VP/MS application.

The model is saved to a .pms file.

The model is created in the Workbench (see the Workbench User's Guide or Online Help for more information about the Workbench).

The model is compiled within the Workbench to create a runtime model.


Runtime model

Page#: 3_01_02_concepts_runtimemodel.htm

Runtime model

The runtime model is used in the consultation for the actual calcuations required for the busines logic.

The runtime model is generated from the model using the Workbench.

The runtime model is saved to a .vpm file.


Layout

Page#: 3_01_03_concepts_layout.htm

Layout

The layout is the source that describes the user interface of the VP/MS application.

The layout is saved to a .vpl file.

The layout is created in the Designer.

The layout is compiled within the Workbench to create a compiled layout.


Compiled layout

Page#: 3_01_04_concepts_compiledlayout.htm

Compiled layout

The compiled layout is used in the consultation to create the user interface.

The compiled layout is generated from the layout using the Designer.

The compiled layout is saved to a .vpc file.

The connection between the layout and model is established by entering the (directory and) filename of the runtime model as the value for the layout property Productmodel.

Attributes of the model are available via the layout drop-down lists for properties if the layout is synchronized with the model. If the required model is the selected model in the Workbench, then synchronization can be accomplished from within the Designer via the synchronization menu item.


Consultation

Page#: 3_01_06_concepts_laymodinconsulation.htm

Consultation

The runtime layout is accessed by a user by opening a consultation.

A consultation is the framework within which the compiled layout is accessed by a user.

Consult the VP/MS Getting Started manual for more information about the Consultation.

Example

The following shows a VFrame dialog without a consultation ("beratung") selected.

3_01_06_vframedialog.gif (2796 Byte)

The following shows the VFrame dialog with a consultation (Zyx) selected. The layout displayed is generated by the runtime layout.

3_01_06_vframedialog2.gif (6107 Byte)


Report

Page#: 3_01_07_concepts_report.htm

Report

The report is generated with the IFOS Report Generator (for more information about IFOS, consult the IFOS User's Guide).

The report contains the information entered in the consultation. The report can be printed to a file or an output device (printer, screen).

Example

The following example shows the first page of a report displayed in the IFOS Report Viewer.

3_01_07_report.gif (5899 Byte)


Layout components

Page#: 3_02_concepts_layoutcomponents.htm

000212TTA: links added to header/footers.

Layout components

A layout is comprised of an application.

An application can have a header and/or footer.

The application contains 1 or more workareas (each with a separate tab).

A workarea can have a header and/or footer.

Each workarea contains 1 or more pages.

Each page contains 0, 1 or multiple elements.


Application

Page#: 3_02_1_application.htm

Application

The application is a complete layout.

Complete list of Application properties.

Example

The following is an application with 3 workareas ("Kunde info", "General information", "Capital").

3_02_1_application.gif (4244 Byte)


Application Header/Footer

Page#: 3_02_15_application_headerfooter.htm

v09 000229TTA: last edit... pics added. build013b

Application Header/Footer

A header / footer can be added to an application with <Style> = <Notebook> by defining application properties <Header> / <Footer> to <Yes>.

Note: An empty (containing no elements) header or footer will not be saved when saving the model.

Complete list of Application properties.

Examples

The following application has a header with 50-pixel height, a green background and a Label.

3_02_15_application_headerfooter.gif (2719 Byte)

3_02_15_application_headerfooter1.gif (514 Byte)

Note that the application <Height> includes the <Height> of the header.

The following layout contains a footer. Note that the application <Height> also contains the height of the footer.

3_02_15_application_headerfooter2.gif (3752 Byte)

3_02_15_application_headerfooter3.gif (436 Byte)


Workarea

Page#: 3_02_2

Workarea

An application has 1 or more workareas.

If an application has more than 1 workarea, then each workarea has a tab.

If a workarea has more than 1 page, then the left area of the workarea contains a frame with an icon for each page (similar to the tabs for each workarea).

Complete list of Workarea properties.

Example

In the following example, the workarea with tab text "Capital" has a frame with the names of 3 pages ("Entry fields", "Grid", "Graphic"). Page "Entry fields" is the currently displayed page.

3_02_2_workarea.gif (4244 Byte)


Workarea Header/Footer

Page#: 3_02_25_workarea_headerfooter.htm

v09 000229TTA: last edit. pics added. build013b.

Workarea Header/Footer

A header / footer can be added to a workarea with <Style> = <Frame> by defining workarea properties <Header> / <Footer> to <Yes>.

Note: An empty (containing no elements) header or footer will not be saved when saving the model.

Complete list of Workarea properties.

Example

The following application has:

  • Workarea Area2 header (pink) with label "WAH label" positioned to the right of the frame.
  • Workarea Area2 footer (light blue) with label "Workarea footer label" positioned on the bottom (under) the frame.

3_02_25_workarea_headerfooter.gif (6122 Byte)

The application height includes all footers and headers.

Note that the workarea header/footer is also for Page4.

3_02_25_workarea_headerfooter1.gif (2909 Byte)

The workarea Area2 header/footer are not included in workarea Area1.

3_02_25_workarea_headerfooter2.gif (1924 Byte)

The following layout has the workarea header <Position> = <Top> and workarea footer <Position> = <Right>.

3_02_25_workarea_headerfooter3.gif (5562 Byte)


Page

Page#: 3_02_3_page.htm

Page

Each workarea has 1 or more pages.

Only 1 page can be displayed in the layout at any time (the frame with the name of other pages for the selected workarea and the tabs with the names of all workareas for the application are also displayed).

A page contains 0, 1 or multiple elements.

Complete list of Page properties.

Example

In the following example, the workarea with tab text "Capital" has a frame with the names of 3 pages ("Entry fields", "Grid", "Graphic"). Page "Entry fields" is the currently displayed page.

3_02_3_page.gif (4244 Byte)


Element

Page#: 3_02_4_element.htm

Element

A page can contain any number of elements.

An element can be used to:

  • Enter/select data
  • Display data
  • Make external calls

The following types of elements are available in Designer:

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • PushButton
  • Label
  • Border
  • Grid
  • ExtendedGrid
  • 3D Border
  • Line
  • Multimedia element
  • ResultField
  • RadioGroup
  • Graphic

Example

In the following example, the workarea with tab text "General information" has many elements (labels, entry fields, combo box, multimedia, border, 3d border, etc.), each with a different color.

3_02_4_element.gif (7899 Byte)


Concept: EditField

Page#: 3_02_4_02_element_entryfield.htm

Concept: EditField

An EditField is used to enter data. An EditField can also be used to dynamically display data.

The Sourceproperty of an EditField specifies the model attribute or model property (not to be confused with a designer component property) that is entered / displayed in the EditField. The Typeproperty specifies the data type of the attribute.

Complete list of EditField properties.

Toolbar icon for adding EditField to the layout.

Example

The following EditField has attribute a_Years as the source.

3_02_4_02_editfield.gif (904 Byte)

The type of the entered data is by default Text. Note that not only the type of data can be specified (Text / Date / Currency / Number), but also that the type of element can be changed (to ComboBox / RadioButton / CheckBox / RadioGroup / Mask).

3_02_4_02_editfield2.gif (2245 Byte)


Concept: ComboBox

Page#: 3_02_4_03_element_combobox.htm

Concept: ComboBox

A ComboBox is used to enter data(as for an EditField) or select data (from a list of available values).

The Source property of a ComboBox specifies the model attribute or model property (not to be confused with a designer component property) that is entered / selected / displayed in the ComboBox.

Complete list of ComboBox properties.

Toolbar icon for adding ComboBox to the layout.

Example

The following ComboBox has attribute a_Weeks as the source.

3_02_4_03_combobox.gif (1058 Byte)

During runtime, the ComboBox can be used to display the available values (defined in a Workbench table) as shown below (the available values are "1 week" and "2 weeks"):

3_02_4_03_combobox2.gif (692 Byte)


Concept: CheckBox

Page#: 3_02_4_04_element_checkbox.htm

Concept: CheckBox

A CheckBox is used to select a value of type boolean.

The Source property of a CheckBox specifies the model attribute or model property (not to be confused with a designer component property) that is seleted / displayed in the CheckBox.

Complete list of CheckBox properties.

Toolbar icon for adding CheckBox to the layout.

Example

The following CheckBox has attribute Zuweisen as the source.

3_02_4_04_checkbox.gif (833 Byte)


Concept: Radio button

Page#: 3_02_4_05_element_radiobutton.htm / v07 / 000218

000218TTA: german pic added.

Concept: Radio button

A RadioButton is used to select a value of type boolean.

The Source property of a RadioButton specifies the model attribute or model property (not to be confused with a designer component property) that is seleted / displayed in the RadioButton.

Complete list of RadioButton properties.

Toolbar icon for adding a RadioButton to a layout.

Example

The following RadioButton has attribute Zuweisen as the source.

3_02_4_05_radiobutton.gif (811 Byte)


Concept: Push Button

Page#: 3_02_4_06_element_pushbutton.htm

Concept: Push Button

A PushButton is used for an external calls.

The Action property of a PushButton specifies the action (Compute, DLL, Dialog, Accept, Cancel) taken when the PushButton is clicked.

Complete list of PushButton properties.

Toolbar icon for adding a PushButton to a layout.

Example

The following PushButton makes a call to the DLL specified in the the file kndbearb.ini when clicked.

3_02_4_06_pushbutton.gif (1164 Byte)


Concept: Label

Page#: 3_02_4_07_element_label.htm

Concept: Label

A Label is used to display static text or dynamic text.

The text displayed by a Label is specified by:

  • IF property Attributeis not defined: Property Title.
  • IF property Attribute is defined: The text string referenced the attribute.

Complete list of Label properties.

Toolbar icon for adding a Label to a layout.

Example

The text displayed by the following Label is defined by the model attribute A_KND_Geschlecht.

3_02_4_07_label.gif (1266 Byte)


Concept: Border

Page#: 3_02_4_08_element_border.htm

Concept: Border

A Border is used to visually (not functionally) group together elements.

A Border is also used to display (in the upper-left corner of the Border) static text or dynamic text.

The text displayed by a Border is specified by:

  • IF property Attributeis not defined: Property Title.
  • IF property Attribute is defined: The text string referenced the attribute.

Complete list of Border properties.

Toolbar icon for adding a Border to a layout.

Example

The text displayed by the following Border is defined by the Border title property.

3_02_4_08_border.gif (1517 Byte)


Concept: Grid

Page#: 3_02_4_09_element_grid.htm

Concept: Grid

A Grid is used to display the model attributes and model properties for an array of elements.

A Grid consists of the following:

  • Columns
  • Rows

Grid columns support certain data types.

Complete list of Grid properties.

Toolbar icon for adding a Grid to a layout.

Example

The following example shows a layout Grid with 4 columns (column 2 is used to generate the array pointer).

3_02_4_09_grid.gif (4099 Byte)

The following shows the above Grid in a compiled layout with an array of years with 3 members:

3_02_4_09_grid2.gif (1567 Byte)


Concept: Grid Columns

Page#: 3_02_4_09_1_columns.htm

Concept: Grid Columns

A Grid normally has 3 types of columns:

  • A single key column that displays the array key
  • A hidden (property Width = 0) next-key column used for generating for the key for the next row
  • 1 or more attribute or property columns


Concept: Grid Key Column

Page#: 3_02_4_09_1_1_column_key.htm

Concept: Grid Key Column

The Key column (usually the first column) uniquely identifies each row.

The following are the most important properties for the key column:

  • "Usage". Normally set to "Input", because the key column row will receive input (the text to display in a cell).
  • "Attribute". Attribute is the model attribute that determines the value for the key column in the first row.
  • "Next line". Specifies the column in the grid which defines how the text for the key column in the next row is generated.

Example

In the following Grid, Attribute "a_YearStart" provides the value for the key column in the first row. The text for the next row is generated in column 2 ("Next line").

3_02_4_09_1_1_column_key.gif (3299 Byte)

The result is shown in the following runtime layout:

3_02_4_09_1_1_column_key2.gif (806 Byte)


Concept: Grid Next Key Column

Page#: 3_02_4_09_1_2_column_nextkey.htm

Concept: Grid Next Key Column

The Next Key column (typically the last column; however, it can be any column) provides the link to the runtime model property that generates the text for the key column for the next row.

The following are the most important properties for the next key column:

  • "Usage". Normally set to "Output", because the next key column row will output data for the next row's key column.
  • "Property". Property is the model property that generates the value for the key column in the next row.

Example

In the following Grid, column 2 (the next key column) is linked the model attribute p_YearNext(). Column 1 specifies Column2 as the source for the Column 1 text ("Next line"). Note in the column Year in the second row the text "[(internal)]-1": This specifies that the key column text is generated in the column with title "(internal)" in the preceding ("-1") row.

3_02_4_09_1_2_column_nextkey.gif (2436 Byte)


Concept: Grid Attribute / Property Columns

Page#: 3_02_4_09_1_3_columns_attrprop.htm

Concept: Grid Attribute / Property Columns

The remaining (ie, not Key Column or Next Key Column) columns display the value in an array.

The following are the most important properties for attribute / property columns:

  • "Usage". Normally set to "Output".
  • "Property". Specifies the model property that references an array of data.

Note also the property under "Iteration type". This specifies the index attribute in the model for the arrays of data.

Example

In the following Grid, column 3 contains data values from the array "p_Interest()" in the model. The index for this array in the model is "a_Years". The value displayed in a row in the Grid for Column "Interest" is determined by the value in the Key Column of the Grid. This value is used as the index a_Years for looking up the value.

3_02_4_09_1_3_column_attributeproperty.gif (4591 Byte)

In the following runtime layout example:

  • p_Interest(1) = DM 22
  • p_Capital(1) = DM 122
  • p_Interest(2) = DM 26
  • p_Capital(2) = DM 148

3_02_4_09_1_3_column_attributeproperty2.gif (1563 Byte)


Concept: Grid column data types

Page#: 3_02_4_09_3_column_datatypes.htm

Concept: Grid column data types

The data displayed in a Grid column can be of the following types:

  • Text
  • Number
  • Currency
  • Date
  • MaskResult


Concept: Grid Rows

Page#: 3_02_4_09_4_rows.htm

Concept: Grid Rows

Each Grid row shows the members of all of the arrays in the Grid with an index equal to the value in the Key column for that row.


Concept: ExtendedGrid

Page#: 3_02_4_10_element_extendedgrid.htm

Concept: ExtendedGrid

An ExtendedGrid is visually similar to a Grid. However, the functionality of the 2 element types differs significantly.

The major difference is that data can be entered (not simply displayed) in an ExtendedGrid.

The property Count attribute specifies the model attribute that will be used to count the rows.

An ExtendedGrid has 2 types of columns:

  • Input. An Input column can only reference a model attribute.
  • Output. An Output column can only reference a model property.

ExtenedGrid column supported data types.

The ExtendedGrid rowsare similar in function to those of the Grid with one major exception: Rows can be dynamically added or deleted in an Extended Grid.

For step-by-step examples of using the ExtendedGrid, consult the VP/MS Getting Started Guide.

Complete list of ExtendedGrid properties.

Toolbar icon for adding an ExtendedGrid to a layout.

Example

(The following example is used in the help subtopics for this topic).

The following example shows a layout ExtendedGrid with 4 columns.

  • Columns 1 and 4 are output columns (referencing model properties).
  • Columns 2 and 3 are input columns (referencing model attributes (column 2 uses a ComboBox for the input)).

3_02_4_10_extendedgrid.gif (1782 Byte)

The following shows the above ExtendedGrid in a compiled layout:

3_02_4_10_extendedgrid2.gif (1239 Byte)


ExtendedGrid: Count attribute

Page#: 3_02_4_10_1_countattribute.htm

ExtendedGrid: Count attribute

The property "Count attribute" specifies the model attribute that is the count attribute for the multiple inclusion rule in the model (in model terminology, the "IncType" = "multiple" and the "IncRule" = the model attribute).

Note: To display the count attribute in the ExtendedGrid, the attribute must be sent from the model to the layout via a property (shown in the example below).

Example

In the following ExtendedGrid, the Count attribute is set to a_Persons. Thus, whenever a new row is added to the ExtendedGrid, a_Persons will be incremented.

3_02_4_10_1_countattribute.gif (2150 Byte)

In the model, a_Persons is the IncRule for a multiple inclusion. Note that the property Folge(i) is used to send the count attribute back to the layout (the count is incremented by 1, since the index for the array starts at 0).

3_02_4_10_1_countattribute2.gif (2002 Byte)

Note: Any name can be used to reference the index ("i" is used above). Workbench automatically substitutes the IncRule variable into the index variable.

The following runtime layout shows the results:

3_02_4_10_extendedgrid3.gif (1095 Byte)

Note: No input was entered for the above example. 2 persons are shown because a_Persons has a default of 2.


ExtendedGrid: Column types

Page#: 3_02_4_10_2_columns.htm

ExtendedGrid: Column types

An ExtendedGrid has 2 types of columns:

  • Input
  • Output


ExtendedGrid: Input column

Page#: 3_02_4_10_2_1_input.htm

ExtendedGrid: Input column

ExtendedGrid input columns support only certain data types.

Note: An ExtendedGrid can accept text input by specifying the propery "Type" as a ComboBox.

An input column must reference a model attribute.

Example

Column 3 property "Usage" is set to "Input". The attribute is a_DOB.

3_02_4_10_1_1_input.gif (2540 Byte)

Column 2 property "Usage" is set to "Input". The attribute is a_Name. Note that the Type is ComboBox.

3_02_4_10_1_1_input2.gif (2367 Byte)

In the runtime layout, the values for the indexed attributes are entered directly in the ExtendedGrid.

3_02_4_10_1_1_input3.gif (1228 Byte)


ExtendedGrid: Output column

Page#: 3_02_4_10_2_2_output.htm

ExtendedGrid: Output column

ExtendedGrid output columns support only certain data types.

There are 2 types of output columns in an ExtendedGrid:

  • The counter output column. References a model property in the upper branch of the multiple inclusion.
  • A row result column(s). References a model property in the lower branch of the multiple inclusion.

Example

Column 1 property "Usage" is set to "Output". The model property is Folge().

3_02_4_10_2_2_output.gif (1661 Byte)

The property Folge() is defined in the model in the upper branch of the multiple inclusion.

3_02_4_10_2_2_output2.gif (1999 Byte)

Note that the Workbench automatically inserts the indexed value of the IncRule a_Persons for the index variable ("i").

Column 4 property "Usage" is set to "Output". The model property is p_PremiumP2Each().

3_02_4_10_2_2_output3.gif (2738 Byte)

Note, however, that property p_PremiumP2Each() is defined in the model in the lower branch of the multiple inclusion.

3_02_4_10_2_2_output4.gif (3814 Byte)

The runtime layout results:

3_02_4_10_1_1_input3.gif (1228 Byte)


Concept: ExtendedGrid column data types

Page#: 3_02_4_10_3_datatypes.htm

Concept: ExtendedGrid column data types

The data displayed in a Grid column can be of the following types:

  • Text (this is also the data type when a ComboBox is selected)
  • Number
  • Currency
  • Date
  • MaskResult


Concept: ExtendedGrid Rows

Page#: 3_02_4_10_4_rows.htm

Concept: ExtendedGrid Rows

Each Grid row shows the members of all of the arrays in the Grid with an index equal to the value the counter column.

Rows can be added / deleted.


Add/delete ExtendedGrid Rows

Page#: 3_02_4_10_4_1_rows_adddelete.htm

Add/delete ExtendedGrid Rows

Rows can be dynamically added or deleted in an ExtendedGrid.

Example

The properties "Caption New" and "Caption Delete" specify the text that will be displayed when right clicking on an ExtendedGrid.

3_02_4_10_4_1_adddeleterows.gif (2144 Byte)

In the runtime layout, right clicking will display the following context menu.

3_02_4_10_4_1_adddeleterows2.gif (897 Byte)


Concept: 3d Border

Page#: 3_02_4_11_element_3dborder.htm

Concept: 3d Border

A 3D Border is used to visually (not functionally) group together elements.

A 3D Border does NOT display (in the upper-left corner of the Border) text.

Toolbar icon for adding a 3D Border to a layout.

Complete list of 3D Border properties.

Example

The following diagram shows a 3D Border.

3_02_4_11_element_3dborder.gif (218 Byte)


Concept: Line

Page#: 3_02_4_12_element_line.htm

Concept: Line

A Line is used to visually (not functionally) separate elements.

Toolbar icon for adding a Line to a layout.

Complete list of Line properties.

Example

The following diagram shows 3 Line elements.

3_02_4_12_element_line.gif (450 Byte)


Concept: Multimedia element

Page#: 3_02_4_13_element_multimedia.htm

Concept: Multimedia element

A Multimedia element can have as the Source a file of the following types:

  • .avi
  • .wav
  • .bmp
  • .jpg
  • .tif

Toolbar for adding a Multimedia element to a layout.

Complete list of Multimedia properties.

Example

A Multimedia element in the non-runtime layout always appears with the VP/MS icon:

3_02_4_13_element_multimedia.gif (4509 Byte)

In the runtime layout the appropriate type of multimedia element is displayed/played. In the diagram below, an .avi movie is shown.

3_02_4_13_element_multimedia2.gif (818 Byte)

Note: The movie plays only when the page of the movie is selected. If another page or workarea is selected, the movie stops playing. If the page is again displayed, the movie starts from the beginning.


Concept: ResultFields

Page#: 3_02_4_14_element_resultfield.htm

Concept: ResultFields

A ResultField is used to display a property that is a result of other properties/attributes.

The type of ResultField must match the data type to be displayed. The following types of ResultFields exist:

  • Result (TextResult)
  • NumberResult
  • CurrencyResult
  • DateResult
  • MaskResult

Toolbar icon for adding a ResultField to an element.

Complete list of ResultField properties.


Result (TextResult)

Page#: 3_02_4_14_1_result.htm

Result

The Result field is used to display any type of data as a String.

Example

The following is a Result field.

3_02_4_14_1 result.gif (751 Byte)


NumberResult

Page#: 3_02_4_14_2_numberresult.htm

NumberResult

A NumberResult field is used to display numeric results.

Example

Assume the following layout with an EditField and a NumberResult field.

3_02_4_14_2 numberresult.gif (1556 Byte)

Any data entered in the EntryField will be displayed in numerical format.

3_02_4_14_2 numberresult2.gif (471 Byte)


CurrencyResult

Page#: 3_02_4_14_3_currencyresult.htm

CurrencyResult

A CurrencyResult field is used to display currency results.

Example

Assume the following layout with an EditField and a CurrencyResult field.

3_02_4_14_3 currencyresult.gif (1447 Byte)

Any data entered in the EntryField will be displayed in currency format.

3_02_4_14_3 currencyresult1.gif (508 Byte)


DateResult

Page#: 3_02_4_14_4_dateresult.htm

DateResult

A DateResult field is used to display date results.

Example

Assume the following layout with an EditField and a DateResult field.

3_02_4_14_4 dateresult.gif (1389 Byte)

Any data entered in the EntryField will be displayed in currency format.

3_02_4_14_4_dateresult1.gif (469 Byte)

Note that invalid input (input that doesn not represent a valid date) will not be displayed.

3_02_4_14_4_dateresult2.gif (372 Byte)

Normally the Date EntryField is used to restrict the values entered for an attribute to valid Date strings.


MaskResult

Page#: 3_02_4_14_5_maskresult.htm

MaskResult

A MaskResult field is used to display a customized data format using a mask.

Example

Assume the following layout with an EditField and a MaskResult field.

3_02_4_14_5 maskresult.gif (1509 Byte)

Any data entered in the EntryField will be displayed in the format defined by the mask.

3_02_4_14_5 maskresult1.gif (462 Byte)

3_02_4_14_5 maskresult2.gif (427 Byte)

Normally a Mask EntryField is used to restrict the values entered for an attribute to the required format to be displayed in the MaskResult field.


Concept: RadioGroup

Page#: 3_02_4_15_element_radiogroup.htm

Concept: RadioGroup

A RadioGroup is used to:

  • Display a list of available values
  • Select a value from the list of available values

The major property for a RadioGroup is the Source. The Source references a model attribute which references a table with the text for the RadioGroup selections (see the Workbench User's Guide for more information).

Toolbar for adding a RadioGroup to a layout.

Complete list of RadioGroup properties.

Example

The following RadioGroup in the layout has as Source attribute a_Weeks.

3_02_4_15_element_radiogroup.gif (1105 Byte)

Attribute a_Weeks references a table (in the model) with the following content:

3_02_4_15_element_radiogroup3.gif (1713 Byte)

The content is displayed in the runtime version of the RadioGroup:

3_02_4_15_element_radiogroup2.gif (384 Byte)


Concept: Graphics element

Page#: 3_02_4_16_element_graphic.htm

Concept: Graphics element

A Graphics elements can display arrays of data in a graphic format.

  • A graphics element requires an ID Grid as the source of information to be displayed.
  • The key column provides the numerical values for the x-axis of the graphic.
  • A serie is a set of data in the graphic. A graphic can contain multiple series, with each serie corresponding to a column of data in the id grid.
  • The normalized result of the series becomes the numerical value for the y-axis.
  • The legend is a description of each serie in the graphic.
  • The axis names describe the x-axis and y-axis.
  • There are several graphic element types.

See also:

  • Complete list of Graphics properties.
  • Graphics element toolbar icon.

Example

The following is a typical graphic.

3_02_4_16_element_graphic.gif (2448 Byte)

In the above graphic:

  • The key column of the source grid contains values 1, 2, 3.
  • The graphic displays 2 series of data (a green and a red serie).
  • The normalized result range shown in the y-axis is DM 0 ... 250.
  • The legend for the red serie is "Interest" and for the green serie "Capital" (column names from the source grid).
  • The axis names are "Year" and "DM".
  • There graphic type is 3D vertical bar.


Identification Grid

Page#: 3_02_4_16_12_idgrid.htm

Identification Grid

The identification grid is a Grid or ExtendedGrid that provides the information to be displayed in the graphic. The ID grid is specified by entering the element name of the grid for the graphic property Identification grid.

Example

Assume the following ExtendedGrid.

3_02_4_16_12_idgrid.gif (4113 Byte)

The above ExtendedGrid would be specified as the ID grid for the followin graphic.

3_02_4_16_12_idgrid2.gif (5202 Byte)


Key column

Page#: 3_02_4_16_13_keycolumn.htm

Key column

The key column is a column in the Identification Grid and provides the numerical values for the x-axis of the graphic. The key column is specified with the property Key column.

Example

Assume the following graphic:

3_02_4_16_13_keycolumn.gif (2423 Byte)

Assume the following Grid with the entered data as the Identification grid:

3_02_4_16_13_keycolumn2.gif (1548 Byte)

Note that the above grid contains entries for 3 years.

The resulting graphic would be:

3_02_4_16_13_keycolumn3.gif (1385 Byte)

The digits "1", "2", "3" above is the text from column 1 in the Identification grid.


Serie

Page#: 3_02_4_16_14_serie.htm

Serie

A serie is a set of data in the graphic. A graphic can contain multiple series, with each serie corresponding to a column of data in the id grid.

The number of series in a graphic is specified by the property Series.

The data and color of each series is specified by:

  • Selecting the serie from the drop-down list of all series in the "Property for" property.
  • Specifying the data column in the Identification grid that supplies each value for the serie by specifying property Data column.
  • Specifying the color of the serie by specifying property Color.

Example

Assume the following graphic:

3_02_4_16_14_serie.gif (2903 Byte)

3_02_4_16_14_serie2.gif (200 Byte)

3_02_4_16_14_serie3.gif (691 Byte)

3_02_4_16_14_serie4.gif (680 Byte)

Assume the following Grid with the entered data as the Identification grid:

3_02_4_16_13_keycolumn2.gif (1548 Byte)

Note the contents in columns 3 and 4 in the above grid.

The resulting graphic would be:

3_02_4_16_14_serie5.gif (1469 Byte)


Normalized result

Page#: 3_02_4_16_16_normalizedresults.htm

Normalized result

The normalized result of the series becomes the numerical value for the y-axis. The range of values is determined automatically by Designer.

Example

Assume the following Grid with the entered data as the Identification grid:

3_02_4_16_13_keycolumn2.gif (1548 Byte)

Note the contents in columns 3 and 4 in the above grid.

The resulting graphic would have the range 0..250 on the y-axis.

3_02_4_16_14_serie5.gif (1469 Byte)


Legend

Page#: 3_02_4_16_17_legend.htm

Legend

The legend is a description of each serie in the graphic.

The legend is the name of the column in the Grid.

The legend can be placed to the right or bottom of the graphic by specifying property Legend placement.

Example

Assume the following graphic:

3_02_4_16_17_legend.gif (3517 Byte)

Note "Caption 1" and "Caption 2" above. In the runtime the captions will be replaced by the text heading of the appropriate column in the Grid. Assume the following Grid with the entered data as the Identification grid:

3_02_4_16_13_keycolumn2.gif (1548 Byte)

The column name is specified by Grid property Title as shown below for column 3:

3_02_4_16_17_legend3.gif (1825 Byte)

The resulting graphic would be:

3_02_4_16_17_legend2.gif (1443 Byte)


Axis names

Page#: 3_02_4_16_18_axisnames.htm

Axis names

The axis names describe the x-axis and y-axis and are specified with the properties X-axe nameand Y-axe name.

Example

3_02_4_16_18_axisnames.gif (3216 Byte)


Graphic element types

Page#: 3_02_4_16_4_graphictypes.htm

Graphic element types

The following types of graphic elements are available:

  • Line
  • Vertical bar
  • Horizontal bar
  • Vertical 3D bar
  • Horizontal 3D bar
  • Vertical Gantt
  • Horizontal Gantt
  • Pie
  • 3D Pie


Line

Page#: 3_02_4_16_4_1_line.htm

Line

The graphic type line shows each serie as a line.

Example

Layout:

3_02_4_16_4_1_line.gif (2908 Byte)

Runtime:

3_02_4_16_4_1_line1.gif (1475 Byte)


Vertical Bar

Page#: 3_02_4_16_4_2_verticalbar.htm

Vertical Bar

The graphic type vertical bar shows each serie as a vertical bar.

Example

Layout:

3_02_4_16_4_2_verticalbar.gif (3290 Byte)

Runtime:

3_02_4_16_4_2_verticalbar1.gif (1852 Byte)


Horizontal Bar

Page#: 3_02_4_16_4_3_horizontalbar.htm

Horizontal Bar

The graphic type horizontal bar shows each serie as a horizontal bar.

Example

Layout:

3_02_4_16_4_3_horizontalbar.gif (2892 Byte)

Runtime:

3_02_4_16_4_3_horizontalbar2.gif (1705 Byte)


Vertical 3D Bar

Page#: 3_02_4_16_4_4_vertical3dbar.htm

Vertical 3D Bar

The graphic type vertical 3d bar shows each serie as a vertical 3d bar.

Example

Layout:

3_02_4_16_4_4_vertical3dbar.gif (3640 Byte)

Runtime:

3_02_4_16_4_4_vertical3dbar1.gif (2290 Byte)


Horizontal 3D Bar

Page#: 3_02_4_16_4_5_horizontal3dbar.htm

Horizontal 3D Bar

The graphic type horizontal 3d bar shows each serie as a horizontal 3d bar.

Example

Layout:

3_02_4_16_4_5_horizontal3dbar.gif (3416 Byte)

Runtime:

3_02_4_16_4_5_horizontal3dbar1.gif (2205 Byte)


Vertical Gantt

Page#: 3_02_4_16_4_6_verticalgantt.htm

Vertical Gantt

The graphic type vertical gantt shows:

  • Each serie as a single 1-dimensional vertical column.
  • Each subset as a separate color.

Example

Layout:

3_02_4_16_4_6_verticalgantt.gif (3137 Byte)

Runtime:

3_02_4_16_4_6_verticalgantt1.gif (1842 Byte)


Horizontal Gantt

Page#: 3_02_4_16_4_7_horizontalgantt.htm

Horizontal Gantt

The graphic type horizontal gantt shows:

  • Each serie as a single 1-dimensional horizontal column.
  • Each subset as a separate color.

Example

Layout:

3_02_4_16_4_7_horizontalgantt.gif (3112 Byte)

Runtime:

3_02_4_16_4_7_horizontalgantt1.gif (1945 Byte)


Pie

Page#: 3_02_4_16_4_8_pie.htm

Pie

The graphic type pie shows:

  • All series for a subset combined.
  • Each subset as a piece of a pie (with the size of the pie in percentage).

Example

Layout:

3_02_4_16_4_8_pie.gif (2581 Byte)

Runtime:

3_02_4_16_4_8_pie1.gif (1774 Byte)


3D Pie

Page#: 3_02_4_16_4_9_3dpie.htm

3D Pie

The graphic type pie shows:

  • All series for a subset combined.
  • Each subset as a piece of a 3d pie (with the size of the pie in percentage).

Example

Layout:

3_02_4_16_4_9_3dpie.gif (2641 Byte)

Runtime:

3_02_4_16_4_9_3dpie1.gif (1670 Byte)


Add / delete layout components

Page#: 3_031_concepts_adddeleteformatcomponents.htm

v08 000212TTA: links to application/workarea header/footer added.

Add / delete layout components

Designer provides a wide variety of options for adding and deleting the following types of layout components:

  • Application header/footer
  • Workarea
  • Workarea header/footer
  • Page
  • Element
  • Group of elements


Application header/footer add/delete

Page#: 3_031_0_appl_headfoot_adddelete.htm

Application header/footer add/delete

Application header

To add the application header:

  1. Set application property <Style> = <Notebook>.
  2. Set application property <Header> = <Yes>.
  3. Set application header properties <Height> and <Background color(R,G,B)>.
    3_031_0_appl_headfoot_adddelete.gif (2682 Byte)

To delete the application header:

  1. Set application property <Header> = <No>.

Application footer

To add the application footer:

  1. Set application property <Style> = <Notebook>.
  2. Set application property <Footer> = <Yes>.
  3. Set application footer properties <Height> and <Background color(R,G,B)>.
    3_031_0_appl_headfoot_adddelete1.gif (2646 Byte)

To delete the application footer:

  1. Set application property <Footer> = <No>.


Workarea insert / shift / remove

Page#: 3_031_1_workarea.htm

Workarea insert / shift / remove

  • Insert second workarea (switch to application <Style> = <Notebook>
  • Insert (before / after existing workarea)
  • Shift (left / right)
  • Remove


Application switch to notebook style

Page#: 3_031_1_0_switchtonotebook.htm

Application: Switch to notebook style

Notebook style means multiple work areas, each with a tab.

When switching to notebook style:

  • The current layout becomes the first workarea.
  • A second (empty) workarea is added.

Example

Assume the following layout with <Style> = <Simple>.

3_031_0_2_1_switchtonotebook.gif (1271 Byte)

Changing <Style> to <Notebook> results in the following:

3_031_0_2_1_switchtonotebook2.gif (1967 Byte)


Workarea insert before / after

Page#: 3_031_1_1_insertbeforeafter.htm

Workarea insert before / after

A new workarea is created by inserting before or after an existing workarea.

Note: Workareas can only be inserted if the Application property <Style> = <Notebook>.

Example

Assume the following layout.

3_031_1_1_insertbeforeafter.gif (572 Byte)

Right-clicking on tab "P1" results in the following context menu:

3_031_1_1_insertbeforeafter1.gif (1018 Byte)

Selecting "Insert workarea before" results in the following:

3_031_1_1_insertbeforeafter2.gif (666 Byte)


Workarea shift left / right

Page#: 3_031_1_2_shiftleftright.htm

Workarea shift left / right

A workarea can be shifted to the left or right.

Example

Assume the following layout.

3_031_1_1_insertbeforeafter.gif (572 Byte)

Right-clicking on tab "P1" results in the following context menu:

3_031_1_1_insertbeforeafter1.gif (1018 Byte)

Selecting "Shift workarea right" results in the following:

3_031_1_2_shiftleftright.gif (537 Byte)


Workarea remove

Page#: 3_031_1_3_remove.htm

Workarea remove

A workarea can be removed.

Note: Workareas can only be removed if the Application property <Style> = <Notebook> and at least 3 workareas exist.

Note: To delete a workarea when only 2 workareas exist: Change the Application <Style> to <Simple>.

Example

Assume the following layout.

3_031_1_3 remove.gif (733 Byte)

Right-clicking on tab "Area6" results in the following context menu:

3_031_1_3_remove2.gif (941 Byte)

Selecting "Remove workarea" and clicking "Yes" in the resulting dialog results in the following:

3_031_1_3_remove3.gif (549 Byte)


Application: Switch to simple style

Page#: 3_031_1_5_switchtosimple.htm

Application: Switch to simple style

Simple style means a single work area (with no tab).

When switching to simple style, a dialog appears in which the single workarea that will remain in the layout is selected.

Example

Assume the following layout with <Style> = <Notebook>.

3_031_0_2_2_switchtosimple.gif (626 Byte)

Changing <Style> to <Simple> causes the following dialog to appear:

3_031_0_2_2_switchtosimple2.gif (1842 Byte)

Select the workarea to keep results in the following:

3_031_0_2_2_switchtosimple3.gif (392 Byte)


Workarea header/footer add/delete

Page#: 3_031_15_workarea_headfoot_adddelete.htm

Workarea header/footer add/delete

Workarea header

To add the workarea header:

  1. Set workarea property <Style> = <Frame>.
  2. Set workarea property <Header> = <Yes>.
  3. Set workarea header properties <Height>, <Position> and <Background color(R,G,B)>.
    3_031_15_workarea_headfoot_adddelete.gif (3220 Byte)

To delete the workarea header:

  1. Set workarea property <Header> = <No>.

Workarea footer

To add the workarea footer:

  1. Set workarea property <Style> = <Frame>.
  2. Set workarea property <Footer> = <Yes>.
  3. Set workarea footer properties <Height>, <Position> and <Background color(R,G,B)>.
    3_031_15_workarea_headfoot_adddelete1.gif (3415 Byte)

To delete the workarea footer:

  1. Set workarea property <Footer> = <No>.


Page insert / shift / remove

Page#: 3_031_2_page.htm

Page insert / shift / remove

  • Create a frame (switch to workarea <Style> = <Frame>) (required for multiple pages)
  • Page insert below / above
  • Page insert as subnode
  • Page shift up / down
  • Page remove
  • Delete the frame (switch to workarea <Style> = <Simple>) (leaves a single page)


Workarea switch to frame style

Page#: 3_031_2_0_switchtoframe.htm

Workarea switch to frame style

When changing the workarea property <Style> to <Frame>, the contents of the workarea become the contents of the single page in the workarea.

Example

Assume the following layout:

3_031_1_4_1_switchtoframe.gif (356 Byte)

Changing the workarea property <Style> to <Frame> results in the following layout:

3_031_1_4_1_switchtoframe2.gif (1918 Byte)

Resizing the frame results in the following:

3_031_1_4_1_switchtoframe3.gif (642 Byte)

Note that the size of the layout (the red dotted lines) includes the frame.


Page insert below / above

Page#: 3_031_2_1_insertbelowabove.htm

Page insert below / above

A new page is created by inserting below or above an existing page.

Note: Pages can only be inserted if the Workarea property <Style> = <Frame>.

Example

Assume the following layout.

3_031_2_1_insertbelowabove.gif (598 Byte)

Right-clicking on the icon/text "Page1" results in the following context menu:

3_031_2_1_insertbelowabove2.gif (1034 Byte)

Selecting "Insert node above" ("node" = page) results in the following:

3_031_2_1_insertbelowabove3.gif (763 Byte)


Page insert subnode (below)

Page#: 3_031_2_2_insertsubnodebelow.htm

Page insert subnode (below)

A new page can be created as a subpage of an existing page.

Example

Assume the following layout.

3_031_2_1_insertbelowabove.gif (598 Byte)

Right-clicking on the icon/text "Page1" results in the following context menu:

3_031_2_1_insertbelowabove2.gif (1034 Byte)

Selecting "Insert subnode" ("node" = page) results in the following:

3_031_2_1_insertbelowabove4.gif (668 Byte)


Page shift up / down

Page#: 3_031_2_3_shiftupdown.htm

Page shift up / down

The location of a page in the frame can be shifted up or down in relation to other pages on the same level in the frame.

Example

Assume the following layout.

3_031_2_3_shiftupdown.gif (1053 Byte)

Right-clicking on the icon/text "Page7" results in the following context menu:

3_031_2_3_shiftupdown2.gif (914 Byte)

Selecting "Shift node up" ("node" = page) results in the following:

3_031_2_3_shiftupdown3.gif (1087 Byte)


Page remove

Page#: 3_031_2_4_remove.htm

Page remove

A page can be removed from the frame.

Note the following:

  • The subnodes of a removed page are also removed.
  • The last remaining top-level node can only be removed by changing the workarea property <Style> from <Frame> to <Simple>.

Example

Assume the following layout.

3_031_2_4_remove.gif (884 Byte)

Right-clicking on the icon/text "Page6" results in the following context menu:

3_031_2_4_remove1.gif (984 Byte)

Selecting "Remove node" ("node" = page) and clicking "Yes" in the resulting dialog results in the following:

3_031_2_4_remove2.gif (593 Byte)

Right-clicking on the icon/text "Page1" results in a context menu with the option "Remove node" disabled.


Workarea switch to simple style

Page#: 3_031_2_5_switchtosimple.htm

Workarea switch to simple style

When changing the workarea property <Style> to <Simple>, all pages except for 1 will be deleted from the layout.

Example

Assume the following layout:

3_031_1_4_2_switchtosimple.gif (834 Byte)

Changing the workarea property <Style> to <Simple> results in the following dialog:

3_031_1_4_2_switchtosimple2.gif (1874 Byte)

Selecting the page ("workarea" in the above dialog) and clicking "OK" results in the following:

3_031_1_4_2_switchtosimple3.gif (400 Byte)

Note that the size of the layout (the red dotted lines) included the frame.


Element add / delete

Page#: 3_031_3_element.htm

v09 000229TTA: levels moved to 3_08.

Element add / delete

Most of the standard windows functions such as copy / cut / paste / delete are supported in the Designer for elements.

  • Add
  • Copy
  • Cut
  • Paste
  • Delete


Add element

Page#: 3_031_3_1_add.htm

Add element

To add an element to the layout:

  • Click on the element toolbar. The mouse cursor changes to cross-hairs.
  • Click with the mouse on the page where the element is to be added.

Example

Click with the cursor the EntryField icon.

3_031_3_1_add.gif (1481 Byte)

Move the cursor to the position on the page where the element should be added.

3_031_3_1_add2.gif (1034 Byte)

Click. The element is added.

3_031_3_1_add3.gif (381 Byte)


Copy element

Page#: 3_031_3_2_copy.htm

Copy element

An element can be copied (and pasted).

Example

Right click on the element. A context menu appears.

3_031_3_2_copy.gif (1691 Byte)

Click on Copy. The element has been copied to the clipboard.


Cut element

Page#: 3_031_3_3_cut.htm

Cut element

An element can be cut (to the clipboard).

Example

Right click on the element. A context menu appears.

3_031_3_2_copy.gif (1691 Byte)

Click on Cut. The element is copied to the clipboard and deleted from the layout.


Paste element

Page#: 3_031_3_4_paste.htm

Paste element

An element can be pasted to the layout (from the clipboard).

Example

Assume an element has been copied to the clipboard using copy or cut. Position the cursor in the layout. Right click. A context menu (with typically only a single selection) appears.

3_031_3_4_paste.gif (1145 Byte)

Click on Paste. The element is pasted from the clipboard to the layout.


Delete element

Page#: 3_031_3_5_delete.htm

Delete element

An element can deleted from the layout.

Example

Right click on the element. A context menu appears.

3_031_3_2_copy.gif (1691 Byte)

Click on Delete. The element is deleted from the layout.


ElementGroup add / delete

Page#: 3_031_4_elementgroup.htm

ElementGroup add / delete

Most of the standard windows functions such as copy / cut / paste / delete are supported in the Designer for element groups.

Designer also provides functionality for writing and reading element groups from files.

  • Select
  • Copy
  • Write to file
  • Cut
  • Paste
  • Read from file to clipboard
  • Delete


Select ElementGroup

Page#: 3_031_4_1_select.htm

Select ElementGroup

A collection of elements can be selected as a group in any of the following ways:

  • Hold down the left mouse button. Draw a box by moving the mouse. Any element totally or partially in the box become part of the group.
  • Hold down the Ctrl key. Click on all elements that should be part of the group.

Example

This example shows how to select by drawing a box.

3_031_4_1_select.gif (1767 Byte)

3_031_4_1_select2.gif (939 Byte)


Copy ElementGroup

Page#: 3_031_4_2_copy.htm

Copy ElementGroup

An element group can be copied (and pasted).

Example

Select the element group. Right click on any element in the element group. A context menu appears.

3_031_4_2_copy.gif (2555 Byte)

Click on Copy. The element group has been copied to the clipboard.


Write ElementGroup to file

Page#: 3_031_4_21_writetofile.htm

Write ElementGroup to file

An element group can written to a .vpg file.

See also:

  • Menu item.
  • Toolbar icon.

Example

Select the element group. Right click on any element in the element group. A context menu appears.

3_031_4_21_writetofile.gif (3089 Byte)

Click on Disk operations / Save marked group to disk. A dialog appears for entering the directory/filename of the .vpg in which the group will be saved.


Cut ElementGroup

Page#: 3_031_4_3_cut.htm

Cut ElementGroup

An element group can be cut (copied to the clipboard and deleted from the layout).

Example

Select the element group. Right click on any element in the element group. A context menu appears.

3_031_4_2_copy.gif (2555 Byte)

Click on Cut. The element group is copied to the clipboard and deleted from the layout.


Paste ElementGroup

Page#: 3_031_4_4_paste.htm

Paste ElementGroup

An element group can be pasted to the layout (from the clipboard).

Example

Assume an element group has been copied to the clipboard using copy or cut. Position the cursor in the layout. Right click. A context menu (with typically only a single selection) appears.

3_031_3_4_paste.gif (1145 Byte)

Click on Paste. The element group is pasted from the clipboard to the layout.


Read ElementGroup from file to clipboard

Page#: 3_031_4_41_readfromfile.htm

Read ElementGroup from file to clipboard

An element group can copied from a .vpg file to the clipboard (an element group cannot be copied from a file to the layout directly).

See also:

  • Menu item.
  • Toolbar icon.

Example

Click on the Read Group icon in the toolbar.

3_031_4_41_readfromfile.gif (1711 Byte)

A dialog appears for selecting the file.

3_031_4_41_readfromfile2.gif (1306 Byte)

Click Open. The contents of the file have now been copied to the clipboard (and can now be added to the layout with Paste).


Delete ElementGroup

Page#: 3_031_4_5_delete.htm

Delete ElementGroup

An element group can be deleted from the layout.

Example

Select the element group. Right click on any element in the element group. A context menu appears.

3_031_4_2_copy.gif (2555 Byte)

Click on Delete. The element group is deleted from the layout.


Properties

Page#: 3_04_concepts_properties.htm

Properties

Properties have the following functions:

  • Determine layout and components format.
  • Specify external connnections.
  • Specify layout runtime functionality.

Component properties can be viewed and editted using the Inspector tool.


Layout and component format

Page#: 3_04_2_layoutcharacteristics.htm

Layout and component format

Properties determine the format of the layout and the layout components.

Example

Assume the following application properties:

3_04_2_layoutcharacteristics.gif (3747 Byte)

The properties that determine layout format are:

  • Version info
  • Title
  • Width
  • Height
  • Format
  • Style
  • Default font
  • AppActiveColor

Example

The following Label has property <Title> set to <Label text>.

3_041_0_modelproperties.gif (837 Byte)


External connections

Page#: 3_04_3_externalconnections.htm

External connections

The layout can have connections to the following products:

  • The Application property <Productmodel> specifies the run-time model that is connected to the layout. The most important external product is the run-time model. The run-time model performs many functions, but most importantly performs all calculations. The layout properties can also specify data connections between model and layout.
  • Media files can be included in the layout using the property <Media file>.
  • DLL.
  • Help file.


Layout runtime functionality

Page#: 3_04_4_layoutfunctionality.htm

Layout runtime functionality

Properties can specify runtime layout functionality.

Only a very limited runtime functionality without an external connection is supported within Designer.

Runtime functionality for the following external connections is very simple, in that the external program is simply called from the Designer (and after that Designer has no effect on the connection):

  • Media file
  • DLL
  • Help file

Designer provides a wide range of functionality for controlling the run-time model connection during runtime.


Run-time functionality without external connection

Page#: 3_04_4_1_noexternalconn.htm

Run-time functionality without external connection

Only a very limited runtime functionality without an external connection is supported within Designer. This functionality is dynamic during runtime, but no external connection (ie, model, dll, etc.) is required.

This includes:

  • Visualize / Devisualize (dynamic visibility of workareas / pages).
  • EntryField minimum / maximum values.


Run-time model connection

Page#: 3_04_4_2_modelconn.htm

Run-time model connection

Designer properties provide a wide range of functionality for controlling the run-time model connection during runtime. This includes, for example (this list may not be exhaustive), control of the following functionality:

  • Data input / selection to the model attributes (controlled by layout).
  • Computation in the model (controlled by layout).
  • Add / delete array members (controlled by layout).


Data connections model/layout

Page#: 3_041_concepts_datasources.htm

Data connections model/layout

The following model data sources are available for layout components:

  • Model attributes.
  • Model attribute properties.
  • Model properties.


Model attributes

Page#: 3_041_1_modelattributes.htm

Model attributes

A layout component can display the value of a model attribute.

Example

Assume that the model has the following attribute:

3_041_1_modelattributes.gif (1019 Byte)

To display and modify this model attribute in the layout, the following EntryField could be added to the layout:

3_041_1_modelattributes2.gif (1061 Byte)


Model attribute properties

Page#: 3_041_11_modelattributeproperties.htm

Model attribute properties

A model attribute can have properties that are also displayed in the layout:

  • Default
  • Label
  • Table


Default

Page#: 3_041_11_1_default.htm

Default

The attribute property <default> can be used to recalculate the value of a property.

Example

Assume that the model has the following attribute with the following property <default>:

3_041_11_1_default.gif (2295 Byte)

Note: The default property can also be defined by an equation.

The value of the attribute can using various mechanisms be re-set to the value defined by the property <default>.


Label

Page#: 3_041_11_2_label.htm

Label

The text for a label in a layout can be defined not only in the layout, but also by the model attribute property <label>.

Example

Assume that the model has the following attribute with the following property <label>:

3_041_11_2_label.gif (2407 Byte)

Note: The label property can also be defined by an equation.

The text for a label in the layout could then be defined by the attribute property <label> by specifing the property <Attribute> for the label in the layout.

3_041_11_2_label2.gif (1226 Byte)


Table

Page#: 3_041_11_3_table.htm

Table

The index and text for a drop-down list, radio button group, etc., can be defined in a table in the model.

Example

Assume that the model has the following attribute with the following property <table>:

3_041_11_3_table.gif (3392 Byte)

The table <t_Attribute1> contains the following:

3_041_11_3_table2.gif (3053 Byte)

If a RadioGroup is added to the layout:

3_041_11_3_table3.gif (949 Byte)

Then the runtime layout would contain the following:

3_041_11_3_table4.gif (304 Byte)


Model properties

Page#: 3_041_2_modelproperties.htm

Model properties

Model properties (not attribute properties) are typically displayed in the layout as results.

Example

Assume that the model contains the property <p_Result> which is defined as shown in the following diagram:

3_041_2_modelproperties.gif (3103 Byte)

Assume that the layout contains a ResultField:

3_041_2_modelproperties2.gif (1165 Byte)

Then the ResultField for <p_Result> would display the result in the runtime layout:

3_041_2_modelproperties3.gif (404 Byte)


Data types

Page#: 3_046_1_datatypes.htm

v10 000405TTA: file page# corrected. mask added. arrays moved to this section. previous 2 arrays pages removed.

Data types

The following data types are supported by Designer.

  • Single-line text
  • Multi-line text
  • Boolean
  • Number
  • Currency
  • Date
  • Arrays.


Text

Page#: 3_046_1_1_text.htm

v10 000405TTA: page# changed.

Text (single-line)

Text is the most common data type.

Integer values can also be displayed as text.


Text (multiline)

Page#: 3_046_1_11_multilinetext.htm

v10 000405TTA: page# changed.

Multi-line Text

Multiline text can be entered in a Text EditField with <Multiline> = <Yes>. Multiline text contains special characters for line feed and carriage return that cannot be displayed in a single-line text EditField.

Example

Assume the following layout with a multiline and single-line text EditField.

In the runtime layout, only the first line of multiline text will be displayed in the single-line text EditField.


Boolean

Page#: 3_046_1_2_boolean.htm

v10 000405TTA: page# changed.

Boolean

Boolean data types are typically the values used by checkboxes.

Example

Assume that the layout has a CheckBox with property <Source> = <a_Boolean1>.

3_041_3_1_2_boolean.gif (994 Byte)

The only values that <a_Boolean1> could have would be 0 (CheckBox not checked) or 1 (CheckBox checked).


Number

Page#: 3_046_1_3_number.htm

v10 000405TTA: page# changed.

Number

The data type number is used for displaying numerical values with a fixed number of places after the decimal point.

Example

Assume that the layout has 2 EntryFields.

The first EntryField Source is <a_Number1> with Type <Text>.

3_041_3_1_3_number1.gif (1244 Byte)

The second EntryField Source is <a_Number1> with Type <Number> (and <Decimal position> = 2).

3_041_3_1_3_number.gif (1280 Byte)

Entering 123,456 (note that more that only 2 places are allowed after the decimal point) in the Text EntryField would result in the following:

3_041_3_1_3_number2.gif (460 Byte)


Currency

Page#: 3_046_1_4_currency.htm

v10 000405TTA: page# changed.

Currency

The data type Currency is similar to Number. However Currency can also displayed a currency symbol.

Example

Assume that the layout has 2 EntryFields.

The first EntryField Source is <a_Number1> with Type <Text>.

3_041_3_1_3_number1.gif (1244 Byte)

The second EntryField Source is <a_Number1> with Type <Currency> (and <Decimal position> = 2).

3_041_3_1_4_currency.gif (1317 Byte)

Entering 123,456 in the Text EntryField would result in the following:

3_041_3_1_4_currency3.gif (496 Byte)


Date

Page#: 3_046_1_5_date.htm

v10 000405TTA: page# changed.

Date

The data type Date displays dates.

Example

Assume that the layout has 2 EntryFields.

The first EntryField Source is <a_Number1> with Type <Text>.

3_041_3_1_3_number1.gif (1244 Byte)

The second EntryField Source is <a_Number1> with Type <Date> (and <Format> = yy/mm/dd).

3_041_3_1_5_date2.gif (1509 Byte)

Entering 01.02.2345 (1 Feb 2345) in the Text EntryField would result in the following:

3_041_3_1_5_date3.gif (481 Byte)


Mask

Page#: 3_046_1_55_mask.htm

v10 000405TTA XX: non-tta text added.

Mask

A mask is a custom data type.

To provide possibility to have an edit field behavior different from the standard edit types (text, number, currency, date), a masking mechanism for edit fields should be implemented. It should be implemented as a new type (mask edit) supported for edits, result fields and grid columns and allowing the following mask symbols.

  • # - must be a digit.
  • N - must be a digit. If not entered will be set to ‘0’.
  • & - must be a digit or system decimal delimiter.
  • X - must be a letter.
  • C - must be a letter. If not entered will be set to <space>.
  • U - must be a letter. When entered converted to uppercase.
  • L - must be a letter. When entered converted to lowercase.
  • ? - any character may be entered.
  • \ - the next character will be counted as a delimiter, not the mask character.

At the same time a separate formatting mechanism is necessary for date edits, date result fields and date grid columns to allow application specific date formats independent from the system settings. That can be achieved with introducing an additional Format property for date edits. The following patterns are allowed for this property.

  • dd - must be a day of month (two digit, 1-31);
  • mm - must be a month number (1-12);
  • M, MM, MMM - must be a month name (English or defined by the system settings);
  • yy - must be a year (two digit, the current century is assumed);
  • yyyy - must be a year (four digit);
  • other characters considered as delimiters.


Arrays

Page#: 3_10_concepts_arrays.htm

This page/subpages describe arrays in Designer/Workbench as tta understands it.

v09 000228TTA: last edit.

Arrays

Designer provides a wide range of functionality for arrays. This functionality can be divided into 3 basic categories:

  • Table
  • Iteration
  • Multiple inclusion


Table

Page#: 3_10_1_a_tables.htm

v09 000228TTA: last edit.

Table

Model components are required for defining the table.

Layout components are required for displaying the table.

The model property filter can be used to display only a subset of the table rows in the layout (rows in the table cannot be altered, added or deleted in the design-time or runtime layout).


Model components

Page#: 3_10_1_1_comp_model.htm

v09 000228TTA: last edit.

Model components

The simplest form of a table requires the following in the model:

  • A table.
  • An attribute with property <table> that specifies the table.

Table

The table is defined in the Workbench subwindow "Tables".

The table must have the following 2 columns:

  • Column 1: Key column. The key column contains a unique integer identifier (index) for each row in the table. When a row in the column is selected in the layout (for example via a ComboBox or RadioGroup), the value in the key column for that row is assigned to the attribute whose property <table> specifies the table.
  • Column 2: Value column. The value column typically contains text. The rows of text in this column are displayed in the layout when selecting a row via a ComboBox or RadioGroup.

Attribute

The model attribute property <table> references the table and contains the key for the selected row.

Example

Attribute a_Table1 property <table> = <"t_Table1">:

3_10_1_1_comp_model.gif (2138 Byte)

Table t_Table1 contains columns <key> and <value> with 3 rows of data:

3_10_1_1_comp_model1.gif (2974 Byte)

See the next page for an example layout that uses the above example model.


Layout components

Page#: 3_10_1_2_comp_layout.htm

v09 000228TTA: last edit.

Layout components

The following layout components are typically used to display the rows of table text and select a row:

  • CheckBox
  • RadioGroup

The component property <Source> = the model attribute whose property <table> specifies the model table.

Example

Assume the model described on the previous page.

Assume the following layout:

3_10_1_2 comp_layout.gif (978 Byte)

3_10_1_2 comp_layout1.gif (989 Byte)

In the runtime layout:

3_10_1_2 comp_layout2.gif (768 Byte)

Selecting "table1_value2" from either layout element would cause the same selection to be displayed in the other element (note: element property <Compute> should be <OnChange> to see the change immediately).

3_10_1_2 comp_layout3.gif (885 Byte)


Accessing key/value without ComboBox/RadioGroup

Page#: 3_10_1_3_access_attr_ttext.htm

v09 000228TTA: last edit.

Accessing key/value without ComboBox/RadioGroup

The previous 2 pages described how to use a ComboBox or RadioGroup to display the contents of a table and select the index.

This page describes how the key and value of the selected row can be accessed.

Key

The key of the selected row is stored in the model attribute whose property <table> specifies the table. This attribute is available throughout the model.

The attribute can be displayed in the layout by defining the value of a model property equal to the attribute.

Value

The value can be accessed via an equation of the format table_name[table_index].

Example

Model property p_1 = a_Table1 (attribute that holds the key of the selected row).

3_10_1_3 access_attr_ttext1.gif (1992 Byte)

Model attribute a_Table1Text property <default> = value in table t_Table1 in the selected row.

3_10_1_3 access_attr_ttext.gif (2363 Byte)

a_Table1Text is dynamically updated by changes to a_Table1.

3_10_1_3 access_attr_ttext2.gif (2487 Byte)

The layout has a ResultField for p_1 and an EditField for a_Table1Text. <ChkDynamic> = <Yes> for the ComboBox and the RadioGroup.

3_10_1_3 access_attr_ttext3.gif (1278 Byte)

In the runtime layout, choosing a table row via the ComboBox or the RadioGroup would also display the key and value for the selected row:

3_10_1_3 access_attr_ttext4.gif (1177 Byte)


Table filter

Page#: 3_10_1_4_tablefilter.htm

v09 000228TTA: last edit.

Table filter

Table rows cannot be added or deleted via the layout.

However, the rows displayed in the layout can be filtered as defined by the model attribute property <filter>.

Example

Assume the following model:

3_10_1_4_tablefilter.gif (2288 Byte)

t_Table1:

3_10_1_4_tablefilter1.gif (2821 Byte)

t_Table2 contains 3 columns. Column 2 contains the same values as column 2 in t_Table1. Column 3 contains values for display in the layout.

3_10_1_4_tablefilter3.gif (3347 Byte)

Attribute a_Table2 property <filter> =

if(stricmp(t_Table1[a_Table1];t_Table2[key])=0;1;0)

The above expression specifies that only rows in t_Table2 will be displayed in the layout if t_Table2 column 2 value = selected t_Table1 column 2 value.

3_10_1_4_tablefilter2.gif (3399 Byte)

Assume the following layout with ComboBox's for both tables:

3_10_1_4_tablefilter4.gif (3064 Byte)

In the runtime layout:

If t_Table1 row 1 is selected in the upper ComboBox, only t_Table2 rows 2 and 3 are available from the lower ComboBox.

3_10_1_4_tablefilter5.gif (1730 Byte)

If t_Table1 row 2 is selected in the upper ComboBox, no t_Table2 rows are available from the lower ComboBox.

3_10_1_4_tablefilter6.gif (1511 Byte)

If t_Table1 row 3 is selected in the upper ComboBox, only t_Table2 row 1 and 3 is available from the lower ComboBox.

3_10_1_4_tablefilter7.gif (1593 Byte)


Iteration (with Grid)

Page#: 3_10_2_a_generatedarrays.htm

v09 000228TTA: last edit.

Iteration (with Grid)

An array can be generated with an Iteration.

Model components.

Layout component consists of a Grid.


Model components

Page#: 3_10_2_1_comp_model.htm

v09 000228TTA: last edit.

Model components

The simplest form of an iteration requires the following in the model:

  • An iteration attribute which specifies the total number of iterations.
  • A start attribute which defines the number for the first iteration.
  • A next-line property that generates the number for an iteration from the number of the previous iteration.
  • A value for each iteration.

Example

Iteration and start attributes:

3_10_2_1_comp_model.gif (1167 Byte)

Next-line property and a value for each iteration:

3_10_2_1_comp_model1.gif (2358 Byte)

Note: "xx" and "yy" used above could be changed to any string with no effect.

See the next page for an example layout that uses the above example model.


Layout components

Page#: 3_10_2_2_comp_layout.htm

v09 000228TTA: created

Layout components

A grid is typically used to display all iterations.

Example

Assume the model described on the previous page.

The following 2 EditField's in the layout are used for entering the start and iteration attributes:

3_10_2_2 comp_layout.gif (896 Byte)

Note: The above elements are not absolutely required in the layout. For example, the start and iteration could be defined with attribute propery <default> in the model.

Assume the following Grid:

3_10_2_2 comp_layout1.gif (2002 Byte)

p_NextLine() and p_Value() in the model do not use a defined index (on the previous page "xx" and "yy" were used). The common index for all attributes/properties in the Grid is defined by specifying Grid property <Key column> (1 for this example). The computed value of each iteration will be stored in the iteration attribute specified by property <Attribute>:

3_10_2_2 comp_layout2.gif (622 Byte)

The computed value for the iteration is saved to the attribute specified for the Key column. Therefore key column property <Usage> = <Input>.

The Grid column whose <Property> specifies the property that generates the iteration is specified with <Next line> (in this example 2).

Note, however, that the key column in the first row must be defined somehow; this is accomplished by defining <Attribute> = <a_Start>.

3_10_2_2 comp_layout3.gif (1035 Byte)

Column 2 <Usage> = <Output>, since this column "outputs" a value to other columns (column 1).

3_10_2_2 comp_layout4.gif (994 Byte)

Finally, Column 3 contains the value:

3_10_2_2 comp_layout5.gif (943 Byte)

In the runtime layout: Entering 7 for a_Start and 3 for a_Iteration would have the following results (p_Value(x) = x*x):

3_10_2_2_comp_layout6.gif (1294 Byte)


Multiple pages

Page#: 3_10_3_multipages.htm

v09 000228TTA: last edit.

Multiple pages

Arrays of data can be generated using the multiple pages functionality in the Designer.

Multiple pages can be implemented with

  • No Grid
  • Grid
  • ExtendedGrid


Multiple pages: No Grid

Page#: 3_10_3_1_multipages_nogrid.htm

v09 000228TTA: last edit.

Multiple pages without Grid

Model components.

Layout components.

Adding/deleting array elements.


Model components

Page#: 3_10_3_1_1_multinogrid_comp_model.htm

v09 000228TTA: created.

Model components

The model requires a product subnode with <IncType> = <multiple>.

The subnode property <IncRule> = iteration attribute.

Calculating a result for display in the main node requires an equation of the form:

p_Result = a_Attribute[#iteration_attribute]

Including a result for each iteration on each multiple page requires in the subnode an equation of the form:

p_Result(zyx) = if(zyx=#iteration_attribute;p_Result;0)

Example

Product main node Product1 has a subnode Product11 with <IncType> = <multiple> and <IncRule> = <a_Iteration>.

3_10_3_1_1_multinogrid_comp_model.gif (3028 Byte)

2 default array iterations are defined with a_Iteration <default> = 2.

a_Data is the data attribute for each iteration.

3_10_3_1_1_multinogrid_comp_model1.gif (1696 Byte)

p_Result(yy) ("yy" can be any text) is required for displaying the result for an iteration on the layout subnode for that iteration.

3_10_3_1_1_multinogrid_comp_model2.gif (2111 Byte)

p_Result is used to sum all results in the Product11 subnodes on the Product1 node as p_Total.

3_10_3_1_1_multinogrid_comp_model3.gif (1592 Byte)

See the next page for an example layout that uses the above example model.


Layout components

Page#: 3_10_3_1_2_multinogrid_comp_layout.htm

v09 000228TTA: last edit.

Layout components

The layout requires a page with multiple subnodes.

The multiple subnode has:

  • <Multiple> = <Yes>
  • <Count attribute> = iteration attribute.

The layout also requires the elements to enter data and display results.

Example

Assume the model described on the previous page.

Assume the following layout:

Multiple subnode Product11 with <Count attribute> = <a_Iteration>.

3_10_3_1_2_multinogrid_comp_layout.gif (2305 Byte)

On subnode Product11: An EditField for a_Data and a ResultField for p_Result(), both with <Multiple> = <Yes>.

3_10_3_1_2_multinogrid_comp_layout1.gif (4964 Byte)

3_10_3_1_2_multinogrid_comp_layout2.gif (1056 Byte)

The main node has a ResultField for p_Total.

3_10_3_1_2_multinogrid_comp_layout3.gif (1353 Byte)

In the runtime layout:

A subnode:

3_10_3_1_2_multinogrid_comp_layout4.gif (1701 Byte)

The main node:

3_10_3_1_2_multinogrid_comp_layout5.gif (1233 Byte)


Add/delete array members

Page#: 3_10_3_1_3_multipnogrid_adddelete.htm

v09 000228TTA: last edit.

Add/delete array members

Addition and deletion of array members is implemented directly in the layout.

The subnode properties <Caption New> and <Caption Delete> define the text displayed in the runtime layout when the mouse is right-clicked in order to delete a subnode or when the icon is double-clicked to add a subnode.

Example

Assume the layout/model described on the previous pages with <Caption New> and <Caption Delete> as shown:

3_10_3_1_3_multipnogrid_adddelete.gif (2206 Byte)

In the runtime layout, double-clicking on the "new" icon would create a new array member:

3_10_3_1_3_multipnogrid_adddelete1.gif (1377 Byte)

Right-clicking on a subpage icon would cause a popup menu with "delete" to appear:

3_10_3_1_3_multipnogrid_adddelete2.gif (2342 Byte)

Clicking on "delete" brings up the following dialog.

3_10_3_1_3_multipnogrid_adddelete3.gif (1723 Byte)

Clicking "Yes" deletes the array member.

3_10_3_1_3_multipnogrid_adddelete4.gif (1073 Byte)


Multiple pages with Grid

Page#: 3_10_3_2_multipages_grid.htm

v09 000228TTA: last edit.

Multiple pages with Grid

Model components.

Layout components.


Model components

Page#: 3_10_3_2_1_multigrid_comp_model.htm

v09 000228TTA: last edit.

Model components

In addition to the requirements for multiple pages without a grid, with a grid the model requires the following:

  • Start attribute with default.
  • Property that generates the index for the next iteration.
  • Properties that reference the attributes to be displayed in the Grid.

Example

Start attribute a_Start with <default> = 0.

3_10_3_2_1_multigrid_comp_model.gif (1439 Byte)

Upper node property p_NextLine() generates the index for the next iteration.

Upper node property p_Data() references attribute a_Data.

3_10_3_2_1_multigrid_comp_model2.gif (1954 Byte)

See the next page for an example layout that uses the above example model.


Layout components

Page#: 3_10_3_2_2_multigrid_comp_layout.htm

v09 000228TTA: last edit.

Layout components

In addition to the requirements for model subnodes, the layout requires the following definitions for the Grid:

  • # of columsn
  • Key column
  • Iteration attribute
  • Start attribute
  • Next line column and property
  • Data input column and property (note: The data input column is specified as an "output" column).
  • Result column and property.

Example

Assume the model described on the previous page.

Assume the following layout:

3_10_3_2_2_multigrid_comp_layout.gif (3629 Byte)

<Column> = 4 (number of columns).

Column 1 is the key column.

Iteration attribute is a_Iteration.

3_10_3_2_2_multigrid_comp_layout1.gif (1054 Byte)

Start attribute is a_Start.

Column 2 generates the next line iteration.

3_10_3_2_2_multigrid_comp_layout2.gif (1045 Byte)

3_10_3_2_2_multigrid_comp_layout3.gif (983 Byte)

Column 3 is the output column for inputting a_Data value.

3_10_3_2_2_multigrid_comp_layout4.gif (915 Byte)

Column 4 is the column for displaying result p_Result().

3_10_3_2_2_multigrid_comp_layout5.gif (965 Byte)

In the runtime layout:

The initial Grid with 2 default iterations.

3_10_3_2_2_multigrid_comp_layout6.gif (2709 Byte)

Grid after data entered.

3_10_3_2_2_multigrid_comp_layout7.gif (2685 Byte)

Elements added or deleted are shown in the Grid:

3_10_3_2_2_multigrid_comp_layout8.gif (2944 Byte)


Multiple pages with Extended Grid

Page#: 3_10_3_3_multipages_extgrid.htm

v09 000228TTA: last update.

Multiple pages with Extended Grid

Model components.

Layout components.

Adding/deleting array members.


Model components

Page#: 3_10_3_3_1_multiextgrid_comp_model.htm

v09 000229TTA: last edit.

Model components

In addition to the requirements for multiple pages without a grid, with an ExtendedGrid the model requires the following:

  • Iteration attribute with default.
  • Attributes for data input.
  • Properties that provide an indexed and non-indexed result.

Example

Iteration attribute default 2.

Attribute a_Data is the input data for each iteration.

3_10_3_3_1_multiextgrid_comp_model.gif (1679 Byte)

Lower node property p_Result() is required for displaying the result for each iteration in the ExtendedGrid.

(p_Result is not required for the ExtendedGrid, but rather provides the result for each iteration that will be summed to a single result within the model).

3_10_3_3_1_multiextgrid_comp_model1.gif (2713 Byte)

Upper node property p_NextLine() is required for generating the iteration index for the next line in the ExtendedGrid.

(p_Total is not required for the ExtendedGrid, but rather is the result for the ResultField in the upper page in the layout).

3_10_3_3_1_multiextgrid_comp_model2.gif (1895 Byte)

See the next page for an example layout that uses the above example model.


Layout components

Page#: 3_10_3_3_2_multiextgrid_comp_layout.htm

v09 000229TTA: last edit.

Layout components

In addition to the requirements for model subnodes, the layout requires the following definitions for the ExtendedGrid:

  • # of columsn
  • Iteration attribute (ExtendedGrid property <Count attribute>)
  • Next line column and property
  • Data input column and attribute (the data input column is specified as an "input" column).
  • Result column and property.

Example

Assume the model described on the previous page.

Assume the following layout with an ExtendedGrid:

3_10_3_3_2_multiextgrid_comp_layout.gif (2704 Byte)

<Column> = 3 specifies that the ExtendedGrid contains 3 columns.

a_Iteration is the count attribute.

3_10_3_3_2_multiextgrid_comp_layout2.gif (836 Byte)

Column 1 contains the iteration.

3_10_3_3_2_multiextgrid_comp_layout2.gif (1195 Byte)

Column 2 is the column for data input.

3_10_3_3_2_multiextgrid_comp_layout3.gif (2667 Byte)

Column 3 is the result column.

3_10_3_3_2_multiextgrid_comp_layout4.gif (1195 Byte)

In the runtime layout:

The ExtendedGrid has 2 default rows.

3_10_3_3_2_multiextgrid_comp_layout5.gif (2496 Byte)

With entered data.

3_10_3_3_2_multiextgrid_comp_layout6.gif (2552 Byte)

Elements added or deleted using the page frame add/delete functionality are shown in the ExtendedGrid:

3_10_3_3_2_multiextgrid_comp_layout7.gif (2863 Byte)


Add/delete array elements

Page#: 3_10_3_3_3_multiextgrid_adddelete.htm

v09 000229TTA: last edit.

Add/delete array elements

Elements in the array can be added/deleted directly from within the ExtendedGrid by simply right-clicking on the row to delete or on any row (for adding a row) and selecting from the pop-up menu.

Example

Model

Assume the model described on the previous page with properties <Caption New> and <Caption Delete> specifying the text for the pop-up menu:

3_10_3_3_3_multiextgrid_adddelete.gif (1937 Byte)

Run-time layout

In the runtime layout:

Right-clicking on iteration 1 opens the pop-up menu:

3_10_3_3_3_multiextgrid_adddelete1.gif (3775 Byte)

Clicking on "new" adds a new iteration at the end of the ExtendedGrid. Note that the iteration list in the Frame is not updated.

3_10_3_3_3_multiextgrid_adddelete2.gif (2643 Byte)

Right-clicking on row 1, clicking on "delete" in the pop-up menu and clicking on "Yes" in the resulting message dialog deletes row 1.

3_10_3_3_3_multiextgrid_adddelete3.gif (3884 Byte)

3_10_3_3_3_multiextgrid_adddelete4.gif (1757 Byte)

3_10_3_3_3_multiextgrid_adddelete5.gif (2385 Byte)


Entering / selecting data

Page#: 3_05_concepts_enterselectdata.htm

Entering / selecting data

Designer provides components for:

  • Entering data (values for model properties and attributes)
  • Selecting data (from model tables)

Designer also provides the following functionality for entering/selecting data:

  • Element order. Determines the order that layout components will obtain the focus.
  • Start attribute. The first attribute on start-up in the layout.
  • Parameter search. Designer can automatically give the focus to layout components for entering required data.
  • Data indicator. The data indicator indicates when all required data has been entered.


Entering data

Page#: 3_05_2_enterdata.htm

Entering data

Designer provides the following components for entering values:

  • EditField. Allows entry of text, number, date, currency.
  • ExtendedGrid. An EditField can be used within the ExtendedGrid to enter data.


EditField: Entering data

Page#: 3_05_2_1_editfield.htm

Entering data: EditField

The EditField is used to enter text or numerical (decimal numbers, dates, currency amounts) values.


ExtendedGrid

Page#: 3_05_2_2_extendedgrid.htm

Entering data: ExtendedGrid

A column in an ExtendedGrid can use an EntryField for entering values.


Selecting data

Page#: 3_05_3_selectdata.htm

Selecting data

Designer provides the following components for selecting data from a list of available values:

  • CheckBox and RadioButton allow a boolean value to be selected.
  • ComboBox and RadioGroup allows a value to be selected from a list of available values.
  • ExtendedGrid can include a ComboBox in a column.


CheckBox

Page#: 3_05_3_1_checkbox.htm

CheckBox

A CheckBox allows a value of 1 or 0 to be entered for a model attribute.


RadioButton

Page#: 3_05_3_2_radiobutton.htm

RadioButton

A RadioButton allows a value of 1 or 0 to be entered for a model attribute.


ComboBox

Page#: 3_05_3_3_combobox.htm

ComboBox

A ComboBox allows an integer value to be entered for a model attribute.

The integer value is selected by selecting a text item from the drop-down list provided by the ComboBox. The contents of the drop-down list and the integer associated with each text item is provided by a model table.


RadioGroup

Page#: 3_05_3_4_radiogroup.htm

RadioGroup

A RadioGroup allows an integer value to be entered for a model attribute.

The integer value is selected by selecting a text item from the RadioGroup. The contents of the RadioGroup and the integer associated with each text item is provided by a model table.


ExtendedGrid

Page#: 3_05_3_5_extendedgrid.htm

ExtendedGrid

An ExtendedGrid column can use a ComboBox to select data.


Element order

Page#: 3_05_5_elementorder.htm

Concept: Element order

The element order is the order in which the elements on a page will obtain the focus when using the tab key.

There is a menu item for displaying/hiding element order in layout.

The element order can be changed using the Elements (re)ordering dialog.

Note: Changing the element order is not possible if the page sequence default is set to standard.

Example

Assume that you have the following elements on a page.

3_05_5_order.gif (2587 Byte)

You want a_Years to be before a_Capital. Click on EF_Years in the Elements ordering dialog and using the Shift-Up key combination move EF_Years above EF_Capital. Clicking OK results in the following:

3_05_5_order2.gif (719 Byte)


Start attribute

Page#: 3_05_6_startattribute.htm

Start attribute

The Start attribute is the first attribute that obtains the focus when the layout is first displayed.

The Start attribute can be:

  • Constant.
  • Dynamic.


Start attribute: Constant

Page#: 3_05_6_1_startattribute_constant.htm

Start attribute: Constant

A Constant start attribute specifies the attribute and the value for the attribute.

Example

Assume that the start attribute is Constant and the attribute is a_Attribute1 with value 456.

3_05_6_1_startattribute_constant.gif (1466 Byte)

a_Attribute1 property <default> = 123.

3_05_6_2_startattribute_dynamic2.gif (1158 Byte)

When the layout is started, the value for a_Attribute1 = 456.

3_05_6_1_startattribute_constant2.gif (260 Byte)


Start attribute: Dynamic

Page#: 3_05_6_2_startattribute_dynamic.htm

Start attribute: Dynamic

A Dynamic start attribute is an attribute that is specified by an attribute.

Example

Assume that the start attribute is Dynamic and the attribute that specifies the dynamic start attribute = <a_StartAttribute>.

3_05_6_2_startattribute_dynamic.gif (1363 Byte)

a_StartAttribute property <default> specifies the start attribute (<default> could include an equation).

3_05_6_2_startattribute_dynamic1.gif (1304 Byte)

a_Attribute1 property <default> = 123.

3_05_6_2_startattribute_dynamic2.gif (1158 Byte)


Parameter search

Page#: 3_05_61_parametersearch.htm

Parameter search

Assume that a model attribute is required to compute a model property (for example: p_Result = a_Variable1 * ...).

If a value for the attribute is entered in the layout AND the model property is displayed on the same page in the layout: The Designer enters parameter search mode for the remaining attributes required to calculate the model property.

Parameter search mode algorithm

In parameter search mode:

  • Each remaining page can be opened 1 time (regardless of whether or not the page contains an entry element for a required attribute).
  • If a required attribute is not entered on an open page and an attempt is made to open another page: parameter search mode ends.
  • If the last required attribute is entered: parameter search mode ends.
  • Attempting to open a page a 2nd time (the page contained no required data or the required data was entered the 1st time the page was opened) will cause a previously unselected page that contains required data to be selected.
  • Attempting to open a page a 3rd time will cause parameter search mode to end.

If parameter search mode was started and ended:

  • If a required attribute is entered on any page (not necessarily the page where the result is displayed): Parameter search model is restarted. Note the following:
    • Data already entered for required attributes is not part of the restarted parameter search.
    • Any page that contains no entry field for required data can be opened 1 more time.

Example

The following example assume that the model contains property p_Result where:

  • p_Result = a_Variable1 * a_Variable2 * a_Variable3

The example also assumes that the layout has the following structure:

  • Workarea <V1> with EntryField for a_Variable1 and ResultField for p_Result.
    3_05_61_parametersearch.gif (1488 Byte)
  • Workarea <V2/V3> with EntryFields for a_Variable2, a_Variable3.
    3_05_61_parametersearch2.gif (1517 Byte)
  • Workarea <Empty> with no components.

In workarea V1: Enter 1 for Variable1. Parameter search mode is started.
3_05_61_parametersearch3.gif (904 Byte)

Select workarea Empty. Note that Empty can be selected 1 time, even though it contains no entry fields for required attributes.

Attempt to select workarea V1. Workarea V2/V3 is automatically selected.

Select workarea V1 or Empty. Both have previously been selected and data entry is required in neither. Therefore, parameter search mode has ended.

Select any workarea. Note that parameter search mode is not active.

In workarea V2/V3: Enter 2 for Variable2.
3_05_61_parametersearch4.gif (1271 Byte)

Select workarea Empty.

Attempt to select workarea V1. Note that workarea V2/V3 is selected.

Enter 3 for Variable3. Note that parameter search mode has ended since all required attributes were entered.


Data indicator

Page#: 3_05_7_dataindicator.htm

v10 000405TTA XX: non-tta (functional description) text added.

Data indicator

A data indicator is used to indicate that all required data has been entered.

Specifying default path location of DI bitmaps.

Purpose of the "data indicator" (DI) is to visualize, if data exists/has been entered in logical parts of the application. Especially in voluminous or highly structured applications with more than only a few areas/pages, it is very helpful for the user to see, which part of the application contains data and which part does no

Restrictions of the data indicator

Although it would be very useful, not only to visualize the existence of data but also to visualize and represent their logical status ("either the data is consistent and error free or the data violates validation rules"), this cannot be supplied by the data indicator

To obtain and especially to keep consistency of this kind of context specific information would require, that, if any status relevant information in any page is modified, the status indicator of all other pages have to be checked and updated. This can consequently only be achieved by checking (validating) all concerned input information as well as by computing all result information. The performance overload caused by this behavior or concept would be significantly.

Moreover, not all status information can be obtained by checking input definitions – a significant amount of errors and validation violation messages are not "attribute-bound" in the application model but defined in conjunction with the computational logic of results (in workbench terminology: computed properties in the product tree). Errors caused in this way cannot be mapped directly to pages in the application, therefore no actualization of the DI can be done in consequence.

Due to this reasons the DI does not represent the validation status of data.

Represented conditions by the data indicator

The DI is a page specific flag, that represents for the user of the application one of the following logical conditions for the page:

  • Condition: Data exists. The page contains data the DI is "ON".
  • Condition: Data does not exist. The page contains no data the DI is OFF.

So far as it is very difficult to find an appropriate way for defining of the DI state using visual element states of the page, a rule defining the DI state must exist in the computational model for every page needed the DI. This rule should be connected to an attribute property of the computational model having two possible values 0 and 1.

DI symbol file format

So far as the DI symbol set should be editable the following approach is used. In the Designer a special directory (as a part of the Designer installation) containing the DI bitmaps is supported. All the DI bitmaps from this directory are displayed in the secondary dialog for DI symbol selection in the inspector. A certain standard set of the DI bitmaps is provided with the Designer. If a new DI symbol is necessary, any bitmap of this set may be edited with some graphical tool (ex. MS Paint) or a new bitmap may be added to the set. The DI bitmaps used in XPL-application are saved in the byte code of the application (VPC-file) in a special resource section. This approach provides flexibility in defining of various DI symbols and allows to distribute XPL-applications without any additional files containing DI symbols bitmaps (also acceptable for Intranet/Internet platform).


Displaying data

Page#: 3_07_concepts_displaydata.htm

Displaying data

Designer provides the following components for displaying data:

  • EntryField can be used to display data.
  • ResultField is the standard component for displaying results.
  • Label (dynamic) can be used to display results in a textual format.
  • Grid / ExtendedGrid can include EntryFields and ResultFields in the columns.
  • Graphic (dynamic) can display arrays of data from a Grid or ExtendedGrid in several different visual formats.


EditField: Displaying data

Page#: 3_07_1_entryfield.htm

Displaying data: EditField

The EntryField can be used to display resultant data in the following ways:

  • Default property for an EntryField can specify a result.
  • Reformatted Entry. An EntryField can reformat entered data.


Default

Page#: 3_07_1_1_default.htm

Default

The model attribute property <default> can specify an equation. This default value will be recalculated and displayed in the layout if:

  • The second attribute has property <Dynamic> = <(name of first attribute)>.
  • The second attribute has property <ChkDynamic> = <Yes>.
  • The second attribute is changed.

Example

Assume the following model:

3_07_1_1_default.gif (1348 Byte)

3_07_1_1_default2.gif (663 Byte)

3_07_1_1_default3.gif (672 Byte)

Assume the following layout:

3_07_1_1_default4.gif (1868 Byte)

The runtime layout would then display a_A * a_B in the EntryField a_C.

3_07_1_1_default5.gif (580 Byte)


Reformatted Entry

Page#: 3_07_1_2_reformattedentry.htm

Reformatted Entry

An EntryField can reformat entered data.

Example

Assume that an EntryField has <Type> = Currency and <Decimal position> = 4.

Entering the following

3_07_1_2_reformattedentry.gif (1084 Byte)

would result in the following display

3_07_1_2_reformattedentry2.gif (360 Byte)


ResultField

Page#: 3_07_2_resultfield.htm

ResultField

The ResultField is the standard component for displaying results. The ResultField normally displays a property of a product in the model.

Note: The drop-down list for layout property <Source> does not display product properties from the model (only attributes are displayed). The property name must always be typed in.

Example

Assume the following model.

3_07_2_resultfield.gif (1052 Byte)

3_07_2_resultfield2.gif (1939 Byte)

Assume the following layout.

3_07_2_resultfield3.gif (1367 Byte)

The runtime layout would then be:

3_07_2_resultfield4.gif (373 Byte)


Dynamic Label / Border

Page#: 3_07_3_label(dynamic).htm

Dynamic Label / Border

Dynamic Labels, Borders, Lines, Multimedia elements can be used to display results.

To create a dynamic label:

  • A model attribute must have property <label> defined. The definition normally uses an "If" statement with a string return value.
  • A second model attribute has attribute <dynamic> = <"first attribute">.
  • The layout element for the second model element has property <dynamic> = <Yes>.

Example

Assume the following model:

3_07_3_label_dynamic.gif (1051 Byte)

3_07_3_label_dynamic1.gif (623 Byte)

3_07_3_label_dynamic2.gif (831 Byte)

Assume the following layout:

3_07_3_label_dynamic3.gif (1338 Byte)

3_07_3_label_dynamic4.gif (1424 Byte)

The runtime layout would then be:

3_07_3_label_dynamic5.gif (366 Byte)


Grid / ExtendedGrid

Page#: 3_07_4_gridextgrid.htm

Grid / ExtendedGrid

The Grid and ExtendedGrid can be used to display results.


Dynamic Graphic

Page#: 3_07_5_graphics(dynamic).htm

Dynamic Graphic

A dyamic graphic can be used to display results.


Compute result property

Page#: 3_071_concepts_compute_result.htm

Compute result property

After attributes have been changed, the resultant properties must be recalculated. The recalculation can occur based on the following:

  • Change page.
  • Pushbutton is pressed.
  • Enter data.
  • Change focus. (a different layout component is clicked on).


Change page

Page#: 3_071_1_change_page.htm

Change page

The results on a page are recalculated when the page changes if property <Calculation> = <Automatic>.

Example

Assume that the layout contains EntryField for a_Attribute1 and ResultField for p_Result where p_Result = a_Attribute1 * 2.

3_071_1_change_page.gif (1892 Byte)

a_Attribute1 property <ComputeResult> = No.

3_071_1_change_page2.gif (998 Byte)

Open the layout. Note that the EntryField for a_Attribute1 is empty.

3_071_1_change_page3.gif (937 Byte)

If data is entered in the EntryField and the CheckBox is checked, the result is still not re-calculated.

3_071_1_change_page4.gif (974 Byte)

If workarea 2 is selected and then workarea 1 reselected, the result is re-calculated.

3_071_1_change_page5.gif (1008 Byte)


Pushbutton

Page#: 3_071_2_pushbutton.htm

Pushbutton

The results on a page can be recalculated when a PushButton is pressed if:

  • Application property <Calculation> = <Manual>.
  • PushButton property <Action> = <Compute>.

Example

Assume the following layout:

  • Calculation = Automatic
  • EntryField for a_Attribute1
  • ResultField for p_Result where p_Result = a_Attribute1 * 2
    3_071_2_pushbutton.gif (1828 Byte)
  • PushButton with property <Action> = <Compute>.
    3_071_2_pushbutton2.gif (763 Byte)

Open the layout. Enter for a_Attribute1 value 678.

3_071_2_pushbutton3.gif (918 Byte)

Change pages. Note that the result is not calculated.

Click the Compute PushButton. The result is calculated.

3_071_2_pushbutton4.gif (972 Byte)


Enter data

Page#: 3_071_3_enter_data.htm

Enter data

The results on a page can be recalculated when data (a single letter or number) is entered if:

  • Application property <Calculation> = <Automatic>.
  • EntryField property <ComputeResult> = <Yes>.
  • EntryField property <Compute> = <OnChange>.

Example

Assume the following layout:

  • Calculation = Automatic
  • EntryField for a_Attribute1 with:
    • <ComputeResult> = <Yes>.
    • <Compute> = <OnChange>.
  • ResultField for p_Result where p_Result = a_Attribute1 * 2
    3_071_3_enter_data.gif (2021 Byte)

    3_071_3_enter_data2.gif (3218 Byte)

Open the layout. Click in EntryField for a_Attribute1 and then press 3. Note that the result is computed immediately.

3_071_3_enter_data3.gif (718 Byte)

Press 4. The result of 68 is computed immediately.


Change focus

Page#: 3_071_4_change_focus.htm

Change focus

The results on a page can be recalculated when the focus changes if:

  • Application property <Calculation> = <Automatic>.
  • EntryField property <ComputeResult> = <Yes>.
  • EntryField property <Compute> = <OnExit>.

Example

Assume the following layout:

  • Calculation = Automatic
  • EntryField for a_Attribute1 with:
    • <ComputeResult> = <Yes>.
    • <Compute> = <OnExit>.
  • ResultField for p_Result where p_Result = a_Attribute1 * 2

    3_071_3_enter_data.gif (2021 Byte)

    3_071_4_change_focus.gif (2982 Byte)

Open the layout. Enter 234 a_Attribute1. Note that the result is not computed.

3_071_4_change_focus2.gif (1772 Byte)

Click on the CheckBox <Change focus>. The result is re-calculated.

3_071_4_change_focus3.gif (947 Byte)


Re-compute attribute default/label

Page#: 3_072_concepts_recompute_attribute.htm

Re-compute attribute default/label

The following can be re-computed:

  • Attribute property <default>
  • Attribute property <label>

when the following occurs:

  • Enter data.
  • Change focus.


Enter data

Page#: 3_072_1_enter_data.htm

Enter data

The default and label for Attribute2 can be recalculated when data (a single letter or number) is entered in an EntryField for Attribute1 if:

  • Application property <Calculation> = <Automatic>.
  • EntryField for Attribute1 property <ComputeResult> = <Yes>.
  • EntryField for Attribute1 property <Compute> = <OnChange>.
  • Model attribute Attribute2 property <default> = (calculation).
  • Model attribute Attribute2 property <label> = (calculation).

Example

Assume the following layout:

  • Calculation = Automatic
  • EntryField for a_Attribute1 with:
    • <ComputeResult> = <Yes>.
    • <Compute> = <OnChange>.
  • EntryField with <Source> = a_Attribute2.
  • Label with <Source> = a_Attribute2.
    3_072_1_enter_data3.gif (722 Byte)

Assume the following model for the above layout:

  • a_Attribute1 with <dynamic> = <"a_Attribute2">
    3_072_1_enter_data2.gif (1401 Byte)
  • a_Attribute2 with:
    • <default> = <a_Attribute1 * 2>
    • <label> = <if(a_Attribute1<1000;"small";"large")>
      3_072_1_enter_data.gif (2067 Byte)

Start the layout.

3_072_1_enter_data4.gif (553 Byte)

Click in the a_Attribute1 EntryField. Click on 1. The a_Attribute2 Label and EntryField are updated.

3_072_1_enter_data5.gif (555 Byte)

Enter for a_Attribute1 1234. Note that a_Attribute2 Label and EntryField are updated with each entered digit.

3_072_1_enter_data6.gif (618 Byte)


Change focus

Page#: 3_072_2_change_focus.htm

Change focus

The default and label for Attribute2 can be recalculated when the focus changes (a different component or page is selected) if:

  • Application property <Calculation> = <Automatic>.
  • EntryField for Attribute1 property <ComputeResult> = <Yes>.
  • EntryField for Attribute1 property <Compute> = <OnExit>.
  • Model attribute Attribute2 property <default> = (calculation).
  • Model attribute Attribute2 property <label> = (calculation).

Example

Assume the following layout:

  • Calculation = Automatic
  • EntryField for a_Attribute1 with:
    • <ComputeResult> = <Yes>.
    • <Compute> = <OnExit>.
  • EntryField with <Source> = a_Attribute2.
  • Label with <Source> = a_Attribute2.
    3_072_1_enter_data3.gif (722 Byte)

Assume the following model for the above layout:

  • a_Attribute1 with <dynamic> = <"a_Attribute2">
    3_072_1_enter_data2.gif (1401 Byte)
  • a_Attribute2 with:
    • <default> = <a_Attribute1 * 2>
    • <label> = <if(a_Attribute1<1000;"small";"large")>
      3_072_1_enter_data.gif (2067 Byte)

Start the layout.

3_072_1_enter_data4.gif (553 Byte)

Enter 1 in the a_Attribute1 EntryField.

Change the focus by clicking on a differnt component. The a_Attribute2 Label and EntryField are updated.

3_072_1_enter_data5.gif (555 Byte)

Enter for a_Attribute1 1234. Change the focus. Note the a_Attribute2 Label and EntryField contents.

3_072_1_enter_data6.gif (618 Byte)


Visibility

Page#: 3_08_concepts_visibility.htm

v09 000229TTA: changed. design-time layout (levels) added.

Visibility

The visibility of layout components can be defined in:

  • Design-time layout
  • Runtime layout


Design-time visibility (element levels)

Page#: 3_08_0_designtime.htm

v09 000229TTA: moved from 3_031_3.

Design-time visibility (element levels)

Designer provides a level functionality for complex layouts or layouts where multiple components occupy the same space in a page:

  • 8 levels exist in a layout: Level 0 ... Level 7.
  • An element can be assigned to any level.
  • An element is assigned to Level 0 by default.
  • For Levels 1...7: All of the elements on a level can be hidden by deselecting that level.

This is normally used for overlaying elements that are optionally displayed.

Menu item for displaying / hiding levels.

Level property.

Example:

Assume that a layout has a Label and EntryField (with Level specified as 1) as shown below.

3_031_3_0_levels.gif (828 Byte)

From the main menu: Select Options / Levels / Level 1 to deselect Level 1. Note that the EntryField disappears:

3_031_3_0_levels2.gif (189 Byte)

Now the EntryField a_Months could be added at the same location in the layout with Level 2 specified. In the runtime layout either the a_Years or the a_Months EntryField would be displayed.


Runtime layout visibility

Page#: 3_08_01_runtime.htm

Runtime layout visibility

The visibility of layouts components in the runtime layout can be:

  • Static (the visibility does not change in the runtime model)
  • Dynamic (the visibility can change in the runtime model)


Static visibility

Page#: 3_08_1_static.htm

000212TTA: subpages deleted.

Static visibility

A workarea, page, or element can be made non-visible by setting the property <Visible> = <No>.

Example

Assume the following layout.

3_08_1_1_static_elements.gif (1421 Byte)

In the runtime layout the EntryField would not be visible.

3_08_1_1_static_elements2.gif (678 Byte)


Dynamic visibility

Page#: 3_08_2_dynamic.htm

v07 000212TTA: updated for workareas/pages.

Dynamic visibility

Dynamic visibility means that the visibility of the component can change during runtime. The following components can have dynamic visibility:

  • Workareas, Pages, Elements (with property <Visible> = <Property>)
  • EntryField (property <Check>)
  • Workareas/Pages (with <Visualize> and <Devisualize>)


Dynamic visibility with <Visible> = <Property>

Page#: 3_08_2_1_allelements.htm

000212TTA: updated for workareas/pages.

Dynamic visibility with <Visible> = <Property>

Workarea, page, and element visibility can dynamically change in the runtime layout with the following:

  • An boolean-value element (typically a CheckBox) is used to set the value of an attribute for the visibility (the visibility can be controlled by a model property or function as well).
  • The property <ChkOtherVisibility> of the above element is set to <Yes>.
  • The element property Source . Visible = . <Property> = the value of the attribute for visibility.

See also:

  • ChkOtherVisibility: Setting the default value.

Example

Assume the following layout:

3_08_2_1_allelements.gif (2661 Byte)

Note above:

  • <Source> = <Attribut>
  • <ChkOtherVisibility> = <Yes>

3_08_2_1_allelements1.gif (1796 Byte)

In the runtime layout:

3_08_2_1_allelements2.gif (317 Byte)

3_08_2_1_allelements3.gif (412 Byte)


Dynamic visibility: EntryField property <Check>

Page#: 3_08_2_2_entryfield.htm

Dynamic visibility: EntryField property <Check>

The EntryField supports an added mechanism for dynamic visibility: The property <Check>. To use this property for dynamic visibility:

  • The element property Source . Visible = <Check>
  • In the model: The Attribute which is the Source for the EditField has property <visible> which returns a boolean (1 or 0).
  • The property <ChkOtherVisibility> of any element that might cause the model property value to change is set to <Yes>.

See also:

  • ChkOtherVisibility: Setting the default value.

Example

Assume the following layout:

3_08_2_2_entryfield.gif (2585 Byte)

Note above:

  • <Source> = <Check_Visible>
  • <ChkOtherVisibility> = <Yes>

3_08_2_2_entryfield2.gif (2365 Byte)

Note above:

  • <Source> = <EditField>
  • <Visible> = <Check>

In the model:

3_08_2_2_entryfield3.gif (1375 Byte)

In the runtime layout:

3_08_2_2_entryfield4.gif (281 Byte)

3_08_2_2_entryfield5.gif (388 Byte)


Dynamic visibility using <Visualize> and <Devisualize>

Page#: 3_08_2_3_workareaspages.htm

Dynamic visibility using <Visualize> and <Devisualize>

Dynamic visibility of workareas and pages can be implemented using <Visualize> and <Devisualize>.

Typically this is implemented with a CheckBox (or similar element) with property <Visualize> and/or <Devisualize> with the required workareas or pages specified.

Example

Note: This example demonstrates property <Visualize>. Property <Devisualize> is the opposite of <Visualize>.

Assume the following layout:

3_08_2_3_workareaspages.gif (2470 Byte)

Click on property <Visualize>. A button appears. Click on the button and the following dialog appears:

3_08_2_3_workareaspages1.gif (4145 Byte)

Select the workarea and page for visualization as shown below:

3_08_2_3_workareaspages2.gif (2492 Byte)

Click OK. Note that the property <Visualize> = <selected>.

3_08_2_3_workareaspages3.gif (523 Byte)

In the runtime layout

3_08_2_3_workareaspages4.gif (771 Byte)

3_08_2_3_workareaspages5.gif (913 Byte)


Availibility

Page#: 3_09_concepts_availability.htm

Availibility

An element is not available if the element is grey and input is not possible.

"Availibility" in Designer depends on whether or not the element is required for computing any result in a specified list of results.

Element availability can be:

  • Static. The list of elements required for computing each result in the result list does not change.
  • Dynamic. For 1 or more results in the list of results: The list of elements required to compute the result is dynamic (using the "If" expression).


Results list

Page#: 3_09_1_resultslist.htm

Results list

"Availibility" in Designer for an element is determined by whether or not the model attribute for the element is required for a list of model properties (results) specified for the element.

The following types of result lists can be specified:

  • No result (no list is specified (the element is always available))
  • All results (in the layout)
  • Element result list (a list for the specific element)
  • Page result list (a list for the page the element is on)

See also:

  • Setting the default value for the results list.
  • Property ChkOwnAvailibility (specifies the result list).


Result list: None

Page#: 3_09_1_0_rl_none.htm

Result list: None

If no result list is specified: The element is always available.

Example

The EntryField has <ChkOwnAvailibility> = <None>:

3_09_1_0_chkownavailibility_none.gif (890 Byte)

The EntryField is always available.


Result list: All

Page#: 3_09_1_1_rl_all.htm

Result list: All

If element property <ChkOwnAvailibility> = <All>: The element is available if the element is required for computing any model result property (on any page) in the layout.

Example

Assume the following layout

3_09_1_1_chkownavailibility_all.gif (1998 Byte)

with the following model

3_09_1_1_chkownavailibility_all2.gif (2609 Byte)

The EntryField would be available in the runtime-layout:

3_09_1_1_chkownavailibility_all3.gif (895 Byte)

However, if the ResultField for p_1 was removed, the EntryField would be unavailable:

3_09_1_1_chkownavailibility_all4.gif (810 Byte)


Result list: Element

Page#: 3_09_1_2_rl_element.htm

Result list: Element

If element property <ChkOwnAvailibility> = <List>: The element is available if the element is required for computing any model result property in the list specified by element property <List (...;...)>.

Example

Assume the following layout

3_09_1_2_chkownavailibility_list.gif (1911 Byte)

with the following model

3_09_1_1_chkownavailibility_all2.gif (2609 Byte)

The EntryField would be available in the runtime-layout since a_1 is required for computing p_1.


Result list: Page

Page#: 3_09_1_3_rl_page.htm

Result list: Page

If element property <ChkOwnAvailibility> = <Page>: The element is available if the element is required for computing any model result property in the list specified by the page property <AVAILABLE-Property> for the page that contains the element.

Examples

Example 1

Assume the following layout

3_09_1_3_chkownavailibility_page.gif (1803 Byte)

3_09_1_3_chkownavailibility_page2.gif (1654 Byte)

3_09_1_3_chkownavailibility_page3.gif (1552 Byte)

with the following model

3_09_1_1_chkownavailibility_all2.gif (2609 Byte)

The EntryField would not be available in the runtime-layout since p_1 is not specified for P1 property <AVAILABLE-Property>.

3_09_1_3_chkownavailibility_page4.gif (450 Byte)

Example 2

Assume the above layout, except that P1 <AVAILABLE-Property> includes p_1:

3_09_1_3_chkownavailibility_page5.gif (1588 Byte)

The EntryField would be available in the runtime-layout since p_1 is specified for P1 property <AVAILABLE-Property>.

3_09_1_3_chkownavailibility_page6.gif (444 Byte)


Static Availibility

Page#: 3_09_11_static.htm

Static Availibility

"Static availibility" means that list of elements required for computing each result in the result list does not change.


Dynamic availibility

Page#: 3_09_2_dynamic.htm

Dynamic availibility

"Dynamic availibility" means that the availibility of an element can change during runtime. The following is true for dynamic availibility:

  • The list of elements required for computing each result in the result list does NOT change (as for static availibility). The list can be ALL, LIST, or PAGE.
  • The required elements for a property do change (using an IF expression).
  • If changes to an element should possibly cause changes in the availability of any element in the layout: The element property <ChkOtherAvailibility> = <Yes>.

See also:

  • Setting the default value for ChkOtherAvailibility.
  • Property ChkOtherAvailibility.

Example

Assume the following layout

3_09_2_dynamic.gif (1680 Byte)

3_09_2_dynamic2.gif (1684 Byte)

with the following model

3_09_2_dynamic3.gif (2245 Byte)

The EntryField would be available if a_2<10. For example, in the following a_2 = 2:

3_09_2_dynamic4.gif (1087 Byte)

In the following a_2 = 10 and the a_1 EntryField is unavailable (and the ResultField = 999):

3_09_2_dynamic5.gif (1084 Byte)


Subdialogs

Page#: 3_12_concepts_subdialogs.htm

v10 000405TTA XX: non-tta text (from functional description) added.

Subdialogs

Secondary Dialogs can be understood visually as an application within an XPL-application. That means, that the same information structure Application/Area/Page/Element can be used to describe and maintain them. Each secondary dialog may be considered like an XPL-application described by its own VPL-file, so we can speak about nested XPL-applications. Maximal nesting level (theoretically unlimited) may be limited on some reasonable number (e.g.16).

VP/MS Designer Runtime will support modal secondary dialogs only. Modal secondary dialogs are "application modal" for the XPL-application. When a modal secondary dialog "pops up", the underlying XPL-application isn´t accessible as long as this secondary dialog is open. The intercommunication with the application model (VP/MS-model) is restricted to the information and elements in the secondary dialog (e.g. result fields of the underlying XPL-application are not computed/updated as long as the secondary dialog is active, they are only computed automatically when the secondary dialog is closed with the OK-Event and if the application property "Calculation" is set to "automatic").

Subdialogs (sub-layouts) can be opened (and closed) from a layout.

  • Open
  • Close


Subdialog: Open

Page#: 3_12_1_subdialog_open.htm

Subdialog: Open

A subdialog is opened by clicking on a PushButton that specifies the .vpc (compiled layout) to open.

Example

The following layout (tta1.vpl) is the main dialog and contains a PushButton with:

  • <Action> = <Dialog-Call>
  • <Dialog-Description> = directory and filename of compiled layout for subdialog (<tta2.vpc>)

3_12_1_subdialog_open.gif (2922 Byte)

The following is the subdialog (tta2.vpl):

3_12_1_subdialog_open3.gif (600 Byte)

In the runtime layout, clicking on the Pushbutton would open the subdialog:

3_12_1_subdialog_open2.gif (1730 Byte)


Subdialog: Close

Page#: 3_12_2_subdialog_close.htm

Subdialog: Close

A subdialog can be closed by:

  • Clicking on an Accept PushButton (the changes made in the subdialog are accepted).
  • Clicking on a Cancel PushButton (the changes made in the subdialog are not accepted).
  • Clicking on the Windows dialog-close button in the upper right corner of the subdialog.


Subdialog: Accept

Page#: 3_12_2_1_subdialog_accept.htm

v10 000405TTA XX: non-tta (functional description) text added.

Subdialog: Accept

The changes in a subdialog can be accepted by clicking on a PushButton with property <Action> = <Dialog Accept>.

Logical event: Accept. Every data manipulation (in general every user interaction) that happened from the time when the dialog was invoked is accepted. The dialog will be closed and dialog control goes back to the place in the underlying XPL-application from where the dialog was initiated. If the application property calculation; is set to automatic, the XPL-application is computed (intercommunication with the application model). If the application property calculation is set to manual, the XPL-application is not computed only checked.

Example

The following layout (tta2.vpl) is the subdialog and contains a PushButton with:

  • <Action> = <Dialog Accept>

3_12_2_1_subdialog_accept.gif (2219 Byte)

In the runtime layout, clicking on the Dialog Accept Pushbutton would close the subdialog and accept all changes:

3_12_2_1_subdialog_accept2.gif (1926 Byte)


Subdialog: Cancel

Page#: 3_12_2_2_subdialog_cancel.htm

v10 000405TTA XX: non-tta (functional description) text added.

Subdialog: Cancel

The dialog can be closed without accepting changes by clicking on a PushButton with property <Action> = <Dialog Cancel>.

Logical event: Cancel. Every data manipulation that happened from the time when the dialog was invoked is canceled by the Designer Runtime. The dialog will be closed and dialog control goes back to the place in the underlying XPL-application from where the secondary dialog was initiated. The status of the XPL-application is exactly the same as before the secondary dialog was called. The logical events Accept and Cancel are mapped to the standard user interactions for secondary dialogs (keyboard Esc, the close symbol x in the window title and so on) as well as to specific Pushbutton actions (see below).

Example

The following layout (tta2.vpl) is the subdialog and contains a PushButton with:

  • <Action> = <Dialog Cancel>

3_12_2_2_subdialog_cancel.gif (2107 Byte)

In the runtime layout, clicking on the Dialog Cancel Pushbutton would close the subdialog without accepting the changes:

3_12_2_2_subdialog_cancel2.gif (1936 Byte)


Media element

Page#: 3_121_concepts_media.htm

Media element

The following types of multimedia elements can be displayed in the Designer:

  • avi
  • bmp
  • jpg
  • tif
  • wav

Example

Assume the following layout Media element:

The element is visible if model attribute <a_Persons> property <mediavisible> = 1 (any audio supplied by the element is always played regardless of the visibility).

The following is the clock.avi element (this should play if you are viewing an online version of this help:

Note: Click on the "Stop" button (red with the "X") in the help or browser toolbar to stop playing the .avi file.

In the runtime layout, the element would appear stretched to the border defined by the layout element:

The element stops playing if a different page is selected. The element starts playing from the beginning if the page is reselected.


DLL call

Page#: 3_13_concepts_dllcall.htm

DLL call

A DLL can be called by clicking on a PushButton that specifies the .ini file that specifies the DLL interface.

Example

The following layout contains a PushButton with:

  • <Action> = <DLL-Call>
  • <Dll-Description> = directory and filename of .ini file that specifies DLL interface (<kndneu.ini>)

3_13_concepts_dllcall.gif (2573 Byte)

Clicking on the PushButton in the runtime-layout will start the DLL.


Layout help / tooltips

Page#: 3_13_concepts_layout_helptooltips.htm

Layout help / tooltips

Designer supports

  • Help
  • Tooltips


Layout help

Page#: 3_13_1_concepts_help.htm

Layout help

A help topic ID can be specified for each element with the element property <HelpID>.

Example

The EntryField in the following layout has <HelpID> = 123.

3_032_1_concepts_help.gif (1468 Byte)


Tooltips

Page#: 3_13_2_concepts_tooltips.htm

Tooltips

2 types of tooltips exist.

  • Static tooltips are defined in the layout.
  • Dynamic tooltips are defined in the model or in the layout.


Static tooltips

Page#: 3_13_2_1_concepts_tooltips_static.htm

Static tooltips

The text for a static tooltip is defined in the layout.

Components with static tooltips

The following components can have ONLY static tooltips:

  • ExtendedGridList
  • Graphics
  • GridList
  • Page
  • ResultField
  • Workarea

The following components can have static OR dynamic tooltips:

  • CheckBox
  • ComboBox
  • EditField
  • Label
  • Multimedia
  • PushButton
  • RadioButton
  • RadioGroup

Defining a static tooltip

A static tooltip can be defined in 3 different ways.

Method 1 (for components that can have only static tooltips)

  • Property <Tooltip> is set to Yes.
  • Property <Tooltip text> is set to the tooltip text.

Example:

The following diagram shows a result field with <Tooltip text> = "(tooltip text)".

3_032_2_1 concepts tooltips_static.gif (1417 Byte)

Method 2 (for components that can have dynamic tooltips)

  • Property <Tooltip> is set to Static.
  • Property <Tooltip text> is set to the tooltip text.

Example:

The following diagram shows an EntryField with <Tooltip text> = "(static: layout)".

3_032_2_1 concepts tooltips_static2.gif (1472 Byte)

Method 3 (for components that can have dynamic tooltips)

  • Property <Tooltip> is set to Dynamic.
  • Property <Tooltip text> is set to the tooltip text.
  • The source attribute for the component does not have the attribute property <Tooltip> defined (in the model).

Example:

The following diagram shows an EntryField with <Tooltip text> = "(dynamic: layout)". The attribute for the EntryField does not have the property <Tooltip> defined in the model.

3_032_2_1 concepts tooltips_static3.gif (1545 Byte)


Dynamic tooltips

Page#: 3_13_2_2_concepts_tooltips_dynamic.htm

Dynamic tooltips

The text for a dynamic tooltip is defined in the model.

Components with dynamic tooltips

The following components can have dynamic tooltips:

  • CheckBox
  • ComboBox
  • EditField
  • Label
  • Multimedia
  • PushButton
  • RadioButton
  • RadioGroup

Defining a dynamic tooltip

  • Property <Tooltip> is set to Dynamic.
  • In the model: For the component attribute: Attribute property <Tooltip> is set to the tooltip text (the value of the property can be dynamic).

Example:

An EntryField has:

  • Property <Tooltip> = Dynamic.
  • Property <Source> = a_Persons.

In the model for the layout the attribute a_Persons has the property <Tooltip> = "tooltip from model".

3_032_2_2_concepts_tooltips_dynamic.gif (1385 Byte)

The following tooltip would be displayed in the layout:

3_032_2_2_concepts_tooltips_dynamic2.gif (1537 Byte)


Layout comment / print / screen shot

Page#: 3_15_concepts_layoutcommentprint.htm

Layout comment / print / screen shot

Comments (version information) can be added for all layout components (application, workarea, page, and element).

The contents of the layout can be written to file by printing (CRF preparation) the layout.

Any number of layout pages can be saved to individual bmp files using export screen shot.


Comments

Page#: 3_15_1_layoutcomment.htm

Comments

Commentary can be added for any layout component if comments for the component are enabled (default setting for enabling comments is set in the Options dialog) with the version info property.

  • Enabling comments (versioning)
  • Adding (modifying) comments
  • Deleting (disabling) comments


Enabling comments (versioning)

Page#: 3_15_1_1_layoutversion_enable.htm

Enabling comments (versioning)

To enable comments for a component:

  • Select the component.
  • Set property Version info for the component to Yes. Note that the subproperty Version appears.
    3_011_1_layoutversion.gif (1437 Byte)


Adding (modifying) comments

Page#: 3_15_1_2_layoutversion_enter.htm

Adding (modifying) comments

To add or modify comments for the component:

  • Click in the cell to the right of property Version. Note that a button appears.
    3_011_1_layoutversion.gif (1437 Byte)
  • Click on the button. The following Version information dialog appears:
    3_011_1_versiondialog.gif (4555 Byte)
  • Add or modify the information in the Version information dialog.
    Note: The fields <Last update by> and <Last updated date> will be filled automatically.
  • Click OK to close the dialog. Note that the information entered for "Version" (in this example "(version)") appears in the Inspector.
    3_011_1_layoutversion2.gif (721 Byte)


Disabling comments (versioning)

Page#: 3_15_1_3_layoutversion_disable.htm

Disabling comments (versioning)

To disable comments for a component:

  • Select the component.
  • Set property Version info for the component to No. A message warning that all version information will be lost appears.
  • Click Yes. Note that the subproperty Version disappears.


Layout print (CRF Preparation)

Page#: 3_15_3_print(crf_prep).htm

v09 000302TTA: rewritten. subtopics added.

v10 000406TTA: non-tta (functional description) text added.

Layout print (CRF Preparation)

A report can be generated that contains a description of the layout components. Report concepts include:

  • IFOS settings
  • Report format
  • Report content
  • Report range
  • Report sorting
  • Report output

The documentation of the user interface (the VPL-definitions) will be done by the new Print-action. The print action can be initiated either by the new menu item File Printing or by the appropriate button in the toolbar.

Executing the print action causes the VPMS Designer implicitly to save the VPL file and then to write all information in the VPL file into formatted ASCII files, that can be read by IFOS (Note: all dialogs will be dumped also each as a single bitmap.

After this information is written to disk into these files, the command file for IFOS will be produced and IFOS will be initiated (new parameters about the configuration of IFOS are added in the INI-file of the VPMS Designer for this purpose).

Depending of report purpose, different kind of element list sorting may be necessary (sorting on elements or attribute names, or pages names). To provide report flexibility IFOS report generator is used for XPL-application reporting. That allows to have different report formats for different kinds of sorting. Every time an XPL-application report generated Designer produces a temporary file containing information about application. This file is an ASII-file then been used together with an IFOS report template for report producing.


IFOS settings

Page filename#: 3_15_3_1_ifos.htm

v09 000302TTA: created.

IFOS settings

The following IFOS components are used for generating reports:

  • Report editor
  • Report viewer
  • .cat files


IFOS: Report editor

Page filename#: 3_15_3_1_1_ifos_reporteditor.htm

v09 000302TTA: created.

IFOS: Report editor

The report editor (Ifosre.exe) is required for generating the report and must be specified in the "Options" dialog:

3_15_3_1_3_ifos_catfiles.gif (4958 Byte)


IFOS: Report viewer

Page filename#: 3_15_3_1_2_ifos_reportviewer.htm

v09 000302TTA: created.

IFOS: Report viewer

The generated report is automatically opened in the IFOS ReportViewer when the report is output to the screen.


IFOS: .cat files

Page filename#: 3_15_3_1_3_ifos_catfiles.htm

v09 000302TTA: created.

IFOS: .cat files

The following lists the .cat files supplied for generating reports and the function of each file:

  • des_p.cat: Table report sorted by page name.
  • des_a.cat: Table report sorted by element name or element order..
  • des_at.cat: Table report sorted by element attribute <Source> value.
  • desx.cat: Text report layout.
  • area.cat: Text report workarea.
  • page.cat: Text report page.
  • element.cat: Text report element.
  • colinfo.cat, graphic.cat, tip1.cat ... tip6.cat: Text report properties.

Some of the above files must be specified in the Options dialog:

3_15_3_1_3_ifos_catfiles.gif (4958 Byte)


Report format

Page filename#: 3_15_3_2_report_format.htm

v09 000302TTA: created.

Report format

The following report formats are available:

  • Table
  • Text


Report format: Table

Page filename#: 3_15_3_2_1_report_format_table.htm

v09 000302TTA: created.

Report format: Table

A report in table format contains a 4-column table with the following columns:

  • Workarea name
  • Page name
  • Element name
  • Element property <Source> value

Table format is selected by selecting either "Sorting" or "Unsorted" as the report type.

3_15_3_2_1_report_format_table.gif (678 Byte) 3_15_3_2_1_report_format_table1.gif (703 Byte)


Report format: Text

Page filename#: 3_15_3_2_2_report_format_text.htm

v09 000302TTA: created.

Report format: Text

A report in text format (no tables) with a line for each property in the selected range is generated by selecting "Report type" radio button "Detail":

3_15_3_2_2_report_format_text.gif (682 Byte)

Example

The following is a typical page for a generated report:

3_15_3_5_report_sort94.gif (2829 Byte)


Report content

Page filename#: 3_15_3_3_report_content.htm

v09 000302TTA: created. what do checkboxes "layout" and "cover" do??

Report content

A report can contain the following information:

  • Names of workareas
  • Names of pages
  • Names of elements
  • Element attribute <Source> value
  • (text report only) All properties (for application/workareas/pages/elements).
  • (text report only) Comments (version information) for all properties (if the checkbox "Version information" is checked).

Examples

A typical table report with the names of workareas / pages / elements / <Source> attributes:

3_15_3_5_report_sort1.gif (2274 Byte)

The following is the first page of a text report that describes all properties and includes component commentary (version information):

3_15_3_3_report_content.gif (3826 Byte)


Report range

Page filename#: 3_15_3_4_report_range.htm

v09 000302TTA: created.

Report range

The report contents can be limited to components from one of the following "ranges":

  • Application (all components in the layout)
  • (text format only) Workarea (all components in the selected workarea)
  • (text format only) Page (all components in the selected page)

Examples

Assume the following layout:

3_15_3_5_report_sort7.gif (2726 Byte)

Selecting the following print options:

3_15_3_4_report_range.gif (3224 Byte)

would generated a text format report for:

  • The application properties.
  • Properties for components in workarea "Area1".


Report sort

Page filename#: 3_15_3_5_report_sort.htm

v09 000302TTA: created.

Report sort

The report contents can be sorted according to the following:

  • (table format only) Ascending alphabetical order based on 1 of the following:
    • Page names.
    • Element names.
    • Element attribute <Source> value.
  • Order of the workareas/pages/elements/properties in the layout/Inspector.

Examples

In the following examples assume the following layout:

3_15_3_5_report_sort7.gif (2726 Byte)

3_15_3_5_report_sort8.gif (1185 Byte)

3_15_3_5_report_sort9.gif (1698 Byte)

Table format / sort by page names

CRF preparation dialog:

3_15_3_5_report_sort.gif (1371 Byte)

Resultant report:

3_15_3_5_report_sort1.gif (2274 Byte)

Table format / sort by element names

CRF preparation dialog:

3_15_3_5_report_sort2.gif (1340 Byte)

Resultant report:

3_15_3_5_report_sort3.gif (2357 Byte)

Table format / sort by element attribute <Source> value

CRF preparation dialog:

3_15_3_5_report_sort4.gif (1355 Byte)

Resultant report:

3_15_3_5_report_sort6.gif (2360 Byte)

Table format / sort by element order

CRF preparation dialog:

3_15_3_5_report_sort91.gif (1496 Byte)

Resultant report:

3_15_3_5_report_sort92.gif (2364 Byte)

Text format / sort by workareas/pages/elements/properties order

CRF preparation dialog:

3_15_3_5_report_sort93.gif (2315 Byte)

Resultant report:

Page1:

3_15_3_5_report_sort94.gif (2829 Byte)

Page2:

3_15_3_5_report_sort95.gif (4986 Byte)

Page3:

3_15_3_5_report_sort96.gif (4621 Byte)

Page4:

3_15_3_5_report_sort97.gif (3913 Byte)


Report output

Page filename#: 3_15_3_6_report_output.htm

v09 000302TTA: created.

Report output

The generated report can be output to:

  • Screen
  • Printer


Report output: Screen

Page filename#: 3_15_3_6_1_report_output_screen.htm

v09 000302TTA: created.

Report output: Screen

When the report is output the the screen, the report is opened in the Report Editor. There are several options available within the ReportEditor, including the following:

  • Saving the report to an .rg file.
  • Printing the report.

Click the "Help?" button in the ReportEditor for online help.


Report output: Printer

Page filename#: 3_15_3_6_2_report_output_printer.htm

v09 000302TTA: created. didnt work on my computer so i didnt describe.

Report output: Printer

The report can be sent directly to a printer.


Layout screenshot

Page#: 3_15_4_export_bmp.htm

000213TTA: created.

Layout screenshot

Workareas and pages can be selected individually for export to individual .bmp flies.

See also:

  • Screen shot dialog
  • Opening screen shot dialog from menu File / Export screen shot

Example

Assume the following layout:

3_15_4_export_bmp.gif (1502 Byte)

Selecting from the main menu "File / Export screen shot" opens the following dialog:

3_15_4_export_bmp1.gif (3986 Byte)

Selecting each file and clicking the ">>" button moves the files into the right half of the dialog. Clicking "OK" then displays the following dialog:

3_15_4_export_bmp2.gif (1177 Byte)

The follwoing 2 .bmp files were generated in the same directory as the .vpl file:

  • scr_W2Page1.bmp
  • scr_Workarea1().bmp


Layout test

Page#: 3_16_designertest.htm

Layout test

The layout can be tested without VFrame using the layout test application (vpmste32.exe).

The test routine can be started by performing any 1 of the following:

  • Selecting from the main menu File / Test.
  • Clicking on the Test icon.
  • Double clicking on the compiled layout file (.vpc) (assuming that designer test is registered as the application for opening files with the .vpc extension).


Common tasks

Page#: 5_common_tasks.htm

000216TTA: example tasks added just to show what this section should be like.

Common tasks

The following tasks are required often while working with Designer.

  • Versioning of layout components and the layout itself.
  • Searching for layout components via element or attribute names.
  • Aligning the elements in a page.


Task: Versioning

Page#: 5_15_ct_versioning.htm

000216TTA: created.

Task: Versioning

A layout should be versioned at regular intervals.

The versioning process consists of the following:

  • Commenting parts.
  • Creating a versioned copy of the layout.


Task: Searching

Page#: 5_35_ct_searching.htm

000216TTA: created.

Task: Searching

A layout can be searched according to the following:

  • Element name
  • Attribute name


Task: Aligning

Page#: 5_55_ct_aligning.htm

000216TTA: created.

Task: Aligning

The elements in a layout can be aligned using the alignment tools.


Examples

Page#: 6_examples.htm

v08 000222TTA: examples added.

v13 000602TTA: examples link added.

Examples

Each of the following example layouts demonstrates various ways to implement certain functionality in Designer. The layout and the required model for each example are in a subdirectory of directory /docs/english/designer/examples on the CD ROM.

  • Tabulator.
  • RadioGroup.
  • ComboBox.
  • Conversion.
  • Data indicator.
  • Visualize.
  • Dynamic.
  • Visibility.
  • Multiple.
  • Page autostart.
  • Secondary dialog.
  • Compute result.
  • Expand/collapse page tree.
  • Availability.
  • Strict check.
  • Grid.
  • Wizard.


Example: Dynamic drop-down list (combobox)

Page#: 6_05_ex_tab.htm

v08 000222TTA: added. kka example.

v13 000602TTA: renamed (previously tab). links to files added. filename length is 8+3. other files (other than tabintern.xxx) deleted from directory.

Example: Dynamic drop-down list (combobox)

Location on CD-ROM

\docs\english\examples\combodyn (combodyn.vpl, combodyn.pms)

Description

This example demonstrates how to create comboboxes with dynamic content. When the car manufacturer is chosen from the upper combobox, then the available models in the lower combobox are only for that manufacturer.


Example: Radiogroup

Page#: 6_06_ex_radiogroup.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. example is pretty bad. filename length is 8+3.

Example: Radiogroup

Location on CD-ROM

\docs\english\examples\radiogroup (radiogr.vpl, radiogr.pms)

Description

The Radiogroups serve mainly to display contents of the tables defined by means of VP/MS-Workbench. The displaying can be carried out both in the vertical form and in the horizontal one. If in Designer-Inspec-tor "Number of columns" for any Radiogroup has value of 1 (default value) the vertical form of displaying is used, otherwise the horizontal one is used. In case of the horizontal displaying of the Radiogroup it is nec-essary to take into account that "Number of columns" corresponds to the number of displayed lines of the table. In case of the vertical displaying it is necessary only to set correct height so that to put all displayed elements inside. The name of the Workbench-attribute with which the displayed table is associated should be specified as "Source" for the Radiogroup in Designer-Inspector. If default value was assigned to the attribute in Workbench this value will be automatically transferred to Designer Runtime.


Example: Combobox

Page#: 6_07_ex_combobox.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. the example is pretty bad... needs to have some stuff added.

Example: Combobox

Location on CD-ROM

\docs\english\examples\combobox (combobox.vpl, combobox.pms)

Description

Comboboxes, as well as the Radiogroups, serve mainly to display contents of the tables defined by means of VP/MS-Workbench. The name of the Workbench-attribute with which the displayed table is associated should be specified as "Source" for the Combobox in Designer-Inspector. If default value was assigned to the attribute in Workbench this value will be automatically transferred to Designer Runtime.

At the startup of any XPL application Comboboxes are filled with the contents of the lists. If the lists are long this process can last for some time, especially if the contents of the list is read out from a database. To reduce starting up time for the application it is possible to specify the Property DYNCOMBO for the Work bench attribute associated to the table. DYNCOMBO is the signal for Designer Runtime to fill the list only when the Combobox is activated for the first time. Thus the time of startup is certainly reduced.

If default value was assigned to the Workbench attribute the related record in Designer Runtime can not been displayed until the list is filled. The attribute’s Property LONGTEXT is responsible for that. LONG TEXT returns to Designer Runtime the text, which should be displayed in the Combobox so long as there is no list there.

Java Applets: Here the Property DYNCOMBO is ignored, and Comboboxes are always filled at startup of the application.


Example: Conversion list

Page#: 6_08_ex_conversion.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: text editted.... layout and model redone. filename length is 8+3.

Example: Conversion list

Location on CD-ROM

\docs\english\examples\conversion (conversi.vpl, conversi.pms)

Description

Conversion Lists are usually used to set up certain values in some input fields or to return their default values. The conversion can be performed when pressing a Pushbutton, switching on/off a Checkbox or clicking Radiobuttons. The Property "Conversion List" in Designer Inspector for all mentioned Designer elements serves for these purposes. For Checkboxes the Property "OFF Conversion List" is added to pro-vide an accept to another list of conversion when switching off the Checkbox. The attributes of the conver-sion are defined in VP/MS Workbench and should be associated with the tables where the actual lists of conversion are. The first column of the table should contain a list of attribute names, which are transformed by Designer Runtime after definite conversion rules. These conversion rules should be specified in the second column of the table.

It is necessary to take into consideration that the routine use of one Conversion List to set new values and another Conversion List to set the default values for 2 Radiobuttons make sense only if they are incorpo-rated in one group in Designer Inspector through Subproperty "Group".


Example: Data indicator

Page#: 6_09_ex_dataindicator.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filename length is 8+3.

Example: Data indicator

Location on CD-ROM

\docs\english\examples\dataindicator (di.vpl, di.pms)

Description

By means of Data Indicators the user can define either the relevant data was entered or no in the certain areas/pages. It is helpful when working with voluminous applications where there are many areas and pages.

In Designer Inspector the Property "DataIndicator" " for the area or the page must be set to "ON" for those areas (Notebooks) and pages (Frames) which should be supplied with Data Indicators. After it has been done, two flags appear in front of the corresponding Notebook heading or Frame heading. They let us know that during the program execution the Data Indicator for the area or the page is used.

In order to use the Data Indicator the Properties of the VP/MS Workbench attributes should have the values which define under what circumstances the Data Indicator is set to ON or to OFF during the running of the program. This Properties should be specified in Designer Inspector as "DI Rule". There should be either written down a complete VP/MS name <Attribute>. <Property>, or only the name of an attribute (in this case the standard Workbench property "DataIndicator" is taken). Properties which used as "DI Rule" should have the value of 0 or of 1. If during the program performance the decision rule (DI Rule) is assigned the value of 1 the corresponding Data Indicator is switched on, if its value is 0 it is switched off.

Through the Subproperties "IN Symbol" and "OUT Symbol" in Designer Inspector it is possible to define what Bitmaps are used when displaying of the Data Indicator during of the program performance (Bitmaps by default: "+" and "-"). The library of Bitmaps for the Data Indicators is together with VP/MS Designer delivered .


Example: Visualize

Page#: 6_11_ex_visualize.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filename length is 8+3.

Example: Visualize

Location on CD-ROM

\docs\english\examples\visualize (visualiz.vpl, visualiz.pms)

Description

Some Notebook areas and Frame pages during the program performance can be visualized(displayed) or devisualized(hidden). This opportunity of Displaying / Hiding areas and pages can be defined for Radiobuttons and Checkboxes. It is realized through Subproperties "Visualize" and "Devisualize" in Designer Inspector. After opening the dialog "Visualize" it is possible to define what areas and / or pages will display on the screen when activating appropriate Radiobuttons or Checkboxes. When switching off the Radiobuttons or Checkboxes the visualized area and / or pages are again hidden. The same is for the dialog "Devisualize". But here it is necessary to select the areas and / or the pages which should be removed from the screen when activating appropriate Radiobuttons or Checkboxes.

Attention: When switching on or switching off any Radiobutton or Checkbox not all Frame pages, which are available on one of the Notebook pages, may be removed from the screen. It would cause a collapse of the program.


Example: Dynamic

Page#: 6_13_ex_dynamic.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added.

Example: Dynamic

Location on CD-ROM

\docs\english\examples\dynamic (dynamic.vpl, dynamic.pms)

Description

The Standard-Property "Dynamic" serves for updating attribute / group of attributes, used as input field(s) in VP/MS Designer, when another attribute / group of attributes, to which this attribute / group of attributes was connected by means of "Dynamic", is changed. This functionality is accessible for use only if in the file "win.ini " in the section [VPMS] refresh=0. If refresh=1 then the Standard-Properties "Refresh/Recalc" are processed instead of "Dynamic".

The Property "Dynamic" for the appropriate attributes is defined in a window "Attribute" of VP/MS-Workbench. For each attribute with "Dynamic" the list of attributes should be defined. The attributes in this list are immediately recalculated when the attribute with "Dynamic" is changed. This process is carried out on the basis of the rules, which are defined by means of the Standard-Property "Default" for the attributes

updated with the help of the Property "Dynamic". Here all permissible for VP/MS Workbench interrelations can be considered. While using "Dynamic" it is necessary don’t allowed giving the rise of an infinite cycle, that can result in the suspending of an application

"Dynamic" processing of a GUI element is carried out by means of the Subproperty "CheckDynamic" which can be switched on or switched off.

It is recommended to set the Subproperty "CheckDynamic" to "NO" for the inputs fields which contents don’t affect the dynamic status of other GUI elements.


Example: Visible

Page#: 6_14_ex_visible.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changes to 8+3 format.

Example: Visible

Location on CD-ROM

\docs\english\examples\visibility (visibili.vpl, visibili.pms)

Description

Visibility of visual elements can be controlled both in VP/MS Workbench and in VP/MS Designer. In VP/MS Workbench it is carried out through the specially reserved Property "Visible", which can be defined for an attribute in a window "Attribute". It determines under what circumstances the attribute becomes visible or invisible.

In VP/MS Designer for the majority of GUI elements there are 2 additional Subproperties "Visible" and "CheckOtherVisibility", which are displayed in Designer Inspector after defining of the source of the corresponding element.

Subproperty "Visible" replaces the old Subproperty "CheckOwnVisibility" and can assume values "Yes", "No", "Check" or "Value". If the value "No" is assumed, the corresponding GUI element during the program performance is always invisible. If "Visible" = "Yes" the GUI element is always visible. In these two cases no visibility checking are carried out during the program performance. In other two cases the visibility of a GUI element is checked.

When "Visible" = "Check" (for the result fields such opportunity is absent) visibility of the corresponding GUI element is checked through the attribute, for which a Standard Property "Visible" was defined in VP/MS Workbench. And depending on the rule defined by means of the Property "Visible" a GUI element during program performance becomes visible or invisible. It takes place, certainly, only when the other GUI elements (their names are specified in a Visible condition in WorkBench), on which the visibility of the given GUI element depends have the Subproperty "CheckOtherVisibility" set to "Yes".

If the Property "Visible" set to "Value", it is possible to indicate as value, a name of an attribute, or a Property or a function defined in the product model. If during the program performance the attribute, the Property or the function assumes value TRUE (1), the corresponding GUI element becomes visible. Otherwise the GUI element is removed from the screen. It is necessary to take into account that only the functions without call parameters can be used for visibility check. Besides, the visibility check while using the attribute as the value is carried out only when the other GUI element on which attribute the visibility of this GUI element depends, have the Subproperty "CheckOtherVisibility" set to "Yes".

For the Subproperty "CheckOtherVisibility" the values "Yes" or "No" can be selected. If set to "No" no visibility checking for other GUI elements which visibility depends on this GUI element is processed at runtime.

If the Subproperty "CheckOtherVisibility" assumes value "Yes", the visibility of other GUI elements is checked but in fact of those only with which Subproperty "Visible" was not assigned "Yes" or "No". Taking into account the productivity reasons it means, that this Subproperty should not assume value "No" for all the GUI elements which do not influence visibility of other GUI elements.


Example: Multiple

Page#: 6_15_ex_multiply.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. i dont understand the example at all... but left it in here anyway.

Example: Multiple

Location on CD-ROM

\docs\english\examples\multiple (multiple.vpl, multiple.pms)

Description

The multiple instances are used when the number of persons or objects should be insured. The logic of repetitive processings (accounts) is described in detail in the Handbook for VP/MS Workbench. Here are considered only special features of VP/MS Designer.

To represent repeated Workbench-instances in VP/MS Designer are used the Frame pages the Property "Dynamic" for which has value "Yes". The Subproperty "Identification" indicates which Workbench attribute is selected as the identifier for the Frame page and is used as heading of the corresponding copy of the page. In the Subproperty "Count attribute" from VP/MS Workbench the corresponding run counter should be copied (this counter is recommended not to be used as a GUI element in VP/MS Designer). The Sub properties "Caption New" and "Caption Delete" mean in each case Frame heading when placing a multiple page copy and the message which will be displayed in the dialogue when removing a multiple page copy.

It is necessary to take into account that the Subproperty "Multiple" should be set to "Yes" for the elements which attributes differ for the insured person or the object If the Subproperty "Multiple" set to "No" for some elements in Designer Inspector then the same value of the attribute will be used for this elements on all multiple page copies.


Example: Page autostart

Page#: 6_16_ex_pageautostart.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changed to 8+3 format.

Example: Page autostart

Location on CD-ROM

\docs\english\examples\page_autostart (pageauto.vpl, pageauto.pms)

Description

The situation when the result field and the input fields which are needed for calculations placed on the dif-ferent Frame pages or Notebook areas happens enough often.

In this case, if the input field, which used for calculating the result, is placed on one page and the result field is placed on another, the corresponding page where the input field is placed is automatically started up. Certainly, it doesn’t occur, if this input field has a default value. Then this value is used for calculating the result.

If the input field on the started page is not filled or the contents of the given field is deleted and the user is returned back to the previous page (that is possible in Designer Runtime only at the second attempt), an automatic transition is not possible any more (thus, the infinite cycles are excluded).

It is necessary to pay attention to the value of the Subproperty "ComputeResult "of an element. If this Sub property set to "No" for any of the input fields, no calculating of the result field will be executed after changing of the data in these elements (other pages will not be started up also). This means that for productivity of the work with application this Subproperty should be set to "No" for all input fields having an informative meaning.


Example: Secondary dialog

Page#: 6_17_ex_parentchild.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changed to 8+3 format. the .pms source file is missing.

Example: Secondary dialogs

Location on CD-ROM

\docs\english\examples\secondary_dialogs (parent.vpl, child.vpl)

Description

During the running of the program there is an opportunity to get access to another XPL-applications. For this purpose so-called secondary dialogs, which can be activated from a parental application, are used. Each secondary dialog may be consider as the XPL-application and is described by its own VPL-file (like every XPL-application). VP/MS-Designer-Runtime sets no limits to the maximal depth of inclusions.

Designer-Runtime supports only modal secondary dialogs. It means that if the secondary dialog is activated, the parental application becomes inaccessible until the nested dialog will be closed.

The only way to activate the secondary dialog is with a pushbutton. For this purpose the actual pushbut-tons Property "Action" with the value "Dialog-Call" is used.

The Subproperty "Dialog-Description" is necessary to specify the name of the VPL-file, which is considered as the child application. The heading of the child application appears in the headline of the secondary dialog when it called during the program performance. By means of the Subproperty "New Session" is defined whether the secondary dialog uses the same VP/MS-session as its parental application or it opens a new one (it is necessary if the child application uses another VPM-file as a product model). In the Sub-properties "Left" and "Top" a distance from the left top corner of secondary dialog to the left top corner of the parental application is indicated.

The child application can be used, for example, for data transfer to the parental application for result calcu-lating. Therefore 2 Pushbuttons should be defined in the child application. One of the Pushbuttons should serve for accepting the data entered in the secondary dialogue. It is achieved if the value "Dialog Accept" is set in the Pushbutton-Property "Action" in Designer-Inspector. By pressing the second Pushbutton the data entered in the secondary dialog are rejected and not used in the parental application for calculating the result. It is achieved by means setting the Pushbutton-Property "Action" to "Dialog Cancel" .

It is necessary to take into account that the result fields in the parental application are computed automati-cally only when the secondary dialog was closed with result OK and the Application Property "Calculation" for the parental application is set to "Automatic".


Example: Compute result

Page#: 6_18_ex_manual.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changed to 8+3 format. the .pms source file is missing.

Example: Compute results

Location on CD-ROM

\docs\english\examples\compute_results (compute.vpl)

Description

The result fields of the XPL-application can be computed either automatically or manually. It is controlled by the Application Property "Calculation". Using manual computing the values in the result fields are com-puted only when the corresponding Pushbutton is pressed. To have an opportunity to carry out manual cal-culation, it is necessary to define a Pushbutton and to set "Compute" to the Element Property "Action". Besides, the Application Property "Calculation" should be set to"Manual".

It is necessary to take into account that the Property "Calculation" influences all result fields, i.e. all result fields are computed either automatically or by pressing the Pushbutton. For some input fields it is possible to define, however, through the Element Subproperty "Compute" whether the corresponding fields of result will be computed "OnChange" of a input field or only "OnExit" of input field.

Java Applets: Here computing of the result fields is carried out only after quitting the corresponding input fields regardless of the Element Subproperty "Compute" set to "OnChange" or "OnExit".


Example: Expand/collapse page tree

Page#: 6_19_ex_expand.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added.

Example: Expand/collapse page tree

Location on CD-ROM

\docs\english\examples\expand_collapse_tree (expand.vpl, expand.pms)

Description

If any Frame-page has subpages it is possible to expand or collapse the Tree-View by means of double click by the left button of the mouse.

It can be defined in Designer-Inspector whether at loading of the XPL-application the corresponding Frame-page are automatically expanded and subpages displayed in Tree-View, or this page are collapsed and its subpages in Tree-View remain hidden.

For this purpose the Page Property "Defolding" is used. If the value "Manual" is set for this Property, Tree-View for the page will not be expanded automatically during loading and it can be then expanded only using the mouse. For automatic expanding of the Frame-page it is necessary to set the value "Automatic" (default value) for the Property "Defolding".


Example: Available

Page#: 6_20_ex_available.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changed to 8+ format.

Example: Available

Location on CD-ROM

\docs\english\examples\availability (availabi.vpl, availabi.pms)

Description

Availability of the visual elements, unlike the visibility, can be checked only in VP/MS-Designer. For the majority of GUI-elements in VP/MS-Designer are additionally present 2 Subproperties "CheckOwnAvailibility" and "CheckOtherAvailibility" which are displayed after definition of a source for the corresponding element in Designer-Inspector.

The Subproperty "CheckOwnAvailibility" can be set to "No", "All", "List" or "Page". If the Subproperty set to "No" the Availability check of the corresponding GUI-element will not be carried out during the program performance.

If "CheckOwnAvailibility" = "All", the GUI-element Availability is checked during the program performance using all result fields that are present in the XPL-application. It means that if for processing of at least one result field in the application a relevant attribute is required by the GUI-element this GUI-element becomes accessible. However, owing to the productivity reasons this value is not recommended to set. When saving Layout with such settings in a references window a reference to elements with "CheckOwnAvailibility" = "All" is provided.

If "CheckOwnAvailibility" = "List" the Availability of the GUI-element is checked during the program performance only through result fields specified in the Subproperty "List (...; ...)". It means that only these GUI-elements become available, which attributes for processing at least one result field are needed. Owing to the productivity reasons it is recommended to place in the list only one result field.

If "CheckOwnAvailibility" = "Page" the Availability of the GUI-element on the page is checked during the program performance through the result field specified in AVAILABLE-Property for the page. It means that if for processing a result field the attribute of the GUI-element located on this page is needed this GUI-ele-ment becomes accessible.

It also should be taken into account that in the product model can be additionally the attributes which used for calculating the result. It means that when these attributes assume the certain values the different lists of the attributes can be used for calculating the Property (in VP/MS-Designer as the result fields are used Workbench-Properties). Therefore in Designer is a Subproperty "CheckOtherAvailibility", which can take values "Yes" or "No".

If "CheckOtherAvailibility" = "No", the Availability check for other GUI-elements during the program performance will not be carried out if the contents of the element changed. Otherwise the availability of the GUI-elements is checked. However if "CheckOtherAvailibility" = "Yes" those GUI-elements are checked only, for which the Subproperty "CheckOwnAvailibility" set to "Yes".

Owing to the productivity reasons it is recommended to set the Subproperty "CheckOtherAvailibility" to "No" for those GUI-elements, whose values do not influence the availability of other GUI-elements.


Example: Strict check

Page#: 6_21_ex_obligation.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added. filenames changed to 8+ format.

Example: Strict check

Location on CD-ROM

\docs\english\examples\strict check (strictch.vpl, strictch.pms)

Description

The Subproperty of an element "Strict check" enables to forbid the leaving of an input field at some condi-tions. This Subproperty can be set to "Yes" or "No".

If the Subproperty "Strict check" is set to "Yes" and Minimum-check or the Check-check for the GUI-element returns a negative result, this input field can’t be left until the contents of the field satisfied the respec-tive conditions. At Minimum-check it is tested whether the entered value takes less positions than was specified in the element Subproperty "Minimum" or no. At Check-check it is checked whether the entered value meets the requirements specified in the Workbench-Property "check" or no. Here it is necessary to take into account that in addition the element Subproperty "CheckValidation" should be set to "Yes" to perform check specified for attribute in the Workbench-Property "check".

If the Subproperty "Strict check" set to "No" the field can be left always, independently of the results of the Minimum- and the Check-checks.


Example: Grid

Page#: 6_22_ex_grid.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added.

Example: Grid

Location on CD-ROM

\docs\english\examples\grid (grid.vpl, grid.pms, grid1.vpl, grid1.pms)

Description

Grids are used to display data in a tabular form. It can be necessary, for example, to display the data of each instance of a multiple page in a separate row of the table, or to display in each row different results of functions depending on the one variable factor.

The element Properties "Column" and "Key column" in Designer-Inspector define the number of columns and key column number for the grid. By means of the Property "Iteration type" the number of lines in the grid is defined. This number can be either constant (if the Property "Iteration type" is set to"Counter" and in the Subproperty "Iteration count" is defined a constant number) or variable depending on a value of the attribute or the Property (if the Property "Iteration type" is set to "Attribute" or "Property" and in the Sub-property "Attribute" or "Iteration property" is indicated the Workbench-attribute or the Workbench-Prop-erty).

In the Property "Property for" is indicated the column, for which the following Properties are defined. In the Properties "Title" and "Width" the heading of the corresponding column of the grid and the width of this column can be defined. In the Property "Usage" for key column the value "Input" and for others columns the value "Output" should be selected.

In the first line of the key column during the program performance the initial value of the attribute defined in Workbench is displayed. This value serves for identification of the grid columns and should be changeable by means of the function defined in Workbench. This attribute is defined in Designer-Inspector in the Column Subproperty "Attribute". By means of the Column Subproperty "Next Line" in Designer-Inspector the function is defined through which key attribute can be transformed. There the grid column number (output column) is indicated, in which the result of the function will be displayed. Usually during the program performance in Designer-Inspector this column is not shown. For this purpose zero width is defined for this column.

For output columns in the Subproperty "Property" the name of the function or the Workbench-Property of the multiple page with the parentheses should be specified. This function / Property should depend only on the one parameter so that it could be identified by means of the corresponding value of the key column. This value of the function / Property is displayed in the line identified in an appropriate way.


Example: Wizard

Page#: 6_23_ex_wizard.htm

v08 000222TTA: non-tta text added.

v13 000602TTA: links to files added.

Example: Wizard

Location on CD-ROM

\docs\english\examples\wizard (wizard.vpl, wizard.pms)

Description

VP/MS Designer-Runtime does not give a direct opportunity for development of the Wizard-Applications, as, for example, by means of the visualizing / hiding pages by pressing Pushbuttons. Certainly, it is possible to avoid this restriction of Designer-Runtime. For this purpose it is proposed to use Checkboxes for the visualizing / hiding pages, and also to switch on or switch off these Checkboxes by means of using convert attributes assigned to Pushbuttons.

At first in VP/MS Designer should be created the Frame-pages the transition to which will be carried out using Pushbuttons. Then the WorkArea Subproperty "Frame width" for these pages in Designer-Inspector should be set to 0 in order to the Tree-View remains hidden from the user. For each page it is necessary to define the Checkbox and indicate in the Subproperty "Visualize" the page which will appear on the screen when this checkbox is switched on. For all Checkboxes the Subproperty "Visible" has to be set to "No" in order to the user can’t see they during the program performance. For each Checkbox the Workbench-attribute, which then is changed by means of the conversion lists during the program performance, should be assumed. The value of 1 should be set by default to the Workbench-attribute for this Checkbox, which makes page visible at the startup of the application. On each page it is necessary to place Pushbuttons, by pressing on which it would be possible to come over to the certain pages. It is necessary to assign the con-version list to every Pushbutton. The rules in each conversion table in WorkBench should be defined so that by pressing an appropriate Pushbutton the Checkbox is activated making visible the page on which you come over while other Checkboxes remain inactive.

If you perform all actions described above you’ll receive a pure Wizard-application from the user point of view .

The note: Using of the conversion attributes was described in detail in the chapter "The Purpose and Using Conversion Lists".


Properties

Page#: 7_properties.htm

Properties

The properties are accessible via the Inspector.

  • Properties listed by component.
  • Alphabetical list of all properties.


Properties: Component list

Page#: 7_0_properties_components.htm

Properties: Component list

Properties for:

  • Application
  • Workarea
  • Page

Properties for elements:

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • PushButton
  • Label
  • Border
  • Grid
  • ExtendedGrid
  • 3D Border
  • Line
  • Multimedia element
  • ResultField
  • RadioGroup
  • Graphic element


Properties: Application

Page#: 7_0_011_properties_application.htm

000212TTA: added properties/subproperties "Header", "Footer".

Properties: Application

The following properties can be set for the application:

  • Version info
  • Version info = Yes . Version
  • Title
  • Width
  • Height
  • Format
  • Productmodel
  • Style
  • Style = Notebook . Tab font
  • Calculation
  • StartAttr
  • StartAttr = Constant . Name
  • StartAttr = Constant . Value
  • StartAttr = Dynamic . Name
  • Default font
  • AppActiveColor
  • Header
  • Header = Yes . Height
  • Header = Yes . Background color(R,G,B)
  • Footer
  • Footer = Yes . Height
  • Footer = Yes . Background color(R,G,B)


Properties: Workarea

Page#: 7_0_012_properties_workarea.htm

000212TTA: added properties/subproperties "Header", "Footer" and "Visible". "Table color" corrected to "Tab color".

Properties: Workarea

The following properties can be set for the workarea:

  • Version info
  • Version info = Yes . Version
  • Title
  • Tab color
  • DataIndicator
  • DataIndicator = On . DI Rule
  • DataIndicator = On . ON Symbol
  • DataIndicator = On . OFF Symbol
  • HelpID
  • Tooltip
  • Tooltip = Yes . Tooltip text
  • Tooltip = Yes . Background
  • Tooltip = Yes . Font
  • Style
  • Style = Frame . Frame width
  • Style = Frame . Frame font
  • Style = Frame . FrameMoveable
  • Style = Frame . FrameMoveable = Yes . MinFrameWidth
  • Style = Frame . FrameMoveable = Yes . MaxFrameWidth
  • Header
  • Header = Yes . Height
  • Header = Yes . Position
  • Header = Yes . Background color(R,G,B)
  • Footer
  • Footer = Yes . Height
  • Footer = Yes . Position
  • Footer = Yes . Background color(R,G,B)
  • Visible
  • Visible = Property . Name


Properties: Page

Page#: 7_0_013_properties_page.htm

000212TTA: added property/subproperties "Visible".

Properties: Page

The following properties can be set for a page:

  • Version info
  • Version info = Yes . Version
  • Title
  • Tooltip
  • Tooltip = Yes . Tooltip text
  • Tooltip = Yes . Background
  • Tooltip = Yes . font
  • HelpID
  • Multiple
  • Multiple = Yes . Identification
  • Multiple = Yes . Count attribute
  • Multiple = Yes . Caption New
  • Multiple = Yes . Caption Delete
  • Defolding
  • Order
  • Background color(R,G,B)
  • AVAILABLE-Property
  • DataIndicator
  • DataIndicator = On . DI Rule
  • DataIndicator = On . ON Symbol
  • DataIndicator = On . OFF Symbol
  • Data Elements
  • Visible
  • Visible = Property . Name


Properties: EditField

Page#: 7_0_02_properties_entryfield.htm

Properties: EditField

The following properties can be set for an EditField:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = Text / Currency / Number . Minimum
  • Type = Text / Currency / Number . Maximum
  • Type = Text . Multiline
  • Type = Text / Date / Currency / Number / Mask . Alignment
  • Type = Text / Date / Currency / Number / Mask . Strict check
  • Type = Date . Format
  • Type = Currency . Currency symbol
  • Type = Currency / Number . Decimal position
  • Type = Mask . Mask
  • Source
  • Source = [source] . Compute
  • Source = [source] . Strict check
  • Source = [source] . ChkValidation
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherVisibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility = List . List [...;...]
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ComputeResult
  • Source = [source] . ChkDynamic
  • Default font
  • Background color(R,G,B)
  • ActivColor
  • ActivColor = UserDef . ElemActiveColor
  • Element3D
  • HelpID
  • Level


Properties: ComboBox

Page#: 7_0_03_properties_comboxbox.htm

Properties: ComboBox

The following properties can be set for a ComboBox:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Source
  • Source = [source] . Compute
  • Source = [source] . Strict check
  • Source = [source] . ChkValidation
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherVisibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility = List . List [...;...]
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ComputeResult
  • Source = [source] . ChkDynamic
  • Default font
  • Background color(R,G,B)
  • ActivColor
  • ActivColor = UserDef . ElemActiveColor
  • Element3D
  • HelpID
  • Level


Properties: CheckBox

Page#: 7_0_04_properties_checkbox.htm

Properties: CheckBox

The following properties can be set for a CheckBox:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = CheckBox . Title
  • Type = CheckBox . Alignment
  • Type = CheckBox . Multiline
  • Type = CheckBox . Visualize
  • Type = CheckBox . Devisualize
  • Type = CheckBox . Conversion List
  • Type = CheckBox . OFF conversion List
  • Source
  • Source = [source] . Compute
  • Source = [source] . Strict check
  • Source = [source] . ChkValidation
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherVisibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility = List . List [...;...]
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ComputeResult
  • Source = [source] . ChkDynamic
  • Default font
  • Background color(R,G,B)
  • Element3D
  • HelpID
  • Level


Properties: RadioButton

Page#: 7_0_05_properties_radiobutton.htm

Properties: RadioButton

The following properties can be set for a RadioButton:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = RadioButton . Title
  • Type = RadioButton . Group
  • Type = RadioButton . Alignment
  • Type = RadioButton . Multiline
  • Type = RadioButton . Visualize
  • Type = RadioButton . Devisualize
  • Type = RadioButton . Conversion List
  • Source
  • Source = [source] . Compute
  • Source = [source] . Strict check
  • Source = [source] . ChkValidation
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherVisibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility = List . List [...;...]
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ComputeResult
  • Source = [source] . ChkDynamic
  • Default font
  • Background color(R,G,B)
  • Element3D
  • HelpID
  • Level


Properties: PushButton

Page#: 7_0_06_properties_pushbutton.htm

Properties: PushButton

The following properties can be set for a PushButton:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Title
  • Action
  • Action = DLL-Call . Dll-Description
  • Action = Dialog-Call . Dialog-Description
  • Action = Dialog-Call . New Session
  • Action = Dialog-Call . Left
  • Action = Dialog-Call . Top
  • ConvertAttr
  • Source
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . ChkOwnAvailibility = List . List [...;...]
  • Default font
  • Element3D
  • HelpID
  • Level


Properties: Label

Page#: 7_0_07_properties_label.htm

Properties: Label

The following properties can be set for a Label:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = Label . Title
  • Type = Label . Default font
  • Type = Label . Attribute
  • Type = Label . Attribute = [attribute] . Visible
  • Type = Label . Attribute = [attribute] . Visible = Value . Property
  • Type = Label . Attribute = [attribute] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Type = Label . Attribute = [attribute] . ChkOwnAvailibility = List . List [...;...]
  • Type = Label . Alignment
  • Type = Label . Multiline
  • Type = Label . Background color (R,G,B)
  • Level


Properties: Border

Page#: 7_0_08_properties_border.htm

Properties: Border

The following properties can be set for a Border:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Type
  • Type = Border . Title
  • Type = Border . Default font
  • Type = Border . Attribute
  • Type = Border . Attribute = [attribute] . Visible
  • Type = Border . Attribute = [attribute] . Visible = Value . Property
  • Type = Border . Attribute = [attribute] . ChkOwnAvailibility
  • Type = Border . Attribute = [attribute] . ChkOwnAvailibility = List . List [...;...]
  • Type = Border . Background color (R,G,B)
  • Level


Properties: Grid

Page#: 7_0_09_properties_grid.htm

Properties: Grid

The following properties can be set for a Grid:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Yes . Tooltip text
  • Tooltip = Yes . Background
  • Tooltip = Yes . font
  • Type (cannot be changed)
  • Column
  • Columns moveable
  • Key column
  • Iteration type
  • Iteration type = Attribute . Attribute
  • Iteration type = Property . Iteration property
  • Iteration type = Counter . Iteration count
  • Visible
  • Visible = Value . Property
  • Level
  • Property for
  • Property for = Column [column#] . Title
  • Property for = Column [column#] . Width
  • Property for = Column [column#] . Usage
  • Property for = Column [column#] . Usage = Input . Attribute
  • Property for = Column [column#] . Usage = Input . Next line
  • Property for = Column [column#] . Usage = Output . Property
  • Property for = Column [column#] . Type
  • Property for = Column [column#] . Type = Text / Number / Currency . Alignment
  • Property for = Column 1 . Type = Number / Currency . Decimalposition
  • Property for = Column 1 . Type = Number / Currency . Alignment
  • Property for = Column 1 . Type = Currency . CurrencySymbol
  • Property for = Column 1 . Font
  • Property for = Column 1 . Background color(R,G,B)


Properties: ExtendedGrid

Page#: 7_0_10_properties_extendedgrid.htm

Properties: ExtendedGrid

The following properties can be set for an ExtendedGrid:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Yes . Tooltip text
  • Tooltip = Yes . Background
  • Tooltip = Yes . font
  • Type (cannot be changed)
  • Columns moveable
  • Column
  • Count attribute
  • Caption New
  • Caption Delete
  • Visible
  • Visible = Value . Property
  • Level
  • Header font
  • Property for
  • Property for = Column [column#] . Title
  • Property for = Column [column#] . Width
  • Property for = Column [column#] . Usage
  • Property for = Column [column#] . Usage = Input . Type
  • Property for = Column [column#] . Usage = Input . Type = Text / Number / Currency . Minimum
  • Property for = Column [column#] . Usage = Input . Type = Text / Number / Currency . Maximum
  • Property for = Column [column#] . Usage = Input . Type = Text / Number / Currency / Date / Mask . Alignment
  • Property for = Column [column#] . Usage = Input . Type = Text / Number / Currency / Date / Mask . Strict check
  • Property for = Column [column#] . Usage = Input . Type = Number / Currency . Decimal position
  • Property for = Column [column#] . Type = Number / Currency . Alignment
  • Property for = Column [column#] . Type = Currency . CurrencySymbol
  • Property for = Column [column#] . Usage = Input . Type = Date . Format
  • Property for = Column [column#] . Usage = Input . Type = Mask . Mask
  • Property for = Column [column#] . Font
  • Property for = Column [column#] . Background color(R,G,B)


Properties: 3D Border

Page#: 7_0_11_properties_3dborder.htm

Properties: 3D Border

The following properties can be set for a 3D Border:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Type
  • Type = 3D-Area . Background color (R,G,B)
  • Level


Properties: Line

Page#: 7_0_12_properties_line.htm

Properties: Line

The following properties can be set for a Line:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Type
  • Type = Line . Background color (R,G,B)
  • Level


Properties: Multimedia element

Page#: 7_0_13_properties_multimedia.htm

Properties: Multimedia element

The following properties can be set for a Multimedia element:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = Media . Attribute
  • Type = Media . Attribute = [attribute] . Visible
  • Type = Media . Attribute = [attribute] . Visible = Value . Property
  • Type = Media . Media file
  • Level


Properties: ResultField

Page#: 7_0_14_properties_resultfield.htm

Properties: ResultField

The following properties can be set for a ResultField:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Yes . Background
  • Tooltip = Yes . font
  • Tooltip = Yes . Tooltip text
  • Type
  • Type = Result . Multiline
  • Type = Result / Number result / Currency result / Date result / Mask result . Alignment
  • Type = Date result . Format
  • Type = Currency result . Currency symbol
  • Type = Currency result / Number result . Decimal position
  • Type = Mask result . Mask
  • Source
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Default font
  • Background color(R,G,B)
  • Element3D
  • HelpID
  • Level


Properties: RadioGroup

Page#: 7_0_15_properties_radiogroup.htm

Properties: RadioGroup

The following properties can be set for a RadioGroup:

The following properties can be set for a RadioGroup:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Static / Dynamic . Tooltip text
  • Tooltip = Static / Dynamic . Background
  • Tooltip = Static / Dynamic . font
  • Type
  • Type = RadioButton . Alignment
  • Type = RadioButton . Number of columns
  • Source
  • Source = [source] . Compute
  • Source = [source] . Strict check
  • Source = [source] . ChkValidation
  • Source = [source] . Visible
  • Source = [source] . Visible = Value . Property
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherVisibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ChkOwnAvailibility = List . List [...;...]
  • Source = [source] . Visible = Yes / Check / Value . ChkOtherAvailibility
  • Source = [source] . Visible = Yes / Check / Value . ComputeResult
  • Source = [source] . ChkDynamic
  • Default font
  • Background color(R,G,B)
  • Element3D
  • HelpID
  • Level


Properties: Graphics element

Page#: 7_0_16_properties_graphic.htm

Properties: Graphics element

The following properties can be set for a Graphics element:

The following properties can be set for a Graphics element:

  • Version info
  • Version info = Yes . Version
  • Bounds
  • Bounds = [ top,left,width,height ] . Left
  • Bounds = [ top,left,width,height ] . Top
  • Bounds = [ top,left,width,height ] . Width
  • Bounds = [ top,left,width,height ] . Height
  • Tooltip
  • Tooltip = Yes . Tooltip text
  • Tooltip = Yes . Background
  • Tooltip = Yes . font
  • Type (cannot be changed)
  • Identification Grid
  • font
  • Background color(R,G,B)
  • Element3D
  • HelpID
  • Graphics type
  • Graphics type = Line / Vertical bar / Horizontal bar / Vertical 3D bar / Horizontal 3D bar / Vertical Gantt / Horizontal Gantt . X-axe name
  • Graphics type = Line / Vertical bar / Horizontal bar / Vertical 3D bar / Horizontal 3D bar / Vertical Gantt / Horizontal Gantt . Y-axe name
  • Key column
  • Series
  • Legend placement
  • Level
  • Property for
  • Property for = Serie [serie#] . Data column
  • Property for = Serie [serie#] . Color


Properties: All (alphabetical)

Page#: 7_00_properties_all.htm

v10 000329TTA: last update (small changes).

Properties: All

The following is an alphabetical list of reserved Designer properties.

The properties are accessible via the Inspector.

  • Action
  • ActivColor
  • Alignment
  • AppActiveColor
  • Attribute
  • AVAILABLE-Property
  • Background
  • Background color
  • Bounds
  • Calculation
  • Caption Delete
  • Caption New
  • ChkDynamic
  • ChkOtherAvailibility
  • ChkOtherVisibility
  • ChkOwnAvailibility
  • ChkValidation
  • Color
  • Column
  • Columns moveable
  • Compute
  • ComputeResult
  • Conversion List
  • ConvertAttr
  • Count attribute
  • Currency symbol
  • Data column
  • Data elements
  • DataIndicator
  • Decimal position
  • Default font
  • Defolding
  • Devisualize
  • DI Rule
  • Dialog-Description
  • Dll-Description
  • ElemActiveColor
  • Element3D
  • Font
  • Footer
  • Format (application)
  • Format (element)
  • Frame font
  • Frame width
  • FrameMoveable
  • Graphics type
  • Group
  • Header
  • Header font
  • Height (application)
  • Height (header/footer)
  • HelpID
  • Identification
  • Identification Grid
  • Indexed
  • Iteration count
  • Iteration property
  • Iteration type
  • Key column
  • Left
  • Legend placement
  • Level
  • List (...;...)
  • Mask
  • MaxFrameWidth
  • Maximum
  • Media file
  • MinFrameWidth
  • Minimum
  • Multiline
  • Multiple
  • Name (application)
  • Name (workarea/page)
  • New Session
  • Next line
  • Number of columns
  • Off conversion list
  • Off symbol
  • On symbol
  • Order
  • Position (footer)
  • Position (header)
  • ProductModel
  • Property
  • Property for
  • Series
  • Source
  • StartAttr
  • Strict check
  • Style (application)
  • Style (workarea)
  • Tab color
  • Tab font
  • Title
  • Tooltip (static/dynamic)
  • Tooltip (static)
  • Tooltip text
  • Top
  • Type (entry elements)
  • Type (ExtendedGrid column)
  • Type (ExtendedGrid)
  • Type (GraphicsElement)
  • Type (Grid column)
  • Type (Grid)
  • Type (result elements)
  • Type (visual elements)
  • Usage
  • Value
  • Version
  • Version info
  • Visible (element)
  • Visible (workarea/page)
  • Visualize
  • Width (application)
  • Width (Grid/ExtendedGrid)
  • X-axe name
  • Y-axe name


Property: Action

Page#: 7_01_properties_action.htm

v10 000406TTA XX: non-tta (functionaly description) text added.

Property: Action

Possible values

  • Compute
  • DLL-Call
  • Dialog-Call
  • Dialog Accept
  • Dialog Cancel

Property for

  • PushButton

Definition

The action carried out when a pushbutton is clicked.

The only way to close secondary dialogs and finish the user interaction between the secondary dialog and the user is with the following predefined logical events:

  • Logical event: Accept. Every data manipulation (in general every user interaction) that happened from the time when the dialog was invoked is accepted. The dialog will be closed and dialog control goes back to the place in the underlying XPL-application from where the dialog was initiated. If the application property calculation; is set to automatic, the XPL-application is computed (intercommunication with the application model). If the application property calculation is set to manual, the XPL-application is not computed only checked.
  • Logical event: Cancel. Every data manipulation that happened from the time when the dialog was invoked is canceled by the Designer Runtime. The dialog will be closed and dialog control goes back to the place in the underlying XPL-application from where the secondary dialog was initiated. The status of the XPL-application is exactly the same as before the secondary dialog was called. The logical events Accept and Cancel are mapped to the standard user interactions for secondary dialogs (keyboard Esc, the close symbol x in the window title and so on) as well as to specific Pushbutton actions (see below).

Example

Assume the following layout:

7_01_properties_action.gif (859 Byte)

Clicking on the PushButton would open the dialog specified by property <Dialog description>.


Property: ActivColor

Page#: 7_02_properties_activcolor.htm

Property: ActivColor

Possible values

  • AppDef
  • UserDef

Property for

  • ComboBox
  • EditField

Definition

Determines whether the active color for an element is:

  • AppDef: The default color for the application (see AppActiveColor).
  • UserDef: A color defined by the user.

Example

The active color for EditField a_Capital is defined as green:

7_02_example.gif (1144 Byte)

When the EntryField is selected, it turns green:

7_02_example2.gif (357 Byte)


Property: Alignment

Page#: 7_03_properties_alignment.htm

v10 000406TTA: text modified (es geht nicht um die ausrichtung des texts, aber die ausrichtung des elements).

Property: Alignment

Possible values

  • Left
  • Right

Property for

  • CheckBox . Type = CheckBox
  • EditField . Type = Currency / Date / Mask / Number / Text
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Currency / Date / Mask / Number / Text
  • GridList . Property for = Column 1 . Type = Currency / Number / Text
  • Label . Type = Label
  • RadioButton . Type = RadioButton
  • RadioGroup . Type = RadioButton
  • ResultField . Type = Currency result / Date result / Mask result / Number result / Result

Definition

Alignment of the element.

Examples

Example 1

The following CheckBox is aligned to the right (the text is on the left).

7_03_example.gif (861 Byte)

Example 2

The following layout has EditFields with <Alignment> = <Right>, <Left>.

7_03_properties_alignment.gif (1923 Byte)

The runtime layout:

7_03_properties_alignment2.gif (546 Byte)


Property: AppActiveColor

Page#: 7_04_properties_appactivecolor.htm

v10 000405TTA: new pics/text added.

Property: AppActiveColor

Possible values

  • (0..255,0..255,0..255)

Property for

  • Application

Definition

Active color of the application. This color is the default color for all elements (the color for a specific element can be defined using ActivColor).

Example

The active color for application Zyx is set to yellow:

7_04_example.gif (1440 Byte)

The left EditField uses the active color defined for the application.

7_04_example5.gif (886 Byte)

The right EditField has its own active color:

7_04_example6.gif (1173 Byte)

The following shows the results in the runtime layout:

7_04_example2.gif (1227 Byte)

7_04_example7.gif (1214 Byte)


Property: Attribute

Page#: 7_05_properties_attribute.htm

Property: Attribute

Possible values

  • An attribute from the model.

Property for

  • Border . Type = Border
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = ComboBox
  • GridList . Iteration type = Attribute
  • GridList . Property for = Column 1 . Usage = Input
  • Label . Type = Label
  • Multimedia . Type = Media

Definition

Defines the model attribute for the layout component.

Example

Assume the following layout with 2 EditFields and a ResultField, each with <Source> = <a_Variable1>.

7_05_properties_attribute.gif (1273 Byte)

In the runtime layout: Entering data in the top EditField will cause the following:

  • The data is written to model attribute "a_Variable1".
  • Any elements in the layout with <Source> = <a_Variable1> are updated with the new value.
    7_05_properties_attribute1.gif (493 Byte)


Property: AVAILABLE-Property

Page#: 7_06_properties_availableproperty.htm

Property: AVAILABLE-Property

Possible values

  • A list of properties (separated by semicolons (;)).

Property for

  • Page

Definition

For any element on the page with <ChkOwnAvailibility> = <Page>: The element will only be available if the element is required for computing any of the result properties listed in <AVAILABLE-Property>.

Example

Assume the following model:

7_06_properties_availableproperty.gif (3713 Byte)

where a_1, a_2, a_3 have default values 1, 2, 3.

Assume the following layout:

7_06_properties_availableproperty2.gif (2572 Byte)

EntryFields for model attributes a_1, a_2, a_3 have element property <ChkOwnAvailibility> = <Page>. The page property <AVAILABLE-Property> = <p_1;p_2> (does not include p_3).

7_06_properties_availableproperty3.gif (1948 Byte)

This would result in the following runtime layout:

7_06_properties_availableproperty4.gif (1519 Byte)

Note that the EntryField for a_3 is not available (is grey).


Property: Background

Page#: 7_07_properties_background.htm

Property: Background

Possible values

  • (0..255,0..255,0..255)

Property for

  • CheckBox . Tooltip = Dynamic / Static
  • ComboBox . Tooltip = Dynamic / Static
  • EditField . Tooltip = Dynamic / Static
  • ExtendedGridList . Tooltip = Yes
  • Graphics . Tooltip = Yes
  • GridList . Tooltip = Yes
  • Label . Tooltip = Dynamic / Static
  • Multimedia . Tooltip = Dynamic / Static
  • Page . Tooltip = Yes
  • PushButton . Tooltip = Dynamic / Static
  • RadioButton . Tooltip = Dynamic / Static
  • RadioGroup . Tooltip = Dynamic / Static
  • ResultField . Tooltip = Yes
  • Workarea . Tooltip = Yes

Definition

The background color.

Example

Assume a layout with EntryFields with a Static tooltip defined as shown:

7_07_properties_background3.gif (2208 Byte)

The runtime layout tooltip would have a yellow background color:

7_07_properties_background4.gif (1646 Byte)


Property: Background color(R,G,B)

Page#: 7_08_properties_backgroundcolor.htm

000212TTA: added to "property for" application/workarea header/footer.

v10 000406TTA: pics added, text changed.

Property: Background color(R,G,B)

Possible values

  • (0..255,0..255,0..255)

Property for

  • Application . Header = Yes
  • Application . Footer = Yes
  • Workarea . Header = Yes
  • Workarea . Footer = Yes
  • Line . Type = Line . Line color
  • 3DBorder . Type = 3D-Area
  • Border . Type = Border
  • Label . Type = Label
  • Graphics
  • Page
  • RadioGroup
  • ResultField
  • CheckBox
  • ComboBox
  • EditField
  • ExtendedGridList . Property for = Column 1
  • GridList . Property for = Column 1
  • PushButton
  • RadioButton

Definition

Color of the background.

See also:

  • Property Background
  • Default background color settings for Page.

Examples

Example 1

Assume a layout with an EditField with setting as shown:

7_07_properties_background.gif (1414 Byte)

The runtime layout:

  • EditField not selected:
    7_07_properties_background2.gif (234 Byte)
  • EditField selected:
    7_07_properties_background5.gif (1067 Byte)

Example 2

The following example shows a layout page with a defined background color.

7_08_example.gif (2120 Byte)


Property: Bounds

Page#: 7_09_properties_bounds.htm

Property: Bounds

Possible values

  • [ 0.. (top),0.. (left),0.. (width),0.. (height) ]

Property for

  • Border
  • Label
  • Multimedia
  • ResultField
  • Line
  • 3DBorder
  • ExtendedGridList
  • GridList
  • CheckBox
  • ComboBox
  • EditField
  • Graphics
  • PushButton
  • RadioButton
  • RadioGroup

Definition

The location (top, left) and dimensions (width, height) of the element.

Example

The following example shows an entry field located in the uppermost left corner (0, 0). Note that the location is in relation to the upper left corner of the page not including the frame.

7_09_example.gif (2982 Byte)


Property: Calculation

Page#: 7_10_properties_calculation.htm

v10 000406TTA: small format error fixed.

Property: Calculation

Possible values

  • Automatic
  • Manual

Property for

  • Application

Definition

If Automatic: All elements on a page are re-calculated whenever a different page is selected.

If Manual: Results are only computed when a PushButton is used to manually re-calculate.

Example

Assume the following model:

7_10_properties_calculation.gif (2085 Byte)

Assume the following layout:

7_10_properties_calculation1.gif (2556 Byte)

The PushButton <Action> = <Compute>:

7_10_properties_calculation2.gif (689 Byte)

The EntryField properties:

  • <ComputeResult> = <Yes>
  • <Compute> = <OnChange>

7_10_properties_calculation4.gif (3745 Byte)

In the runtime layout, the result would not be calculated even if the pages were changed:

7_10_properties_calculation3.gif (929 Byte)

Pressing the PushButton would cause the result to be computed.

7_10_properties_calculation6.gif (941 Byte)

Note: The PushButton can be located anywhere in the layout (on any page or workarea).


Property: Caption Delete

Page#: 7_11_properties_captiondelete.htm

Property: Caption Delete

Possible values

  • Any text.

Property for

  • ExtendedGridList
  • Page . Multiple = Yes

Definition

The caption that will be displayed in the context menu (right-click) for deleting a member of an array.

See also Caption New.

Example

The following example shows a multiple page with the Caption Delete set to "delete1P".

7_11_example.gif (2873 Byte)

In the layout test, right-clicking on an array member will bring up a context menu with the text "delete1P":

7_11_example2.gif (1477 Byte)


Property: Caption New

Page#: 7_12_properties_captionnew.htm

Property: Caption New

Possible values

  • Any text.

Property for

  • ExtendedGridList
  • Page . Multiple = Yes

Definition

The caption that will be displayed in the layout for adding a member to an array.

See also Caption Delete.

Example

The following example shows a multiple page with the Caption New set to "new1P".

7_11_example.gif (2873 Byte)

In the layout test, the text will be displayed beside the icon for adding a new member to the array.

7_12_example2.gif (1459 Byte)


Property: ChkDynamic

Page#: 7_121_properties_chkdynamic.htm

Property: ChkDynamic

Possible values

  • Yes
  • No

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

If <ChkDynamic> = <Yes>: The following occurs:

  • The model property <default> is re-evaluated for all model attributes.
  • For all layout Labels with property <Attribute> = (a model attribute): The corresponding model attribute property <label> is re-evaluated and assigned to the label.

When exactly the above occurs is determined by:

  • If <Compute> = <OnChange>: When data (a digit or letter) is entered in the EntryField.
  • If <Compute> = <OnExit>: When the focus changes after data (a digit or letter) has been entered in the EntryField.

See also: Setting the default value for ChkDynamic.

Example

See the discussion of re-computing attribute default / label.


Property: ChkOtherAvailibility

Page#: 7_122_properties_chkotheravailibility.htm

Property: ChkOtherAvailibility

Possible values

  • Yes
  • No

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

Determines whether or not the availability of the other elements is to be determined when the content of the element is changed.

See also:

  • Setting the default value.
  • Concepts: Availibility


Property: ChkOtherVisibility

Page#: 7_123_properties_chkothervisibility.htm

Property: ChkOtherVisibility

Possible values

  • No
  • Yes

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

If <Yes>: Changing the value in the element will cause the visible property for all elements in the page with dynamic visibility to be checked (reevaluated).

See also:

  • Concept: Dynamic visibility.
  • Setting the default value.


Property: ChkOwnAvailibility

Page#: 7_124_properties_chkownavailibility.htm

Property: ChkOwnAvailibility

Possible values

  • None
  • All
  • List
  • Page

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • PushButton
  • Label
  • Border
  • RadioGroup

Definition

Specifies a set of result elements. The element is available if the element is required for the computation of at least 1 of the result elements in the set. If <ChkOwnAvailibility> =

  • <None>: Element is ALWAYS available.
  • <All>: Element is available IF the element's model attribute is required for ANY result on ANY page.
  • <List>: Element is available IF the element's model attribute is required for ANY result in the list of results specified by element property <List (...;...)> (the listed results can be on any page).
  • <Page>: Element is available IF the element's model attribute is required for ANY result in the list of results specified by page property <AVAILABLE-Property> (the listed results can be on any page).

See also:

  • Setting the default value.

Example

For an example see Results list.


Property: ChkValidation

Page#: 7_125_properties_chkvalidation.htm

v10 000406TTA: text/pics added.

Property: ChkValidation

Possible values

  • Yes
  • No

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

If <Yes>: When a value is entered (or selected): The equation defined (in the model) for the element attribute property <Check> will be executed. This equation is typically an IF statement that returns 1 of 2 possible values depending on the value entered. The returned value will be displayed in the element. Typically 1 of the returned values is the attribute itself.

See also: Setting the default value.

Example

Assume the following model attribute:

7_125_properties_chkvalidation.gif (1556 Byte)

Assume the following layout EditField:

7_125_properties_chkvalidation1.gif (1270 Byte)

When the runtime layout is opened, the value of 0 is displayed since a_1 has no default value (is null).

7_125_properties_chkvalidation2.gif (219 Byte)

Clicking on the key "5" would result in 0 again being displayed.

Clicking on the key "4" would result in 4 being displayed.

Clicking on the key "4" again would result in 0 being displayed, since the entered value was 44.


Property: Color

Page#: 7_13_properties_color.htm

Property: Color

Possible values

  • (0..255,0..255,0..255)

Property for

  • Graphics . Property for = Serie 1

Definition

Color of the series.

Example

In the following Graphic the <Color> for Serie 1 is 255,0,0 (Red):

7_13_properties_color.gif (3179 Byte)


Property: Column

Page#: 7_14_properties_column.htm

Property: Column

Possible values

  • Positive Integer

Property for

  • ExtendedGridList
  • GridList

Definition

The number of columns in a Grid / ExtendedGrid.

Example

In the following layout the Grid has 4 columns:

7_14_properties_column.gif (3320 Byte)

Note: Normally the Grid / ExtendedGrid next-key column column has <Width> = 0 (ie, the column is not visible).


Property: Columns moveable

Page#: 7_15_properties_columnsmoveable.htm

Property: Columns moveable

Possible values

  • Yes
  • No

Property for

  • ExtendedGridList
  • GridList

Definition

If <Yes>: The column is "moveable" (can be resized).

Example

Assume the following layout with a Grid with <Columns moveable> = <Yes>.

7_15_properties_columnsmoveable.gif (3375 Byte)

In the runtime layout the columns can be resized:

7_15_properties_columnsmoveable2.gif (1129 Byte)

Note: The total width of the columns cannot exceed the width of the element. For the above Grid the maximum width of the element is shown below:

7_15_properties_columnsmoveable1.gif (1372 Byte)


Property: Compute

Page#: 7_151_properties_compute.htm

Property: Compute

Possible values

  • OnExit
  • OnChange.

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

If <ComputeResult> = <Yes> and <Calculation> = <Automatic>: Model product results whose calculations include the the model value represented by the element are re-calculated based on the setting of <Compute>.

See also:

  • Concept: Compute results.
  • Setting the default value for elements (Compute event).


Property: ComputeResult

Page#: 7_152_properties_computeresult.htm

Property: ComputeResult

Possible values

  • Yes
  • No

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup

Definition

If <ComputeResult> = <Yes> and <Calculation> = <Automatic>: Model product results whose calculations include the the model value represented by the element are re-calculated based on the setting of <Compute>.

See also:

  • Concept: Compute results
  • Setting the default value.


Property: Conversion List

Page#: 7_16_properties_conversionlist.htm

Property: Conversion List

Possible values

  • Name of a model attribute

Property for

  • CheckBox . Type = CheckBox
  • RadioButton . Type = RadioButton

Definition

Specifies the model attribute whose property <table> references the (ON) conversion table when the element is selected.

Example

Assume the following layout:

7_16_properties_conversionlist.gif (1536 Byte)

Assume the following model:

7_16_properties_conversionlist5.gif (1816 Byte) 7_16_properties_conversionlist6.gif (1102 Byte)

7_16_properties_conversionlist2.gif (535 Byte) 7_16_properties_conversionlist3.gif (921 Byte) 7_16_properties_conversionlist4.gif (574 Byte)

In the runtime model, the attribute a_X would be converted to a_X_Convert.default when the CheckBox is checked:

7_16_properties_conversionlist7.gif (482 Byte)


Property: ConvertAttr

Page#: 7_17_properties_convertattr.htm

Property: ConvertAttr

Possible values

  • Name of a model attribute

Property for

  • PushButton

Definition

Specifies the model attribute whose property <table> references the conversion table when the PushButton is clicked.

Example

Assume the following layout:

7_17_properties_convertattr.gif (1893 Byte)

Assume the following model:

7_16_properties_conversionlist5.gif (1816 Byte) 7_16_properties_conversionlist6.gif (1102 Byte)

7_16_properties_conversionlist2.gif (535 Byte) 7_16_properties_conversionlist3.gif (921 Byte) 7_16_properties_conversionlist4.gif (574 Byte)

7_63_properties_offconversionlist.gif (537 Byte) 7_63_properties_offconversionlist1.gif (992 Byte) 7_63_properties_offconversionlist2.gif (598 Byte)

In the runtime layout:

  • Attribute a_X would be converted to a_X_OffConvert.default when the top PushButton is clicked.
    7_17_properties_convertattr1.gif (1835 Byte)
  • Attribute a_X would be converted to a_X_OnConvert.default when the bottom PushButton is clicked.
    7_17_properties_convertattr2.gif (1865 Byte)


Property: Count attribute

Page#: 7_18_properties_countattribute.htm

v10 000406TTA: text/pics added.

Property: Count attribute

Possible values

  • Name of model attribute

Property for

  • ExtendedGridList
  • Page . Multiple = Yes

Definition

The model attribute that stores the number of multiple pages (Page) or number of rows (ExtendedGrid).

Example

Assume the following model:

7_18_properties_countattribute.gif (2586 Byte)

Assume the following layout:

7_18_properties_countattribute1.gif (2131 Byte)

7_18_properties_countattribute2.gif (1910 Byte)

Runtime Layout with 3 subnodes:

7_18_properties_countattribute3.gif (1833 Byte)


Property: Currency symbol

Page#: 7_19_properties_currencysymbol.htm

Property: Currency symbol

Possible values

  • On
  • Off

Property for

  • EditField . Type = Currency
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Currency
  • ResultField . Type = Currency result
  • GridList . Property for = Column 1 . Type = Currency

Definition

If <On>: A currency symbol will be displayed.

Example

Assume the following layout:

7_19_properties_currencysymbol.gif (2816 Byte)

All 3 of the above EditFields have the same <Source> attribute. The second EditField has <Currency symbol> = <Yes>.

In the runtime layout:

7_19_properties_currencysymbol1.gif (978 Byte)


Property: Data column

Page#: 7_20_properties_datacolumn.htm

Property: Data column

Possible values

  • Integer

Property for

  • Graphics . Property for = Serie 1

Definition

Specifies the source Grid / ExtendedGrid data column for the Serie.

Example

Assume the following layout Grid:

7_20_properties_datacolumn.gif (2258 Byte)

Assume the following layout Graphic:

7_20_properties_datacolumn1.gif (1740 Byte)

7_20_properties_datacolumn2.gif (747 Byte)

7_20_properties_datacolumn3.gif (738 Byte)

Model product properties will be shown in series:

  • p_Interest() : serie 1 (red)
  • p_Capital() : serie 2 (green)

In the runtime layout:

7_20_properties_datacolumn4.gif (1446 Byte)

7_20_properties_datacolumn5.gif (1041 Byte)


Property: Data elements

Page#: 7_21_properties_dataelements.htm

Property: Data elements

Possible values

  • Selected
  • Not selected

Property for

  • Page

Definition

If <Selected>: Data elements have been selected for the page.

Data elements provide VFrame with access to model attributes that are not included as elements in the layout.

Example

Assume that no data elements have been selected for the page:

7_21_properties_dataelements.gif (1308 Byte)

Click on the <not selected> text. A directory button appears. Click on the button.

7_21_properties_dataelements1.gif (2212 Byte)

Click "Add New". A new element (without a model attribute) is added to the list.

7_21_properties_dataelements2.gif (839 Byte)

Change the name (optional). Select the Source.

7_21_properties_dataelements3.gif (772 Byte)

Click "OK". Note that <Data elements> = <selected>.

7_21_properties_dataelements4.gif (348 Byte)


Property: DataIndicator

Page#: 7_22_properties_dataindicator.htm

Property: DataIndicator

Possible values

  • On
  • Off

Property for

  • Page
  • Workarea

Definition

Specifies if a data indicator should be displayed.

Example

In the following layout, the data indicator for the page is on:

7_22_properties_dataindicator.gif (686 Byte)


Property: Decimal position

Page#: 7_23_properties_decimalposition.htm

Property: Decimal position

Possible values

  • Non-negative Integer

Property for

  • EditField . Type = Currency / Number
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Currency / Number
  • ResultField . Type = Currency result / Number result
  • GridList . Property for = Column 1 . Type = Currency / Number

Definition

Number of places after the decimal point.

Example

Assuming the following layout:

7_23_properties_decimalposition.gif (702 Byte)

In the runtime layout:

7_23_properties_decimalposition1.gif (266 Byte)

When entering data, only a maximum of 3 digits after the decimal point can be entered:

7_23_properties_decimalposition2.gif (281 Byte)


Property: Default font

Page#: 7_24_properties_defaultfont.htm

Property: Default font

Possible values

  • A font / fontsize (other font properties can also be selected but are not shown in the Inspector)

Property for

  • Application
  • Border . Type = Border
  • CheckBox
  • ComboBox
  • EditField
  • Label . Type = Label
  • PushButton
  • RadioButton
  • ResultField

Definition

The default font.

See also:

  • Setting the default Application default font.
  • Setting the default Workarea default font.

Example

Assume the following layout:

7_24_properties_defaultfont.gif (689 Byte)

7_24_properties_defaultfont2.gif (1484 Byte)

7_24_properties_defaultfont1.gif (820 Byte)

In the runtime layout the EditField contents would use the default font/size specified above:

7_24_properties_defaultfont3.gif (306 Byte)

Click on the <Default font> value field. A button appears. Click on the button. The "font style" dialog appears. Select the font style and characteristics:

7_24_properties_defaultfont4.gif (5993 Byte)

Click "OK". Note the <Default font> property:

7_24_properties_defaultfont5.gif (882 Byte)

In the runtime layout:

7_24_properties_defaultfont6.gif (381 Byte)


Property: Defolding

Page#: 7_25_properties_defolding.htm

Property: Defolding

Possible values

  • Automatic
  • Manual

Property for

  • Page

Definition

If <Automatic>: A visible node's immediate subnodes are displayed when the workarea is displayed.

If <Manual>: A visible node's immediate subnodes are only displayed when the node icon or text is double-clicked.

Example

Assume the following layout with:

  • Page "Auto1" property <Defolding> = <Automatic>
  • Page "Manual2" property <Defolding> = <Manual>
  • Page "Auto3" property <Defolding> = <Automatic>
    7_25_properties_defolding.gif (1247 Byte)

Upon opening the runtime layout:

7_25_properties_defolding1.gif (528 Byte)

Double-clicking on "Manual2" yields:

7_25_properties_defolding2.gif (829 Byte)

Changing the workareas does not affect the current state of the page tree.

Double-clicking on "Auto1" folds the tree. Double-clicking on "Auto1" again opens the subtree with the unfolded state for the subtree for "Manual2" unchanged.


Property: Devisualize

Page#: 7_26_properties_devisualize.htm

Property: Devisualize

Possible values

  • Selected
  • Not selected

Property for

  • CheckBox . Type = CheckBox
  • RadioButton . Type = RadioButton

Definition

If <Selected>: A page / workarea has been selected as being "devisualized" when the element is selected.

If <Not selected>: Selecting the element has no effect.

Example

Assume the following layout:

7_26_properties_devisualize.gif (1727 Byte)

Assume the following the selected pages/workareas for devisualization:

7_26_properties_devisualize2.gif (711 Byte)

The runtime layout:

7_26_properties_devisualize3.gif (553 Byte)

7_26_properties_devisualize4.gif (492 Byte)


Property: DI Rule

Page#: 7_27_properties_dirule.htm

Property: DI Rule

Possible values

  • Model attribute / property that evaluates to boolean.

Property for

  • Page . DataIndicator = On
  • Workarea . DataIndicator = On

Definition

The rule that determines when the data required / data not required icons will be displayed for the data indicator.

Example

Assume the following layout:

7_27_properties_dirule.gif (1888 Byte)

7_27_properties_dirule1.gif (735 Byte)

Assume the following model:

7_27_properties_dirule2.gif (2620 Byte)

The runtime layout:

7_27_properties_dirule3.gif (977 Byte)

7_27_properties_dirule4.gif (981 Byte)

7_27_properties_dirule5.gif (1004 Byte)


Property: Dialog-Description

Page#: 7_28_properties_dialogdescription.htm

Property: Dialog-Description

Possible values

  • Directory / filename of runtime layout (.vpc)

Property for

  • PushButton . Action = Dialog-Call

Definition

Specifies the runtime layout to be opened as a subdialog when the PushButton is clicked.

Example

Assume the following layout element:

7_28_properties_dialogdescription.gif (1145 Byte)

In the runtime dialog, clicking on the PushButton would open the runtime layout zyx40.vpc in a subdialog.

7_28_properties_dialogdescription1.gif (1009 Byte)


Property: Dll-Description

Page#: 7_29_properties_dlldescription.htm

Property: Dll-Description

Possible values

  • Path and name of the dll description .ini file

Property for

  • PushButton . Action = DLL-Call

Definition

Specifies the directory and filename of the configuration file (.ini) for the dll that is executed when the PushButton is clicked.

Example

Assume the following dialog:

7_29_properties_dlldescription.gif (1063 Byte)

In the runtime layout, when the PushButton is clicked a call to the .dll whose interface is specified in zyx41_kndneu.ini is made.


Property: ElemActiveColor

Page#: 7_30_properties_elemactivecolor.htm

Property: ElemActiveColor

Possible values

  • (0..255,0..255,0..255)

Property for

  • ComboBox . ActivColor = UserDef
  • EditField . ActivColor = UserDef

Definition

Color of the active element.

Example

Assume the following layout element:

7_30_properties_elemactivecolor.gif (989 Byte)

In the runtime layout:

  • Element does not have the focus
    7_30_properties_elemactivecolor1.gif (210 Byte)
  • Element has the focus
    7_30_properties_elemactivecolor2.gif (1043 Byte)


Property: Element3D

Page#: 7_31_properties_element3d.htm

Property: Element3D

Possible values

  • Yes
  • No

Property for

  • CheckBox
  • ComboBox
  • EditField
  • Graphics
  • PushButton
  • RadioButton
  • RadioGroup
  • ResultField

Definition

If Yes: The element is 3 dimensional.

Example

Assume the following layout:

7_31_properties_element3d.gif (1068 Byte)

In the runtime layout:

7_31_properties_element3d1.gif (367 Byte)


Property: Font

Page#: 7_32_properties_font.htm

Property: Font

Possible values

  • A font / fontsize (other font properties can also be selected but are not shown in the Inspector).

Property for

  • CheckBox . Tooltip = Dynamic / Static
  • ComboBox . Tooltip = Dynamic / Static
  • EditField . Tooltip = Dynamic / Static
  • ExtendedGridList . Property for = Column 1
  • ExtendedGridList . Tooltip = Yes
  • Graphics
  • Graphics . Tooltip = Yes
  • GridList . Property for = Column 1
  • GridList . Tooltip = Yes
  • Label . Tooltip = Dynamic / Static
  • Multimedia . Tooltip = Dynamic / Static
  • Page . Tooltip = Yes
  • PushButton . Tooltip = Dynamic / Static
  • RadioButton . Tooltip = Dynamic / Static
  • RadioGroup . Tooltip = Dynamic / Static
  • ResultField . Tooltip = Yes
  • Workarea . Tooltip = Yes

Definition

The default font.

See also: Setting the default Application default font.

Example

Assume the following layout:

7_32_properties_font.gif (1337 Byte)

7_24_properties_defaultfont2.gif (1484 Byte)

7_24_properties_defaultfont1.gif (820 Byte)

In the runtime layout the EditField tooltip would use the default font/size specified above:

7_32_properties_font2.gif (1250 Byte)

Click on the <font> value field. A button appears. Click on the button. The "font style" dialog appears. Select the font style and characteristics:

7_32_properties_font4.gif (6094 Byte)

Click "OK". Note the <font> property:

7_32_properties_font5.gif (1409 Byte)

In the runtime layout:

7_32_properties_font6.gif (1360 Byte)


Property: Footer

Page#: 7_325_properties_footer.htm

v10 000407TTA: pics/text added.

Property: Footer

Possible values

  • No
  • Yes

Property for

  • Application
  • Workarea

Definition

If <Yes>: A footer is added.

Note: If the footer contains no elements: If the layout is saved: The footer is deleted.

Example

Assume the following layout:

7_325_properties_footer.gif (1330 Byte)

Changing Application property <Footer> to <Yes> causes an application footer to be added.

7_325_properties_footer1.gif (3164 Byte)

Changing Workarea property <Footer> to <Yes> causes a workarea footer to be added.

7_325_properties_footer2.gif (3379 Byte)


Property: Format (application)

Page#: 7_331_properties_format.htm

v10 000405TTA XX: non-tta (functional description) text added.

Property: Format (application)

Possible values

  • Individual
  • 640*480
  • 800*600
  • 1024*768

Property for

  • Application

Definition

The format of the application.

Different screen resolutions should be supported by the designer and its runtime.

The appearance of the user interface according to the different screen resolutions is totally defined at design time for three resolutions:

  • Screen resolution: 640 * 480 Pixels
  • Screen resolution: 800 * 600 Pixels
  • Screen resolution 3: 1024 * 768 Pixels

In this case, the first design of the user interface will be done for one of the explicitly previously selected screen resolutions (new application property Screen resolution) the so called primary resolution.

After finishing the GUI-design for the primary resolution, the other layouts (the so called secondary resolutions) can be generated automatically by the VPMS designer (activated through new menu items).

The basic principles of this automatic generation can be influences previously to the generation process by individually determining the appropriate font specifications for each screen resolution (the user can maintain a font map with two rows, the first row refers to source font and the second one contains the corresponding font for target resolution.)

Generating the layouts for the secondary resolutions is done by the VPMS Designer by changing the font for each object (using the font map as lookup information) and repositioning the objects on the screen (recalculating is done by following a proportional factor, that can be either manually defined for each resolution or is determined automatically by the VPMS Designer). Generating the layout for the secondary resolution will cause appearance of a new application open in Designer.

To store the new layout definition with keeping the primary resolution layout a menu option Save as should be used to store the new layout in a new VPL-file.

The different layouts for the screen resolutions can be maintained by the user manually, after they have been generated once. This can be done by switching between the layout definitions within the VPMS Designer (new menu items and actions will be required for this feature, e.g. a dropdown list box in the toolbar with three selectable entries 640*480, 800*600 and 1024 * 768).

To assist the user by keeping the different layouts consistent if one of the layouts was changed, the VPMS Designer has a check synchronicity action, that lists all the possible differences between the primary resolution layout and the secondary resolution layouts in a non-modal report window (dialog box). By following this dialog box, the user can update the layouts of the secondary resolutions manually and keep them identical with the layout of the primary resolution.

At runtime, it is the part of the frame application to pass a parameter to the Designer runtime which resolution layout should be used.

The advantage of this alternative is, that almost no process overhead is required at runtime to support the different screen resolutions (the controls and the whole interface requires no ongoing and time consuming recalculation). The performance impacts will be for seeable minor.

Another advantage is, that the user can define for each screen resolution a total different user interface for the application also (e.g. information, that is spread over several notepages in the 640 * 480 resolution can be combined in a single notepage in the other resolutions).


Property: Format (element)

Page#: 7_33_properties_format.htm

Property: Format (element)

Possible values

  • dd/mm/yy
  • dd/mm/yyyy
  • mm/dd/yy
  • yy/mm/dd
  • dd.mm.yyyy
  • dd-mm-yyyy
  • MMM dd,yyyy
  • dd-MMM-yy

Property for

  • EditField . Type = Date
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Date
  • ResultField . Type = Date result

Definition

The format (selected from a drop-down list) of the date in the element.

Example

Assume the following layout:

7_33_properties_format.gif (1572 Byte)

Assume that the 3 above EditFields have the same <Source>.

In the runtime layout:

7_33_properties_format1.gif (789 Byte)

Entering "010203" in the top EditField results in the following:

7_33_properties_format2.gif (971 Byte)

Note: Invalid input is ignored.


Property: Frame font

Page#: 7_34_properties_framefont.htm

Property: Frame font

Possible values

  • A font / fontsize (other font properties can also be selected but are not shown in the Inspector).

Property for

  • Workarea . Style = Frame

Definition

The default font for the frame text.

See also: Setting the default Workarea default font.

Example

Assume the following layout with the default font for the frame text:

7_24_properties_defaultfont2.gif (1484 Byte)

7_24_properties_defaultfont1.gif (820 Byte)

7_34_properties_framefont.gif (1084 Byte)

Click on the <Frame font> value field. A button appears. Click on the button. The "font style" dialog appears. Select the font style and characteristics:

7_32_properties_font4.gif (6094 Byte)

Click "OK". Note the <Frame font> property (the color is not displayed):

7_34_properties_framefont5.gif (1280 Byte)

In the runtime layout:

7_34_properties_framefont6.gif (563 Byte)


Property: Frame width

Page#: 7_35_properties_framewidth.htm

Property: Frame width

Possible values

  • Non-negative Integer

Property for

  • Workarea . Style = Frame

Definition

The width (in pixels) of a frame in a workarea (workarea with style specified as frame).

Note: The width can also be set by moving the right edge of the frame with the mouse.

See also: Setting the default Frame width.

Example

Assume the following layout with a frame:

7_35_properties_framewidth.gif (811 Byte)

Place the cursor over the right edge of the frame. The cursor changes to a double arrow.

7_35_properties_framewidth2.gif (1242 Byte)

Press and hold the left mouse button. Drag the mouse and then release the left mouse button to change the frame width.

7_35_properties_framewidth3.gif (1390 Byte)

7_35_properties_framewidth4.gif (951 Byte)


Property: FrameMoveable

Page#: 7_36_properties_framemoveable.htm

Property: FrameMoveable

Possible values

  • No
  • Yes

Property for

  • Workarea . Style = Frame

Definition

Specifies if the frame in the runtime layout is "moveable" (ie, can be resized).

Note: The frame is always resizeable in the design-time layout.

Example

Assume the following layout:

7_36_properties_framemoveable.gif (1168 Byte)

In the runtime layout: Note that the cursor does not change to a double arrow for resizing the frame.

7_36_properties_framemoveable1.gif (1362 Byte)

Change <FrameMoveable> = <Yes>.

7_36_properties_framemoveable2.gif (1251 Byte)

Note that the frame can now be resized in the runtime layout:

7_36_properties_framemoveable3.gif (1340 Byte)


Property: Graphics type

Page#: 7_37_properties_graphicstype.htm

v10 000407TTA: link fixed.

Property: Graphics type

Possible values

  • Line
  • Vertical Bar
  • Horizontal Bar
  • Vertical 3D bar
  • Vertical Gantt
  • Horizontal Gantt
  • Pie
  • 3D Pie

Property for

  • Graphics

Definition

Specifies the graphics type.

Examples


Property: Group

Page#: 7_38_properties_group.htm

Property: Group

Possible values

  • Name of RadioButton group

Property for

  • RadioButton . Type = RadioButton

Definition

Defines the Group that the RadioButton belongs to. Only 1 RadioButton in a RadioGroup can be enabled at any time (assuming that the <Source> for each RadioButton is different).

Note: A Group is created by entering the name of the Group in the <Group> drop-down list.

Example

Assume the following layout:

Assume the following model:

In the runtime model:

Note that when selecting the second or third RadioButton, both buttons are selected, since both buttons reference the same <Source>.


Property: Header

Page#: 7_385_properties_header.htm

v10 000407TTA XX: example added. note that when an application header is added, the height of the header is added to the application height (this does not occur when an application footer is added). the application height is also shown incorrectly in the inspector... however, it is corrected (refreshed) as soon as you click in the height field. (build 016).

Property: Header

Possible values

  • No
  • Yes

Property for

  • Application
  • Workarea

Definition

If <Yes>: A header is added.

Note: If the Header contains no elements: If the layout is saved: The header is deleted.

Example

Assume the following layout:

7_385_properties_header.gif (1317 Byte)

Changing Application property <Header> to <Yes> causes an application header to be added.

7_385_properties_header1.gif (2931 Byte)

Changing Workarea property <Header> to <Yes> causes a workarea header to be added.

7_385_properties_header2.gif (3307 Byte)


Property: Header font

Page#: 7_39_properties_headerfont.htm

Property: Header font

Possible values

  • A font / fontsize (other font properties can also be selected but are not shown in the Inspector).

Property for

  • GridList
  • ExtendedGridList

Definition

Specifies the header font.

Example

Assume the following layout ExtendedGrid:

Click on the <Header font> value field. A button appears. Click on the button. The "Font style" dialog appears. Select the font style and characteristics:

Click "OK". Note the <Font> property:


Property: Height (application)

Page#: 7_40_properties_height.htm

Property: Height (application)

Possible values

  • Non-negative Integer.

Property for

  • Application

Definition

Specifies the height of the application.

Example

Assume the following layout:

In the runtime layout:

The mouse change be used to change the Width/Height. Move the mouse over the red-dotted line so that the mouse pointer becomes a double-arrow.

Press and hold the left mouse button while moving the mouse to change the application width/height.


Property: Height (Header/Footer)

Page#: 7_405_properties_heightheader.htm

v10 000407TTA: example added.

Property: Height (Header/Footer)

Possible values

  • No
  • Yes

Property for

  • Application
  • Workarea

Definition

Specifies the height of the Header / Footer.

Example

The following layout has:

  • Application header with <Height> = 10.
  • Workarea header with <Height> = 20.
  • Workarea footer with <Height> = 30.
  • Application footer with <Height> = 40.

7_405_properties_heightheader.gif (2037 Byte)

7_405_properties_heightheader1.gif (2422 Byte)

7_405_properties_heightheader2.gif (2636 Byte)


Property: HelpID

Page#: 7_41_properties_helpid.htm

v10 000407TTA: links fixed.

Property: HelpID

Possible values

  • Integer.

Property for

  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • RadioGroup
  • Graphics
  • Page
  • PushButton
  • Resultfield
  • Workarea

Definition

HelpID for the element.

Example

Assume the following layout EditField

Clicking "F1" in the runtime layout while the above EditField has the focus will cause the HelpID 123 to be sent to the the application help file.


Property: Identification

Page#: 7_42_properties_identification.htm

Property: Identification

Possible values

  • The name of an element on the page.

Property for

  • Page . Multiple = Yes

Definition

Identifies the element on the page that whose attribute value (a string) is the name of each of the multiple pages in the frame.

Example

Assume the following layout:

<Identification> = <EditFieldName> (the name of the EditField):

Note that the available values for <Identification> includes both EditFields.

In the runtime layout:


Property: Identification Grid

Page#: 7_43_properties_identificationgrid.htm

Property: Identification Grid

Possible values

  • Specification of a grid.

Property for

  • Graphics

Definition

The name of the source grid for the graphic.

Example

Assume the following layout with a Graphics and the source Grid:

In the runtime layout


Property: Indexed

Page#: 7_435_properties_indexed.htm

v10 XX 000407TTA: text and pics added. i tried to get something to work with index=no... but nothing worked. i have no idea why you would use it with index=no.

also note: this property is displayed improperly in the inspector. normally, when a property only appears if another property is set to a certain value, then that property is displayed as a "subproperty" in the inspector. not so with "indexed".

Property: Indexed

Possible values

  • Yes
  • No

Property for

  • IF (ExtendedGrid . Usage = Output) : ExtendedGrid . Property. Indexed

Definition

Specifies that the value to be angezeigt in an ExtendedGrid column is indexed in the model.

Example

Assume the following model with property <Folge(i)> in the upper branch and p_PremiumP2Each(i) in the lower branch.

7_435_properties_indexed.gif (2013 Byte)

7_435_properties_indexed1.gif (2577 Byte)

The layout would require having <Zeilen-Indizierung> = <Ja> for columns that display the properties.

7_435_properties_indexed2.gif (1940 Byte)

7_435_properties_indexed3.gif (2175 Byte)

7_435_properties_indexed4.gif (2138 Byte)


Property: Iteration count

Page#: 7_44_properties_iterationcount.htm

v10 000407TTA: link fixed.

Property: Iteration count

Possible values

  • A non-negative Integer

Property for

  • Grid . Iteration type = Counter

Definition

The number of iterations in a Grid.

Example

Assume the following layout

In the runtime layout, note that 3 iterations are always included in the Grid, regardless of how many multiple pages exist (note that only the first 3 are displayed).


Property: Iteration property

Page#: 7_45_properties_iterationproperty.htm

v10 000407TTA: linked fixed.

Property: Iteration property

Possible values

  • Property.

Property for

  • Grid . Iteration type = Property

Definition

The property that controls iteration.

Example

Assume the following layout Grid:

Assume the multiple subpages <Count attribute> = <a_Persons>.

Assume the model

In the runtime model, the number of iterations is determined by the value of p_NumberCustomers.


Property: Iteration type

Page#: 7_46_properties_iterationtype.htm

v10 000407TTA: linked fixed.

Property: Iteration type

Possible values

  • Attribute
  • Property
  • Counter

Property for

  • Grid

Definition

The iteration type.

Example

For the following Grid, the number of iterations would be dynamic and = a_Persons

For the following Grid, the number of iterations would be dynamic and = model product property p_NumberCustomers:

For the following Grid, the number of iterations would always = 3:


Property: Key column

Page#: 7_47_properties_keycolumn.htm

Property: Key column

Possible values

  • Positive Integer

Property for

  • Graphics
  • GridList

Definition

For Grid: Specifies the Grid key column. The key column is the index for the data array.

For Graphics: Specifies the source Grid key column for the Graphics x-axis pointer.

Example

Assume the following layout Grid:

7_47_properties_keycolumn.gif (2890 Byte)

Assume the following layout Graphic (with the above Grid as the source):

7_47_properties_keycolumn1.gif (2246 Byte)

In the runtime layout:

7_47_properties_keycolumn2.gif (1463 Byte)

7_47_properties_keycolumn3.gif (1041 Byte)


Property: Left

Page#: 7_48_properties_left.htm

Property: Left

Possible values

  • Non-negative Integer

Property for

  • PushButton . Action = Dialog-Call

Definition

Number of pixels that the subdialog left edge is to the right of the calling dialog (with the PushButton) left edge.

Example

Assume the following layout:

7_79_properties_top.gif (673 Byte)

In the runtime layout, the subdialog upper left corner would correspond with the calling dialog upper left corner:

7_79_properties_top1.gif (367 Byte)

With <Left> = 50:

7_48_properties_left2.gif (603 Byte)


Property: Legend placement

Page#: 7_49_properties_legendplacement.htm

Property: Legend placement

Possible values

  • Right
  • Bottom

Property for

  • Graphics

Definition

Location of the graphic legend.

Examples

7_49_properties_legendplacement.gif (1693 Byte)

7_49_properties_legendplacement1.gif (1796 Byte)


Property: Level

Page#: 7_50_properties_level.htm

Property: Level

Possible values

  • Level0 ... Level7

Property for

  • 3DBorder
  • Border
  • CheckBox
  • ComboBox
  • EditField
  • ExtendedGridList
  • Graphics
  • GridList
  • Label
  • Line
  • Multimedia
  • PushButton
  • RadioButton
  • RadioGroup
  • ResultField

Definition

The level on which the element is located.

Example

Assume that all levels are displayed:

7_50_properties_level1.gif (4034 Byte)

Assume the following layout:

7_50_properties_level.gif (1044 Byte)

Deselecting levels 3-5

7_50_properties_level2.gif (632 Byte)

would result in the following:

7_50_properties_level3.gif (387 Byte)


Property: List (...;...)

Page#: 7_501_properties_list.htm

Property: List (...;...)

Possible values

  • A list of model product results separated by semicolons.

Property for

  • EditField . ChkOwnAvailibility = List
  • ComboBox . ChkOwnAvailibility = List
  • CheckBox . ChkOwnAvailibility = List
  • RadioButton . ChkOwnAvailibility = List
  • PushButton . ChkOwnAvailibility = List
  • Label . ChkOwnAvailibility = List
  • Border . ChkOwnAvailibility = List
  • RadioGroup . ChkOwnAvailibility = List

Definition

Specifies a result list for availibility.


Property: Mask

Page#: 7_51_properties_mask.htm

v10 000407TTA: text/pics added.

Property: Mask

Possible values

Any combination of the following symbols:

  • # (digit)
  • N (digit; default = 0)
  • & (digit or system decimal limiter)
  • X (letter)
  • C (letter; default = [space])
  • U (letter; converted to upper case on entry)
  • L (letter; converted to lower case on entry)
  • ? (any character)
  • / (signifies that the next character is a delimiter)

Property for

  • EditField . Type = Mask
  • Extended Grid . Property for = Column (column number) . Usage = Input . Type = Mask
  • ResultField . Type = Mask result

Definition

For EditField: Defines the acceptable input and how that input maybe be modified upon entry.

For ResultField: Defines how the result will be modified before output.

Example

Assume the following layout:

The first EditField uses a mask to mask input:

7_51_properties_mask.gif (1744 Byte)

The second EditField displays (without a mask) the attribute entered in the first mask.

7_51_properties_mask1.gif (1017 Byte)

The ResultField displays with a mask the attribute entered in the first mask.

7_51_properties_mask2.gif (939 Byte)

Upon opening the runtime layout:

7_51_properties_mask3.gif (471 Byte)

Placing the cursor at the start of the top EditField and then pressing any combination of character keys will have no effect (the first 2 digits must be numbers (##)).

After the first 2 number have been entered, then any 2 letters must be entered (XX).

Next any 2 letters must be entered; the letters will be converted to uppercase (UU).

Next any 2 letters must be entered; the letters will be converted to lowercase (LL).

Next any 2 numbers/letters can be entered (??).

The last 4 characters do not have to be entered; If not entered, they will automatically be set to 2 space characters and 2 zeros (CCNN).

Entering "12aBcDeF3g" would result in the following:

7_51_properties_mask4.gif (782 Byte)

Note in the second Edit Field that a default of " 00" (space + space + 00) was added.

Note in the ResultField that "b" is lowercase, "E" is uppercase, and that an error was generated (extra space inserted) when 3 appeared in a location that should be displayed in lowercase.


Property: MaxFrameWidth

Page#: 7_52_properties_maxframewidth.htm

v10 000407TTA: link fixed.

Property: MaxFrameWidth

Possible values

  • Integer.

Property for

  • Workarea . Style = Frame . FrameMoveable = Yes

Definition

Specifies the maximum frame width.

Example

Assume the following frame in the layout:

In the runtime, the frame width can be changed to any size. In the following example, the right edge of the frame is to the left of the left edge of the workarea (the frame width is actually negative):

Assume the following frame in the layout:

In the runtime layout, the right edge of the frame can be dragged any distance to the right:

However, after releasing the right mouse button, the right edge of the frame will be set at <MaxFrameWidth>.


Property: Maximum

Page#: 7_53_properties_maximum.htm

Property: Maximum

Possible values

  • Non-negative Integer

Property for

  • EditField . Type = Currency / Number / Text
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Currency / Number / Text

Definition

The maximum number of digits/characters that can be entered.

Note: If <Maximum> = 0: No maximum limit is set.

Example

Assume the following layout with a text EditField with <Maximum> = 10.

7_53_properties_maximum.gif (1145 Byte)

In the runtime layout, a maximum of 10 characters can be entered:

7_53_properties_maximum1.gif (389 Byte)


Property: Media file

Page#: 7_54_properties_mediafile.htm

v10 000407TTA: link fixed.

Property: Media file

Possible values

  • Path and name of media file.

Property for

  • Multimedia . Type = Media

Definition

Specifies the media file.

Example

Assume the following layout:

3_04_3_3_medialfiles.gif (5813 Byte)

In the runtime layout the .avi file would be played:

3_04_3_3_medialfiles1.gif (718 Byte)


Property: MinFrameWidth

Page#: 7_55_properties_minframewidth.htm

v10 000407TTA: link fixed.

Property: MinFrameWidth

Possible values

  • Integer.

Property for

  • Workarea . Style = Frame . FrameMoveable = Yes

Definition

Specifies the minimum frame width.

Example

Assume the following frame in the layout:

In the runtime, the frame width can be changed to any size. In the following example, the right edge of the frame is to the left of the left edge of the workarea (the frame width is actually negative):

Assume the following frame in the layout:

In the runtime layout, the right edge of the frame can be dragged any distance to the left:

However, after releasing the right mouse button, the right edge of the frame will be set at <MinFrameWidth>.


Property: Minimum

Page#: 7_56_properties_minimum.htm

Property: Minimum

Possible values

  • Non-negative Integer

Property for

  • EditField . Type = Currency / Number / Text
  • ExtendedGridList . Property for = Column 1 . Usage = Input . Type = Currency / Number / Text

Definition

The minimum number of digits/characters required for entry. If the minimum number is not entered: The focus cannot be switched to another layout component.

Note: If <Minimum> = 0: No minimum is set.

Example

Assume the following layout with a text EditField with <Minimum> = 5.

7_56_properties_minimum.gif (1150 Byte)

In the runtime layout: If less than 5 characters have been entered in the EditField: Clicking on another element does not change the focus.


Property: Multiline

Page#: 7_57_properties_multiline.htm

Property: Multiline

Possible values

  • Yes
  • No

Property for

  • CheckBox . Type = CheckBox
  • RadioButton . Type = RadioButton
  • EditField . Type = Text
  • Label . Type = Label
  • ResultField . Type = Result

Definition

If <Yes>: The element can accept multiline input (with each line separated by a carriage return).

Example

Assume the following layout:

7_57_properties_multiline.gif (2116 Byte)

Note that the left EditField is multiline and that the right EditField is single line.

In the runtime layout entering the following lines

  • a very very long first line
  • third line
  • fourth line

would result in the following:

7_57_properties_multiline2.gif (1176 Byte)

Note: To view the text "fourth line": Click in the left EditField and scroll down.


Property: Multiple

Page#: 7_58_properties_multiple.htm

v10 000407TTA: link added.

Property: Multiple

Possible values

  • No
  • Yes

Property for

  • Page

Definition

If <Yes>: Multiple pages can be created.

Example

Assume the following page with <Multiple> = <Yes>.

In the runtime layout: Multiple pages can be created:


Property: Name

Page#: 7_59_properties_name.htm

Property: Name

Possible values

  • Model attribute name

Property for

  • Application . StartAttr = Constant / Dynamic

Definition

The name of the application start attribute (a model attribute).

Example

Assume the following layout:

7_59_properties_name.gif (1845 Byte)

When the runtime layout is opened, the model attribute a_Variable2 = 1234:

7_59_properties_name2.gif (235 Byte)


Property: Name (Workarea / Page)

Page#: 7_595_properties_name_workareapage.htm

Property: Name (Workarea/Page)

Possible values

  • Model attribute name

Property for

  • Workarea . Visible = Property
  • Page . Visible = Property

Definition

If the model attribute specified by <Name> is an Integer > 0: The Workarea / Page is visible.


Property: New Session

Page#: 7_60_properties_newsession.htm

v10 000405TTA XX: non-tta (from functional description) text added. link added.

Property: New Session

Possible values

  • No
  • Yes

Property for

  • PushButton . Action = Dialog-Call

Definition

If <Yes>: The dialog opened by clicking on the PushButton is opened in a different session.

This property indicates, whether the secondary dialog uses the same VP/MS session as the parent application (value No), or opens a new session using the VP/MS model name described in its VPL-file (value Yes ). If the secondary dialog uses a new session, it will have no any impact on the state of the VP/MS model of the parent application. Default value is No.

Example

Assume the following "parent" layout with the PushButton property <New Session> = <Yes>:

Assume the following "child" layout:

Assume the following model:

In the runtime layout, clicking on the "Get the data" PushButton opens a child dialog in a new session. Entering the values for A and B

and then pressing the "OK

Note that the data was entered in a new session, and therefore is not available in the parent dialog.

If <New Session> is changed to <No>

and the above steps are repeated, then the result is calculated:


Property: Next line

Page#: 7_61_properties_nextline.htm

v10 000407TTA: link added. XX: text also changed... i am not sure if what i wrote here is correct.... if so, then "Next line" is a very uncorrect name for the property.

Property: Next line

Possible values

  • Positive Integer.

Property for

  • Grid . Property for = Column (column number) . Usage = Input

Definition

Specifies the column that uses the contents of the selected column for generating the index value for an array.

Example

Assume the following Grid in the layout:

For column 5 <Next line> = 1. Thus the value in column 5 will be used as the input into the model equation that defines the value for column 1 (Folge()).

The next value for column 5 comes from the previous row in the column that generated the value (column 1). Therefore the value in row 2 for column 5 is "[Nr]-1".

<Next line> = 1. Therefore, the value for column "Folge" in the second row will be the value from column "Nr" in the previous row ("[Nr]-1").

Assume the following model with Folge(i) = i+1 (i = iteration counter).

In the runtime layout, the value for row 1 of column 1 is 1 (0 from row 1 column 5 plus 1). The value for row 2 of column 5 is from row 1 of column 1 (1). Thus the value generated for row 2 of column 2 is 2 (1 + 1).


Property: Number of columns

Page#: 7_62_properties_numberofcolumns.htm

v10 000407TTA: link added.

Property: Number of columns

Possible values

  • Positive Integer.

Property for

  • RadioGroup . Type = RadioButton

Definition

Number of horizontal colums for the RadioGroup.

Example

Assume the following layout:

Assume the following model:

In the runtime layout:


Property: Off conversion List

Page#: 7_63_properties_offconversionlist.htm

Property: Off conversion List

Possible values

  • Name of a model attribute

Property for

  • CheckBox . Type = CheckBox

Definition

Specifies the model attribute whose property <table> references the (OFF) conversion table when the CheckBox is NOT selected.

Example

Assume the following layout:

7_16_properties_conversionlist.gif (1536 Byte)

Assume the following model:

7_16_properties_conversionlist5.gif (1816 Byte) 7_16_properties_conversionlist6.gif (1102 Byte)

7_63_properties_offconversionlist.gif (537 Byte) 7_63_properties_offconversionlist1.gif (992 Byte) 7_63_properties_offconversionlist2.gif (598 Byte)

In the runtime model, the attribute a_X would be converted to a_X_OffConvert.default when the CheckBox is NOT checked:

7_63_properties_offconversionlist3.gif (473 Byte)


Property: Off symbol

Page#: 7_64_properties_offsymbol.htm

Property: Off symbol

Possible values

  • filename (of symbol .bmp file)

Property for

  • Page . DataIndicator = On
  • Workarea . DataIndicator = On

Definition

The symbol .bmp file contains 2 icons for indicating when all required data has been entered and when not entered.

See also:

  • Specifying directory of symbol files (DI path).

Example

Assume the following DI path:

7_641_properties_onsymbol.gif (1761 Byte) 7_641_properties_onsymbol1.gif (623 Byte)

Clicking in the <Off symbol> property area in the Inspector and clicking on the resulting button opens the "Select Data Indicator" dialog:

7_641_properties_onsymbol2.gif (4016 Byte)

Clicking on a DI icon and clicking on "OK" selects the DI icon for the element. Note, however, that the icon is not shown in the design-time layout:

7_64_properties_offsymbol3.gif (1409 Byte)

In the runtime layout:

  • Required data not entered (fireoff.bmp icon):
    7_64_properties_offsymbol4.gif (479 Byte)
  • Required data entered (default icon):
    7_64_properties_offsymbol5.gif (461 Byte)


Property: On symbol

Page#: 7_641_properties_onsymbol.htm

Property: On symbol

Possible values

  • filename (of symbol .bmp file)

Property for

  • Page . DataIndicator = On
  • Workarea . DataIndicator = On

Definition

The symbol .bmp file contains 2 icons for indicating when all required data has been entered and when not entered.

See also:

  • Specifying directory of symbol files (DI path).

Example

Assume the following DI path:

7_641_properties_onsymbol.gif (1761 Byte) 7_641_properties_onsymbol1.gif (623 Byte)

Clicking in the <On symbol> property area in the Inspector and clicking on the resulting button opens the "Select Data Indicator" dialog:

7_641_properties_onsymbol2.gif (4016 Byte)

Clicking on a DI icon and clicking on "OK" selects the DI icon for the element. Note, however, that the icon is not shown in the design-time layout:

7_641_properties_onsymbol3.gif (946 Byte)

In the runtime layout:

  • Required data not entered (default icon):
    7_641_properties_onsymbol4.gif (483 Byte)
  • Required data entered (fireon.bmp icon):
    7_641_properties_onsymbol5.gif (529 Byte)


Property: Order

Page#: 7_65_properties_order.htm

000407TTA XX: does anyone understand what this property is for??

Property: Order

Possible values

  • Individual
  • Standard

Property for

  • Page

Definition

The order in which the pages are displayed.


Property: Position (Footer)

Page#: 7_653_properties_position_footer.htm

v10 000407TTA: example added.

Property: Position (Footer)

Possible values

  • Right
  • Bottom

Property for

  • Workarea

Definition

Specifies the position of the Footer in relation to the workarea.

Example

Footer with <Position> = <Right>.

7_653_properties_position_footer.gif (3031 Byte)

Footer with <Position> = <Under>.

7_653_properties_position_footer1.gif (3030 Byte)


Property: Position (Header)

Page#: 7_655_properties_position_header.htm

v10 000407TTA: example added.

Property: Position (Header)

Possible values

  • Right
  • Top

Property for

  • Workarea

Definition

Specifies the position of the header in relation to the workarea.

Example

Header with <Position> = <Right>.

7_655_properties_position_header.gif (2980 Byte)

Header with <Position> = <Top>.

7_655_properties_position_header1.gif (2985 Byte)


Property: Productmodel

Page#: 7_66_properties_productmodel.htm

v10 000407TTA: link added.

Property: Productmodel

Possible values

  • Path and name of .vpm file.

Property for

  • Application

Definition

The compiled product model (.vpm) linked to the layout.

Example

Assume the 2 models:

Assume the following layout with <Productmodel> = <model1.vpm>:

In the runtime layout:

Changing to <Productmodel> = <model2.vpm>:

In the runtime layout:


Property: Property

Page#: 7_67_properties_property.htm

v10 000407TTA: text and example added.

Property: Property

Possible values

  • A model property to links to a model attribute.

Property for

  • ExtendedGrid . Visible = Value
  • Grid . Property for = Column 1 . Usage = Output
  • Grid . Visible = Value
  • ResultField . Source = <Empty> . Visible = Value

Definition

The model property that provides access to the model variable.

Example

Assume the following model:

7_67_properties_property1.gif (2706 Byte)

7_67_properties_property2.gif (2321 Byte)

Note the model properties provide access to the model attributes.

Assume the following layout Grid.

7_67_properties_property.gif (3643 Byte)

Note that column 2 displays p_NextLine().

Column 3 displays p_Data() (<Property>=<p_Data()>).

Column 4 displays p_Result() (<Property>=<p_Result()>).


Property: Property for

Page#: 7_68_properties_propertyfor.htm

v10 000407TTA: links, example added.

Property: Property for

Possible values

  • Column.

Property for

  • Grid
  • ExtendedGrid
  • Graphics

Definition

Specifies the column that the properties are listed for.

Example

Assume the following layout ExtendedGrid:

7_68_properties_propertyfor.gif (1817 Byte)

The following shows the properties for column 1 only. Each column has its own set of these properties.

7_68_properties_propertyfor1.gif (1402 Byte)


Property: Series

Page#: 7_69_properties_series.htm

v10 000407TTA: example added.

Property: Series

Possible values

  • Integer.

Property for

  • Graphics

Definition

The number of series in the graphic.

Example

The following graphic has 5 series.

7_69_properties_series.gif (2556 Byte)


Property: Source

Page#: 7_70_properties_source.htm

v10 000407TTA: links, example added.

Property: Source

Possible values

  • Attribute.

Source

  • CheckBox
  • ComboBox
  • EditField
  • PushButton
  • RadioButton
  • RadioGroup
  • ResultField

Definition

The source attribute for the element.

Example

The following EditField has model property a_Variable1 as its source.

7_70_properties_source.gif (1321 Byte)


Property: StartAttr

Page#: 7_71_properties_startattr.htm

v10 000407TTA: links, example added.

Property: StartAttr

Possible values

  • No
  • Constant
  • Dynamic

Property for

  • Application

Definition

The type of start attribute for the application.

Beispiel

Folgendes Layout with a constant StartAttr:

7_59_properties_name.gif (1866 Byte)

Wenn das Runtime Layout geöffnet ist, ist das Modell-Attribut a_Variable2 = 1234:

7_59_properties_name2.gif (285 Byte)


Property: Strict check

Page#: 7_72_properties_strictcheck.htm

v10 000407TTA: links added.

Property: Strict check

Possible values

  • No
  • Yes

Property for

  • EditField . Type = Currency / Date / Mask / Number / Text
  • ExtendedGrid . Property for = Column 1 . Usage = Input . Type = Currency / Date / Mask / Number / Text

Definition

Specifies if a strict check.


Property: Style (application)

Page#: 7_73_properties_style.htm

v10 000407TTA: link added.

Property: Style (application)

Possible values

  • Notebook
  • Simple

Property for

  • Application

Definition

Specifies the application style (notebook or simple).

Default setting.

Example

The following application has style Notebook:

2__2_1_2_applstyle.gif (1334 Byte)

The following application has style Simple. Note that the other notebook pages were simply deleted (when converting to simple only 1 page can remain).

2__2_1_2_applstyle2.gif (826 Byte)


Property: Style (workarea)

Page#: 7_731_properties_style.htm

v10 000407TTA: links, example added.

Property: Style (workarea)

Possible values

  • Simple
  • Frame

Property for

  • Workarea

Definition

Specifies the workarea style (simple or frame)

Example

The following workarea has style Einfach:

7_731_properties_style.gif (1393 Byte)

The following workarea has style Frame. Note that when first created the frame contains only 1 page.

7_731_properties_style1.gif (1709 Byte)

When changing from Style frame to Einfach, a prompt appears requesting which page will not be deleted (all other pages will be deleted).


Property: Tab color

Page#: 7_75_properties_tablecolor.htm

v10 000407TTA: example added.

Property: Tab color

Possible values

  • (0..255,0..255,0..255)

Property for

  • Workarea

Definition

The color of the workarea tab.

Example

7_75_properties_tablecolor.gif (1700 Byte)


Property: Tab font

Page#: 7_74_properties_tabfont.htm

v10 000407TTA XX: text/example added. pics are wrong... for some reason i got german dialog for schriftart.

Property: Tab font

Possible values

  • font, font size

Property for

  • Application . Style = Notebook

Definition

The font style for the workarea tabs.

Example

In the following layout the font for the workarea tabs is the default.

7_74_properties_tabfont.gif (1841 Byte)

Clicking in the cell to the right of "Tab Schrift" causes a button to appear:

7_74_properties_tabfont1.gif (1527 Byte)

Clicking the button causes the "Schriftart" window to appear. The properties for the new schrift can be selected:

7_74_properties_tabfont2.gif (6228 Byte)

The new schrift then appears in the workarea tabs:

7_74_properties_tabfont3.gif (1233 Byte)

Note: To change the font back to the default value, reopen the Schriftart dialog, delete all settings, and click OK:


Property: Title

Page#: 7_76_properties_title.htm

v10 000407TTA: links/example added.

Property: Title

Possible values

  • Text.

Property for

  • Application
  • Border . Type = Border
  • CheckBox . Type = CheckBox
  • GridList . Property for = Column 1
  • ExtendedGridList . Property for = Column 1
  • Label . Type = Label
  • Page
  • PushButton
  • RadioButton . Type = RadioButton
  • Workarea

Definition

The title.

Example

The following layout contains:

  • Workarea with <Title>=<Area2>.
  • Workarea with <Title>=<Area3>.
  • Label with <Title>=<Label title>.
  • Checkbox with <Title>=<Checkbox title>.

7_76_properties_title.gif (2169 Byte)


Property: Tooltip (static/dynamic)

Page#: 7_77_properties_tooltip.htm

v10 000407TTA: links added.

Property: Tooltip (static/dynamic)

Possible values

  • No (default)
  • Static
  • Dynamic

Property for

  • CheckBox
  • ComboBox
  • EditField
  • Label
  • Multimedia
  • PushButton
  • RadioButton
  • RadioGroup

Definition

Specifies a static tooltip or dynamic tooltip.


Property: Tooltip (static only)

Page#: 7_771_properties_tooltip.htm

v10 000407TTA: links/example added.

Property: Tooltip (static only)

Possible values

  • No
  • Yes

Property for

  • ExtendedGridList
  • Graphics
  • GridList
  • Page (if Bereich <Stil>=<Frame>)
  • ResultField
  • Workarea (if Anwendung <Stil>=<Notebook>)

Definition

Specifies a static tooltip.

Example

Assume the following layout with bereich and seite tooltips.

7_771_properties_tooltip.gif (2248 Byte)

7_771_properties_tooltip1.gif (1502 Byte)

In the runtime layout:

7_771_properties_tooltip2.gif (1731 Byte)

7_771_properties_tooltip3.gif (1649 Byte)


Property: Tooltip text

Page#: 7_78_properties_tooltiptext.htm

v10 000407TTA: links/example added.

Property: Tooltip text

Possible values

  • Text (can include "/p" for multiline tooltips).

Property for

  • CheckBox . Tooltip = Dynamic / Static
  • ComboBox . Tooltip = Dynamic / Static
  • EditField . Tooltip = Dynamic / Static
  • ExtendedGridList . Tooltip = Yes
  • Graphics . Tooltip = Yes
  • GridList . Tooltip = Yes
  • Label . Tooltip = Dynamic / Static
  • Multimedia . Tooltip = Dynamic / Static
  • Page . Tooltip = Yes
  • PushButton . Tooltip = Dynamic / Static
  • RadioButton . Tooltip = Dynamic / Static
  • RadioGroup . Tooltip = Dynamic / Static
  • ResultField . Tooltip = Yes
  • Workarea . Tooltip = Yes

Definition

The tooltip text.

Use "/p" for a carriage return for multiple-line tooltips.

The tooltip properties Background color and font can also be specified.

Example

The following EntryField has property <Tooltip text> set to "(tooltip text)".

7_78_properties_tooltiptext.gif (1313 Byte)

The following Eingabefeld has multi-line tooltip text.

Layout:

7_78_properties_tooltiptext1.gif (1392 Byte)

Runtime layout:

7_78_properties_tooltiptext2.gif (1497 Byte)


Property: Top

Page#: 7_79_properties_top.htm

Property: Top

Possible values

  • Non-negative Integer

Property for

  • PushButton . Action = Dialog-Call

Definition

Number of pixels that the subdialog top edge is below the calling dialog (with the PushButton) top edge.

Example

Assume the following layout:

7_79_properties_top.gif (673 Byte)

In the runtime layout, the subdialog upper left corner would correspond with the calling dialog upper left corner:

7_79_properties_top1.gif (367 Byte)

With <Top> = 50:

7_79_properties_top2.gif (807 Byte)


Property: Type (entry elements)

Page#: 7_80_properties_type_entry.htm

Property: Type (entry elements)

Possible values

  • Text
  • Date
  • Currency
  • Number
  • ComboBox
  • RadioButton
  • CheckBox
  • RadioGroup
  • Mask

Property for

The following list shows: Type of element (Corresponding property).

  • Text EditField(Text)
  • Date EditField(Date)
  • Currency EditField(Currency)
  • Number EditField(Number)
  • ComboBox(ComboBox)
  • RadioGroup(RadioButton)
  • CheckBox(CheckBox)
  • RadioGroup(RadioGroup)
  • Mask (Mask)

Definition

Specifies the type of entry element. Changing the property will change the type of element.

Example

Assume the following layout RadioGroup

Assume the following model:

In the runtime layout:

Assume that the layout element <Type> is changed to <ComboBox>:

In the runtime layout:


Property: Type (ExtendedGrid column)

Page#: 7_807_properties_type_extgridcol.htm

Property: Type (ExtendedGrid column)

Possible values

  • Text
  • Number
  • Currency
  • Date
  • Mask
  • ComboBox (available if <Usage> = <Input>)

Property for

  • ExtendedGrid column

Definition

Specifies the type of EntryField/data in the column (the ComboBox contains text).

Example

Assume the following layout ExtendedGrid:

Assume the following model:

In the runtime layout, data can be entered for column 2 with a ComboBox:


Property: Type (ExtendedGrid)

Page#: 7_805_properties_type_extgrid.htm

Property: Type (ExtendedGrid)

Possible values

  • "Extended Grid"

Property for

  • ExtendedGrid

Definition

Specifies the type of element.


Property: Type (GraphicsElement)

Page#: 7_803_properties_type_graphics.htm

Property: Type (GraphicsElement)

Possible values

  • "Graphics"

Property for

  • GraphicsElement

Definition

Specifies the type of element.


Property: Type (Grid column)

Page#: 7_806_properties_type_gridcol.htm

v10 000407TTA: example added.

Property: Type (Grid column)

Possible values

  • Text
  • Number
  • Currency

Property for

  • Grid column

Definition

Specifies the type of data in the column.

Example

Assume the following layout Grid:

7_806_properties_type_gridcol.gif (2554 Byte)

7_806_properties_type_gridcol1.gif (1342 Byte)

7_806_properties_type_gridcol2.gif (1217 Byte)

7_806_properties_type_gridcol3.gif (1368 Byte)

7_806_properties_type_gridcol4.gif (1708 Byte)

In the runtime layout:

7_806_properties_type_gridcol5.gif (1509 Byte)


Property: Type (Grid)

Page#: 7_804_properties_type_grid.htm

Property: Type (Grid)

Possible values

  • "Grid"

Property for

  • Grid

Definition

Specifies the type of element.


Property: Type (result elements)

Page#: 7_801_properties_type_result.htm

v10 000407TTA: example added.

Property: Type (result elements)

Possible values

  • (Text) Result
  • Number result
  • Currency Result
  • Date Result
  • Mask (Result)

Property for

The following list shows: Type of element (Corresponding property).

  • (Text)Result (Result)
  • NumberResult (Number result)
  • CurrencyResult (Currency result)
  • DateResult (Date result)
  • MaskResult (Mask result)

Definition

Specifies the type of result element. Changing the property will change the type of element.

Example

Assume the following layout:

7_801_properties_type_result1.gif (1468 Byte)

Assume the following layout:

7_801_properties_type_result.gif (1260 Byte)

In the runtime layout:

7_801_properties_type_result2.gif (1299 Byte)

7_801_properties_type_result3.gif (1349 Byte)


Property: Type (visual elements)

Page#: 7_802_properties_type_visual.htm

Property: Type (visual elements)

Possible values

  • 3D-Area
  • Border
  • Label
  • Line
  • Media

Property for

  • Label
  • Border
  • 3D Border
  • Line
  • Multimedia

Definition

Specifies the type of visual element. Changing this property will change the element accordingly.

Example

Assume the following layout Label:

Changing <Type> to <Border> changes the element to a Border with the same text for the title.


Property: Usage

Page#: 7_81_properties_useage.htm

Property: Usage

Possible values

  • Input
  • Output

Property for

  • ExtendedGridList . Property for = Column 1
  • GridList . Property for = Column 1

Definition

The usage (input or output) of the column.

Example

Assume the following layout ExtendedGrid:

In the runtime layout: Data can be entered in column 2 and not entered in column 4.


Property: Value

Page#: 7_82_properties_value.htm

Property: Value

Possible values

  • Any alpha-numeric value

Property for

  • Application . StartAttr = Constant

Definition

Specifies the value for the constant start attribute.

Example

Assume the following application with <StartAttr> = <Constant>, <Name> = <a_A>, and <Value> = 123.

When the runtime layout is opened:

Note: If model attribute <a_A> has property <default> defined: The value specified for the model default will be used.


Property: Version

Page#: 7_821_properties_version.htm

Property: Version

Possible values

  • Any text.

Property for

  • Application . Version info = Yes
  • Workarea . Version info = Yes
  • Page . Version info = Yes
  • EditField . Version info = Yes
  • ComboBox . Version info = Yes
  • CheckBox . Version info = Yes
  • RadioButton . Version info = Yes
  • PushButton . Version info = Yes
  • Label . Version info = Yes
  • Border . Version info = Yes
  • Grid . Version info = Yes
  • ExtendedGrid . Version info = Yes
  • 3D Border . Version info = Yes
  • Line . Version info = Yes
  • Multimedia . Version info = Yes
  • ResultField . Version info = Yes
  • RadioGroup . Version info = Yes
  • Graphic . Version info = Yes

Definition

The text entered as the version for the layout component in the dialog "Version information" (the version text cannot be entered in the Inspector field).

Example

Assume that the element version support default = <Yes>. If an EditField is added to the layout, <Version> = <1.0> by default.

This value can be changed in the "Version information" dialog. To open the dialog, click in the field that contains the version text and click on the resulting directory button.


Property: Version info

Page#: 7_83_properties_versioninfo.htm

Property: Version info

Possible values

  • No
  • Yes

Property for

  • Application
  • Workarea
  • Page
  • EditField
  • ComboBox
  • CheckBox
  • RadioButton
  • PushButton
  • Label
  • Border
  • Grid
  • ExtendedGrid
  • 3D Border
  • Line
  • Multimedia
  • ResultField
  • RadioGroup
  • Graphic

Definition

  • If Yes: Commentary (version info) can be entered for the layout component.
  • If set to No: Commentary for the layout component is deleted.

Example

For an example: See Commentary .


Property: Visible (element)

Page#: 7_84_properties_visible.htm

v10 000329TTA: last edit

Property: Visible (element)

Possible values

  • Yes
  • No
  • Check
  • Value

Property for

  • ExtendedGridList
  • GridList
  • ResultField . Source = <Empty>

Definition

Specifies the visibility of the element.

Examples

For examples of visibility see:

  • Setting the default value.
  • Concepts: Visibility.


Property: Visible (Workarea/Page)

Page#: 7_845_properties_visible_workareapage.htm

NOTE XX : a default setting option has not been added for workarea / page (build013).

Property: Visible (Workarea/Page)

Possible values

  • Yes
  • No
  • Property

Property for

  • Workarea
  • Page

Definition

Specifies the visibility of the workarea/page.

Examples

For examples of visibility see:

  • Setting the default value.
  • Concepts: Visibility.


Property: Visualize

Page#: 7_85_properties_visualize.htm

Property: Visualize

Possible values

  • Selected
  • Not selected

Property for

  • CheckBox . Type = CheckBox
  • RadioButton . Type = RadioButton

Definition

If <Selected>: A page / workarea has been selected as being "visualized" when the element is selected.

If <Not selected>: Selecting the element has no effect.

Example

Assume the following layout:

7_85_properties_visualize.gif (1665 Byte)

Assume the following the selected pages/workareas for visualization:

7_85_properties_visualize2.gif (661 Byte)

The runtime layout:

7_85_properties_visualize3.gif (474 Byte)

7_85_properties_visualize4.gif (542 Byte)


Property: Width (application)

Page#: 7_851_properties_widthapplication.htm

Property: Width (application)

Possible values

  • Non-negative Integer

Property for

  • Application

Definition

Specifies the width of the application.

Example

Assume the following layout:

7_40_properties_height.gif (2124 Byte)

In the runtime layout

7_40_properties_height1.gif (1641 Byte)

The mouse change be used to change the Width/Height. Move the mouse over the red-dotted line so that the mouse pointer becomes a double-arrow.

7_40_properties_height2.gif (1952 Byte)

Press and hold the left mouse button while moving the mouse to change the application width/height.

7_40_properties_height3.gif (1477 Byte)


Property: Width (Grid/ExtendedGrid)

Page#: 7_86_properties_width.htm

v10 000329TTA: last edit

Property: Width (Grid/ExtendedGrid)

Possible values

  • Integer.

Property for

  • Application
  • ExtendedGridList . Property for = Column 1
  • GridList . Property for = Column 1

Definition

Width for a column.

Note: The width of the column can be changed in the runtime layout if element property <Columns moveable> = <Yes>.

Example

Assume the following layout Grid column:


Property: X-axe name

Page#: 7_87_properties_xaxe.htm

v10 000407TTA: pic replaced.

Property: X-axe name

Possible values

  • Text

Property for

  • Graphics . Graphics type = Horizontal 3D bar / Horizontal bar / Horizontal Gantt / Line / Vertical 3D bar / Vertical bar / Vertical Gantt

Definition

Name of the x axis in the graphic.

Example

In the following layout <X-axe name> = <x axis data>.

7_88_properties_yaxe.gif (2529 Byte)


Property: Y-axe name

Page#: 7_88_properties_yaxe.htm

v10 000407TTA: pic replaced.

Property: Y-axe name

Possible values

  • Text

Property for

  • Graphics . Graphics type = Horizontal 3D bar / Horizontal bar / Horizontal Gantt / Line / Vertical 3D bar / Vertical bar / Vertical Gantt

Definition

Name of the y axis in the graphic.

Example

In the following layout <Y-axe name> = <y axis data>.

7_88_properties_yaxe.gif (2529 Byte)


Trouble-shooting

Page#: 71_troubleshooting.htm

000215TTA: first items added.

Trouble-shooting

Click on the any problem listed below for a description of the most common solutions for that problem.

  • The upper-left portion of a layout window is hidden in the Designer (window cannot be moved).
  • An element is not visible in the design-time layout.
  • A model attribute is not available from the drop-down list for an element.
  • The header and/or footer for the application and/or workarea is not visible.
  • The header and/or footer for the application and/or workarea is missing (the layout was previously saved an upon re-opening the header and footer were missing).


Window not visible

Page#: 71_05_ts_windownotvisible_.htm

Window not visible

Problem

It is possible that a layout can be opened in the layout with the layout shifted to the upper-left such that the dialog cannot be moved with a mouse. For example:

71_05_window_not_visible.gif (4787 Byte)

Solution

Select from the main menu "Window / Cascade".


Element not visible

Page#: 71_15_ts_elementnotvisible.htm

Element not visible

Problem

An element exists in the layout, but is not visible in the design-time (not runtime) layout. For example, the following layout has 2 Labels, but only Label1 is visible.

71_15_ts_elementnotvisible.gif (4132 Byte)

Solution

The non-visible element is probably on a level that is not displayed in the design-time layout. In the above example:

71_15_ts_elementnotvisible1.gif (1569 Byte)

71_15_ts_elementnotvisible2.gif (3941 Byte)

Select "Options / Levels / Level 2" to display the level. The element is now visible.

71_15_ts_elementnotvisible3.gif (1255 Byte)


Model attribute not available

Page#: 71_25_ts_attributenotavailable.htm

Model attribute not available

Problem

You want to select a model attribute as the <Source> for an element. However, the attribute is not in the drop-down list for the element property <Source>.

For example, you want to select model 333.pms attribute a_3 as the source for an EntryField in a layout. However, a_3 is not available from the drop-down list:

71_25_ts_attributenotavailable.gif (3164 Byte)

Requirement 1

The model must be selected for application property <Productmodel>.

71_25_ts_attributenotavailable1.gif (1006 Byte)

Requirement 2

The model must be opened in the Workbench and be the currently selected model.

Example

Assume that <Productmodel> = 333.vpm.

Assume model 333.vpm includes 444.vpm:

71_25_ts_attributenotavailable2.gif (866 Byte)

71_25_ts_attributenotavailable3.gif (898 Byte)

Although 333.vpm is specified as <Productmodel>, only 444.vpm attribute a_4 will be available from the drop-down list if model 444 is selected in the Workbench. Model 333 must be selected (the selected model tab is white).

Requirement 3

The runtime model is selected as the <Productmodel>, not the model. Therefore if an attribute has been added to a model, the model be compiled to a runtime model.

Requirement 4

If an attribute has been added to the runtime model since the layout was opened or the last time the layout was synchronized with the model, then the layout must be synchronized with the model by selecting from the main menu "Options / Workbench synchronization".


Header/footer (application/workarea) not visible

Page#: 71_45_ts_headfootnotvisible.htm

Header/footer (application/workarea) not visible

Problem

The header and/or footer for the application and/or workarea is not visible. For example:

71_45_ts_headfootnotvisible.gif (4473 Byte)

Solution

Click on the required Header or Footer icons in the Header/Footer toolbar.

71_45_ts_headfootnotvisible1.gif (460 Byte)

The header and footer will be displayed.

71_45_ts_headfootnotvisible2.gif (2999 Byte)


Header/footer missing

Page#: 71_46_ts_headfootmissing.htm

Header/footer missing

Problem

You opened a layout and the header or footer for the application or workarea is missing.

Solution

A header or footer must contain at least 1 element to be saved to the .vpl file.

Example

Assume the following layout with an application header and footer:

71_46_ts_headfootmissing.gif (2502 Byte)

Closing (and saving) the layout and then reopening would result in the following layout:

000215TTA XX : i faked this pic... when i tried this on my computer the reopened file was total garbage.

71_46_ts_headfootmissing1.gif (2285 Byte)


FAQ (frequently-asked questions)

Page#: 72_faq.htm

FAQ (frequently-asked questions)

The following is a list of frequently-asked questions.

  • Can different elements be displayed in the sample place in the runtime layout?
  • Can attributes from more than 1 model be included in a single layout?


Overlapping elements

Page#: 72_15_faq_2elements1spot.htm

000215TTA: created. ARG!!!! why cant you uncheck level0!!!

Overlapping elements

Question

How can the element in a runtime layout change?

Answer

The element in the runtime layout can change by specifying overlapping elements in the design-time layout.

Only 1 of the overlapping elements is visible at any time in the runtime layout.

The overlapping elements are editted in the design-time layout by using levels.

Example

Assume the following layout:

72_15_faq_2elements1spot.gif (2357 Byte)

72_15_faq_2elements1spot1.gif (833 Byte)

72_15_faq_2elements1spot2.gif (821 Byte)

Assume the following model:

72_15_faq_2elements1spot3.gif (2621 Byte)

In the runtime layout, either the EntryField or the ComboBox would be visible:

72_15_faq_2elements1spot4.gif (466 Byte) 72_15_faq_2elements1spot5.gif (517 Byte)

The problem at this point is how to edit the 2 elements in the design-time layout if they are to be overlapping. This is solved by using levels.

Note the following settings for the EntryField:

72_15_faq_2elements1spot6.gif (661 Byte) 72_15_faq_2elements1spot7.gif (455 Byte)

The settings for the ComboBox are changed to the following:

72_15_faq_2elements1spot8.gif (646 Byte) 72_15_faq_2elements1spot9.gif (450 Byte)

Note that the levels for the 2 elements differ. The EntryField is normally shown on top of the CheckBox (level 1 on top of level 2).

72_15_faq_2elements1spot91.gif (588 Byte)

To display the ComboBox (level 2), select (uncheck) from the main menu "Options / Levels / Level 1". All components on level 1 are hidden and the ComboBox is visible:

72_15_faq_2elements1spot92.gif (481 Byte)

NOTE: Level 0 can NOT be hidden.


Attirbutes from more than 1 model

Page#: 72_25_faq_elementsfrom2models.htm

Attributes from more than 1 model

Question

How can elements from more than 1 model be included in the layout?

Answer

Only a single runtime model (.vpm) can be specified for the layout property <Productmodel>. However, the model specified for the layout can include other models. The attributes from the included models are also available in the layout.


Glossary

Page#: 8_glossary.htm

000224TTA: changed to a single file (makes more logical sense).

Glossary

Active tree

Different types of cover are found side by side in the product tree. By defining inclusion rules, the product modeler defines which parts of the tree will be included in the calculations under certain conditions and which not. The part of the product tree where the inclusion rules are fulfilled in a specific situation is known as the active tree. If a property is used several times within the active tree, only the property in the active tree will be included in the evaluation.

Attribute

The rules and calculations featuring in this product relate to data which describe e.g. the characteristics of an insured object (e.g. kW of a ve-hicle). This data is mapped as attributes in the VP/MS. In other words, all input fields on the application program's user interface are defined as attributes. Checks and default values can be defined for each attribute.

Automatic aggregation

If several partial premiums are calculated for a product, these partial premiums must be aggregated into a total premium. This aggregation process is performed automatically by complying with the following convention: A superordinate level of the product tree states that the total premium is the same as the total of the partial premiums of the superordinate levels. Avoid manual aggregation of premiums in the form partial premium 1 + partial premium 2 + partial premium 3.

Auxiliary element

Where differences occur for the first time in the product tree, the product modeler can integrate freely selectable auxiliary elements in the product tree. Example: Two types of cover are represented by auxiliary elements.

Basic OEC catalog

The objects, events and compensation which can be used in products are each defined in a basic catalog (Objects window, Events window, Com-pensation window on the Workbench). This is the only place where they can be changed. They are linked dynamically with the products and product components.

Compensation

Standard element of the product tree which specifies what compensation is given and how much. Examples: Daily allowance, pension, restoration costs, disposal costs, indemnification, refund of costs.

Components

In order to avoid having to map identical product parts several times, product components can be created a single time and reused at different locations in the product tree. Changes to product components apply throughout the product model.

Example: Dog owner's liability in household and building insurance, refund of costs of electrical appliances for types of household insurance cover, identical refund of costs for different health insurance rates.

Database

This is a structured collection of data. It enables the gathering and query-ing of information (e.g. master customer data) using specific criteria. The query is made using special query languages such as SQL (Structured Query Language) or ODBC. It is possible to address ODBC-compatible programs (e.g. Access, Excel) in VP/MS as standard.

Editor

The tool which allows the product modeler to enter and change rules and calculations. It is launched by double-clicking a line of the Inspector. Automatic assignment of different colors within the Editor enhances the legibility of formulae (e.g. functions are depicted in blue, attribute or table names in green, values in dark red and text in blue-green).

Event

Standard element of the product tree which specifies what an object is to be insured against. Examples: Accident, start of pension, theft, glass breakage, storm, compensation claim, vehicle damage. The frequently used term 'risk' is not used, since e.g.'start of pension' cannot be termed a 'risk'.

Functions

Like Excel, VP/MS has a number of predefined "standard functions", e.g. if (if; then; else), error (error message), days (date).

Properties which are used several times can also be defined as functions (in the Functions window) by the product modeler. Like the standard functions, these "user-defined functions" can be used in every property. The product modeler can greatly reduce his workload and facilitate the update of product definitions by defining functions for recurring calcula-tions and rules.

It is also possible to use external programs (e.g. actuarial programs in the code of another programming language) as well as user-defined functions.

Inclusion rule

Specifies the condition under which an element of the product tree is part of the active tree. An inclusion rule must always be stated in an element – except where elements are of inclusion type 'mandatory'. In the simplest of cases, the inclusion rule is specified by an attribute.

Inclusion type

For each element in the product tree, the conditions under which it forms part of the active tree are stipulated. The following inclusion types are possible: mandatory, optional, mutually exclusive and multiple. The condi-tions under which an optional element can be included are defined in an inclusion rule.

An element forms part of the active tree if the inclusion rules are satisfied for all superordinate elements and the element itself is either mandatory or satisfies its inclusion rule.

Inclusion value

It is possible to define different product parts where only one part can be included. These product parts are identified by an inclusion rule, e.g. specification of the TypeofCover attribute. The inclusion value specifies the type of cover for which this element is included.

Inspector

Tool for the detailed view of all elements of the product model. The pro-duct modeler can inspect all entries in detail by double-clicking all ele-ments of the model or by selecting the elements and pressing the Enter key.

Object

Standard element of the product tree which defines which person or object is to be insured. In order to identify the object to be insured, ask yourself the following question: Who or what will the event affect? Examples: Person, building, car, animal.

ODBC

Open Database Application Programming Interface. Software interface regulating the exchange of data between an application program and databases. VP/MS can access ODBC-compatible databases such as Access via an ODBC interface.

Platform

This term is used to designate different computer systems in terms of their system architecture. These differ as regards their CPU (central processing unit), hardware components, operating system and available software version. Examples of different operating systems are: Win 3.11, 95, NT, OS2, host systems, Unix.

Product

Insurance products can be represented in the form of a tree which con-tains the elements product, objects, events and compensation (in this order). This tree-like representation of an insurance product can be crea-ted by the product modeler in the Products window, the "heart" of the VP/MS Workbench. Classes of insurance always represent products from the perspective of VP/MS. The product tree maps every aspect of the cover information (both mandatory and optional product elements) and does so in a way which is easy to understand for all target groups. All calculation regulations and rules can be defined here.

Product tree

The objects which can be insured in a product, the events relating to these which can be insured, and the associated compensation are represented in the form of a tree in the VP/MS Workbench. The product tree is a complete representation of the cover provided by a product.

Property

The rules and calculations relating to a product are known as properties in VP/MS. Properties can be defined as formulae for an element in the product tree or as formulae for attributes (=data fields relevant for the product rate). Properties consist of a property name and a calculation formula for determining the value of this property. Examples of properties include: checks, defaults, premiums.

Reference model

In section "Standardizing Attributes, Functions, Tables", the subordinate product model is known as the reference model. Attributes, functions and tables relating to this reference model are available to the top model (superordinate model).

Runtime module

To run the product model on different target systems, a system-independent file is created with the filename extension "VPM". This VPM file is also known as a "runtime" module and uses a platform-specific DLL file which enables it to run on all platforms!!

This DLL, also known as a runtime, corresponds to a virtual machine which runs the runtime modules (VPM) on different target systems. This runtime is available for the following operating systems, for example: Windows 3.x (16-bit runtime = vpmsdll.dll), Windows 95 (32-bit runtime = vpmsdl32.dll) and OS2.

DLL is an abbreviation for Dynamic Link Library. These are object libraries which can be loaded dynamically (i.e. as required). Several programs can access a loaded DLL simultaneously.

Submodel

In section "Creating Bundled Products", the linked product model is known as the submodel. The product tree, attributes, functions and tables of the submodel (of the linked model) are available to the top model (superordi-nate model) by means of a link.

Table

Within tables, you can map mortality tables, premiums, descriptions (long text), error messages and default values in selection fields. These default values (e.g. different types of cover in the Product selection field) are also known as selection options or selection list entries. All elements in the product tree can access a table.

VP/MS can be used to access external dBase tables, internal VP/MS tables and external ODBC-compatible programs (Access, Excel).

Top model

The superordinate product model is known as the top model in sections "Standardizing Attributes, Functions, Tables" and "Creating Bundled Products".

VP/MS

VP/MS means Virtual Product / Modeling System and is a tool for insuran-ce product modeling. VP/MS contains the Workbench, runtime module, test and mass test. VP/MS is an expert system which works in the back-ground of application programs. The application programs (=client appli-cations, e.g. field service programs, broker software, host applications) access the expert system.

Workbench

The product developer is equipped with a graphical workstation complete with intuitive graphical interface for modeling insurance products. This workstation is known as the Workbench in VP/MS. The product developer uses the Workbench to edit and manage products (define new products, change existing products). The insurance product models created with the Workbench are given the filename extension PMS.


Directories and files

Page#: 81_dirsfilestypes.htm

v09 000224TTA: created.

Directories and files

To understand how to best utilize Designer, to find solutions to problems, etc., it is important to understand the following in Designer:

  • Directories
  • Files
  • File types


Directories

Page#: 81_1_dirs.htm

Directories

The following is a list of directories created for VPMS / Designer on your computer.

Note: The directory name "ZYX" is associated with VPMS application ZYX. If you have created or installed other applications, then directories with the corresponding name will be created for these applications.

  • c:\vpms
  • c:\vpms\designer
  • c:\vpms\vframe
  • c:\vpms\vframe\menu
  • c:\vpms\wbench
  • c:\vpl_apps
  • c:\vpl_apps\zyx
  • c:\vpl_apps\zyx\data
  • c:\vpl_apps\zyx\help
  • c:\vpl_apps\zyx\images
  • c:\vpl_apps\zyx\print
  • c:\vpl_apps\zyx\struct
  • c:\vpl_apps\zyx\vorgang


c:\vpms

Page#: 81_1_1_dir_c_vpms.htm

c:\vpms

The main VPMS application directory.


c:\vpms\designer

Page#: 81_1_1_1_dir_designer.htm

c:\vpms\designer

All Designer files (including Designer Test).


c:\vpms\vframe

Page#: 81_1_1_2_dir_vframe.htm

c:\vpms\vframe

Vframe executive and help.


c:\vpms\vframe\menu

Page#: 81_1_1_2_1_dir_menu.htm

c:\vpms\vframe\menu

ini files for the Vframe menus (including consultation).


c:\vpms\wbench

Page#: 81_1_1_3_dir_wbench.htm

c:\vpms\wbench

All Workbench (including Workbench Test) and IFOS files.


c:\vpl_apps

Page#: 81_1_2_dir_c_vpl_apps.htm

c:\vpl_apps

VPMS application subdirectories. When a VPMS application is installed on your computer, a subdirectory is created in this directory for that application.


c:\vpl_apps\zyx

Page#: 81_1_2_1_dir_zyx.htm

c:\vpl_apps\zyx

Zyx application files, including .pms, .vpc, .vpd, .vpl, .vpm files for the Zyx application.


c:\vpl_apps\zyx\data

Page#: 81_1_2_1_1_dir_data.htm

c:\vpl_apps\zyx\data

Zyx application data files (if any).


c:\vpl_apps\zyx\help

Page#: 81_1_2_1_2_dir_help.htm

c:\vpl_apps\zyx\help

Zyx application windows help files (if any).


c:\vpl_apps\zyx\images

Page#: 81_1_2_1_3_dir_images.htm

c:\vpl_apps\zyx\images

Zyx application image files (if any).


c:\vpl_apps\zyx\print

Page#: 81_1_2_1_4_dir_print.htm

c:\vpl_apps\zyx\print

Zyx application Report Editor .cat files for printing.


c:\vpl_apps\zyx\struct

Page#: 81_1_2_1_5_dir_struct.htm

c:\vpl_apps\zyx\struct

Zyx application .ini files for .dll calls (if any).


c:\vpl_apps\zyx\vorgang

Page#: 81_1_2_1_6_dir_vorgang.htm

c:\vpl_apps\zyx\vorgang

Zyx application vorgang files.


Files

Page#: 81_2_files.htm

v11 000414TTA: empty.vpm added.

Files

The following is a list of files associated with Designer (and VPMS in general).

  • cafrg.exe
  • consult.ini
  • empty.vpm
  • ifosre.exe
  • menubar.ini
  • menuburo.ini
  • menufens.ini
  • menuhelp.ini
  • menuinfo.ini
  • menukund.ini
  • vds.exe
  • vds_tx32.exe
  • verwalt.ini
  • vframe32.exe
  • vorgang.ini
  • vpms32.exe
  • vpmsdl32.dll
  • vpmsdll.dll
  • vpmsin32.dll
  • vpmsinfo.dll
  • vpmste32.exe
  • xplconf.ini


cafrg.exe

Page#: 81_2_01_files_cafrg_exe.htm

cafrg.exe

Description

Report viewer exe.

Directory

C: \ VPMS \ Wbench \


consult.ini

Page#: 81_2_02_files_consult_ini.htm

consult.ini

Description

Definition of submenu items for VFrame main menu item Consultation.

Directory

C: \ VPMS \ Vframe \ menu \


 empty.vpm

Page#: 81_2_025_files_empty_vpm.htm

v11 000414TTA: created.

empty.vpm

Description

The default runtime model for layouts. This model is used if layout property <Product model> is not specified.

Directory

empty.vpm should be in the same directory as the layout.


ifosre.exe

Page#: 81_2_03_files_ifosre_exe.htm

ifosre.exe

Description

Report editor.

Directory

C: \ VPMS \ Wbench \


menubar.ini

Page#: 81_2_04_files_menubar_ini.htm

menubar.ini

Description

Definition of Vframe main menu.

Directory

C: \ VPMS \ Vframe \menu \


menuburo.ini

Page#: 81_2_05_files_menuburo_ini.htm

menuburo.ini

Description

Directory

C: \ VPMS \ Vframe \menu \


menufens.ini

Page#: 81_2_06_files_menufens_ini.htm

menufens.ini

Description

Definition of submenu items for VFrame main menu item Fenster.

Directory

C: \ VPMS \ Vframe \menu \


menuhelp.ini

Page#: 81_2_07_files_menuhelp_ini.htm

menuhelp.ini

Description

Definition of submenu items for VFrame main menu item Help.

Directory

C: \ VPMS \ Vframe \menu \


menuinfo.ini

Page#: 81_2_08_files_menuinfo_ini.htm

menuinfo.ini

Description

Definition of submenu items for VFrame main menu item Infodesk.

Directory

C: \ VPMS \ Vframe \menu \


menukund.ini

Page#: 81_2_09_files_menukund_ini.htm

menukund.ini

Description

Definition of submenu items for VFrame main menu item Customer.

Directory

C: \ VPMS \ Vframe \menu \


vds.exe

Page#: 81_2_10_files_vds_exe.htm

vds.exe

Description

Designer exec.

Directory

C: \ VPMS \ Designer \


vds_tx32.exe

Page#: 81_2_11_files_vds_tx32_exe.htm

vds_tx32.exe

Description

Designer test exec.

Directory

C: \ VPMS \ Designer \


verwalt.ini

Page#: 81_2_12_files_verwalt_ini.htm

verwalt.ini

Description

Definition of submenu items for VFrame main menu item Administration.

Directory

C: \ VPMS \ Vframe \ menu \


vframe32.exe

Page#: 81_2_13_files_vframe32_exe.htm

vframe32.exe

Description

VFrame exec.

Directory

C: \ VPMS \ Vframe \


vorgang.ini

Page#: 81_2_14_files_vorgang_ini.htm

vorgang.ini

Description

Definition of submenu items for VFrame main menu item Process.

Directory

C: \ VPMS \ Vframe \ menu \


vpms32.exe

Page#: 81_2_15_files_vpms32_exe.htm

vpms32.exe

Description

Workbench exec.

Directory

C: \ VPMS \ Wbench \


vpmsdl32.dll

Page#: 81_2_16_files_vpmsdl32_dll.htm

vpmsdl32.dll

Description

Creates a runtime from the .pms file.

Directory

C: \ VPMS \ Wbench \


vpmsdll.dll

Page#: 81_2_17_files_vpmsdll_dll.htm

vpmsdll.dll

Description

16-bit interface to the 16-bit IFOS.

Directory

C: \ Winnt \ System32 \


vpmsin32.dll

Page#: 81_2_18_files_vpmsin32_dll.htm

vpmsin32.dll

Description

32-bit interface to the 32-bit IFOS.

Directory

C: \ Winnt \ System32 \


vpmsinfo.dll

Page#: 81_2_19_files_vpmsinfo_dll.htm

vpmsinfo.dll

Description

Provides access to the attributes in the designer.

Directory

C: \ Winnt \ System32 \


vpmste32.exe

Page#: 81_2_20_files_vpmste32_exe.htm

vpmste32.exe

Description

Workbench test exe.

Directory

C: \ VPMS \ Wbench \


xplconf.ini

Page#: 81_2_21_files_xplconf_ini.htm

xplconf.ini

Description

Definitions for VFrame.

Directory

C: \ VPMS \ Vframe \ menu \


File types

Page#: 7_82_properties_value.htm

000224TTA: doubletext removed.

File types

The following is a list of file types associated with Designer (and VPMS / Windows in general).

  • .cat
  • .hlp
  • .pms
  • .vpc
  • .vpd
  • .vpg
  • .vpl
  • .vpm


.avi

Page#: 82_03_avi.htm

000224TTA: doubletext removed.

.avi

Description

Multimedia (audio-visual) file type supported by Designer with the Multimedia element.

Typical directory

000130 TTA : is this the directory for .avi files??

C: \ VPL_Apps \ (application dir) \

Example

Standard Windows clock.avi file:

Note: Click on the "Stop" button (red with the "X") in the help or browser toolbar to stop playing the .avi file.


.bmp

Page#: 82_05_bmp.htm

000224TTA: doubletext removed.

.bmp

Description

Windows bit-map picture format. Multimedia(audio-visual) file type supported by Designer with the Multimedia element.

Typical directory

000130 TTA : is this the directory for .bmp files??

C: \ VPL_Apps \ (application dir) \


.cat

Page#: 82_10_cat.htm

000224TTA: doubletext removed.

.cat

Description

Report file. Contains print specifications.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ print \ (application name).cat


.hlp

Page#: 82_20_hlp.htm

000224TTA: doubletext removed.

.hlp

Description

Help file for consultation in VFrame.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ help \ (help filename).hlp


.pms

Page#: 82_23_jpg.htm

000224TTA: doubletext removed.

.jpg

Description

JPEG picture format. Multimedia(audio-visual) file type supported by Designer with the Multimedia element.

Typical directory

000130 TTA : is this the directory for .jpg files??

C: \ VPL_Apps \ (application dir) \


.pms

Page#: 82_30_pms.htm

000224TTA: doubletext removed.

.pms

Description

Model file. Text file format.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (application name).pms


.tif

Page#: 82_35_tif.htm

000224TTA: doubletext removed.

.tif (tiff)

000130 TTA : i tried to insert a tif file... didnt work

Description

Tagged-image file format for pictures.

A compressed format with no loss of picture quality.

Multimedia (audio-visual) file type supported by Designer with the Multimedia element.

Typical directory

000130 TTA : is this the directory for .tif files??

C: \ VPL_Apps \ (application dir) \


.vpc

Page#: 82_40_vpc.htm

000224TTA: doubletext removed.

v10 000406TTA XX: non-tta (functional description) text added.

.vpc

Description

Compiled (runtime) layout file. Compiled from .vpl file.

Byte code for distributions of XPL-applications.

As the previous experience has shown the existing VPL-format is rather convenient at design time, but not very suitable at runtime. Most significant disadvantages are low performance during loading an XPL-applications (especially great ones) and ASCII-format that provides possibility to edit VPL-files using usual text editors and does not allow to avoid of distribution of confidential information such as programmer names, comments, etc.

To solve these problems a new binary format (a byte code) of XPL-application should be developed. The following rules are applied to this format:

  • The byte code is used only at runtime. At design time the existing VPL-format is used, as well as newly developed format for storing SQL-statements.
  • The byte code is generated when ‘Save/Save as’ function is applied to the application in the Designer Workbench. The byte code differs from VPL-file by its filename extensions.
  • The byte code contains all information necessary for an XPL-application at runtime. That means, that it consists not only of VPL-file information, but also of necessary SQL-statements, etc. The byte code of an XPL-application will represent a distribution of the application.
  • Load performance of the byte code must be significantly higher than it is for the VPL-format.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (application name).vpc


.vpd

Page#: 82_50_vpd.htm

000224TTA: doubletext removed.

.vpd

Description

Mapping between layout components and model attributes.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (application name).vpd


.vpg

Page#: 82_60_vpg.htm

000224TTA: doubletext removed.

.vpg

Description

Contains a group of elements.

Created by selecting a group of elements and then selecting Write to Disk.

Contents can be copied to a layout by:

  • Selecting Read group from disk to clipboard.
  • Paste the clipboard contents to the layout.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (element group name).vpg


.vpl

Page#: 82_70_vpl.htm

000224TTA: doubletext removed.

v10 000406TTA: text from functional description added.

.vpl

Description

Design-time layout . Text file format.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (application name).vpl

Syntax description

VPL-syntax is described in BNF (Bakus Naur Form).The following agreements a used in the VPL-syntax description.

The terminal symbols are written in capitals. The terminal symbols defining values (such as numbers, strings, identifiers, etc) are prefixed with underscore ‘_’. They are the following.

  • _INT - integer number (unsigned);
  • _STATUS - element binary flags (32 binary digits);
  • _VERSION - version number (version number and sub-number separated with dot ‘.’;
  • _FONTSTYLE - font style (4 binary digits leading by ‘@’, ex. @0110, strike, underline, italic, bold correspondingly);
  • _COLOR - color ( 6 hex digits leading by #, ex. #0A121C , color in RGB-form);
  • _STRING - string in double-quotes, ex. “Insurance”;
  • _IDENTIFIER - VPL-identifier defining layout object name (leaded by ‘:’);
  • _VPM_IDENTIFIER - VPM-identifier passed from product model (leaded by ‘$’);
  • _LAYLEAD_IDENTIFIER - concatenated identifier (VPL-identifier followed by VPM-identifier, ex. :A_ALLG_sFaTelVor$A_ALLG_sFaTelVor);
  • _VPMLEAD_IDENTIFIER - concatenated identifier (VPM-identifier followed by VPL-identifier, ex. $A_PKVV_Nutzart:A_PKVV_Nutzart).

The other terminal symbols define correspondent VPL-keywords.

The changes made in VPL-syntax in version 3.25 (since version 3.1) are outlined in bold characters. Obsolete syntax constructions remaining in the grammar for compatibility with the previous versions are outlined by italic.

/* Grammar of application layout description */

/* Common elements */

/* Font description */

font_description

: FONT ‘(‘ _STRING ‘,’ _INT ‘,’ _FONTSTYLE ‘,’ _COLOR ‘)’

version _description

: VERSION ‘(‘

_STRING ‘,’ /* Title */

_STRING ‘,’ /* Version */

_STRING ‘,’ /* Description */

_STRING ‘,’ /* Created By */

_STRING ‘,’ /* Creation Date */

_STRING ‘,’ /* Last Updated By */

_STRING ‘,’ /* Last Updated Date */

_STRING ‘,’ /* Last Update Description */ ‘)’

tooltip_description

: TOOLTIP ‘(‘ _STRING ‘,’ /* Caption */

_COLOR ‘,’ /* Color */

_fontdescription ‘)’

/*-------------------------------------------------*/

/* Application layout description -- start symbol */

Application_description

: APPLICATION _IDENTIFIER _VERSION ‘,’ app_property_list ‘;’ workarea_description_list END

app_property_list

: app_property

| app_property_list ‘,’ app_property

app_property

: DESIGNER _VERSION

| USER _STRING

| CAPTION _STRING

| MODEL _STRING _VERSION

| STYLE SIMPLE

| STYLE NOTEBOOK notebook_font_description

| STARTATTRIBUTE _VPM_IDENTIFIER

| STARTVALUE _STRING

| STARTVALUE DYNAMIC

| COMPUTE AUTO

| COMPUTE MANUAL

| FORMAT F640x480 /* Resolution 640x480 */

| FORMAT F800x600 /* Resolution 800x600 */

| FORMAT F1024x768 /* Resolution 1024x768 */

| FORMAT CUSTOM /* Custom resolution */

| ACOLOR _COLOR

| SIZE ‘(‘ _INT ‘,’ _INT ‘)’

| DEFAULT font_description /* Default application font */

| version_description

notebook_font_description

: /* Empty */

| font_description

/* Workarea description */

workarea_description_list

: workarea_description

| workarea_description_list workarea_description

workarea_description

: WORKAREA _IDENTIFIER ‘,’ workarea_property_list ‘;’ page_description_list ENDAREA ‘;’

workarea_property_list

: workarea_property

| workarea_property_list ‘,’ workarea_property

workarea_property

: CAPTION _STRING

| STYLE SIMPLE

| TABCOLOR _COLOR

| HELPID _INT

| INDICATOR ‘(‘ _VPM_IDENTIFIER ‘,’ _STRING ‘,’ _STRING ‘)’ /* Data indicator property/attribute, ON image file, OFF image file */

| STYLE FRAME ‘(‘ frame_property_list ‘)’

| tooltip_description

| version_description

frame_property_list

: frame_property

| frame_property_list ‘,’ frame_property

frame_property

: WIDTH _INT /* For compatibility with the previous versions only */

| font_description

| WIDTH ‘(‘ _INT ‘,’ _INT ‘,’ _INT ‘)’ /* Middle, minimal and maximal width */

page_description_list

: page_description

| page_description_list page_description

/* Page description */

page_description

: PAGE _IDENTIFIER page_multiple ‘,’ page_property_list ‘;’page_body ENDPAGE ‘;’

page_body

: /* Empty */

| layout_element_list ‘;’

page_multiple

: /* Empty */

| MULTIPLE

page_property_list

: page_property

| page_property_list ‘,’ page_property

page_property

: CAPTION _STRING

| CAPTION NEW _STRING

| CAPTION DELETE _STRING

| KEYFIELD _IDENTIFIER

| COUNTER _VPM_IDENTIFIER

| INDICATOR ‘(‘ _VPM_IDENTIFIER ‘,’ _STRING ‘,’ _STRING ‘)’ /* Data indicator property/attribute, ON image file, OFF image file */

| LIMIT _VPM_IDENTIFIER

| PARENT WORKAREA /* for frame root page */

| PARENT _IDENTIFIER

| CHECKLIST ‘(‘ check_list ‘)’

| SEQUENCE STANDARD

| SEQUENCE CUSTOM

| DEFOLD AUTO

| DEFOLD MANUAL

| BGCOLOR _COLOR

| HELPID _INT

| version_description

| tooltip_description

/* Page contens description */

layout_element_list

: /* Empty */

| layout_element

| layout_element_list ‘;’ layout_element

layout_element

: element_description

| GROUP _IDENTIFIER ‘;’ layout_element_list ‘;’ ENDGROUP

element_description

: EDIT edit_type element_name ‘,’ element_property_list

| CHECKBOX element_name ‘,’ element_property_list

| COMBOBOX element_name ‘,’ element_property_list

| RADIOBUTTON element_name ‘,’ element_property_list

| PUSHBUTTON element_name ‘,’ element_property_list

| RESULT result_type element_name ‘,’ element_property_list

| LABEL element_name ‘,’ element_property_list

| LINE element_name ‘,’ element_property_list

| BORDER element_name ‘,’ element_property_list

| RADIOGROUP element_name ‘,’ element_property_list

| GRID grid_type element_name ‘,’ element_property_list

| PICTURE element_name ‘,’ element_property_list

| DATA element_name data_element_description /* Data element */

| DIAGRAM element_name _INT /* Diagram type */ ‘,’ element_property_list

element_name

: _IDENTIFIER

| _LAYLEAD_IDENTIFIER

| _VPMLEAD_IDENTIFIER

/* EDIT */

edit_type

: TEXT

| NUMBER

| DATE

| MONEY

| MULTILINE

| MASK

/* RESULT */

result_type

: /* Empty - text result */

| NUMBER

| DATE

| MONEY

| MULTILINE

| MASK

grid_type

:

| ACTIVE

/* DATA */

data_element_description

: /* No properties defined */

| ‘,’ element_property_list

element_property_list

: element_property

| element_property_list ‘,’ element_property

element_property

: CAPTION _STRING

| POSITION ‘(‘ _INT ‘,’ _INT ‘)’

| SIZE ‘(‘ _INT ‘,’ _INT ‘)’

| INPUT ‘(‘ _INT ‘,’ _INT ‘)’ /* Minimal-maximal characters input for text edits */

| font_description

| BGCOLOR _COLOR

| ACOLOR _COLOR

| CURRENCY ON /* Obsolete, now STATUS property is used */

| CURRENCY OFF /* Obsolete, now STATUS property is used */

| LEVEL _INT

| DECIMAL _INT

| HIDE ‘(‘ page_area_name_list ‘)’

| VISUALIZE ‘(‘ page_area_name_list ‘)’

| EXECUTE DLL _STRING

| EXECUTE APPLICATION ‘(‘ _STRING ‘,’ app_session ‘,’ _INT ‘,’ _INT ‘)’ /* Pushbuttons - Secondary dialog call: name, clone session flag, dialog window size */

| EXECUTE ACCEPT /* Pushbutton accept dialog */

| EXECUTE CANCEL /* Pushbutton cancel dialog */

| EXECUTE COMPUTE /* Pushbutton compute */

| CHECKLIST ‘(‘ check_list ‘)’

| COMPUTE ON /* Obsolete, the same as EXECUTE COMPUTE */

| COMPUTE OFF /* Obsolete */

| COMPUTE ONCHANGE /* Obsolete, now STATUS property is used */

| COMPUTE ONEXIT /* Obsolete, now STATUS property is used */

| MULTIPLE ON /* Obsolete, now STATUS property is used */

| MULTIPLE OFF /* Obsolete, now STATUS property is used */

| ALWAYS ACTIVE /* Obsolete, now STATUS property is used */

| STATUS _STATUS

| ALIGNMENT LEFT /* Obsolete, now STATUS property is used */

| ALIGNMENT RIGHT /* Obsolete, now STATUS property is used */

| STYLE SIMPLE

| STYLE SHADOW

| CONVERT _VPM_IDENTIFIER

| CONVERT ON _VPM_IDENTIFIER

| CONVERT OFF _VPM_IDENTIFIER

| FILE _STRING

| HELPID _INT

| COLUMNS _INT

| KEYCOLUMN _INT

| ITERATION iteration_type

| STEP _INT

| HEADER font_description

| column_type ‘(‘ column_property_list ‘)’

| CHECKVISIBLE _VPM_IDENTIFIER /* check visibility of result fields */

| CAPTION LEFT _STRING

| CAPTION RIGHT _STRING

| CAPTION UP _STRING

| CAPTION DOWN _STRING

| COUNTER _VPM_IDENTIFIER

| CAPTION NEW _STRING

| CAPTION DELETE _STRING

| PICTURE ‘(‘ _STRING ‘,’ _STRING ‘,’ _STRING ‘,’ _STRING ‘)’

| version_description

page_area_name_list

: page_area_name

| page_area_name_list ‘,’ page_area_name

page_area_name

: _IDENTIFIER area_mark

area_mark

: /* Empty */

| ‘(‘ ‘)’ /* Here area name in the list */

check_list

: check_name

| check_list ‘,’ check_name

;

check_name

: _IDENTIFIER /* Obsolete, for compatibility with previous VPL versions only */

| _VPM_IDENTIFIER

app_session

: ON

| OFF

column_type

: INPUT column_cell_type COLUMN

| OUTPUT column_cell_type COLUMN

column_cell_type

: /* Empty */

| NUMBER

| DATE

| MONEY

| COMBOBOX

iteration_type

: ATTRIBUTE _VPM_IDENTIFIER

| PROPERTY _VPM_IDENTIFIER

| COUNTER _INT

column_property_list

: column_property

| column_property_list ‘,’ column_property

column_property

: CAPTION _STRING

| WIDTH _INT

| SOURCE _VPM_IDENTIFIER

| NEXT _INT

| font_description

| BGCOLOR _COLOR

| DECIMAL _INT

| ALIGNMENT RIGHT

| CURRENCY OFF

| STATUS _STATUS

| CHECKVISIBLE _VPM_IDENTIFIER

| CHECKLIST LP check_list RP

| MASK _STRING

| INPUT LP _INT CM _INT RP

/* The End */


.vpm

Page#: 82_80_vpm.htm

000224TTA: doubletext removed.

.vpm

Description

Compiled (runtime) model file. Compiled from .pms.

Setting default path for .vpm files.

Typical directory / filename

C: \ VPL_Apps \ (application dir) \ (application name).vpm


.wav

Page#: 82_90_wav.htm

000224TTA: doubletext removed.

.wav

Description

Windows audio-visual format. Multimedia(audio-visual) file type supported by Designer with the Multimedia element.

Typical directory

000130 TTA : how can you stop playing a .wav file??

Is this the right dir for .wav files??

C: \ VPL_Apps \ (application dir) \

Example

Assume the folloiwng layout Media element.

In the runtime layout chimes.wav would play continuously whenever the page is selected.


TXX. Connecting to a database

3.gif (1340 Byte)

Page#: 11_34_database.htm

v10 000404TTA XX: this may not be included in the release version.

TXX. Connecting to a database


TXX. Layout help

3.gif (1340 Byte)

Page#: 11_46_help.htm

v10 000404TTA: this may not be included in the release version.

TXX. Layout help


VP/MS Designer Help Overview

3.gif (1107 Byte)

Page#: (index)

v13 000523TTA: last change.

VP/MS Designer Help Overview

Contents of the help:

  • Overview (this page).
  • Contact. PMS Micado contact information.
  • Copyright and trademarks.
  • Using this help.
  • Other sources of information. Other sources information (help, manuals) for Designer and VP/MS.
  • Release notes.
  • Installation. System requirements and installation.
  • Tutorial.
  • Tools and dialogs. Designer tools and dialogs.
  • Concepts. Designer concepts.
  • Common tasks. Tasks most commonly carried out when using Designer.
  • Example layouts. Example layouts that demonstrate Designer concepts.
  • Properties. A complete list of all Designer properties.
  • Trouble-shooting. Solutions to common problems.
  • FAQ. Frequently-asked questions.
  • Glossary. Designer-specific terminology.
  • Directories and files. Describes the directories, files, and file types utilitzed by Designer.